module     p0_dd_emnebardu_abbrevd39h0
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_globalsh0
   implicit none
   private
   complex(ki), public :: abb39n1
   complex(ki), public :: abb39n2
   complex(ki), public :: abb39n3
   complex(ki), public :: abb39n4
   complex(ki), public :: abb39n5
   complex(ki), public :: abb39n6
   complex(ki), public :: abb39n7
   complex(ki), public :: abb39n8
   complex(ki), public :: abb39n9
   complex(ki), public :: abb39n10
   complex(ki), public :: abb39n11
   complex(ki), public :: abb39n12
   complex(ki), public :: abb39n13
   complex(ki), public :: rat2d39
   complex(ki), public :: abb39n15
   complex(ki), public :: abb39n16
   complex(ki), public :: abb39n17
   complex(ki), public :: abb39n18
   complex(ki), public :: abb39n19
   complex(ki), public :: abb39n20
   complex(ki), public :: abb39n21
   complex(ki), public :: abb39n22
   complex(ki), public :: abb39n23
   complex(ki), public :: abb39n24
   complex(ki), public :: abb39n25
   complex(ki), public :: abb39n26
   complex(ki), public :: abb39n27
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   real(ki) :: t37
   real(ki) :: t38
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_dd_emnebardu_config, only: deltaOS
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_model
      use p0_dd_emnebardu_color, only: TR
      use p0_dd_emnebardu_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t37 = es34+es61-(es345+es234)
      t2 = c1*i_
      t3 = t2*spak1k3
      t4 = t3*spak5k6
      t5 = t4*spbk2k1*spbk4k1
      t38 = TR*mT
      t38 = t38*t38
      t6 = (es34+es56-(es234+es12))*t1
      t37 = t37*t37
      t7 = t37*t6
      t8 = t2*spak3k4
      t9 = t8*spak5k6*spbk4k1
      t10 = t9*spbk4k2
      t11 = t2*spak3k5*spak3k6
      t12 = t11*spbk2k1*spbk4k3
      t1 = (es12+es34-(es56+es345))*t1
      t13 = t37*t1
      t14 = t2*spak3k6
      t15 = t14*spak5k6
      t16 = t15*spbk2k1*spbk6k4
      t17 = c2*i_
      t18 = t17*spak1k3
      t19 = t18*spak5k6
      t20 = t19*spbk2k1*spbk4k1
      t6 = NC*t37*t6
      t21 = t17*spak3k4
      t22 = t21*spak5k6*spbk4k1
      t23 = t22*spbk4k2
      t24 = t17*spak3k5*spak3k6
      t25 = t24*spbk2k1*spbk4k3
      t1 = NC*t37*t1
      t26 = t17*spak3k6
      t27 = t26*spak5k6
      t28 = t27*spbk2k1*spbk6k4
      t29 = es234*c1*i_
      t37 = TR*TR
      t30 = es34*c1*i_
      t31 = es345*c1*i_
      t32 = es61*c1*i_
      t33 = es234*c2*i_
      t34 = es34*c2*i_
      t35 = es345*c2*i_
      t36 = es61*c2*i_
      abb39n1 = ((8.0_ki)*(t38*t25/t1+t38*t28/t1+t38*t10/t7+t38*t20/t6-(t38*t5/t&
      &7+t38*t23/t6+t38*t16/t13+t38*t12/t13))+(4.0_ki/3.0_ki)*(t37*t33/t1*spak3k&
      &5*spak3k6*spbk2k1*spbk4k3+t37*t33/t1*spak3k6*spak5k6*spbk2k1*spbk6k4+t37*&
      &t35/t1*spak3k5*spak3k6*spbk2k1*spbk4k3+t37*t35/t1*spak3k6*spak5k6*spbk2k1&
      &*spbk6k4+t37*t30/t13*spak3k5*spak3k6*spbk2k1*spbk4k3+t37*t30/t13*spak3k6*&
      &spak5k6*spbk2k1*spbk6k4+t37*t32/t13*spak3k5*spak3k6*spbk2k1*spbk4k3+t37*t&
      &32/t13*spak3k6*spak5k6*spbk2k1*spbk6k4+t37*t29/t7*spak3k4*spak5k6*spbk4k1&
      &*spbk4k2+t37*t30/t7*spak1k3*spak5k6*spbk2k1*spbk4k1+t37*t31/t7*spak3k4*sp&
      &ak5k6*spbk4k1*spbk4k2+t37*t32/t7*spak1k3*spak5k6*spbk2k1*spbk4k1+t37*t33/&
      &t6*spak1k3*spak5k6*spbk2k1*spbk4k1+t37*t34/t6*spak3k4*spak5k6*spbk4k1*spb&
      &k4k2+t37*t35/t6*spak1k3*spak5k6*spbk2k1*spbk4k1+t37*t36/t6*spak3k4*spak5k&
      &6*spbk4k1*spbk4k2-(t37*t36/t6*spak1k3*spak5k6*spbk2k1*spbk4k1+t37*t35/t6*&
      &spak3k4*spak5k6*spbk4k1*spbk4k2+t37*t34/t6*spak1k3*spak5k6*spbk2k1*spbk4k&
      &1+t37*t33/t6*spak3k4*spak5k6*spbk4k1*spbk4k2+t37*t32/t7*spak3k4*spak5k6*s&
      &pbk4k1*spbk4k2+t37*t31/t7*spak1k3*spak5k6*spbk2k1*spbk4k1+t37*t30/t7*spak&
      &3k4*spak5k6*spbk4k1*spbk4k2+t37*t29/t7*spak1k3*spak5k6*spbk2k1*spbk4k1+t3&
      &7*t31/t13*spak3k6*spak5k6*spbk2k1*spbk6k4+t37*t31/t13*spak3k5*spak3k6*spb&
      &k2k1*spbk4k3+t37*t29/t13*spak3k6*spak5k6*spbk2k1*spbk6k4+t37*t29/t13*spak&
      &3k5*spak3k6*spbk2k1*spbk4k3+t37*t36/t1*spak3k6*spak5k6*spbk2k1*spbk6k4+t3&
      &7*t36/t1*spak3k5*spak3k6*spbk2k1*spbk4k3+t37*t34/t1*spak3k6*spak5k6*spbk2&
      &k1*spbk6k4+t37*t34/t1*spak3k5*spak3k6*spbk2k1*spbk4k3)))
      abb39n2 = ((4.0_ki)*(t37/t7*t9*spbk5k2-t37*t22/t6*spbk5k2))
      abb39n3 = ((8.0_ki)*(t37/t7*t8*spbk4k1-t37*t21/t6*spbk4k1))
      t8 = TR*sqrt((mT*mT))
      t8 = t8*t8
      abb39n4 = ((8.0_ki)*(t25/t1*t8+t28/t1*t8+t10/t7*t8+t20/t6*t8-(t5/t7*t8+t23&
      &/t6*t8+t16/t13*t8+t12/t13*t8)))
      t8 = t2*spak2k5
      t21 = t8*spak3k6*spbk2k1
      t29 = t17*spak2k5
      t30 = t29*spak3k6*spbk2k1
      abb39n5 = ((4.0_ki)*(t37*t21/t13*spbk4k3-t37*t30/t1*spbk4k3))
      abb39n6 = ((4.0_ki)*(t37*t30/t1*spbk6k4+t37*t18/t6*spak2k5*spbk2k1*spbk4k1&
      &+t37/t7*t8*spak3k4*spbk4k1*spbk4k2-(t37*t3/t7*spak2k5*spbk2k1*spbk4k1+t37&
      &*t29/t6*spak3k4*spbk4k1*spbk4k2+t37*t21/t13*spbk6k4)))
      t5 = t37*t5/t7
      t8 = t37*t10/t7
      t10 = t37*t12/t13
      t12 = t37*t16/t13
      t16 = t37*t20/t6
      t20 = t37*t23/t6
      t21 = t37*t25/t1
      t23 = t37*t28/t1
      abb39n7 = ((16.0_ki)*(t16+t21+t23+t8-(t5+t20+t12+t10)))
      t5 = t10+t12+t20+t5-(t8+t23+t21+t16)
      abb39n8 = ((8.0_ki)*t5)
      abb39n9 = ((16.0_ki)*t5)
      t4 = t4*spbk4k1
      t5 = t2*spak2k6
      t8 = t11*spbk4k3
      t10 = t19*spbk4k1
      t11 = t17*spak2k6
      t12 = t24*spbk4k3
      abb39n10 = ((8.0_ki)*(t37*t12/t1*spbk5k1+t37*t10/t6*spbk5k1+t37*t22/t6*spb&
      &k5k4+t37*t27/t1*spbk5k1*spbk6k4+t37*t11/t6*spak3k4*spbk4k1*spbk4k2+t37/t1&
      &3*t5*spak3k6*spbk2k1*spbk6k4+t37*t3/t7*spak2k6*spbk2k1*spbk4k1+t37*t17/t1&
      &*spak2k3*spak3k6*spbk2k1*spbk4k3-(t37*t2/t13*spak2k3*spak3k6*spbk2k1*spbk&
      &4k3+t37*t5/t7*spak3k4*spbk4k1*spbk4k2+t37*t18/t6*spak2k6*spbk2k1*spbk4k1+&
      &t37*t11/t1*spak3k6*spbk2k1*spbk6k4+t37*t15/t13*spbk5k1*spbk6k4+t37/t7*t9*&
      &spbk5k4+t37*t4/t7*spbk5k1+t37/t13*t8*spbk5k1)))
      abb39n11 = ((4.0_ki)*(t37/t13*t8*spbk5k2+t37*t4/t7*spbk5k2+t37*t15/t13*spb&
      &k5k2*spbk6k4-(t37*t27/t1*spbk5k2*spbk6k4+t37*t10/t6*spbk5k2+t37*t12/t1*sp&
      &bk5k2)))
      abb39n12 = ((8.0_ki)*(t37*t26/t1*spbk4k3-t37*t14/t13*spbk4k3))
      abb39n13 = ((8.0_ki)*(t37*t14/t13*spbk6k4+t37*t3/t7*spbk4k1-(t37*t18/t6*sp&
      &bk4k1+t37*t26/t1*spbk6k4)))
      rat2d39 = abb39n1
      rat2 = rat2 + rat2d39
      abb39n15 = abb39n4
      abb39n16 = abb39n13
      abb39n17 = abb39n12
      abb39n18 = abb39n8
      abb39n19 = abb39n3
      abb39n20 = -(abb39n2)
      abb39n21 = -(abb39n5)
      abb39n22 = -(abb39n6)
      abb39n23 = -(abb39n7)
      abb39n24 = ((2.0_ki)*abb39n8)
      abb39n25 = -(abb39n9)
      abb39n26 = -(abb39n10)
      abb39n27 = -(abb39n11)
   end subroutine
end module p0_dd_emnebardu_abbrevd39h0
