module     p0_dd_emnebardu_abbrevd52h0
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_globalsh0
   implicit none
   private
   complex(ki), public :: abb52n1
   complex(ki), public :: abb52n2
   complex(ki), public :: abb52n3
   complex(ki), public :: abb52n4
   complex(ki), public :: abb52n5
   complex(ki), public :: abb52n6
   complex(ki), public :: abb52n7
   complex(ki), public :: abb52n8
   complex(ki), public :: abb52n9
   complex(ki), public :: rat2d52
   complex(ki), public :: abb52n11
   complex(ki), public :: abb52n12
   complex(ki), public :: abb52n13
   complex(ki), public :: abb52n14
   complex(ki), public :: abb52n15
   complex(ki), public :: abb52n16
   complex(ki), public :: abb52n17
   complex(ki), public :: abb52n18
   complex(ki), public :: abb52n19
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   real(ki) :: t31
   real(ki) :: t32
   real(ki) :: t33
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_dd_emnebardu_config, only: deltaOS
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_model
      use p0_dd_emnebardu_color, only: TR
      use p0_dd_emnebardu_globalsl1, only: epspow
      implicit none
      t1 = c1*i_
      t2 = t1*spak2k3
      t3 = t2*spak5k6
      t31 = TR*TR
      t4 = t31*t3*spbk2k1*spbk4k2
      t5 = (es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t6 = es234*t5
      t7 = t1*spak3k4
      t8 = t7*spak5k6
      t9 = t31*t8*spbk4k1*spbk4k2
      t10 = NC*NC*t6
      t11 = c2*i_
      t12 = t11*spak2k3
      t13 = t12*spak5k6
      t14 = NC*t5
      t15 = es234*t14
      t16 = t11*spak3k4
      t17 = t16*spak5k6
      t18 = NC*c2
      t19 = t18*i_
      t20 = t19*spak2k3
      t21 = t20*spak5k6
      t22 = t19*spak3k4
      t23 = t22*spak5k6
      t24 = es56*c1*i_
      t25 = t31*t24*spak2k3*spak5k6*spbk2k1*spbk4k2
      t32 = es234*es234
      t26 = t32*t5
      t24 = t31*t24*spak3k4*spak5k6*spbk4k1*spbk4k2
      t2 = t2*spbk4k2
      t27 = TR*spak5k6
      t27 = t27*t27
      t28 = t2*t27*spbk5k1*spbk6k2
      t2 = t2*t27*spbk5k2*spbk6k1
      t7 = t7*spbk4k2
      t29 = t27*t7*spbk5k1*spbk6k4
      t7 = t27*t7*spbk5k4*spbk6k1
      t33 = NC*es234
      t5 = t33*t33*t5
      t30 = es56*c2*i_
      t14 = t32*t14
      t12 = t12*spbk4k2
      t16 = t16*spbk4k2
      t18 = es56*t18*i_
      t20 = t20*spbk4k2
      t22 = t22*spbk4k2
      abb52n1 = ((4.0_ki)*(t2/t5+t24/t5+t25/t5+t28/t26+t29/t26+t4/t6+t7/t5+t9/t6&
      &+t12/t14*t27*spbk5k1*spbk6k2+t31*t13/t15*spbk2k1*spbk4k2+t16/t14*t27*spbk&
      &5k1*spbk6k4+t31*t17/t15*spbk4k1*spbk4k2+t20/t26*t27*spbk5k2*spbk6k1+t22/t&
      &26*t27*spbk5k4*spbk6k1+t31*t18/t26*spak2k3*spak5k6*spbk2k1*spbk4k2+t31*t1&
      &8/t26*spak3k4*spak5k6*spbk4k1*spbk4k2-(t31*t30/t14*spak3k4*spak5k6*spbk4k&
      &1*spbk4k2+t31*t30/t14*spak2k3*spak5k6*spbk2k1*spbk4k2+t31*t23/t6*spbk4k1*&
      &spbk4k2+t22/t26*t27*spbk5k1*spbk6k4+t31*t21/t6*spbk2k1*spbk4k2+t20/t26*t2&
      &7*spbk5k1*spbk6k2+t16/t14*t27*spbk5k4*spbk6k1+t12/t14*t27*spbk5k2*spbk6k1&
      &+t29/t5+t28/t5+t7/t26+t25/t26+t24/t26+t2/t26+t9/t10+t4/t10)))
      t2 = t3*spbk4k2
      t3 = t31*t2*spbk5k1
      t4 = t13*spbk4k2
      t6 = t21*spbk4k2
      abb52n2 = ((4.0_ki)*(t3/t5+t31/t26*t6*spbk5k1-(t31/t14*t4*spbk5k1+t3/t26))&
      &)
      t3 = t8*spbk4k2
      t7 = t31*t3*spbk5k1
      t8 = t17*spbk4k2
      t9 = t23*spbk4k2
      abb52n3 = ((4.0_ki)*(t7/t5+t31/t26*t9*spbk5k1-(t31/t14*t8*spbk5k1+t7/t26))&
      &)
      t2 = t31*t2*spbk6k1
      abb52n4 = ((4.0_ki)*(t2/t5+t31/t26*t6*spbk6k1-(t31/t14*t4*spbk6k1+t2/t26))&
      &)
      t2 = t31*t3*spbk6k1
      abb52n5 = ((4.0_ki)*(t2/t5+t31/t26*t9*spbk6k1-(t31/t14*t8*spbk6k1+t2/t26))&
      &)
      t2 = t1*spak3k5*spak5k6
      t3 = t31*t2*spbk4k2*spbk5k1
      t4 = t3/t26
      t6 = t1*spak3k6*spak5k6
      t7 = t31*t6*spbk4k2*spbk6k1
      t8 = t7/t26
      t3 = t3/t5
      t7 = t7/t5
      t9 = t11*spak3k5*spak5k6
      t10 = t31/t14*t9*spbk4k2*spbk5k1
      t12 = t11*spak3k6*spak5k6
      t13 = t31*t12/t14*spbk4k2*spbk6k1
      t15 = t19*spak3k5*spak5k6
      t16 = t31*t15/t26*spbk4k2*spbk5k1
      t17 = t19*spak3k6*spak5k6
      t18 = t31*t17/t26*spbk4k2*spbk6k1
      abb52n6 = ((16.0_ki)*(t16+t18+t3+t7-(t8+t4+t13+t10)))
      abb52n7 = ((16.0_ki)*(t10+t13+t4+t8-(t7+t3+t18+t16)))
      t3 = t31*t2*spbk3k2*spbk5k1
      t4 = t31*t6*spbk3k2*spbk6k1
      t7 = t31*t1*spak4k5*spak5k6*spbk4k2*spbk5k1
      t8 = t31*t1*spak4k6*spak5k6*spbk4k2*spbk6k1
      abb52n8 = ((8.0_ki)*(t3/t5+t4/t5+t7/t5+t8/t5+t31*t15/t26*spbk3k2*spbk5k1+t&
      &31*t17/t26*spbk3k2*spbk6k1+t31*t19/t26*spak4k5*spak5k6*spbk4k2*spbk5k1+t3&
      &1*t19/t26*spak4k6*spak5k6*spbk4k2*spbk6k1-(t31*t11/t14*spak4k6*spak5k6*sp&
      &bk4k2*spbk6k1+t31*t11/t14*spak4k5*spak5k6*spbk4k2*spbk5k1+t31/t14*t9*spbk&
      &3k2*spbk5k1+t31*t12/t14*spbk3k2*spbk6k1+t8/t26+t7/t26+t4/t26+t3/t26)))
      t3 = t31*t1*spak2k5*spak5k6*spbk4k2*spbk5k1
      t1 = t31*t1*spak2k6*spak5k6*spbk4k2*spbk6k1
      t2 = t31*t2*spbk4k3*spbk5k1
      t4 = t31*t6*spbk4k3*spbk6k1
      abb52n9 = ((8.0_ki)*(t1/t26+t2/t5+t3/t26+t4/t5+t31*t15/t26*spbk4k3*spbk5k1&
      &+t31*t17/t26*spbk4k3*spbk6k1+t31*t11/t14*spak2k5*spak5k6*spbk4k2*spbk5k1+&
      &t31*t11/t14*spak2k6*spak5k6*spbk4k2*spbk6k1-(t31*t19/t26*spak2k6*spak5k6*&
      &spbk4k2*spbk6k1+t31*t19/t26*spak2k5*spak5k6*spbk4k2*spbk5k1+t31/t14*t9*sp&
      &bk4k3*spbk5k1+t31*t12/t14*spbk4k3*spbk6k1+t3/t5+t4/t26+t2/t26+t1/t5)))
      rat2d52 = 0
      rat2 = rat2 + rat2d52
      abb52n11 = abb52n1
      abb52n12 = -(abb52n2)
      abb52n13 = -(abb52n3)
      abb52n14 = -(abb52n4)
      abb52n15 = -(abb52n5)
      abb52n16 = -(abb52n6)
      abb52n17 = -(abb52n7)
      abb52n18 = -(abb52n8)
      abb52n19 = -(abb52n9)
   end subroutine
end module p0_dd_emnebardu_abbrevd52h0
