module     p0_dd_emnebardu_d3h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p0_dd_emnebardu/helicity0/d3h0l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d3
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd3h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      real(ki) :: t36
      real(ki) :: t37
      real(ki) :: t38
      real(ki) :: t39
      real(ki) :: t40
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t36 = dotproduct(qshift, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t37 = dotproduct(k6, qshift)
      t38 = dotproduct(k5, qshift)
      t39 = dotproduct(k1, qshift)
      t2 = (spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1k2(3)*qshift(3)-sp&
      &vak1k2(4)*qshift(4))
      t3 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t40 = dotproduct(k2, qshift)
      t4 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t5 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-sp&
      &vak3k2(4)*qshift(4))
      t6 = (spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-sp&
      &vak6k2(4)*qshift(4))
      t7 = (spvak6k4(1)*qshift(1)-spvak6k4(2)*qshift(2)-spvak6k4(3)*qshift(3)-sp&
      &vak6k4(4)*qshift(4))
      t8 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb3n33+t1*abb3n52+t2*abb3n60+t3*abb3n66+t36*abb3n40+t37*a&
         &bb3n53+t38*abb3n54+t39*abb3n55+t4*abb3n68+t40*abb3n67+t1*t3*abb3n49+t1&
         &*t36*abb3n58+t1*t40*abb3n46+t1*t6*abb3n50+t1*t8*abb3n51+t2*t4*abb3n44+&
         &t3*t36*abb3n61+t3*t38*abb3n45+t3*t39*abb3n43+t3*t4*abb3n36+t3*t40*abb3&
         &n43+t36*t5*abb3n63+t36*t7*abb3n56+t37*t4*abb3n38+t38*t5*abb3n41+t38*t7&
         &*abb3n47+t39*t5*abb3n42+t39*t7*abb3n48+t4*t40*abb3n39+t4*t5*abb3n34+t4&
         &*t6*abb3n35+t4*t7*abb3n37+t40*t5*abb3n42+t40*t7*abb3n48+t1*t4*t6*abb3n&
         &69)
         return
      end if
      t9 = k1(iv1)
      t10 = k2(iv1)
      t11 = k5(iv1)
      t12 = k6(iv1)
      t13 = qshift(iv1)
      t14 = spvak1k2(iv1)
      t15 = spvak3k4(iv1)
      t16 = spvak5k1(iv1)
      t17 = spvak5k2(iv1)
      t18 = spvak3k2(iv1)
      t19 = t18*abb3n42
      t20 = t17*abb3n43
      t21 = spvak6k1(iv1)
      t22 = spvak6k2(iv1)
      t23 = spvak6k4(iv1)
      t24 = t23*abb3n48
      if(deg.eq.1) then
         numerator = (t10*abb3n67+t11*abb3n54+t12*abb3n53+t13*abb3n65+t14*abb3n6&
         &0+t15*abb3n52+t16*abb3n68+t17*abb3n66+t19*t39+t19*t40+t20*t39+t20*t40+&
         &t24*t39+t24*t40+t9*abb3n55+t1*t10*abb3n46+t1*t13*abb3n59+t1*t17*abb3n4&
         &9+t1*t21*abb3n51+t1*t22*abb3n50+t10*t3*abb3n43+t10*t4*abb3n39+t10*t5*a&
         &bb3n42+t10*t7*abb3n48+t11*t3*abb3n45+t11*t5*abb3n41+t11*t7*abb3n47+t12&
         &*t4*abb3n38+t13*t3*abb3n62+t13*t5*abb3n64+t13*t7*abb3n57+t14*t4*abb3n4&
         &4+t15*t3*abb3n49+t15*t36*abb3n58+t15*t40*abb3n46+t15*t6*abb3n50+t15*t8&
         &*abb3n51+t16*t2*abb3n44+t16*t3*abb3n36+t16*t37*abb3n38+t16*t40*abb3n39&
         &+t16*t5*abb3n34+t16*t6*abb3n35+t16*t7*abb3n37+t17*t36*abb3n61+t17*t38*&
         &abb3n45+t17*t4*abb3n36+t18*t36*abb3n63+t18*t38*abb3n41+t18*t4*abb3n34+&
         &t22*t4*abb3n35+t23*t36*abb3n56+t23*t38*abb3n47+t23*t4*abb3n37+t3*t9*ab&
         &b3n43+t5*t9*abb3n42+t7*t9*abb3n48+t1*t16*t6*abb3n69+t1*t22*t4*abb3n69+&
         &t15*t4*t6*abb3n69)
         return
      end if
      t36 = d(iv1,iv2)
      t2 = spvak3k2(iv2)
      t8 = spvak5k2(iv2)
      t19 = spvak6k4(iv2)
      t20 = k1(iv2)
      t24 = spvak3k4(iv2)
      t25 = spvak5k1(iv2)
      t26 = k2(iv2)
      t27 = k5(iv2)
      t28 = qshift(iv2)
      t29 = spvak6k2(iv2)
      t30 = t15*t29
      t31 = t22*t24
      t32 = t16*t29
      t33 = t22*t25
      t34 = t15*t25
      t35 = t16*t24
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t36*abb3n40+t1*t36*abb3n58+t3*t36*abb3n61+t36*t5&
         &*abb3n63+t36*t7*abb3n56)+t30*abb3n50+t31*abb3n50+t32*abb3n35+t33*abb3n&
         &35+k6(iv2)*t16*abb3n38+spvak1k2(iv2)*t16*abb3n44+spvak6k1(iv2)*t15*abb&
         &3n51+t1*t32*abb3n69+t1*t33*abb3n69+t10*t19*abb3n48+t10*t2*abb3n42+t10*&
         &t24*abb3n46+t10*t25*abb3n39+t10*t8*abb3n43+t11*t19*abb3n47+t11*t2*abb3&
         &n41+t11*t8*abb3n45+t12*t25*abb3n38+t13*t19*abb3n57+t13*t2*abb3n64+t13*&
         &t24*abb3n59+t13*t8*abb3n62+t14*t25*abb3n44+t15*t26*abb3n46+t15*t28*abb&
         &3n59+t15*t8*abb3n49+t16*t19*abb3n37+t16*t2*abb3n34+t16*t26*abb3n39+t16&
         &*t8*abb3n36+t17*t20*abb3n43+t17*t24*abb3n49+t17*t25*abb3n36+t17*t26*ab&
         &b3n43+t17*t27*abb3n45+t17*t28*abb3n62+t18*t20*abb3n42+t18*t25*abb3n34+&
         &t18*t26*abb3n42+t18*t27*abb3n41+t18*t28*abb3n64+t19*t9*abb3n48+t2*t9*a&
         &bb3n42+t20*t23*abb3n48+t21*t24*abb3n51+t23*t25*abb3n37+t23*t26*abb3n48&
         &+t23*t27*abb3n47+t23*t28*abb3n57+t30*t4*abb3n69+t31*t4*abb3n69+t34*t6*&
         &abb3n69+t35*t6*abb3n69+t8*t9*abb3n43)
         return
      end if
      t37 = d(iv2,iv3)
      t38 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t3 = spvak6k2(iv3)
      t4 = spvak5k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k2(iv3)*t36*abb3n63+spvak5k2(iv3)*t36*abb3&
         &n61+spvak6k4(iv3)*t36*abb3n56+t1*t36*abb3n58+t15*t37*abb3n58+t17*t37*a&
         &bb3n61+t18*t37*abb3n63+t19*t38*abb3n56+t2*t38*abb3n63+t23*t37*abb3n56+&
         &t24*t38*abb3n58+t38*t8*abb3n61)+t3*t34*abb3n69+t3*t35*abb3n69+t1*t16*t&
         &29*abb3n69+t1*t22*t25*abb3n69+t15*t29*t4*abb3n69+t22*t24*t4*abb3n69)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d3:
   subroutine     reconstruct_d3(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_3:
      coeffs%coeffs_3%c0 = derivative(czip)
      coeffs%coeffs_3%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_3%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_3%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_3%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_3%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_3%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_3%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_3%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_3%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_3%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_3%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_3%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_3%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_3%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_3%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_3%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_3%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_3%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_3%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_3%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_3%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_3%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_3%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_3%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_3%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_3%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_3%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_3%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_3%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_3%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_3%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_3:
   end subroutine reconstruct_d3
!---#] subroutine reconstruct_d3:
end module p0_dd_emnebardu_d3h0l1d
