module     p0_dd_emnebardu_d5h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p0_dd_emnebardu/helicity0/d5h0l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d5
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd5h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      real(ki) :: t36
      real(ki) :: t37
      real(ki) :: t38
      real(ki) :: t39
      real(ki) :: t40
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3+k2-k6-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t36 = dotproduct(qshift, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t37 = dotproduct(k5, qshift)
      t38 = dotproduct(k2, qshift)
      t39 = dotproduct(k6, qshift)
      t2 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t3 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t40 = dotproduct(k1, qshift)
      t4 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t7 = (spvak6k4(1)*qshift(1)-spvak6k4(2)*qshift(2)-spvak6k4(3)*qshift(3)-sp&
      &vak6k4(4)*qshift(4))
      t8 = (spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-sp&
      &vak6k2(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb5n33+t1*abb5n64+t2*abb5n80+t3*abb5n81+t36*abb5n45+t37*a&
         &bb5n65+t38*abb5n66+t39*abb5n69+t4*abb5n87+t40*abb5n82+t1*t3*abb5n59+t1&
         &*t36*abb5n77+t1*t40*abb5n52+t1*t6*abb5n60+t1*t8*abb5n57+t2*t3*abb5n37+&
         &t2*t39*abb5n48+t2*t4*abb5n42+t2*t40*abb5n47+t2*t5*abb5n35+t2*t6*abb5n3&
         &6+t2*t7*abb5n46+t3*t36*abb5n90+t3*t37*abb5n41+t3*t38*abb5n43+t3*t40*ab&
         &b5n43+t36*t5*abb5n95+t36*t7*abb5n73+t37*t5*abb5n40+t37*t7*abb5n54+t38*&
         &t5*abb5n38+t38*t7*abb5n56+t40*t5*abb5n38+t40*t7*abb5n56+t1*t2*t6*abb5n&
         &101)
         return
      end if
      t9 = k1(iv1)
      t10 = k2(iv1)
      t11 = k5(iv1)
      t12 = k6(iv1)
      t13 = qshift(iv1)
      t14 = spvak2k1(iv1)
      t15 = spvak3k4(iv1)
      t16 = spvak5k1(iv1)
      t17 = spvak5k2(iv1)
      t18 = spvak3k1(iv1)
      t19 = t18*abb5n97
      t20 = t16*abb5n88
      t21 = spvak6k1(iv1)
      t22 = spvak6k2(iv1)
      t23 = spvak6k4(iv1)
      t24 = t23*abb5n71
      if(deg.eq.1) then
         numerator = (t10*abb5n61+t11*abb5n62+t12*abb5n58+t13*abb5n86+t14*abb5n4&
         &4+t15*abb5n63+t16*abb5n50+t17*abb5n51+t19*t38+t19*t40+t20*t38+t20*t40+&
         &t24*t38+t24*t40+t9*abb5n49+t1*t13*abb5n76+t1*t16*abb5n68+t1*t21*abb5n6&
         &7+t1*t22*abb5n70+t1*t9*abb5n79+t10*t3*abb5n88+t10*t5*abb5n97+t10*t7*ab&
         &b5n71+t11*t3*abb5n92+t11*t5*abb5n93+t11*t7*abb5n75+t12*t2*abb5n83+t13*&
         &t3*abb5n89+t13*t5*abb5n94+t13*t7*abb5n72+t14*t2*abb5n90+t15*t3*abb5n68&
         &+t15*t36*abb5n53+t15*t40*abb5n79+t15*t6*abb5n67+t15*t8*abb5n70+t16*t2*&
         &abb5n98+t16*t36*abb5n42+t16*t37*abb5n92+t17*t3*abb5n98+t17*t39*abb5n83&
         &+t17*t4*abb5n90+t17*t40*abb5n84+t17*t5*abb5n100+t17*t6*abb5n99+t17*t7*&
         &abb5n85+t18*t2*abb5n100+t18*t36*abb5n39+t18*t37*abb5n93+t2*t21*abb5n99&
         &+t2*t23*abb5n85+t2*t9*abb5n84+t23*t36*abb5n55+t23*t37*abb5n75+t3*t9*ab&
         &b5n88+t5*t9*abb5n97+t7*t9*abb5n71+t1*t17*t6*abb5n34+t1*t2*t21*abb5n34+&
         &t15*t2*t6*abb5n34)
         return
      end if
      t36 = d(iv1,iv2)
      t4 = spvak3k1(iv2)
      t8 = spvak3k4(iv2)
      t19 = spvak5k1(iv2)
      t20 = spvak5k2(iv2)
      t24 = spvak6k4(iv2)
      t25 = k1(iv2)
      t26 = k2(iv2)
      t27 = k5(iv2)
      t28 = qshift(iv2)
      t29 = spvak6k1(iv2)
      t30 = t15*t29
      t31 = t21*t8
      t32 = t17*t29
      t33 = t20*t21
      t34 = t15*t20
      t35 = t17*t8
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t36*abb5n45+t1*t36*abb5n77+t3*t36*abb5n90+t36*t5&
         &*abb5n95+t36*t7*abb5n73)+t30*abb5n60+t31*abb5n60+t32*abb5n36+t33*abb5n&
         &36+k6(iv2)*t17*abb5n48+spvak2k1(iv2)*t17*abb5n42+spvak6k2(iv2)*t15*abb&
         &5n57+t1*t32*abb5n101+t1*t33*abb5n101+t10*t19*abb5n43+t10*t24*abb5n56+t&
         &10*t4*abb5n38+t11*t19*abb5n41+t11*t24*abb5n54+t11*t4*abb5n40+t12*t20*a&
         &bb5n48+t13*t19*abb5n91+t13*t24*abb5n74+t13*t4*abb5n96+t13*t8*abb5n78+t&
         &14*t20*abb5n42+t15*t19*abb5n59+t15*t25*abb5n52+t15*t28*abb5n78+t16*t20&
         &*abb5n37+t16*t25*abb5n43+t16*t26*abb5n43+t16*t27*abb5n41+t16*t28*abb5n&
         &91+t16*t8*abb5n59+t17*t19*abb5n37+t17*t24*abb5n46+t17*t25*abb5n47+t17*&
         &t4*abb5n35+t18*t20*abb5n35+t18*t25*abb5n38+t18*t26*abb5n38+t18*t27*abb&
         &5n40+t18*t28*abb5n96+t19*t9*abb5n43+t2*t30*abb5n101+t2*t31*abb5n101+t2&
         &0*t23*abb5n46+t20*t9*abb5n47+t22*t8*abb5n57+t23*t25*abb5n56+t23*t26*ab&
         &b5n56+t23*t27*abb5n54+t23*t28*abb5n74+t24*t9*abb5n56+t34*t6*abb5n101+t&
         &35*t6*abb5n101+t4*t9*abb5n38+t8*t9*abb5n52)
         return
      end if
      t37 = d(iv2,iv3)
      t38 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t2 = spvak6k1(iv3)
      t3 = spvak5k2(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k1(iv3)*t36*abb5n39+spvak5k1(iv3)*t36*abb5&
         &n42+spvak6k4(iv3)*t36*abb5n55+t1*t36*abb5n53+t15*t37*abb5n53+t16*t37*a&
         &bb5n42+t18*t37*abb5n39+t19*t38*abb5n42+t23*t37*abb5n55+t24*t38*abb5n55&
         &+t38*t4*abb5n39+t38*t8*abb5n53)+t2*t34*abb5n34+t2*t35*abb5n34+t1*t17*t&
         &29*abb5n34+t1*t20*t21*abb5n34+t15*t29*t3*abb5n34+t21*t3*t8*abb5n34)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d5:
   subroutine     reconstruct_d5(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group6
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group6), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_5:
      coeffs%coeffs_5%c0 = derivative(czip)
      coeffs%coeffs_5%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_5%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_5%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_5%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_5%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_5%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_5%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_5%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_5%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_5%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_5%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_5%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_5%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_5%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_5%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_5%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_5%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_5%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_5%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_5%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_5%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_5%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_5%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_5%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_5%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_5%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_5%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_5%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_5%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_5%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_5%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_5%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_5%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_5%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_5:
   end subroutine reconstruct_d5
!---#] subroutine reconstruct_d5:
end module p0_dd_emnebardu_d5h0l1d
