module     p17_ddbar_neepdubar_abbrevd13h0
   use p17_ddbar_neepdubar_config, only: ki
   use p17_ddbar_neepdubar_globalsh0
   implicit none
   private
   complex(ki), public :: abb13n1
   complex(ki), public :: abb13n2
   complex(ki), public :: abb13n3
   complex(ki), public :: abb13n4
   complex(ki), public :: abb13n5
   complex(ki), public :: abb13n6
   complex(ki), public :: abb13n7
   complex(ki), public :: abb13n8
   complex(ki), public :: abb13n9
   complex(ki), public :: abb13n10
   complex(ki), public :: abb13n11
   complex(ki), public :: abb13n12
   complex(ki), public :: abb13n13
   complex(ki), public :: abb13n14
   complex(ki), public :: abb13n15
   complex(ki), public :: rat2d13
   complex(ki), public :: abb13n17
   complex(ki), public :: abb13n18
   complex(ki), public :: abb13n19
   complex(ki), public :: abb13n20
   complex(ki), public :: abb13n21
   complex(ki), public :: abb13n22
   complex(ki), public :: abb13n23
   complex(ki), public :: abb13n24
   complex(ki), public :: abb13n25
   complex(ki), public :: abb13n26
   complex(ki), public :: abb13n27
   complex(ki), public :: abb13n28
   complex(ki), public :: abb13n29
   complex(ki), public :: abb13n30
   complex(ki), public :: abb13n31
   complex(ki), public :: abb13n32
   complex(ki), public :: abb13n33
   complex(ki), public :: abb13n34
   complex(ki), public :: abb13n35
   complex(ki), public :: abb13n36
   complex(ki), public :: abb13n37
   complex(ki), public :: abb13n38
   complex(ki), public :: abb13n39
   complex(ki), public :: abb13n40
   complex(ki), public :: abb13n41
   complex(ki), public :: abb13n42
   complex(ki), public :: abb13n43
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   real(ki) :: t39
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p17_ddbar_neepdubar_config, only: deltaOS
      use p17_ddbar_neepdubar_kinematics
      use p17_ddbar_neepdubar_model
      use p17_ddbar_neepdubar_color, only: TR
      use p17_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = c1*i_
      t2 = t1*spak1k5
      t3 = t2*spak3k4
      t39 = TR*TR
      t4 = t39*t3*spbk4k2*spbk6k4
      t5 = (es12+es34-(es56+es345))*(es34+wW*mW*i_-mW*mW)
      t6 = es12*t5
      t7 = t4/t6
      t8 = t2*spak3k6
      t9 = t39*t8*spbk6k2*spbk6k4
      t10 = t9/t6
      t11 = -(t7+t10)
      t12 = NC*NC*t6
      t4 = t4/t12
      t9 = t9/t12
      t13 = c2*i_
      t14 = t13*spak1k5
      t15 = t14*spak3k4
      t5 = es12*NC*t5
      t16 = t39*t15/t5*spbk4k2*spbk6k4
      t14 = t14*spak3k6
      t17 = t39*t14/t5*spbk6k2*spbk6k4
      t18 = NC*c2
      t19 = t18*i_
      t20 = t19*spak1k5
      t21 = t20*spak3k4
      t22 = t39*t21/t6*spbk4k2*spbk6k4
      t23 = t20*spak3k6
      t24 = t39*t23/t6*spbk6k2*spbk6k4
      abb13n1 = ((2.0_ki)*(t11+t22+t24+t4+t9-(t17+t16)))
      t25 = es56*c1*i_*spak1k5
      t26 = es56*t18*i_*spak1k5
      t27 = es234*c1*i_*spak1k5
      t28 = es34*c1*i_*spak1k5
      t29 = es345*c1*i_*spak1k5
      t30 = es61*c1*i_*spak1k5
      t31 = t1*spak3k4
      t32 = TR*spak1k5
      t32 = t32*t32
      t33 = t1*spak3k6
      t34 = es234*t18*i_*spak1k5
      t35 = es34*t18*i_*spak1k5
      t36 = es345*t18*i_*spak1k5
      t18 = es61*t18*i_*spak1k5
      t37 = t19*spak3k4
      t38 = t19*spak3k6
      abb13n2 = ((4.0_ki)*(t39*t25/t6*spak3k4*spbk4k2*spbk6k4+t39*t25/t6*spak3k6&
      &*spbk6k2*spbk6k4-(t39*t26/t6*spak3k6*spbk6k2*spbk6k4+t39*t26/t6*spak3k4*s&
      &pbk4k2*spbk6k4))+(2.0_ki)*(t39*t29/t6*spak3k4*spbk4k2*spbk6k4+t39*t29/t6*&
      &spak3k6*spbk6k2*spbk6k4+t39*t30/t6*spak3k4*spbk4k2*spbk6k4+t39*t30/t6*spa&
      &k3k6*spbk6k2*spbk6k4+t32*t37/t6*spbk4k1*spbk5k2*spbk6k4+t32*t38/t6*spbk5k&
      &2*spbk6k1*spbk6k4+t39*t34/t6*spak3k4*spbk4k2*spbk6k4+t39*t34/t6*spak3k6*s&
      &pbk6k2*spbk6k4+t39*t35/t6*spak3k4*spbk4k2*spbk6k4+t39*t35/t6*spak3k6*spbk&
      &6k2*spbk6k4-(t39*t36/t6*spak3k6*spbk6k2*spbk6k4+t39*t36/t6*spak3k4*spbk4k&
      &2*spbk6k4+t32*t33/t6*spbk5k2*spbk6k1*spbk6k4+t31*t32/t6*spbk4k1*spbk5k2*s&
      &pbk6k4+t39*t28/t6*spak3k6*spbk6k2*spbk6k4+t39*t28/t6*spak3k4*spbk4k2*spbk&
      &6k4+t39*t27/t6*spak3k6*spbk6k2*spbk6k4+t39*t27/t6*spak3k4*spbk4k2*spbk6k4&
      &+t39*t18/t6*spak3k6*spbk6k2*spbk6k4+t39*t18/t6*spak3k4*spbk4k2*spbk6k4)))
      t18 = t1*spak1k3*spak1k5*spbk2k1
      t25 = t19*spak1k3*spak1k5*spbk2k1
      t26 = t2*spak3k5
      t27 = t26*spbk5k2
      t28 = t20*spak3k5
      t29 = t28*spbk5k2
      abb13n3 = ((12.0_ki)*(t39*t18/t6*spbk6k4-t39*t25/t6*spbk6k4)+(4.0_ki)*(t39&
      &*t27/t6*spbk6k4-t39*t29/t6*spbk6k4))
      abb13n4 = ((6.0_ki)*(t39*t25/t6*spbk6k3+t39*t19/t6*spak1k4*spak1k5*spbk2k1&
      &*spbk6k4-(t39*t1/t6*spak1k4*spak1k5*spbk2k1*spbk6k4+t39*t18/t6*spbk6k3))+&
      &(2.0_ki)*(t39*t29/t6*spbk6k3+t39*t20/t6*spak4k5*spbk5k2*spbk6k4-(t39*t2/t&
      &6*spak4k5*spbk5k2*spbk6k4+t39*t27/t6*spbk6k3)))
      abb13n5 = ((6.0_ki)*(t39*t18/t6*spbk4k3+t39*t20/t6*spak1k6*spbk2k1*spbk6k4&
      &-(t39*t2/t6*spak1k6*spbk2k1*spbk6k4+t39*t25/t6*spbk4k3))+(2.0_ki)*(t39*t2&
      &6/t6*spbk4k3*spbk5k2+t39*t2/t6*spak5k6*spbk5k2*spbk6k4-(t39*t20/t6*spak5k&
      &6*spbk5k2*spbk6k4+t39*t28/t6*spbk4k3*spbk5k2)))
      t2 = t10+t7
      abb13n6 = ((4.0_ki)*(t2-(t24+t22)))
      t7 = t1*spak1k2
      t10 = t13*spak1k2
      abb13n7 = ((4.0_ki)*(t39/t12*t7*spak3k4*spbk4k2*spbk6k4+t39/t12*t7*spak3k6&
      &*spbk6k2*spbk6k4-(t39*t10/t5*spak3k6*spbk6k2*spbk6k4+t39*t10/t5*spak3k4*s&
      &pbk4k2*spbk6k4)))
      abb13n8 = ((4.0_ki)*(t16+t17+t2-(t9+t4+t24+t22)))
      abb13n9 = ((4.0_ki)*(t11+t22+t24)+(8.0_ki)*(t16+t17-(t9+t4)))
      t2 = t39*t3*spbk4k1*spbk6k4
      t3 = t39*t8*spbk6k1*spbk6k4
      t4 = t1*spak2k5
      t7 = t39*t4*spak3k4*spbk4k2*spbk6k4
      t4 = t39*t4*spak3k6*spbk6k2*spbk6k4
      t8 = t13*spak2k5
      t9 = t19*spak2k5
      abb13n10 = ((4.0_ki)*(t2/t12+t3/t12+t4/t12+t7/t12+t2/t6+t3/t6+t4/t6+t7/t6-&
      &(t39/t6*t9*spak3k6*spbk6k2*spbk6k4+t39/t6*t9*spak3k4*spbk4k2*spbk6k4+t39/&
      &t5*t8*spak3k6*spbk6k2*spbk6k4+t39/t5*t8*spak3k4*spbk4k2*spbk6k4+t39*t23/t&
      &6*spbk6k1*spbk6k4+t39*t21/t6*spbk4k1*spbk6k4+t39*t15/t5*spbk4k1*spbk6k4+t&
      &39*t14/t5*spbk6k1*spbk6k4)))
      t2 = t39*t31*spbk6k4
      abb13n11 = ((4.0_ki)*(t39*t37/t6*spbk6k4+t39*t13/t5*spak3k4*spbk6k4-(t2/t6&
      &+t2/t12)))
      t2 = t1*spak3k5
      t3 = t39*t2*spbk6k4
      t4 = t13*spak3k5
      t7 = t19*spak3k5
      abb13n12 = ((16.0_ki)*(t3/t12+t3/t6-(t39/t6*t7*spbk6k4+t39*t4/t5*spbk6k4))&
      &)
      t3 = t39*t33*spbk6k4
      abb13n13 = ((4.0_ki)*(t39*t38/t6*spbk6k4+t39*t13/t5*spak3k6*spbk6k4-(t3/t6&
      &+t3/t12)))
      t3 = t39*t2*spbk6k3
      t8 = t39*t1*spak4k5*spbk6k4
      abb13n14 = ((8.0_ki)*(t39*t4/t5*spbk6k3+t39/t6*t7*spbk6k3+t39*t13/t5*spak4&
      &k5*spbk6k4+t39*t19/t6*spak4k5*spbk6k4-(t8/t6+t3/t6+t8/t12+t3/t12)))
      t2 = t39*t2*spbk4k3
      t1 = t39*t1*spak5k6*spbk6k4
      abb13n15 = ((8.0_ki)*(t1/t12+t1/t6+t2/t12+t2/t6-(t39*t19/t6*spak5k6*spbk6k&
      &4+t39*t13/t5*spak5k6*spbk6k4+t39/t6*t7*spbk4k3+t39*t4/t5*spbk4k3)))
      rat2d13 = abb13n1
      rat2 = rat2 + rat2d13
      abb13n17 = abb13n2
      abb13n18 = abb13n15
      abb13n19 = abb13n14
      abb13n20 = abb13n13
      abb13n21 = abb13n12
      abb13n22 = abb13n11
      abb13n23 = abb13n10
      abb13n24 = abb13n9
      abb13n25 = abb13n8
      abb13n26 = abb13n7
      abb13n27 = abb13n6
      abb13n28 = abb13n5
      abb13n29 = abb13n4
      abb13n30 = abb13n3
      abb13n31 = -(abb13n3)
      abb13n32 = -(abb13n4)
      abb13n33 = -(abb13n5)
      abb13n34 = -(abb13n6)
      abb13n35 = -(abb13n7)
      abb13n36 = (-2.0_ki)*abb13n8
      abb13n37 = -(abb13n9)
      abb13n38 = -(abb13n10)
      abb13n39 = -(abb13n11)
      abb13n40 = -(abb13n12)
      abb13n41 = -(abb13n13)
      abb13n42 = -(abb13n14)
      abb13n43 = -(abb13n15)
   end subroutine
end module p17_ddbar_neepdubar_abbrevd13h0
