module     p17_ddbar_neepdubar_abbrevd65h0
   use p17_ddbar_neepdubar_config, only: ki
   use p17_ddbar_neepdubar_globalsh0
   implicit none
   private
   complex(ki), public :: abb65n1
   complex(ki), public :: abb65n2
   complex(ki), public :: abb65n3
   complex(ki), public :: abb65n4
   complex(ki), public :: abb65n5
   complex(ki), public :: abb65n6
   complex(ki), public :: abb65n7
   complex(ki), public :: abb65n8
   complex(ki), public :: abb65n9
   complex(ki), public :: abb65n10
   complex(ki), public :: rat2d65
   complex(ki), public :: abb65n12
   complex(ki), public :: abb65n13
   complex(ki), public :: abb65n14
   complex(ki), public :: abb65n15
   complex(ki), public :: abb65n16
   complex(ki), public :: abb65n17
   complex(ki), public :: abb65n18
   complex(ki), public :: abb65n19
   complex(ki), public :: abb65n20
   complex(ki), public :: abb65n21
   complex(ki), public :: abb65n22
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   real(ki) :: t13
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p17_ddbar_neepdubar_config, only: deltaOS
      use p17_ddbar_neepdubar_kinematics
      use p17_ddbar_neepdubar_model
      use p17_ddbar_neepdubar_color, only: TR
      use p17_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = c1*i_
      t2 = t1*spak1k5
      t3 = t2*spak3k6
      t13 = TR*TR
      t4 = t13*t3*spbk5k2*spbk6k4
      t5 = (es12+es34-(es56+es345))*(es34+wW*mW*i_-mW*mW)
      t6 = NC*NC*t5
      t7 = c2*i_
      t8 = t7*spak1k5
      t9 = t8*spak3k6
      t10 = NC*t5
      abb65n1 = ((4.0_ki)*(t4/t5+t4/t6-t13*(2.0_ki)/t10*t9*spbk5k2*spbk6k4))
      t4 = t2*spak3k4
      t11 = t13*t4*spbk5k2*spbk6k4
      t12 = t8*spak3k4
      abb65n2 = ((4.0_ki)*(t11/t5+t11/t6-t13*(2.0_ki)/t10*t12*spbk5k2*spbk6k4))
      t4 = t13*t4*spbk4k2*spbk6k4
      t3 = t13*t3*spbk6k2*spbk6k4
      abb65n3 = ((8.0_ki)*(-(t13/t10*t9*spbk6k2*spbk6k4+t13*t12/t10*spbk4k2*spbk&
      &6k4))+(4.0_ki)*(t3/t5+t3/t6+t4/t5+t4/t6))
      t3 = t13*t2*spbk4k3
      abb65n4 = ((4.0_ki)*(t13*(2.0_ki)/t10*t8*spbk4k3-(t3/t6+t3/t5)))
      t3 = t13*t2*spbk6k3
      abb65n5 = ((4.0_ki)*(t3/t5+t3/t6-t13*(2.0_ki)/t10*t8*spbk6k3))
      t2 = t13*t2*spbk6k4
      t3 = t2/t5
      t2 = t2/t6
      t4 = t13*(2.0_ki)/t10*t8*spbk6k4
      abb65n6 = ((4.0_ki)*(t2+t3-t4))
      abb65n7 = ((8.0_ki)*(t4-(t3+t2)))
      t2 = t1*spak3k5
      t3 = t13*t2*spbk6k4
      t4 = t7*spak3k5
      abb65n8 = ((8.0_ki)*(t3/t5+t3/t6-t13*(2.0_ki)/t10*t4*spbk6k4))
      t3 = t13*t2*spbk6k3
      t8 = t13*t1*spak4k5*spbk6k4
      abb65n9 = ((8.0_ki)*(t13/t10*t4*spbk6k3+t13/t10*t7*spak4k5*spbk6k4)+(4.0_k&
      &i)*(-(t8/t6+t8/t5+t3/t6+t3/t5)))
      t2 = t13*t2*spbk4k3
      t1 = t13*t1*spak5k6*spbk6k4
      abb65n10 = ((8.0_ki)*(-(t13/t10*t7*spak5k6*spbk6k4+t13/t10*t4*spbk4k3))+(4&
      &.0_ki)*(t1/t5+t1/t6+t2/t5+t2/t6))
      rat2d65 = 0
      rat2 = rat2 + rat2d65
      abb65n12 = -(abb65n1)
      abb65n13 = abb65n10
      abb65n14 = abb65n9
      abb65n15 = abb65n8
      abb65n16 = abb65n7
      abb65n17 = abb65n6
      abb65n18 = abb65n5
      abb65n19 = abb65n4
      abb65n20 = abb65n3
      abb65n21 = -(abb65n2)
      abb65n22 = ((2.0_ki)*abb65n3)
   end subroutine
end module p17_ddbar_neepdubar_abbrevd65h0
