module     p17_ddbar_neepdubar_d55h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p17_ddbar_neepdubar/helicity1/d55h1l1d.f90
   ! generator: haggies (1.1)
   use p17_ddbar_neepdubar_config, only: ki
   use p17_ddbar_neepdubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d55
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p17_ddbar_neepdubar_globalsl1, only: epspow
      use p17_ddbar_neepdubar_kinematics
      use p17_ddbar_neepdubar_abbrevd55h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      real(ki) :: t33
      real(ki) :: t34
      real(ki) :: t35
      real(ki) :: t36
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t33 = dotproduct(k5, qshift)
      t2 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t3 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t4 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t34 = dotproduct(k2, qshift)
      t5 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t6 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t7 = (spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5k4(3)*qshift(3)-sp&
      &vak5k4(4)*qshift(4))
      t8 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t9 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t35 = dotproduct(k6, qshift)
      t10 = (spvak1k6(1)*qshift(1)-spvak1k6(2)*qshift(2)-spvak1k6(3)*qshift(3)-s&
      &pvak1k6(4)*qshift(4))
      t36 = dotproduct(qshift, qshift)
      if(deg.eq.0) then
         numerator = (t1*abb55n21+t33*abb55n48+t1*t10*abb55n39+t1*t2*abb55n23+t1&
         &*t34*abb55n27+t1*t36*abb55n57+t1*t4*abb55n25+t1*t5*abb55n28+t1*t6*abb5&
         &5n29+t1*t8*abb55n31+t3*t33*abb55n24+t3*t7*abb55n30+t33*t8*abb55n38+t34&
         &*t7*abb55n35+t35*t7*abb55n37+t36*t7*abb55n45+t5*t9*abb55n33+t7*t8*abb5&
         &5n32+t3*t5*t9*abb55n62)
         return
      end if
      t11 = k5(iv1)
      t12 = spvak5k1(iv1)
      t13 = k2(iv1)
      t14 = k6(iv1)
      t15 = qshift(iv1)
      t16 = spvak1k6(iv1)
      t17 = spvak2k1(iv1)
      t18 = spvak2k4(iv1)
      t19 = spvak2k5(iv1)
      t20 = spvak2k6(iv1)
      t21 = spvak3k4(iv1)
      t22 = spvak3k6(iv1)
      t23 = spvak5k4(iv1)
      t24 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (t11*abb55n34+t12*abb55n40+t1*t13*abb55n55+t1*t15*abb55n56+&
         &t1*t16*abb55n41+t1*t18*abb55n53+t1*t19*abb55n61+t1*t20*abb55n51+t1*t22&
         &*abb55n59+t1*t24*abb55n54+t10*t12*abb55n41+t11*t3*abb55n60+t11*t8*abb5&
         &5n42+t12*t2*abb55n61+t12*t34*abb55n55+t12*t36*abb55n26+t12*t4*abb55n59&
         &+t12*t5*abb55n54+t12*t6*abb55n53+t12*t8*abb55n51+t13*t7*abb55n47+t14*t&
         &7*abb55n43+t15*t7*abb55n44+t17*t33*abb55n60+t17*t7*abb55n52+t20*t33*ab&
         &b55n42+t20*t7*abb55n50+t21*t5*abb55n49+t23*t3*abb55n52+t23*t34*abb55n4&
         &7+t23*t35*abb55n43+t23*t36*abb55n36+t23*t8*abb55n50+t24*t9*abb55n49+t1&
         &7*t5*t9*abb55n22+t21*t3*t5*abb55n22+t24*t3*t9*abb55n22)
         return
      end if
      t33 = d(iv1,iv2)
      t2 = spvak5k1(iv2)
      t4 = spvak5k4(iv2)
      t6 = k2(iv2)
      t8 = spvak2k1(iv2)
      t10 = spvak2k6(iv2)
      t25 = k5(iv2)
      t26 = qshift(iv2)
      t27 = spvak5k6(iv2)
      t28 = t21*t27
      t29 = spvak3k4(iv2)
      t30 = t24*t29
      t31 = t17*t29
      t32 = t21*t8
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t1*t33*abb55n57+t33*t7*abb55n45)+t28*abb55n33+t3&
         &0*abb55n33+k6(iv2)*t23*abb55n37+spvak1k6(iv2)*t12*abb55n39+spvak2k4(iv&
         &2)*t12*abb55n29+spvak2k5(iv2)*t12*abb55n23+spvak3k6(iv2)*t12*abb55n25+&
         &t10*t11*abb55n38+t10*t12*abb55n31+t10*t23*abb55n32+t11*t8*abb55n24+t12&
         &*t26*abb55n58+t12*t27*abb55n28+t12*t6*abb55n27+t13*t2*abb55n27+t13*t4*&
         &abb55n35+t14*t4*abb55n37+t15*t2*abb55n58+t15*t4*abb55n46+t16*t2*abb55n&
         &39+t17*t25*abb55n24+t17*t4*abb55n30+t18*t2*abb55n29+t19*t2*abb55n23+t2&
         &*t20*abb55n31+t2*t22*abb55n25+t2*t24*abb55n28+t20*t25*abb55n38+t20*t4*&
         &abb55n32+t23*t26*abb55n46+t23*t6*abb55n35+t23*t8*abb55n30+t28*t3*abb55&
         &n62+t3*t30*abb55n62+t31*t5*abb55n62+t32*t5*abb55n62+t17*t27*t9*abb55n6&
         &2+t24*t8*t9*abb55n62)
         return
      end if
      t34 = d(iv2,iv3)
      t35 = d(iv1,iv3)
      t1 = spvak5k6(iv3)
      t3 = spvak3k4(iv3)
      t5 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak5k1(iv3)*t33*abb55n26+spvak5k4(iv3)*t33*abb&
         &55n36+t12*t34*abb55n26+t2*t35*abb55n26+t23*t34*abb55n36+t35*t4*abb55n3&
         &6)+t1*t31*abb55n22+t1*t32*abb55n22+t17*t27*t3*abb55n22+t21*t27*t5*abb5&
         &5n22+t24*t29*t5*abb55n22+t24*t3*t8*abb55n22)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d55:
   subroutine     reconstruct_d55(coeffs)
      use p17_ddbar_neepdubar_groups, only: tensrec_info_group6
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group6), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_55:
      coeffs%coeffs_55%c0 = derivative(czip)
      coeffs%coeffs_55%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_55%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_55%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_55%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_55%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_55%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_55%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_55%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_55%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_55%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_55%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_55%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_55%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_55%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_55%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_55%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_55%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_55%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_55%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_55%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_55%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_55%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_55%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_55%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_55%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_55%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_55%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_55%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_55%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_55%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_55%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_55%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_55%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_55%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_55:
   end subroutine reconstruct_d55
!---#] subroutine reconstruct_d55:
end module p17_ddbar_neepdubar_d55h1l1d
