module     p24_udbar_neepuubar_abbrevd53h0
   use p24_udbar_neepuubar_config, only: ki
   use p24_udbar_neepuubar_globalsh0
   implicit none
   private
   complex(ki), public :: abb53n1
   complex(ki), public :: abb53n2
   complex(ki), public :: abb53n3
   complex(ki), public :: abb53n4
   complex(ki), public :: abb53n5
   complex(ki), public :: abb53n6
   complex(ki), public :: abb53n7
   complex(ki), public :: abb53n8
   complex(ki), public :: abb53n9
   complex(ki), public :: rat2d53
   complex(ki), public :: abb53n11
   complex(ki), public :: abb53n12
   complex(ki), public :: abb53n13
   complex(ki), public :: abb53n14
   complex(ki), public :: abb53n15
   complex(ki), public :: abb53n16
   complex(ki), public :: abb53n17
   complex(ki), public :: abb53n18
   complex(ki), public :: abb53n19
   complex(ki), public :: abb53n20
   complex(ki), public :: abb53n21
   complex(ki), public :: abb53n22
   complex(ki), public :: abb53n23
   complex(ki), public :: abb53n24
   complex(ki), public :: abb53n25
   complex(ki), public :: abb53n26
   complex(ki), public :: abb53n27
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   real(ki) :: t39
   real(ki) :: t40
   real(ki) :: t41
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p24_udbar_neepuubar_config, only: deltaOS
      use p24_udbar_neepuubar_kinematics
      use p24_udbar_neepuubar_model
      use p24_udbar_neepuubar_color, only: TR
      use p24_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t39 = es34+es56-(es234+es12)
      t2 = es12*c1*i_
      t40 = TR*TR
      t3 = t40*t2*spak2k3*spak2k6*spbk4k1*spbk5k2
      t4 = es56*t1
      t41 = t39*t39
      t5 = t41*t4
      t2 = t40*t2*spak2k6*spak3k6*spbk4k1*spbk6k5
      t6 = es123*c1*i_
      t7 = t40*t6*spak2k3*spak2k6*spbk4k1*spbk5k2
      t6 = t40*t6*spak2k6*spak3k6*spbk4k1*spbk6k5
      t8 = es23*c1*i_
      t9 = t40*t8*spak2k3*spak2k6*spbk4k1*spbk5k2
      t8 = t40*t8*spak2k6*spak3k6*spbk4k1*spbk6k5
      t10 = es34*c1*i_
      t11 = t40*t10*spak2k3*spak2k6*spbk4k1*spbk5k2
      t10 = t40*t10*spak2k6*spak3k6*spbk4k1*spbk6k5
      t12 = c1*i_
      t13 = t12*spak1k2*spak2k6
      t14 = TR*spbk4k1
      t14 = t14*t14
      t15 = t13*t14*spak3k4*spbk5k2
      t16 = t12*spak1k3
      t17 = t14*t16*spak2k4*spak2k6*spbk5k2
      t16 = t16*spak2k6
      t18 = t14*t16*spak4k6*spbk6k5
      t19 = t12*spak1k6*spak2k6
      t20 = t14*t19*spak3k4*spbk6k5
      t39 = t39*NC
      t4 = t39*t39*t4
      t21 = es12*c2*i_
      t1 = es56*NC*t41*t1
      t22 = es123*c2*i_
      t23 = es23*c2*i_
      t24 = es34*c2*i_
      t25 = c2*i_
      t26 = t25*spak1k2*spak2k6
      t27 = t25*spak1k3
      t28 = t27*spak2k6
      t29 = t25*spak1k6*spak2k6
      t30 = NC*c2
      t31 = es12*t30*i_
      t32 = es123*t30*i_
      t33 = es23*t30*i_
      t34 = es34*t30*i_
      t30 = t30*i_
      t35 = t30*spak1k2*spak2k6
      t36 = t30*spak1k3
      t37 = t36*spak2k6
      t38 = t30*spak1k6*spak2k6
      abb53n1 = ((4.0_ki)*(t10/t5+t11/t4+t15/t4+t17/t5+t18/t4+t2/t4+t20/t4+t3/t5&
      &+t7/t4+t8/t4+t6/t5+t9/t5+t14*t35/t5*spak3k4*spbk5k2+t14*t37/t5*spak4k6*sp&
      &bk6k5+t14*t38/t5*spak3k4*spbk6k5+t14/t1*t27*spak2k4*spak2k6*spbk5k2+t40*t&
      &21/t1*spak2k3*spak2k6*spbk4k1*spbk5k2+t40*t22/t1*spak2k6*spak3k6*spbk4k1*&
      &spbk6k5+t40*t23/t1*spak2k3*spak2k6*spbk4k1*spbk5k2+t40*t24/t1*spak2k6*spa&
      &k3k6*spbk4k1*spbk6k5+t40*t31/t5*spak2k6*spak3k6*spbk4k1*spbk6k5+t40*t32/t&
      &5*spak2k3*spak2k6*spbk4k1*spbk5k2+t40*t33/t5*spak2k6*spak3k6*spbk4k1*spbk&
      &6k5+t40*t34/t5*spak2k3*spak2k6*spbk4k1*spbk5k2-(t40*t34/t5*spak2k6*spak3k&
      &6*spbk4k1*spbk6k5+t40*t33/t5*spak2k3*spak2k6*spbk4k1*spbk5k2+t40*t32/t5*s&
      &pak2k6*spak3k6*spbk4k1*spbk6k5+t40*t31/t5*spak2k3*spak2k6*spbk4k1*spbk5k2&
      &+t40*t24/t1*spak2k3*spak2k6*spbk4k1*spbk5k2+t40*t23/t1*spak2k6*spak3k6*sp&
      &bk4k1*spbk6k5+t40*t22/t1*spak2k3*spak2k6*spbk4k1*spbk5k2+t40*t21/t1*spak2&
      &k6*spak3k6*spbk4k1*spbk6k5+t14*t36/t5*spak2k4*spak2k6*spbk5k2+t14/t1*t29*&
      &spak3k4*spbk6k5+t14/t1*t28*spak4k6*spbk6k5+t14/t1*t26*spak3k4*spbk5k2+t8/&
      &t5+t7/t5+t9/t4+t6/t4+t3/t4+t20/t5+t2/t5+t18/t5+t17/t4+t15/t5+t11/t5+t10/t&
      &4)))
      t2 = t16*spbk4k1
      t3 = t40*t2*spbk5k2
      t6 = t28*spbk4k1
      t7 = t37*spbk4k1
      abb53n2 = ((4.0_ki)*(t3/t4+t40/t5*t7*spbk5k2-(t40/t1*t6*spbk5k2+t3/t5)))
      t2 = t40*t2*spbk6k5
      abb53n3 = ((4.0_ki)*(t2/t4+t40/t5*t7*spbk6k5-(t40/t1*t6*spbk6k5+t2/t5)))
      t2 = t12*spak2k6
      t3 = t2*spak3k4*spbk4k1
      t6 = t40*t3*spbk5k2
      t7 = t25*spak2k6
      t8 = t7*spak3k4*spbk4k1
      t9 = t30*spak2k6
      t10 = t9*spak3k4*spbk4k1
      abb53n4 = ((4.0_ki)*(t6/t4+t40*t10/t5*spbk5k2-(t40/t1*t8*spbk5k2+t6/t5)))
      t3 = t40*t3*spbk6k5
      abb53n5 = ((4.0_ki)*(t3/t4+t40*t10/t5*spbk6k5-(t40/t1*t8*spbk6k5+t3/t5)))
      t3 = t12*spak2k3*spak2k6
      t6 = t40*t3*spbk4k1*spbk5k2
      t8 = t6/t5
      t10 = t2*spak3k6
      t11 = t40*t10*spbk4k1*spbk6k5
      t14 = t11/t5
      t6 = t6/t4
      t11 = t11/t4
      t15 = t25*spak2k3*spak2k6
      t16 = t40*t15/t1*spbk4k1*spbk5k2
      t17 = t7*spak3k6
      t18 = t40*t17/t1*spbk4k1*spbk6k5
      t20 = t30*spak2k3*spak2k6
      t21 = t40*t20/t5*spbk4k1*spbk5k2
      t22 = t9*spak3k6
      t23 = t40*t22/t5*spbk4k1*spbk6k5
      abb53n6 = ((16.0_ki)*(t11+t16+t23+t8-(t6+t21+t18+t14)))
      abb53n7 = ((16.0_ki)*(t14+t18+t21+t6-(t8+t23+t16+t11)))
      t6 = t40*t3*spbk3k1*spbk5k2
      t8 = t40*t12*spak2k4*spak2k6*spbk4k1*spbk5k2
      t11 = t40*t10*spbk3k1*spbk6k5
      t2 = t40*t2*spak4k6*spbk4k1*spbk6k5
      abb53n8 = ((8.0_ki)*(t11/t4+t2/t4+t6/t5+t8/t5+t40*t15/t1*spbk3k1*spbk5k2+t&
      &40*t22/t5*spbk3k1*spbk6k5+t40/t5*t9*spak4k6*spbk4k1*spbk6k5+t40*t25/t1*sp&
      &ak2k4*spak2k6*spbk4k1*spbk5k2-(t40*t30/t5*spak2k4*spak2k6*spbk4k1*spbk5k2&
      &+t40/t1*t7*spak4k6*spbk4k1*spbk6k5+t40*t20/t5*spbk3k1*spbk5k2+t40*t17/t1*&
      &spbk3k1*spbk6k5+t8/t4+t6/t4+t2/t5+t11/t5)))
      t2 = t40*t13*spbk4k1*spbk5k2
      t6 = t40*t19*spbk4k1*spbk6k5
      t3 = t40*t3*spbk4k3*spbk5k2
      t7 = t40*t10*spbk4k3*spbk6k5
      abb53n9 = ((8.0_ki)*(t2/t5+t3/t5+t7/t4+t6/t5+t40*t15/t1*spbk4k3*spbk5k2+t4&
      &0*t26/t1*spbk4k1*spbk5k2+t40*t29/t1*spbk4k1*spbk6k5+t40*t22/t5*spbk4k3*sp&
      &bk6k5-(t40*t38/t5*spbk4k1*spbk6k5+t40*t35/t5*spbk4k1*spbk5k2+t40*t20/t5*s&
      &pbk4k3*spbk5k2+t40*t17/t1*spbk4k3*spbk6k5+t7/t5+t6/t4+t3/t4+t2/t4)))
      rat2d53 = 0
      rat2 = rat2 + rat2d53
      abb53n11 = abb53n1
      abb53n12 = abb53n9
      abb53n13 = abb53n8
      abb53n14 = abb53n7
      abb53n15 = abb53n6
      abb53n16 = abb53n5
      abb53n17 = abb53n4
      abb53n18 = abb53n3
      abb53n19 = abb53n2
      abb53n20 = -(abb53n2)
      abb53n21 = -(abb53n3)
      abb53n22 = -(abb53n4)
      abb53n23 = -(abb53n5)
      abb53n24 = -(abb53n6)
      abb53n25 = -(abb53n7)
      abb53n26 = -(abb53n8)
      abb53n27 = -(abb53n9)
   end subroutine
end module p24_udbar_neepuubar_abbrevd53h0
