module     p24_udbar_neepuubar_abbrevd7h1
   use p24_udbar_neepuubar_config, only: ki
   use p24_udbar_neepuubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb7n1
   complex(ki), public :: abb7n2
   complex(ki), public :: abb7n3
   complex(ki), public :: abb7n4
   complex(ki), public :: abb7n5
   complex(ki), public :: abb7n6
   complex(ki), public :: rat2d7
   complex(ki), public :: abb7n8
   complex(ki), public :: abb7n9
   complex(ki), public :: abb7n10
   complex(ki), public :: abb7n11
   complex(ki), public :: abb7n12
   complex(ki), public :: abb7n13
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   real(ki) :: t19
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p24_udbar_neepuubar_config, only: deltaOS
      use p24_udbar_neepuubar_kinematics
      use p24_udbar_neepuubar_model
      use p24_udbar_neepuubar_color, only: TR
      use p24_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = c2*i_
      t19 = TR*TR
      t2 = t19*t1*spak2k3*spak2k5*spbk2k1*spbk6k4
      t3 = (es12+es34-(es56+es345))*(es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t4 = t2/t3
      t1 = t1*spak2k5
      t5 = t19*t1*spak3k5*spbk5k1*spbk6k4
      t6 = t5/t3
      t7 = NC*NC*t3
      t2 = t2/t7
      t5 = t5/t7
      t8 = c1*i_
      t9 = NC*t3
      t10 = t19*t8/t9*spak2k3*spak2k5*spbk2k1*spbk6k4
      t8 = t8*spak2k5
      t11 = t19*t8/t9*spak3k5*spbk5k1*spbk6k4
      t12 = NC*c1*i_
      t13 = t19*t12/t3*spak2k3*spak2k5*spbk2k1*spbk6k4
      t12 = t12*spak2k5
      t14 = t19*t12/t3*spak3k5*spbk5k1*spbk6k4
      abb7n1 = ((2.0_ki)*(t10+t11+t4+t6-(t5+t2+t14+t13)))
      t15 = t1*spak3k4
      t16 = t19*t15*spbk2k1*spbk6k4
      t17 = t8*spak3k4
      t18 = t12*spak3k4
      abb7n2 = ((4.0_ki)*(t16/t7+t19*t18/t3*spbk2k1*spbk6k4-(t19*t17/t9*spbk2k1*&
      &spbk6k4+t16/t3)))
      t16 = t19*t1*spbk2k1
      abb7n3 = ((4.0_ki)*(t16/t7+t19*t12/t3*spbk2k1-(t19*t8/t9*spbk2k1+t16/t3)))
      t15 = t19*t15*spbk5k1*spbk6k4
      abb7n4 = ((4.0_ki)*(t15/t3+t19*t17/t9*spbk5k1*spbk6k4-(t19*t18/t3*spbk5k1*&
      &spbk6k4+t15/t7)))
      abb7n5 = ((4.0_ki)*(t13+t14+t2+t5-(t6+t4+t11+t10)))
      t1 = t19*t1*spbk5k1
      abb7n6 = ((4.0_ki)*(t1/t3+t19*t8/t9*spbk5k1-(t19*t12/t3*spbk5k1+t1/t7)))
      rat2d7 = abb7n1
      rat2 = rat2 + rat2d7
      abb7n8 = -(abb7n4)
      abb7n9 = abb7n6
      abb7n10 = abb7n5
      abb7n11 = abb7n3
      abb7n12 = -(abb7n2)
      abb7n13 = ((2.0_ki)*abb7n5)
   end subroutine
end module p24_udbar_neepuubar_abbrevd7h1
