module     p26_udbar_neepgg_abbrevd14h0
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_globalsh0
   implicit none
   private
   complex(ki), public :: abb14n1
   complex(ki), public :: abb14n2
   complex(ki), public :: abb14n3
   complex(ki), public :: abb14n4
   complex(ki), public :: abb14n5
   complex(ki), public :: abb14n6
   complex(ki), public :: abb14n7
   complex(ki), public :: rat2d14
   complex(ki), public :: abb14n9
   complex(ki), public :: abb14n10
   complex(ki), public :: abb14n11
   complex(ki), public :: abb14n12
   complex(ki), public :: abb14n13
   complex(ki), public :: abb14n14
   complex(ki), public :: abb14n15
   complex(ki), public :: abb14n16
   complex(ki), public :: abb14n17
   complex(ki), public :: abb14n18
   complex(ki), public :: abb14n19
   complex(ki), public :: abb14n20
   complex(ki), public :: abb14n21
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   complex(ki) :: t44
   real(ki) :: t45
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p26_udbar_neepgg_config, only: deltaOS
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_model
      use p26_udbar_neepgg_color, only: TR
      use p26_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c1
      t3 = t2*i_
      t4 = t3*spak2k3
      t5 = t4*spak2k6
      t6 = t5*spbk4k2
      t7 = t6*spbk6k1
      t8 = NC*t1
      t9 = es234*t8
      t10 = spak5k6*spak5k6
      t11 = t10*t9
      t4 = t4*spak3k6*spbk4k3
      t12 = t4*spbk6k1
      t13 = es61*t10*t8
      t14 = NC*TR*c1
      t15 = t14*i_
      t16 = t15*spak2k3
      t17 = t16*spak2k6
      t18 = t17*spbk4k2
      t19 = t18*spbk6k1
      t20 = es234*t1
      t21 = t10*t20
      t16 = t16*spak3k6*spbk4k3
      t22 = t16*spbk6k1
      t23 = es61*t1*t10
      t24 = t5*spbk5k2
      t25 = t24*spbk6k1*spbk6k4
      t26 = (es34+es61-(es345+es234))*t1
      t27 = NC*t26
      t28 = es61*t27
      t29 = t17*spbk5k2
      t30 = t29*spbk6k1*spbk6k4
      t31 = es61*t26
      t3 = t3*spak1k5*spak2k3
      t32 = t3*spak2k6
      t33 = t32*spbk4k1*spbk5k2*spbk6k1
      t34 = t10*t28
      t15 = t15*spak1k5*spak2k3
      t35 = t15*spak2k6
      t36 = t35*spbk4k1*spbk5k2*spbk6k1
      t37 = t10*t31
      abb14n1 = ((4.0_ki)*(t25/(t28*spak5k6)+t12/t11+t7/t13+t19/t21+t22/t23+t36/&
      &t37-(t33/t34+t22/t21+t19/t23+t12/t13+t7/t11+t30/(t31*spak5k6))))
      t5 = t5*spbk4k1*spbk5k2
      t11 = t17*spbk4k1*spbk5k2
      t13 = t6*spbk5k1
      t17 = es61*t10*t9
      t21 = t4*spbk5k1
      t23 = t18*spbk5k1
      t10 = es61*t10*t20
      t28 = t16*spbk5k1
      abb14n2 = ((8.0_ki)*(t23/t10+t11/t37+t21/t17-(t5/t34+t13/t17+t28/t10)))
      t31 = es61*spak5k6
      t31 = t31*t31
      t8 = t31*t8
      t38 = t7/t8
      t8 = t12/t8
      t1 = t1*t31
      t39 = t19/t1
      t1 = t22/t1
      t7 = t7/t17
      t12 = t12/t17
      t19 = t19/t10
      t22 = t22/t10
      t40 = t27*t31
      t33 = t33/t40
      t41 = t26*t31
      t36 = t36/t41
      t45 = es61*es61
      t27 = t45*t27*spak5k6
      t25 = t25/t27
      t26 = t45*t26*spak5k6
      t30 = t30/t26
      t2 = es56*t2*i_*spak2k3
      t42 = t31*t9
      t43 = t2/t42*spak2k6*spbk4k2*spbk6k1
      t2 = t2/t42*spak3k6*spbk4k3*spbk6k1
      t14 = es56*t14*i_*spak2k3
      t31 = t20*t31
      t44 = t14/t31*spak2k6*spbk4k2*spbk6k1
      t14 = t14/t31*spak3k6*spbk4k3*spbk6k1
      abb14n3 = ((8.0_ki)*(t2+t25+t44-(t43+t30+t14))+(16.0_ki)*(t1+t12+t19+t36+t&
      &38-(t8+t7+t39+t33+t22)))
      abb14n4 = ((16.0_ki)*(t30-t25)+(8.0_ki)*(t2+t22+t33+t39+t44+t7+t8-(t43+t38&
      &+t36+t19+t14+t12+t1)))
      abb14n5 = ((8.0_ki)*(t18/t10*spbk6k5+t4/t17*spbk6k5+t29/t37*spbk6k4-(t24/t&
      &34*spbk6k4+t6/t17*spbk6k5+t16/t10*spbk6k5)))
      abb14n6 = ((4.0_ki)*(t35/t31*spbk4k2*spbk6k1*spbk6k5+t35/t41*spbk5k2*spbk6&
      &k1*spbk6k4+t3/t42*spak3k6*spbk4k3*spbk6k1*spbk6k5-(t15/t31*spak3k6*spbk4k&
      &3*spbk6k1*spbk6k5+t32/t42*spbk4k2*spbk6k1*spbk6k5+t32/t40*spbk5k2*spbk6k1&
      &*spbk6k4)))
      t1 = t45*t9*spak5k6
      t2 = t45*t20*spak5k6
      abb14n7 = ((4.0_ki)*(t21/t1*spbk6k1+t11/t26*spbk6k1+t23/t2*spbk6k1-(t5/t27&
      &*spbk6k1+t28/t2*spbk6k1+t13/t1*spbk6k1)))
      rat2d14 = 0
      rat2 = rat2 + rat2d14
      abb14n9 = abb14n1
      abb14n10 = abb14n7
      abb14n11 = abb14n6
      abb14n12 = abb14n5
      abb14n13 = abb14n4
      abb14n14 = abb14n3
      abb14n15 = abb14n2
      abb14n16 = -(abb14n2)
      abb14n17 = -(abb14n3)
      abb14n18 = -(abb14n4)
      abb14n19 = -(abb14n5)
      abb14n20 = -(abb14n6)
      abb14n21 = -(abb14n7)
   end subroutine
end module p26_udbar_neepgg_abbrevd14h0
