module     p26_udbar_neepgg_abbrevd45h0
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_globalsh0
   implicit none
   private
   complex(ki), public :: abb45n1
   complex(ki), public :: abb45n2
   complex(ki), public :: abb45n3
   complex(ki), public :: abb45n4
   complex(ki), public :: abb45n5
   complex(ki), public :: abb45n6
   complex(ki), public :: abb45n7
   complex(ki), public :: abb45n8
   complex(ki), public :: abb45n9
   complex(ki), public :: abb45n10
   complex(ki), public :: abb45n11
   complex(ki), public :: abb45n12
   complex(ki), public :: abb45n13
   complex(ki), public :: abb45n14
   complex(ki), public :: abb45n15
   complex(ki), public :: abb45n16
   complex(ki), public :: abb45n17
   complex(ki), public :: abb45n18
   complex(ki), public :: abb45n19
   complex(ki), public :: rat2d45
   complex(ki), public :: abb45n21
   complex(ki), public :: abb45n22
   complex(ki), public :: abb45n23
   complex(ki), public :: abb45n24
   complex(ki), public :: abb45n25
   complex(ki), public :: abb45n26
   complex(ki), public :: abb45n27
   complex(ki), public :: abb45n28
   complex(ki), public :: abb45n29
   complex(ki), public :: abb45n30
   complex(ki), public :: abb45n31
   complex(ki), public :: abb45n32
   complex(ki), public :: abb45n33
   complex(ki), public :: abb45n34
   complex(ki), public :: abb45n35
   complex(ki), public :: abb45n36
   complex(ki), public :: abb45n37
   complex(ki), public :: abb45n38
   complex(ki), public :: abb45n39
   complex(ki), public :: abb45n40
   complex(ki), public :: abb45n41
   complex(ki), public :: abb45n42
   complex(ki), public :: abb45n43
   complex(ki), public :: abb45n44
   complex(ki), public :: abb45n45
   complex(ki), public :: abb45n46
   complex(ki), public :: abb45n47
   complex(ki), public :: abb45n48
   complex(ki), public :: abb45n49
   complex(ki), public :: abb45n50
   complex(ki), public :: abb45n51
   complex(ki), public :: abb45n52
   complex(ki), public :: abb45n53
   complex(ki), public :: abb45n54
   complex(ki), public :: abb45n55
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p26_udbar_neepgg_config, only: deltaOS
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_model
      use p26_udbar_neepgg_color, only: TR
      use p26_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c1*i_
      t3 = t2*spak2k3
      t4 = t3*spak2k6*spbk4k2*spbk6k1
      t5 = NC*t1
      t6 = es234*t5
      t7 = spak5k6*spak5k6
      t8 = t6*t7
      t9 = t4/t8
      t10 = t3*spak3k6*spbk4k3*spbk6k1
      t8 = t10/t8
      t5 = es61*t5
      t11 = t5*t7
      t12 = t4/t11
      t11 = t10/t11
      t13 = NC*TR*c1
      t14 = t13*i_
      t15 = t14*spak2k3
      t16 = t15*spak2k6*spbk4k2
      t17 = t16*spbk6k1
      t18 = es234*t1
      t19 = t18*t7
      t20 = t17/t19
      t21 = t15*spak3k6*spbk4k3
      t22 = t21*spbk6k1
      t23 = t22/t19
      t24 = es61*t1*t7
      t25 = t17/t24
      t26 = t22/t24
      abb45n1 = ((2.0_ki)*(t12+t20+t26+t8-(t9+t25+t23+t11)))
      t1 = t1*t7
      t27 = es61*t13*i_*spak2k3
      t28 = es234*t13*i_*spak2k3
      t29 = t15*spak2k5*spbk4k2
      t30 = t15*spak3k5*spbk4k3
      abb45n2 = ((8.0_ki)*(t17/t1-t22/t1)+(2.0_ki)*(t29/t1*spbk5k1+t27/t19*spak3&
      &k5*spbk4k3*spbk5k1-(t27/t19*spak2k5*spbk4k2*spbk5k1+t30/t1*spbk5k1))+(4.0&
      &_ki)*(t27/t19*spak3k6*spbk4k3*spbk6k1+t28/t24*spak3k6*spbk4k3*spbk6k1-(t2&
      &8/t24*spak2k6*spbk4k2*spbk6k1+t27/t19*spak2k6*spbk4k2*spbk6k1)))
      t1 = t14*spak1k2*spak2k3*spbk4k2
      t27 = t1*spbk5k1
      t28 = t14*spak1k3*spak2k3*spbk4k3
      t31 = t28*spbk5k1
      abb45n3 = ((2.0_ki)*(t27/t19-t31/t19))
      abb45n4 = ((2.0_ki)*(t16/t19*spbk5k1-t21/t19*spbk5k1))
      t16 = (8.0_ki)*(t23+t25-(t26+t20))
      abb45n5 = t16
      t13 = es56*t13*i_*spak2k3
      t18 = es61*t18
      t21 = t18*t7
      t32 = t13/t21*spak2k6*spbk4k2*spbk6k1
      t13 = t13/t21*spak3k6*spbk4k3*spbk6k1
      t18 = t18*spak5k6
      t27 = t27/t18*spbk6k1
      t31 = t31/t18*spbk6k1
      abb45n6 = ((4.0_ki)*(t31+t32-(t27+t13))+(8.0_ki)*(t20+t26-(t25+t23)))
      abb45n7 = ((4.0_ki)*(t13+t27-(t32+t31))+t16)
      t13 = t29*spbk6k1
      t16 = t30*spbk6k1
      t27 = spbk6k1*spbk6k1
      t14 = t14*spak1k5*spak2k3
      abb45n8 = ((2.0_ki)*(t13/t19+t16/t24+t27/t18*t28+t14/t21*t27*spak2k6*spbk4&
      &k2-(t14/t21*t27*spak3k6*spbk4k3+t1/t18*t27+t16/t19+t13/t24)))
      t19 = t3*spbk4k2*spbk6k1
      t24 = t6*spak5k6
      t5 = t5*spak5k6
      abb45n9 = ((4.0_ki)*(t19/t24-t19/t5))
      abb45n10 = ((4.0_ki)*(t11+t23+t25+t9-(t8+t26+t20+t12)))
      t8 = t3*spbk4k3*spbk6k1
      abb45n11 = ((4.0_ki)*(t8/t5-t8/t24))
      t5 = es61*t6
      t6 = t5*t7
      abb45n12 = ((8.0_ki)*(t28/t21*spbk6k1+t2/t6*spak1k3*spak2k3*spbk4k3*spbk6k&
      &1-(t2/t6*spak1k2*spak2k3*spbk4k2*spbk6k1+t1/t21*spbk6k1)))
      t1 = t2*spak1k5*spak2k3
      abb45n13 = ((4.0_ki)*(t1/t6*spbk4k2*spbk6k1+t14/t21*spbk4k2*spbk6k1))
      abb45n14 = ((4.0_ki)*(-(t14/t21*spbk4k3*spbk6k1+t1/t6*spbk4k3*spbk6k1)))
      t1 = t5*spak5k6
      abb45n15 = ((4.0_ki)*(t19/t1+t15/t18*spbk4k2*spbk6k1))
      t2 = t3/t6*spak2k5*spbk4k2*spbk6k1
      t3 = t3/t6*spak3k5*spbk4k3*spbk6k1
      t5 = t13/t21
      t7 = t16/t21
      abb45n16 = ((16.0_ki)*(t3+t7-(t5+t2)))
      abb45n17 = ((16.0_ki)*(t2+t5-(t7+t3)))
      abb45n18 = ((8.0_ki)*(t10/t6+t22/t21-(t4/t6+t17/t21)))
      abb45n19 = ((4.0_ki)*(-(t15/t18*spbk4k3*spbk6k1+t8/t1)))
      rat2d45 = abb45n1
      rat2 = rat2 + rat2d45
      abb45n21 = abb45n2
      abb45n22 = abb45n19
      abb45n23 = abb45n18
      abb45n24 = abb45n17
      abb45n25 = abb45n16
      abb45n26 = abb45n15
      abb45n27 = abb45n14
      abb45n28 = abb45n13
      abb45n29 = abb45n12
      abb45n30 = abb45n11
      abb45n31 = abb45n10
      abb45n32 = abb45n9
      abb45n33 = abb45n8
      abb45n34 = abb45n7
      abb45n35 = abb45n6
      abb45n36 = abb45n5
      abb45n37 = abb45n4
      abb45n38 = abb45n3
      abb45n39 = -(abb45n3)
      abb45n40 = -(abb45n4)
      abb45n41 = -(abb45n5)
      abb45n42 = -(abb45n6)
      abb45n43 = -(abb45n7)
      abb45n44 = -(abb45n8)
      abb45n45 = -(abb45n9)
      abb45n46 = (-2.0_ki)*abb45n10
      abb45n47 = -(abb45n11)
      abb45n48 = -(abb45n12)
      abb45n49 = -(abb45n13)
      abb45n50 = -(abb45n14)
      abb45n51 = -(abb45n15)
      abb45n52 = -(abb45n16)
      abb45n53 = -(abb45n17)
      abb45n54 = -(abb45n18)
      abb45n55 = -(abb45n19)
   end subroutine
end module p26_udbar_neepgg_abbrevd45h0
