module     p26_udbar_neepgg_d107h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity0/d107h0l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d107
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd107h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      real(ki) :: t54
      real(ki) :: t55
      real(ki) :: t56
      real(ki) :: t57
      real(ki) :: t58
      real(ki) :: t59
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t2 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t3 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t54 = dotproduct(k6, qshift)
      t4 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t5 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t6 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t7 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t55 = dotproduct(k5, qshift)
      t8 = (spvak3k5(1)*qshift(1)-spvak3k5(2)*qshift(2)-spvak3k5(3)*qshift(3)-sp&
      &vak3k5(4)*qshift(4))
      t56 = dotproduct(qshift, qshift)
      t57 = dotproduct(k1, qshift)
      t58 = dotproduct(k3, qshift)
      t59 = dotproduct(k4, qshift)
      t9 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t10 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-s&
      &pvak2k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb107n46+t1*abb107n109+t2*abb107n110+t3*abb107n132+t4*abb&
         &107n134+t5*abb107n135+t54*abb107n133+t55*abb107n138+t56*abb107n68+t57*&
         &abb107n89+t58*abb107n90+t59*abb107n90+t6*abb107n136+t7*abb107n137+t8*a&
         &bb107n139+t9*abb107n91+t1*t54*abb107n73+t1*t55*abb107n74+t1*t56*abb107&
         &n119+t10*t56*abb107n106+t2*t54*abb107n72+t2*t55*abb107n71+t2*t56*abb10&
         &7n122+t3*t7*abb107n50+t4*t54*abb107n70+t4*t55*abb107n52+t4*t56*abb107n&
         &125+t4*t6*abb107n53+t4*t7*abb107n48+t4*t8*abb107n51+t5*t7*abb107n47+t5&
         &4*t57*abb107n85+t54*t58*abb107n84+t54*t59*abb107n84+t54*t7*abb107n49+t&
         &54*t9*abb107n83+t55*t57*abb107n84+t55*t58*abb107n85+t55*t59*abb107n85+&
         &t55*t7*abb107n69+t55*t9*abb107n82+t56*t57*abb107n96+t56*t58*abb107n93+&
         &t56*t59*abb107n93+t56*t7*abb107n128+t56*t9*abb107n100+t1*t4*t7*abb107n&
         &130+t10*t4*t7*abb107n108+t2*t4*t7*abb107n131+t4*t57*t7*abb107n102+t4*t&
         &58*t7*abb107n103+t4*t59*t7*abb107n103+t4*t7*t9*abb107n104)
         return
      end if
      t11 = k1(iv1)
      t12 = k3(iv1)
      t13 = k4(iv1)
      t14 = k5(iv1)
      t15 = k6(iv1)
      t16 = qshift(iv1)
      t17 = spvak2k1(iv1)
      t18 = spvak2k5(iv1)
      t19 = spvak2k6(iv1)
      t20 = spvak3k1(iv1)
      t21 = spvak3k4(iv1)
      t22 = spvak3k5(iv1)
      t23 = spvak3k6(iv1)
      t24 = spvak5k6(iv1)
      t25 = spvak6k5(iv1)
      t26 = t14*abb107n93
      t27 = t15*abb107n96
      t28 = t16*abb107n92
      t29 = spvak2k4(iv1)
      t30 = t24*abb107n80
      t31 = t25*abb107n80
      if(deg.eq.1) then
         numerator = (t11*abb107n88+t12*abb107n87+t13*abb107n87+t14*abb107n55+t1&
         &5*abb107n60+t16*abb107n117+t17*abb107n76+t18*abb107n57+t19*abb107n61+t&
         &20*abb107n75+t21*abb107n86+t22*abb107n54+t23*abb107n58+t24*abb107n59+t&
         &25*abb107n56+t26*t58+t26*t59+t27*t58+t27*t59+t28*t58+t28*t59+t1*t14*ab&
         &b107n111+t1*t15*abb107n112+t1*t16*abb107n118+t10*t16*abb107n105+t11*t5&
         &4*abb107n93+t11*t55*abb107n96+t11*t56*abb107n84+t12*t54*abb107n96+t12*&
         &t55*abb107n93+t12*t56*abb107n85+t13*t54*abb107n96+t13*t55*abb107n93+t1&
         &3*t56*abb107n85+t14*t2*abb107n114+t14*t4*abb107n141+t14*t57*abb107n96+&
         &t14*t7*abb107n116+t14*t9*abb107n100+t15*t2*abb107n113+t15*t4*abb107n11&
         &5+t15*t57*abb107n93+t15*t7*abb107n144+t15*t9*abb107n98+t16*t2*abb107n1&
         &21+t16*t4*abb107n124+t16*t57*abb107n95+t16*t7*abb107n127+t16*t9*abb107&
         &n99+t17*t54*abb107n112+t17*t55*abb107n111+t17*t56*abb107n67+t18*t4*abb&
         &107n140+t19*t7*abb107n143+t20*t54*abb107n113+t20*t55*abb107n114+t20*t5&
         &6*abb107n66+t21*t54*abb107n98+t21*t55*abb107n100+t21*t56*abb107n82+t22&
         &*t4*abb107n142+t23*t7*abb107n146+t24*t54*abb107n115+t24*t55*abb107n141&
         &+t24*t56*abb107n65+t24*t6*abb107n140+t24*t7*abb107n145+t24*t8*abb107n1&
         &42+t25*t3*abb107n143+t25*t4*abb107n145+t25*t5*abb107n146+t25*t54*abb10&
         &7n144+t25*t55*abb107n116+t25*t56*abb107n64+t29*t56*abb107n78+t30*t58*t&
         &7+t30*t59*t7+t31*t4*t58+t31*t4*t59+t1*t24*t7*abb107n63+t1*t25*t4*abb10&
         &7n63+t10*t24*t7*abb107n77+t10*t25*t4*abb107n77+t11*t4*t7*abb107n81+t12&
         &*t4*t7*abb107n80+t13*t4*t7*abb107n80+t17*t4*t7*abb107n63+t2*t24*t7*abb&
         &107n62+t2*t25*t4*abb107n62+t20*t4*t7*abb107n62+t21*t4*t7*abb107n79+t24&
         &*t57*t7*abb107n81+t24*t7*t9*abb107n79+t25*t4*t57*abb107n81+t25*t4*t9*a&
         &bb107n79+t29*t4*t7*abb107n77)
         return
      end if
      t54 = d(iv1,iv2)
      t3 = t54*abb107n93
      t5 = k5(iv2)
      t6 = k6(iv2)
      t8 = qshift(iv2)
      t26 = k1(iv2)
      t27 = k3(iv2)
      t28 = k4(iv2)
      t30 = spvak2k1(iv2)
      t31 = spvak3k1(iv2)
      t32 = spvak3k4(iv2)
      t33 = spvak5k6(iv2)
      t34 = spvak6k5(iv2)
      t35 = spvak2k4(iv2)
      t36 = t24*t34
      t37 = t25*t33
      t38 = t11*t33
      t39 = t24*t26
      t40 = t12*t33
      t41 = t24*t27
      t42 = t13*t33
      t43 = t24*t28
      t44 = t17*t33
      t45 = t24*t30
      t46 = t29*t33
      t47 = t24*t35
      t48 = t20*t33
      t49 = t24*t31
      t50 = t21*t33
      t51 = t24*t32
      t52 = t36*abb107n103
      t53 = t37*abb107n103
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t3*t58+t3*t59+t54*abb107n68+t1*t54*abb107n119+t1&
         &0*t54*abb107n106+t2*t54*abb107n122+t4*t54*abb107n125+t54*t57*abb107n96&
         &+t54*t7*abb107n128+t54*t9*abb107n100)+t36*abb107n48+t37*abb107n48+t52*&
         &t58+t52*t59+t53*t58+t53*t59+spvak2k5(iv2)*t24*abb107n53+spvak2k6(iv2)*&
         &t25*abb107n50+spvak3k5(iv2)*t24*abb107n51+spvak3k6(iv2)*t25*abb107n47+&
         &t1*t36*abb107n130+t1*t37*abb107n130+t10*t36*abb107n108+t10*t37*abb107n&
         &108+t11*t5*abb107n84+t11*t6*abb107n85+t11*t8*abb107n97+t12*t5*abb107n8&
         &5+t12*t6*abb107n84+t12*t8*abb107n94+t13*t5*abb107n85+t13*t6*abb107n84+&
         &t13*t8*abb107n94+t14*t26*abb107n84+t14*t27*abb107n85+t14*t28*abb107n85&
         &+t14*t30*abb107n74+t14*t31*abb107n71+t14*t32*abb107n82+t14*t33*abb107n&
         &52+t14*t34*abb107n69+t15*t26*abb107n85+t15*t27*abb107n84+t15*t28*abb10&
         &7n84+t15*t30*abb107n73+t15*t31*abb107n72+t15*t32*abb107n83+t15*t33*abb&
         &107n70+t15*t34*abb107n49+t16*t26*abb107n97+t16*t27*abb107n94+t16*t28*a&
         &bb107n94+t16*t30*abb107n120+t16*t31*abb107n123+t16*t32*abb107n101+t16*&
         &t33*abb107n126+t16*t34*abb107n129+t16*t35*abb107n107+t17*t5*abb107n74+&
         &t17*t6*abb107n73+t17*t8*abb107n120+t18*t33*abb107n53+t19*t34*abb107n50&
         &+t2*t36*abb107n131+t2*t37*abb107n131+t20*t5*abb107n71+t20*t6*abb107n72&
         &+t20*t8*abb107n123+t21*t5*abb107n82+t21*t6*abb107n83+t21*t8*abb107n101&
         &+t22*t33*abb107n51+t23*t34*abb107n47+t24*t5*abb107n52+t24*t6*abb107n70&
         &+t24*t8*abb107n126+t25*t5*abb107n69+t25*t6*abb107n49+t25*t8*abb107n129&
         &+t29*t8*abb107n107+t36*t57*abb107n102+t36*t9*abb107n104+t37*t57*abb107&
         &n102+t37*t9*abb107n104+t38*t7*abb107n102+t39*t7*abb107n102+t40*t7*abb1&
         &07n103+t41*t7*abb107n103+t42*t7*abb107n103+t43*t7*abb107n103+t44*t7*ab&
         &b107n130+t45*t7*abb107n130+t46*t7*abb107n108+t47*t7*abb107n108+t48*t7*&
         &abb107n131+t49*t7*abb107n131+t50*t7*abb107n104+t51*t7*abb107n104+t11*t&
         &34*t4*abb107n102+t12*t34*t4*abb107n103+t13*t34*t4*abb107n103+t17*t34*t&
         &4*abb107n130+t20*t34*t4*abb107n131+t21*t34*t4*abb107n104+t25*t26*t4*ab&
         &b107n102+t25*t27*t4*abb107n103+t25*t28*t4*abb107n103+t25*t30*t4*abb107&
         &n130+t25*t31*t4*abb107n131+t25*t32*t4*abb107n104+t25*t35*t4*abb107n108&
         &+t29*t34*t4*abb107n108)
         return
      end if
      t55 = d(iv2,iv3)
      t56 = d(iv1,iv3)
      t1 = k1(iv3)
      t2 = k3(iv3)
      t3 = k4(iv3)
      t4 = spvak2k1(iv3)
      t5 = spvak2k4(iv3)
      t6 = spvak3k1(iv3)
      t7 = spvak3k4(iv3)
      t8 = spvak5k6(iv3)
      t9 = spvak6k5(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t1*t54*abb107n84+t11*t55*abb107n84+t12*t55*abb10&
         &7n85+t13*t55*abb107n85+t17*t55*abb107n67+t2*t54*abb107n85+t20*t55*abb1&
         &07n66+t21*t55*abb107n82+t24*t55*abb107n65+t25*t55*abb107n64+t26*t56*ab&
         &b107n84+t27*t56*abb107n85+t28*t56*abb107n85+t29*t55*abb107n78+t3*t54*a&
         &bb107n85+t30*t56*abb107n67+t31*t56*abb107n66+t32*t56*abb107n82+t33*t56&
         &*abb107n65+t34*t56*abb107n64+t35*t56*abb107n78+t4*t54*abb107n67+t5*t54&
         &*abb107n78+t54*t6*abb107n66+t54*t7*abb107n82+t54*t8*abb107n65+t54*t9*a&
         &bb107n64)+t38*t9*abb107n81+t39*t9*abb107n81+t40*t9*abb107n80+t41*t9*ab&
         &b107n80+t42*t9*abb107n80+t43*t9*abb107n80+t44*t9*abb107n63+t45*t9*abb1&
         &07n63+t46*t9*abb107n77+t47*t9*abb107n77+t48*t9*abb107n62+t49*t9*abb107&
         &n62+t50*t9*abb107n79+t51*t9*abb107n79+t1*t24*t34*abb107n81+t1*t25*t33*&
         &abb107n81+t11*t34*t8*abb107n81+t12*t34*t8*abb107n80+t13*t34*t8*abb107n&
         &80+t17*t34*t8*abb107n63+t2*t24*t34*abb107n80+t2*t25*t33*abb107n80+t20*&
         &t34*t8*abb107n62+t21*t34*t8*abb107n79+t24*t3*t34*abb107n80+t24*t34*t4*&
         &abb107n63+t24*t34*t5*abb107n77+t24*t34*t6*abb107n62+t24*t34*t7*abb107n&
         &79+t25*t26*t8*abb107n81+t25*t27*t8*abb107n80+t25*t28*t8*abb107n80+t25*&
         &t3*t33*abb107n80+t25*t30*t8*abb107n63+t25*t31*t8*abb107n62+t25*t32*t8*&
         &abb107n79+t25*t33*t4*abb107n63+t25*t33*t5*abb107n77+t25*t33*t6*abb107n&
         &62+t25*t33*t7*abb107n79+t25*t35*t8*abb107n77+t29*t34*t8*abb107n77)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d107:
   subroutine     reconstruct_d107(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_107:
      coeffs%coeffs_107%c0 = derivative(czip)
      coeffs%coeffs_107%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_107%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_107%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_107%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_107%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_107%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_107%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_107%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_107%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_107%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_107%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_107%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_107%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_107%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_107%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_107%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_107%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_107%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_107%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_107%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_107%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_107%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_107%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_107%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_107%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_107%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_107%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_107%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_107%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_107%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_107%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_107%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_107%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_107%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_107:
   end subroutine reconstruct_d107
!---#] subroutine reconstruct_d107:
end module p26_udbar_neepgg_d107h0l1d
