module     p26_udbar_neepgg_d27h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity0/d27h0l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d27
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd27h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      real(ki) :: t32
      real(ki) :: t33
      real(ki) :: t34
      real(ki) :: t35
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k6-k5-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t32 = dotproduct(qshift, qshift)
      t2 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t3 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t33 = dotproduct(k2, qshift)
      t4 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t34 = dotproduct(k5, qshift)
      t7 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t8 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t9 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t35 = dotproduct(k1, qshift)
      if(deg.eq.0) then
         numerator = (t1*abb27n24+t2*abb27n41+t3*abb27n44+t32*abb27n37+t33*abb27&
         &n45+t4*abb27n46+t1*t32*abb27n49+t1*t34*abb27n28+t1*t6*abb27n26+t2*t6*a&
         &bb27n27+t3*t6*abb27n29+t32*t5*abb27n42+t32*t8*abb27n38+t32*t9*abb27n47&
         &+t33*t6*abb27n34+t34*t5*abb27n36+t34*t9*abb27n31+t35*t6*abb27n35+t4*t6&
         &*abb27n33+t5*t6*abb27n25+t6*t9*abb27n32+t7*t8*abb27n30+t3*t6*t8*abb27n&
         &51)
         return
      end if
      t10 = k2(iv1)
      t11 = qshift(iv1)
      t12 = spvak2k1(iv1)
      t13 = spvak2k6(iv1)
      t14 = spvak5k1(iv1)
      t15 = spvak6k1(iv1)
      t16 = k1(iv1)
      t17 = k5(iv1)
      t18 = spvak2k4(iv1)
      t19 = spvak2k5(iv1)
      t20 = spvak3k1(iv1)
      t21 = spvak3k4(iv1)
      t22 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb27n45+t11*abb27n40+t12*abb27n44+t13*abb27n46+t14*ab&
         &b27n41+t15*abb27n24+t1*t11*abb27n50+t1*t17*abb27n28+t1*t22*abb27n26+t1&
         &0*t6*abb27n34+t11*t5*abb27n43+t11*t8*abb27n39+t11*t9*abb27n48+t12*t6*a&
         &bb27n29+t13*t6*abb27n33+t14*t6*abb27n27+t15*t32*abb27n49+t15*t34*abb27&
         &n28+t15*t6*abb27n26+t16*t6*abb27n35+t17*t5*abb27n36+t17*t9*abb27n31+t1&
         &8*t32*abb27n47+t18*t34*abb27n31+t18*t6*abb27n32+t19*t8*abb27n30+t2*t22&
         &*abb27n27+t20*t32*abb27n42+t20*t34*abb27n36+t20*t6*abb27n25+t21*t32*ab&
         &b27n38+t21*t7*abb27n30+t22*t3*abb27n29+t22*t33*abb27n34+t22*t35*abb27n&
         &35+t22*t4*abb27n33+t22*t5*abb27n25+t22*t9*abb27n32+t12*t6*t8*abb27n51+&
         &t21*t3*t6*abb27n51+t22*t3*t8*abb27n51)
         return
      end if
      t32 = d(iv1,iv2)
      t2 = spvak6k5(iv2)
      t4 = spvak2k4(iv2)
      t7 = spvak3k1(iv2)
      t23 = spvak6k1(iv2)
      t24 = k5(iv2)
      t25 = spvak3k4(iv2)
      t26 = qshift(iv2)
      t27 = t12*t2
      t28 = spvak2k1(iv2)
      t29 = t22*t28
      t30 = t12*t25
      t31 = t21*t28
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t32*abb27n37+t1*t32*abb27n49+t32*t5*abb27n42+t32&
         &*t8*abb27n38+t32*t9*abb27n47)+t27*abb27n29+t29*abb27n29+k1(iv2)*t22*ab&
         &b27n35+k2(iv2)*t22*abb27n34+spvak2k5(iv2)*t21*abb27n30+spvak2k6(iv2)*t&
         &22*abb27n33+spvak5k1(iv2)*t22*abb27n27+t10*t2*abb27n34+t11*t23*abb27n5&
         &0+t11*t25*abb27n39+t11*t4*abb27n48+t11*t7*abb27n43+t13*t2*abb27n33+t14&
         &*t2*abb27n27+t15*t2*abb27n26+t15*t24*abb27n28+t15*t26*abb27n50+t16*t2*&
         &abb27n35+t17*t23*abb27n28+t17*t4*abb27n31+t17*t7*abb27n36+t18*t2*abb27&
         &n32+t18*t24*abb27n31+t18*t26*abb27n48+t19*t25*abb27n30+t2*t20*abb27n25&
         &+t20*t24*abb27n36+t20*t26*abb27n43+t21*t26*abb27n39+t22*t23*abb27n26+t&
         &22*t4*abb27n32+t22*t7*abb27n25+t27*t8*abb27n51+t29*t8*abb27n51+t30*t6*&
         &abb27n51+t31*t6*abb27n51+t2*t21*t3*abb27n51+t22*t25*t3*abb27n51)
         return
      end if
      t33 = d(iv2,iv3)
      t34 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t3 = spvak6k5(iv3)
      t5 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k4(iv3)*t32*abb27n47+spvak3k1(iv3)*t32*abb&
         &27n42+spvak6k1(iv3)*t32*abb27n49+t1*t32*abb27n38+t15*t33*abb27n49+t18*&
         &t33*abb27n47+t20*t33*abb27n42+t21*t33*abb27n38+t23*t34*abb27n49+t25*t3&
         &4*abb27n38+t34*t4*abb27n47+t34*t7*abb27n42)+t3*t30*abb27n51+t3*t31*abb&
         &27n51+t1*t12*t2*abb27n51+t1*t22*t28*abb27n51+t2*t21*t5*abb27n51+t22*t2&
         &5*t5*abb27n51)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d27:
   subroutine     reconstruct_d27(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group10
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group10), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_27:
      coeffs%coeffs_27%c0 = derivative(czip)
      coeffs%coeffs_27%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_27%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_27%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_27%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_27%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_27%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_27%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_27%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_27%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_27%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_27%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_27%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_27%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_27%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_27%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_27%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_27%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_27%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_27%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_27%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_27%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_27%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_27%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_27%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_27%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_27%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_27%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_27%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_27%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_27%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_27%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_27%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_27%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_27%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_27:
   end subroutine reconstruct_d27
!---#] subroutine reconstruct_d27:
end module p26_udbar_neepgg_d27h0l1d
