module     p26_udbar_neepgg_abbrevd15h1
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_globalsh1
   implicit none
   private
   complex(ki), public :: abb15n1
   complex(ki), public :: abb15n2
   complex(ki), public :: abb15n3
   complex(ki), public :: abb15n4
   complex(ki), public :: abb15n5
   complex(ki), public :: rat2d15
   complex(ki), public :: abb15n7
   complex(ki), public :: abb15n8
   complex(ki), public :: abb15n9
   complex(ki), public :: abb15n10
   complex(ki), public :: abb15n11
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   real(ki) :: t38
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p26_udbar_neepgg_config, only: deltaOS
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_model
      use p26_udbar_neepgg_color, only: TR
      use p26_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t38 = es234-(es61+es56)
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c2
      t3 = t2*i_
      t4 = t3*spak1k5*spak2k3
      t5 = t4*spak2k5
      t6 = t5*spbk4k2
      t7 = spbk6k1*spbk6k1
      t8 = t6*t7
      t9 = NC*t1
      t38 = t38*t38
      t10 = t38*t9*spak5k6*spbk6k5
      t4 = t4*spak3k5*spbk4k3
      t11 = t4*t7
      t12 = NC*TR*c2
      t13 = t12*i_
      t14 = t13*spak1k5*spak2k3
      t15 = t14*spak2k5
      t16 = t15*spbk4k2
      t17 = t16*t7
      t18 = t38*t1*spak5k6*spbk6k5
      t14 = t14*spak3k5*spbk4k3
      t19 = t14*t7
      t20 = es56*t2*i_
      t21 = t20*spak1k5*spak2k3
      t22 = t21*spak2k5
      t9 = es234*t9*spak5k6
      t23 = t38*t9*spbk6k5
      t24 = es61*t2*i_
      t25 = t24*spak1k5*spak2k3
      t26 = t25*spak2k5
      t27 = es56*t12*i_
      t28 = t27*spak1k5*spak2k3
      t29 = t28*spak2k5
      t30 = es234*t1*spak5k6
      t31 = t38*t30*spbk6k5
      t32 = es61*t12*i_
      t33 = t32*spak1k5*spak2k3
      t34 = t33*spak2k5
      t2 = es234*t2*i_
      t1 = (es345-(es61+es12))*t1
      t35 = NC*t1*spak5k6
      t36 = t38*t35*spbk6k5
      t12 = es234*t12*i_
      t1 = t1*spak5k6
      t37 = t38*t1*spbk6k5
      abb15n1 = ((4.0_ki)*(t11/t10+t17/t18+t22/t23*t7*spbk4k2+t26/t23*t7*spbk4k2&
      &+t22/t36*spbk4k1*spbk6k1*spbk6k2+t26/t36*spbk4k1*spbk6k1*spbk6k2+t28/t31*&
      &t7*spak3k5*spbk4k3+t33/t31*t7*spak3k5*spbk4k3+t12/t37*spak1k5*spak2k3*spa&
      &k2k5*spbk4k1*spbk6k1*spbk6k2-(t2/t36*spak1k5*spak2k3*spak2k5*spbk4k1*spbk&
      &6k1*spbk6k2+t34/t37*spbk4k1*spbk6k1*spbk6k2+t29/t37*spbk4k1*spbk6k1*spbk6&
      &k2+t25/t23*t7*spak3k5*spbk4k3+t21/t23*t7*spak3k5*spbk4k3+t34/t31*t7*spbk4&
      &k2+t29/t31*t7*spbk4k2+t19/t18+t8/t10)))
      t3 = t3*spak2k3
      t7 = t13*spak2k3
      t13 = t20*spak2k3
      t20 = t13*spak2k5
      t21 = t24*spak2k3
      t22 = t21*spak2k5
      t24 = t27*spak2k3
      t25 = t24*spak2k5
      t26 = t32*spak2k3
      t27 = t26*spak2k5
      abb15n2 = ((8.0_ki)*(t20/t23*spbk4k2*spbk6k1+t20/t36*spbk4k1*spbk6k2+t22/t&
      &23*spbk4k2*spbk6k1+t22/t36*spbk4k1*spbk6k2+t3/t10*spak3k5*spbk4k3*spbk6k1&
      &+t7/t18*spak2k5*spbk4k2*spbk6k1+t24/t31*spak3k5*spbk4k3*spbk6k1+t26/t31*s&
      &pak3k5*spbk4k3*spbk6k1+t12/t37*spak2k3*spak2k5*spbk4k1*spbk6k2-(t2/t36*sp&
      &ak2k3*spak2k5*spbk4k1*spbk6k2+t21/t23*spak3k5*spbk4k3*spbk6k1+t7/t18*spak&
      &3k5*spbk4k3*spbk6k1+t13/t23*spak3k5*spbk4k3*spbk6k1+t3/t10*spak2k5*spbk4k&
      &2*spbk6k1+t27/t37*spbk4k1*spbk6k2+t27/t31*spbk4k2*spbk6k1+t25/t37*spbk4k1&
      &*spbk6k2+t25/t31*spbk4k2*spbk6k1)))
      t2 = t8/t23
      t3 = t11/t23
      t7 = t17/t31
      t8 = t19/t31
      t10 = t5*spbk4k1
      t11 = t10/t36*spbk6k1*spbk6k2
      t12 = t15*spbk4k1
      t13 = t12/t37*spbk6k1*spbk6k2
      abb15n3 = ((16.0_ki)*(t13+t3+t7-(t8+t2+t11)))
      abb15n4 = ((8.0_ki)*(t11+t2+t8-(t7+t3+t13)))
      t2 = t38*t9
      t3 = t38*t30
      abb15n5 = ((8.0_ki)*(t10/(t38*t35)*spbk6k2-t12/(t38*t1)*spbk6k2)+(4.0_ki)*&
      &(t14/t3*spbk6k1+t6/t2*spbk6k1+t5/t36*spbk5k4*spbk6k1*spbk6k2-(t15/t37*spb&
      &k5k4*spbk6k1*spbk6k2+t4/t2*spbk6k1+t16/t3*spbk6k1)))
      rat2d15 = 0
      rat2 = rat2 + rat2d15
      abb15n7 = abb15n1
      abb15n8 = -(abb15n2)
      abb15n9 = -(abb15n3)
      abb15n10 = -(abb15n4)
      abb15n11 = -(abb15n5)
   end subroutine
end module p26_udbar_neepgg_abbrevd15h1
