module     p26_udbar_neepgg_abbrevd24h1
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_globalsh1
   implicit none
   private
   complex(ki), public :: abb24n1
   complex(ki), public :: abb24n2
   complex(ki), public :: abb24n3
   complex(ki), public :: abb24n4
   complex(ki), public :: abb24n5
   complex(ki), public :: abb24n6
   complex(ki), public :: abb24n7
   complex(ki), public :: abb24n8
   complex(ki), public :: abb24n9
   complex(ki), public :: abb24n10
   complex(ki), public :: abb24n11
   complex(ki), public :: abb24n12
   complex(ki), public :: abb24n13
   complex(ki), public :: abb24n14
   complex(ki), public :: abb24n15
   complex(ki), public :: abb24n16
   complex(ki), public :: abb24n17
   complex(ki), public :: abb24n18
   complex(ki), public :: abb24n19
   complex(ki), public :: abb24n20
   complex(ki), public :: abb24n21
   complex(ki), public :: abb24n22
   complex(ki), public :: abb24n23
   complex(ki), public :: abb24n24
   complex(ki), public :: abb24n25
   complex(ki), public :: abb24n26
   complex(ki), public :: abb24n27
   complex(ki), public :: abb24n28
   complex(ki), public :: abb24n29
   complex(ki), public :: abb24n30
   complex(ki), public :: abb24n31
   complex(ki), public :: abb24n32
   complex(ki), public :: abb24n33
   complex(ki), public :: abb24n34
   complex(ki), public :: abb24n35
   complex(ki), public :: abb24n36
   complex(ki), public :: abb24n37
   complex(ki), public :: rat2d24
   complex(ki), public :: abb24n39
   complex(ki), public :: abb24n40
   complex(ki), public :: abb24n41
   complex(ki), public :: abb24n42
   complex(ki), public :: abb24n43
   complex(ki), public :: abb24n44
   complex(ki), public :: abb24n45
   complex(ki), public :: abb24n46
   complex(ki), public :: abb24n47
   complex(ki), public :: abb24n48
   complex(ki), public :: abb24n49
   complex(ki), public :: abb24n50
   complex(ki), public :: abb24n51
   complex(ki), public :: abb24n52
   complex(ki), public :: abb24n53
   complex(ki), public :: abb24n54
   complex(ki), public :: abb24n55
   complex(ki), public :: abb24n56
   complex(ki), public :: abb24n57
   complex(ki), public :: abb24n58
   complex(ki), public :: abb24n59
   complex(ki), public :: abb24n60
   complex(ki), public :: abb24n61
   complex(ki), public :: abb24n62
   complex(ki), public :: abb24n63
   complex(ki), public :: abb24n64
   complex(ki), public :: abb24n65
   complex(ki), public :: abb24n66
   complex(ki), public :: abb24n67
   complex(ki), public :: abb24n68
   complex(ki), public :: abb24n69
   complex(ki), public :: abb24n70
   complex(ki), public :: abb24n71
   complex(ki), public :: abb24n72
   complex(ki), public :: abb24n73
   complex(ki), public :: abb24n74
   complex(ki), public :: abb24n75
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p26_udbar_neepgg_config, only: deltaOS
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_model
      use p26_udbar_neepgg_color, only: TR
      use p26_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = NC*TR*c1
      t3 = t2*i_
      t4 = t3*spak1k5
      t5 = t4*spak2k3
      t6 = spbk6k1*spbk6k1
      t7 = t5*t6*spbk6k4
      t8 = t1*spbk6k5
      t9 = t3*spak2k3
      t10 = t9*spbk4k1
      t11 = spak1k5*spbk6k1
      t11 = t11*t11
      t12 = t10*t11
      t13 = t1*spak5k6*spbk6k5
      t14 = es234*t2*i_
      t15 = t14*spak1k5
      t16 = t15*spak2k3
      t1 = es61*t1
      t17 = t1*spbk6k5
      t18 = es34*t2*i_
      t19 = t18*spak1k5*spak2k3
      t20 = es345*t2*i_
      t21 = t20*spak1k5*spak2k3
      t22 = t14*spak2k3
      t1 = t1*spak5k6
      t23 = t1*spbk6k5
      t20 = t20*spak2k3
      t24 = t9*spak2k5
      t25 = t24*spbk6k1*spbk6k2*spbk6k4
      t26 = t5*spak2k5
      t27 = t26*spbk4k1*spbk6k1*spbk6k2
      abb24n1 = ((2.0_ki)*(t25/t8+t16/t23*spak2k5*spbk4k1*spbk6k1*spbk6k2-(t22/t&
      &17*spak2k5*spbk6k1*spbk6k2*spbk6k4+t27/t13))+(4.0_ki)*(t7/t8+t11*t20/t23*&
      &spbk4k1+t11*t22/t23*spbk4k1+t19/t17*t6*spbk6k4-(t11*t18/t23*spak2k3*spbk4&
      &k1+t21/t17*t6*spbk6k4+t16/t17*t6*spbk6k4+t12/t13)))
      t11 = t4*spak2k5
      t18 = t11*t6
      abb24n2 = ((2.0_ki)*(t18/t13-t15/t23*t6*spak2k5))
      t15 = t3*spak1k2
      abb24n3 = (-8.0_ki)*t15/t23*spbk6k1
      t22 = t3*spak1k3
      t28 = t22*spak2k5
      t29 = t28*spbk6k1*spbk6k4
      t30 = t29/t23
      t31 = (4.0_ki)*t30
      abb24n4 = t31
      abb24n5 = -(t31)
      t7 = t7/t17
      t12 = t12/t23
      abb24n6 = ((4.0_ki)*(t12-t7))
      t31 = t9*spbk6k1*spbk6k4
      t32 = es12*t2*i_
      t33 = t5*spbk4k1*spbk6k1
      t34 = t3*spak2k5
      t35 = t34*spak3k5
      t36 = t35*spbk5k4*spbk6k1
      t37 = t15*spak2k3
      t38 = t14*spak2k5
      t39 = t38*spak3k5
      t2 = es56*t2*i_
      t40 = t2*spak2k5
      t41 = t11*spak3k6
      abb24n7 = ((2.0_ki)*(t28/t17*spbk5k1*spbk6k1*spbk6k4-(t40/t23*spak3k6*spbk&
      &6k1*spbk6k4+t24/t13*spbk4k1*spbk6k2))+(4.0_ki)*(t33/t13+t20/t17*spbk6k1*s&
      &pbk6k4+t19/t23*spbk4k1*spbk6k1+t39/t23*spbk5k4*spbk6k1+t37/t17*spbk4k1*sp&
      &bk6k1*spbk6k2+t26/t23*spbk2k1*spbk5k4*spbk6k1+t5/t23*spak2k6*spbk2k1*spbk&
      &6k1*spbk6k4-(t32/t23*spak1k5*spak2k3*spbk4k1*spbk6k1+t40/t23*spak3k5*spbk&
      &5k4*spbk6k1+t32/t17*spak2k3*spbk6k1*spbk6k4+t41/t23*t6*spbk5k4+t21/t23*sp&
      &bk4k1*spbk6k1+t16/t23*spbk4k1*spbk6k1+t31/t8+t36/t13)))
      t8 = t18/t23
      t18 = (4.0_ki)*t8
      abb24n8 = t18
      abb24n9 = (-2.0_ki)*t8
      abb24n10 = -(t18)
      t8 = t34*spbk6k1
      abb24n11 = ((4.0_ki)*(t15/t17*t6-t4/t23*t6*spak2k6)+(8.0_ki)*(t38/t23*spbk&
      &6k1-t40/t23*spbk6k1)-(10.0_ki)/t13*t8)
      abb24n12 = ((4.0_ki)*(t3/t13*spak3k5*spbk6k1+t4/t23*t6*spak3k6-(t14/t23*sp&
      &ak3k5*spbk6k1+t22/t17*t6)))
      abb24n13 = ((4.0_ki)*(t5/t23*spbk5k4*spbk6k1+t15/t23*spak1k3*spbk4k1*spbk6&
      &k1-(t22/t23*spak2k6*spbk6k1*spbk6k4+t37/t23*spbk4k2*spbk6k1+t28/t23*spbk5&
      &k4*spbk6k1+t9/t13*spbk6k4)))
      t5 = t5*spbk6k1*spbk6k4
      t18 = t5/t23
      abb24n14 = ((2.0_ki)*(t30-t18))
      abb24n15 = (-4.0_ki)*t18
      t18 = t11*spak3k5*spbk5k4
      abb24n16 = ((2.0_ki)*(t29/t13+t2/t23*spak1k3*spak2k5*spbk6k1*spbk6k4-(t14/&
      &t23*spak1k3*spak2k5*spbk6k1*spbk6k4+t24/t13*spbk6k2*spbk6k4+t41/t1*spbk6k&
      &1*spbk6k4))+(4.0_ki)*(t5/t13+t19/t23*spbk6k1*spbk6k4+t26/t23*spbk5k4*spbk&
      &6k1*spbk6k2-(t22/t23*t6*spak1k5*spak2k5*spbk5k4+t21/t23*spbk6k1*spbk6k4+t&
      &16/t23*spbk6k1*spbk6k4+t18/t1*spbk6k1)))
      abb24n17 = (-8.0_ki)/t1*t11*spbk6k1
      abb24n18 = ((4.0_ki)/t23*t4*spbk6k1)
      t1 = t35*spbk6k1*spbk6k4
      t2 = t1/t13
      t4 = t25/t17
      t5 = t39/t23*spbk6k1*spbk6k4
      t11 = t18/t23*t6
      t14 = (2.0_ki)*t11
      t16 = t27/t23
      abb24n19 = ((4.0_ki)*(t14+t4+t5-(t2+t16)))
      t18 = t28/t17*t6*spbk6k4
      t6 = t41/t23*t6*spbk6k4
      abb24n20 = ((4.0_ki)*(t11+t5-t2)+(2.0_ki)*(t12+t18+t4-(t7+t6+t16)))
      abb24n21 = ((4.0_ki)*(t16+t2-(t5+t4+t14)))
      abb24n22 = ((4.0_ki)*(t14+t16+t6-(t4+t18)))
      t2 = t31/t17
      t4 = t33/t23
      t5 = t4-(2.0_ki)*t2
      abb24n23 = ((4.0_ki)*t5)
      t1 = t1/t23
      abb24n24 = ((16.0_ki)*t1)
      t6 = (8.0_ki)*t1
      abb24n25 = t6
      t1 = (4.0_ki)*t1
      abb24n26 = t1
      abb24n27 = -(t1)
      abb24n28 = -(t6)
      t1 = t34*spak3k6
      t6 = t1/t23*spbk6k1*spbk6k4
      t7 = (4.0_ki)*t6
      abb24n29 = ((8.0_ki)*(t4-t2)+t7)
      abb24n30 = ((2.0_ki)*(t5+t6))
      t2 = (16.0_ki)/t23*t8
      abb24n31 = t2
      abb24n32 = -(t2)
      t2 = t15/t23*spak3k5*spbk4k1*spbk6k1
      t4 = t24/t23*spbk4k2*spbk6k1
      t5 = t36/t23
      t6 = t3*spak2k6
      t8 = t6/t23*spak3k5*spbk6k1*spbk6k4
      abb24n33 = ((8.0_ki)*(t4+t5+t8-t2)+t7)
      abb24n34 = ((8.0_ki)*(t2-(t8+t5+t4))-t7)
      abb24n35 = ((4.0_ki)*(t9/t17*spbk5k4*spbk6k1+t15/t23*spak3k6*spbk4k1*spbk6&
      &k1-(t9/t23*spak2k6*spbk4k2*spbk6k1+t6/t23*spak3k6*spbk6k1*spbk6k4+t1/t23*&
      &spbk5k4*spbk6k1+t10/t13)))
      abb24n36 = (-8.0_ki)/t23*t6*spbk6k1
      abb24n37 = ((4.0_ki)/t17*t3*spbk6k1)
      rat2d24 = 0
      rat2 = rat2 + rat2d24
      abb24n39 = abb24n1
      abb24n40 = abb24n35
      abb24n41 = abb24n34
      abb24n42 = abb24n33
      abb24n43 = abb24n29
      abb24n44 = abb24n28
      abb24n45 = abb24n25
      abb24n46 = abb24n24
      abb24n47 = abb24n23
      abb24n48 = abb24n20
      abb24n49 = abb24n17
      abb24n50 = abb24n15
      abb24n51 = abb24n13
      abb24n52 = abb24n12
      abb24n53 = abb24n11
      abb24n54 = abb24n10
      abb24n55 = abb24n8
      abb24n56 = abb24n5
      abb24n57 = abb24n4
      abb24n58 = -(abb24n2)
      abb24n59 = -(abb24n3)
      abb24n60 = -(abb24n6)
      abb24n61 = -(abb24n7)
      abb24n62 = -(abb24n9)
      abb24n63 = -(abb24n14)
      abb24n64 = -(abb24n16)
      abb24n65 = -(abb24n18)
      abb24n66 = -(abb24n19)
      abb24n67 = -(abb24n21)
      abb24n68 = -(abb24n22)
      abb24n69 = -(abb24n26)
      abb24n70 = -(abb24n27)
      abb24n71 = -(abb24n30)
      abb24n72 = -(abb24n31)
      abb24n73 = -(abb24n32)
      abb24n74 = -(abb24n36)
      abb24n75 = -(abb24n37)
   end subroutine
end module p26_udbar_neepgg_abbrevd24h1
