module     p26_udbar_neepgg_abbrevd25h1
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_globalsh1
   implicit none
   private
   complex(ki), public :: abb25n1
   complex(ki), public :: abb25n2
   complex(ki), public :: abb25n3
   complex(ki), public :: abb25n4
   complex(ki), public :: abb25n5
   complex(ki), public :: abb25n6
   complex(ki), public :: abb25n7
   complex(ki), public :: abb25n8
   complex(ki), public :: abb25n9
   complex(ki), public :: abb25n10
   complex(ki), public :: abb25n11
   complex(ki), public :: abb25n12
   complex(ki), public :: abb25n13
   complex(ki), public :: abb25n14
   complex(ki), public :: abb25n15
   complex(ki), public :: abb25n16
   complex(ki), public :: abb25n17
   complex(ki), public :: abb25n18
   complex(ki), public :: abb25n19
   complex(ki), public :: abb25n20
   complex(ki), public :: abb25n21
   complex(ki), public :: abb25n22
   complex(ki), public :: abb25n23
   complex(ki), public :: abb25n24
   complex(ki), public :: abb25n25
   complex(ki), public :: abb25n26
   complex(ki), public :: abb25n27
   complex(ki), public :: abb25n28
   complex(ki), public :: abb25n29
   complex(ki), public :: abb25n30
   complex(ki), public :: abb25n31
   complex(ki), public :: rat2d25
   complex(ki), public :: abb25n33
   complex(ki), public :: abb25n34
   complex(ki), public :: abb25n35
   complex(ki), public :: abb25n36
   complex(ki), public :: abb25n37
   complex(ki), public :: abb25n38
   complex(ki), public :: abb25n39
   complex(ki), public :: abb25n40
   complex(ki), public :: abb25n41
   complex(ki), public :: abb25n42
   complex(ki), public :: abb25n43
   complex(ki), public :: abb25n44
   complex(ki), public :: abb25n45
   complex(ki), public :: abb25n46
   complex(ki), public :: abb25n47
   complex(ki), public :: abb25n48
   complex(ki), public :: abb25n49
   complex(ki), public :: abb25n50
   complex(ki), public :: abb25n51
   complex(ki), public :: abb25n52
   complex(ki), public :: abb25n53
   complex(ki), public :: abb25n54
   complex(ki), public :: abb25n55
   complex(ki), public :: abb25n56
   complex(ki), public :: abb25n57
   complex(ki), public :: abb25n58
   complex(ki), public :: abb25n59
   complex(ki), public :: abb25n60
   complex(ki), public :: abb25n61
   complex(ki), public :: abb25n62
   complex(ki), public :: abb25n63
   complex(ki), public :: abb25n64
   complex(ki), public :: abb25n65
   complex(ki), public :: abb25n66
   complex(ki), public :: abb25n67
   complex(ki), public :: abb25n68
   complex(ki), public :: abb25n69
   complex(ki), public :: abb25n70
   complex(ki), public :: abb25n71
   complex(ki), public :: abb25n72
   complex(ki), public :: abb25n73
   complex(ki), public :: abb25n74
   complex(ki), public :: abb25n75
   complex(ki), public :: abb25n76
   complex(ki), public :: abb25n77
   complex(ki), public :: abb25n78
   complex(ki), public :: abb25n79
   complex(ki), public :: abb25n80
   complex(ki), public :: abb25n81
   complex(ki), public :: abb25n82
   complex(ki), public :: abb25n83
   complex(ki), public :: abb25n84
   complex(ki), public :: abb25n85
   complex(ki), public :: abb25n86
   complex(ki), public :: abb25n87
   complex(ki), public :: abb25n88
   complex(ki), public :: abb25n89
   complex(ki), public :: abb25n90
   complex(ki), public :: abb25n91
   complex(ki), public :: abb25n92
   complex(ki), public :: abb25n93
   complex(ki), public :: abb25n94
   complex(ki), public :: abb25n95
   complex(ki), public :: abb25n96
   complex(ki), public :: abb25n97
   complex(ki), public :: abb25n98
   complex(ki), public :: abb25n99
   complex(ki), public :: abb25n100
   complex(ki), public :: abb25n101
   complex(ki), public :: abb25n102
   complex(ki), public :: abb25n103
   complex(ki), public :: abb25n104
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p26_udbar_neepgg_config, only: deltaOS
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_model
      use p26_udbar_neepgg_color, only: TR
      use p26_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = TR*c1
      t2 = t1*i_
      t3 = t2*spak3k5
      t4 = spak2k5*spak2k5
      t5 = NC*(es34+es61-(es345+es234))*(es34+wW*mW*i_-mW*mW)
      t6 = t5*spak5k6
      t7 = t2*spak2k3
      t8 = spak2k5*spbk6k2
      t9 = t6*spbk6k5
      t10 = t2*spak1k3
      abb25n1 = ((4.0_ki)*(t7*t8*t8/t9*spbk6k4+t3*t4/t6*spbk6k2*spbk6k4+t10*t4/t&
      &9*spbk6k1*spbk6k2*spbk6k4))
      t8 = es56*t1*i_
      t11 = t8*spak2k3*spak2k5
      abb25n2 = (-4.0_ki)*t11/t9*spbk6k1*spbk6k4
      t8 = t8*spak2k5
      t12 = t8*spak3k5
      abb25n3 = (-8.0_ki)*t12/t9*spbk6k1*spbk6k4
      abb25n4 = (-4.0_ki)*t8/t9*spbk6k1
      t13 = es12*t1*i_
      t14 = t13*spak2k5
      t15 = es345*t1*i_
      t16 = t15*spak2k5
      t1 = es61*t1*i_
      t17 = t1*spak2k5
      abb25n5 = ((4.0_ki)*(t12/t6*spbk6k4+t11/t9*spbk6k2*spbk6k4+t16/t6*spak3k5*&
      &spbk6k4+t15/t9*spak1k3*spak2k5*spbk6k1*spbk6k4+t15/t9*spak2k3*spak2k5*spb&
      &k6k2*spbk6k4-(t13/t9*spak2k3*spak2k5*spbk6k2*spbk6k4+t13/t9*spak1k3*spak2&
      &k5*spbk6k1*spbk6k4+t1/t9*spak2k3*spak2k5*spbk6k2*spbk6k4+t1/t9*spak1k3*sp&
      &ak2k5*spbk6k1*spbk6k4+t17/t6*spak3k5*spbk6k4+t14/t6*spak3k5*spbk6k4)))
      t1 = t10*spak2k5
      t5 = t5*spbk6k5
      abb25n6 = ((4.0_ki)*t1/t5*spbk6k1*spbk6k2*spbk6k4)
      t10 = t7*spak2k5
      t11 = t10*spbk4k1
      t12 = t11/t9*spbk6k2
      abb25n7 = (-8.0_ki)*t12
      abb25n8 = ((4.0_ki)*t11/t6)
      t11 = t2*spak2k5
      t13 = t11*spak3k5
      t15 = t13*spbk4k1
      abb25n9 = (-4.0_ki)*t15/t9*spbk6k2
      t15 = t15/t6
      abb25n10 = ((8.0_ki)*(t12+t15))
      abb25n11 = ((8.0_ki)*t15)
      abb25n12 = ((4.0_ki)*(t3*t4/t9*spbk5k1*spbk6k2*spbk6k4+t4*t7/t9*spbk2k1*sp&
      &bk6k2*spbk6k4))
      abb25n13 = ((8.0_ki)*t10/t5*spbk6k1*spbk6k2*spbk6k4)
      abb25n14 = ((4.0_ki)*t2*t4/t9*spbk6k1*spbk6k2)
      t3 = t13*spbk6k1
      t7 = t3*spbk6k2
      abb25n15 = ((4.0_ki)/t5*t7*spbk6k4)
      t7 = t7/t9
      abb25n16 = ((8.0_ki)*t7)
      abb25n17 = (-4.0_ki)*t7
      t7 = t11*spak3k6*spbk6k1
      abb25n18 = (-4.0_ki)*t7/t9*spbk6k2
      abb25n19 = ((4.0_ki)*t11/t5*spbk6k1*spbk6k2)
      t3 = t3/t6
      abb25n20 = ((4.0_ki)*t3)
      abb25n21 = (-8.0_ki)*t3
      abb25n22 = ((4.0_ki)/t6*t7)
      t1 = t1*spbk4k1
      abb25n23 = ((4.0_ki)*(t13/t6*spbk4k2+t10/t9*spbk4k2*spbk6k2-t1/t9*spbk6k2)&
      &)
      abb25n24 = ((4.0_ki)*(t14/t9*spbk6k4+t17/t9*spbk6k4+t2/t9*spak1k2*spak2k5*&
      &spbk4k1*spbk6k2-(t2/t6*spak1k5*spak2k5*spbk4k1+t2*t4/t9*spbk5k4*spbk6k2+t&
      &2*t4/t6*spbk4k2+t8/t9*spbk6k4+t16/t9*spbk6k4)))
      t2 = t2*t4/t9*spbk6k2*spbk6k4
      abb25n25 = ((4.0_ki)*t2)
      abb25n26 = (-8.0_ki)*t2
      abb25n27 = (-4.0_ki)*t11/t9*spbk6k2
      abb25n28 = ((4.0_ki)*(t1/t6+t13/t6*spbk5k4+t10/t9*spbk5k4*spbk6k2))
      t1 = t13/t6*spbk6k4
      t2 = t10/t9*spbk6k2*spbk6k4
      abb25n29 = ((8.0_ki)*(t1+t2))
      abb25n30 = ((4.0_ki)*(-(t2+t1)))
      abb25n31 = ((4.0_ki)*t11/t6)
      rat2d25 = 0
      rat2 = rat2 + rat2d25
      abb25n33 = -(abb25n1)
      abb25n34 = abb25n31
      abb25n35 = abb25n30
      abb25n36 = abb25n29
      abb25n37 = abb25n28
      abb25n38 = abb25n27
      abb25n39 = abb25n26
      abb25n40 = abb25n25
      abb25n41 = abb25n24
      abb25n42 = abb25n23
      abb25n43 = abb25n22
      abb25n44 = abb25n21
      abb25n45 = abb25n20
      abb25n46 = abb25n19
      abb25n47 = abb25n18
      abb25n48 = abb25n17
      abb25n49 = abb25n16
      abb25n50 = abb25n15
      abb25n51 = abb25n14
      abb25n52 = abb25n13
      abb25n53 = abb25n12
      abb25n54 = abb25n11
      abb25n55 = abb25n10
      abb25n56 = abb25n9
      abb25n57 = abb25n8
      abb25n58 = abb25n7
      abb25n59 = abb25n6
      abb25n60 = abb25n5
      abb25n61 = abb25n4
      abb25n62 = abb25n3
      abb25n63 = abb25n2
      abb25n64 = abb25n1
      abb25n65 = -(abb25n2)
      abb25n66 = -(abb25n3)
      abb25n67 = -(abb25n4)
      abb25n68 = -(abb25n5)
      abb25n69 = -(abb25n6)
      abb25n70 = -(abb25n7)
      abb25n71 = -(abb25n8)
      abb25n72 = -(abb25n9)
      abb25n73 = -(abb25n10)
      abb25n74 = -(abb25n11)
      abb25n75 = (-2.0_ki)*abb25n12
      abb25n76 = -(abb25n13)
      t1 = (2.0_ki)*abb25n14
      abb25n77 = t1
      abb25n78 = -(abb25n14)
      abb25n79 = -(t1)
      abb25n80 = -(abb25n15)
      abb25n81 = -(abb25n16)
      t1 = (2.0_ki)*abb25n17
      abb25n82 = t1
      abb25n83 = -(abb25n17)
      abb25n84 = -(t1)
      abb25n85 = -(abb25n18)
      abb25n86 = -(abb25n19)
      t1 = (2.0_ki)*abb25n20
      abb25n87 = t1
      abb25n88 = -(abb25n20)
      abb25n89 = -(t1)
      abb25n90 = -(abb25n21)
      abb25n91 = -(abb25n22)
      abb25n92 = -(abb25n23)
      abb25n93 = -(abb25n24)
      t1 = (2.0_ki)*abb25n25
      abb25n94 = t1
      abb25n95 = -(abb25n25)
      abb25n96 = -(t1)
      abb25n97 = -(abb25n26)
      abb25n98 = -(abb25n27)
      abb25n99 = -(abb25n28)
      abb25n100 = -(abb25n29)
      t1 = (2.0_ki)*abb25n30
      abb25n101 = t1
      abb25n102 = -(abb25n30)
      abb25n103 = -(t1)
      abb25n104 = -(abb25n31)
   end subroutine
end module p26_udbar_neepgg_abbrevd25h1
