module     p26_udbar_neepgg_d107h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity1/d107h1l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d107
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd107h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      real(ki) :: t31
      real(ki) :: t32
      real(ki) :: t33
      real(ki) :: t34
      real(ki) :: t35
      real(ki) :: t36
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = t1*t1
      t3 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t4 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t31 = dotproduct(k5, qshift)
      t32 = dotproduct(k6, qshift)
      t5 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t6 = (spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5k4(3)*qshift(3)-sp&
      &vak5k4(4)*qshift(4))
      t33 = dotproduct(k1, qshift)
      t34 = dotproduct(k3, qshift)
      t35 = dotproduct(k4, qshift)
      t7 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t8 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t36 = dotproduct(qshift, qshift)
      t9 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t10 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-s&
      &pvak3k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb107n46+t2*abb107n17+t1*t3*abb107n18+t1*t31*abb107n20&
         &+t1*t32*abb107n21+t1*t36*abb107n48+t1*t4*abb107n19+t1*t5*abb107n22+t1*&
         &t6*abb107n27+t10*t2*abb107n54+t2*t33*abb107n34+t2*t34*abb107n37+t2*t35&
         &*abb107n37+t2*t7*abb107n40+t2*t8*abb107n43+t2*t9*abb107n51)
         return
      end if
      t11 = spvak5k6(iv1)
      t12 = k1(iv1)
      t13 = k3(iv1)
      t14 = k4(iv1)
      t15 = k5(iv1)
      t16 = k6(iv1)
      t17 = qshift(iv1)
      t18 = spvak2k1(iv1)
      t19 = spvak2k4(iv1)
      t20 = spvak2k6(iv1)
      t21 = spvak3k1(iv1)
      t22 = spvak3k4(iv1)
      t23 = spvak3k6(iv1)
      t24 = spvak5k1(iv1)
      t25 = spvak5k4(iv1)
      t26 = t11*abb107n36
      if(deg.eq.1) then
         numerator = (t11*abb107n26+t1*t11*abb107n32+t1*t15*abb107n58+t1*t16*abb&
         &107n57+t1*t17*abb107n47+t1*t20*abb107n56+t1*t23*abb107n59+t1*t24*abb10&
         &7n60+t1*t25*abb107n45+t1*t26*t34+t1*t26*t35+t11*t3*abb107n60+t11*t31*a&
         &bb107n58+t11*t32*abb107n57+t11*t36*abb107n25+t11*t4*abb107n59+t11*t5*a&
         &bb107n56+t11*t6*abb107n45+t12*t2*abb107n31+t13*t2*abb107n30+t14*t2*abb&
         &107n30+t18*t2*abb107n24+t19*t2*abb107n28+t2*t21*abb107n23+t2*t22*abb10&
         &7n29+t1*t10*t11*abb107n53+t1*t11*t33*abb107n33+t1*t11*t7*abb107n39+t1*&
         &t11*t8*abb107n42+t1*t11*t9*abb107n50)
         return
      end if
      t2 = spvak5k6(iv2)
      t3 = t11*t2
      t31 = d(iv1,iv2)
      t4 = t3*abb107n37
      t5 = t12*t2
      t6 = k1(iv2)*t11
      t12 = t13*t2
      t13 = k3(iv2)*t11
      t14 = t14*t2
      t26 = k4(iv2)*t11
      t18 = t18*t2
      t27 = spvak2k1(iv2)*t11
      t19 = t19*t2
      t28 = spvak2k4(iv2)*t11
      t21 = t2*t21
      t29 = spvak3k1(iv2)*t11
      t22 = t2*t22
      t30 = spvak3k4(iv2)*t11
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t3*abb107n17+t34*t4+t35*t4+t1*t31*abb107n48+t10*&
         &t3*abb107n54+t3*t33*abb107n34+t3*t7*abb107n40+t3*t8*abb107n43+t3*t9*ab&
         &b107n51)+k5(iv2)*t11*abb107n20+k6(iv2)*t11*abb107n21+qshift(iv2)*t11*a&
         &bb107n49+spvak2k6(iv2)*t11*abb107n22+spvak3k6(iv2)*t11*abb107n19+spvak&
         &5k1(iv2)*t11*abb107n18+spvak5k4(iv2)*t11*abb107n27+t1*t12*abb107n38+t1&
         &*t13*abb107n38+t1*t14*abb107n38+t1*t18*abb107n52+t1*t19*abb107n44+t1*t&
         &21*abb107n55+t1*t22*abb107n41+t1*t26*abb107n38+t1*t27*abb107n52+t1*t28&
         &*abb107n44+t1*t29*abb107n55+t1*t30*abb107n41+t1*t5*abb107n35+t1*t6*abb&
         &107n35+t15*t2*abb107n20+t16*t2*abb107n21+t17*t2*abb107n49+t2*t20*abb10&
         &7n22+t2*t23*abb107n19+t2*t24*abb107n18+t2*t25*abb107n27)
         return
      end if
      t1 = spvak5k6(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(d(iv1,iv3)*t2*abb107n25+d(iv2,iv3)*t11*abb107n25&
         &+t1*t12*abb107n30+t1*t13*abb107n30+t1*t14*abb107n30+t1*t18*abb107n24+t&
         &1*t19*abb107n28+t1*t21*abb107n23+t1*t22*abb107n29+t1*t26*abb107n30+t1*&
         &t27*abb107n24+t1*t28*abb107n28+t1*t29*abb107n23+t1*t30*abb107n29+t1*t3&
         &1*abb107n25+t1*t5*abb107n31+t1*t6*abb107n31+k1(iv3)*t11*t2*abb107n31+k&
         &3(iv3)*t11*t2*abb107n30+k4(iv3)*t11*t2*abb107n30+spvak2k1(iv3)*t11*t2*&
         &abb107n24+spvak2k4(iv3)*t11*t2*abb107n28+spvak3k1(iv3)*t11*t2*abb107n2&
         &3+spvak3k4(iv3)*t11*t2*abb107n29))
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d107:
   subroutine     reconstruct_d107(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_107:
      coeffs%coeffs_107%c0 = derivative(czip)
      coeffs%coeffs_107%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_107%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_107%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_107%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_107%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_107%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_107%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_107%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_107%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_107%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_107%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_107%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_107%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_107%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_107%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_107%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_107%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_107%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_107%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_107%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_107%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_107%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_107%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_107%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_107%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_107%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_107%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_107%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_107%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_107%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_107%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_107%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_107%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_107%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_107:
   end subroutine reconstruct_d107
!---#] subroutine reconstruct_d107:
end module p26_udbar_neepgg_d107h1l1d
