module     p26_udbar_neepgg_d21h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity1/d21h1l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d21
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd21h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      real(ki) :: t43
      real(ki) :: t44
      real(ki) :: t45
      real(ki) :: t46
      real(ki) :: t47
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = t1*t1
      t43 = dotproduct(qshift, qshift)
      t3 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t4 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t5 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t44 = dotproduct(k2, qshift)
      t45 = dotproduct(k6, qshift)
      t46 = dotproduct(k5, qshift)
      t47 = dotproduct(k1, qshift)
      t6 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t7 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb21n60+t2*abb21n35+t3*abb21n51+t4*abb21n52+t43*abb21n&
         &44+t44*abb21n56+t45*abb21n58+t46*abb21n65+t47*abb21n66+t5*abb21n53+t1*&
         &t3*abb21n49+t1*t4*abb21n36+t1*t43*abb21n61+t1*t44*abb21n47+t1*t45*abb2&
         &1n42+t1*t46*abb21n38+t1*t47*abb21n39+t1*t5*abb21n45+t1*t6*abb21n48+t2*&
         &t3*abb21n63+t3*t5*abb21n43+t4*t43*abb21n73+t4*t45*abb21n37+t43*t46*abb&
         &21n69+t43*t47*abb21n67+t43*t5*abb21n54+t45*t46*abb21n41+t45*t47*abb21n&
         &40+t45*t5*abb21n46+t1*t3*t4*abb21n75+t1*t3*t46*abb21n71+t1*t3*t47*abb2&
         &1n72+t1*t3*t7*abb21n59)
         return
      end if
      t8 = k1(iv1)
      t9 = k2(iv1)
      t10 = k5(iv1)
      t11 = k6(iv1)
      t12 = qshift(iv1)
      t13 = spvak2k6(iv1)
      t14 = spvak3k4(iv1)
      t15 = spvak5k1(iv1)
      t16 = spvak5k6(iv1)
      t17 = spvak2k4(iv1)
      t18 = spvak2k1(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb21n65+t11*abb21n58+t12*abb21n57+t13*abb21n53+t14*ab&
         &b21n51+t15*abb21n52+t16*abb21n60+t8*abb21n66+t9*abb21n56+t1*t10*abb21n&
         &38+t1*t11*abb21n42+t1*t12*abb21n62+t1*t13*abb21n45+t1*t14*abb21n49+t1*&
         &t15*abb21n36+t1*t16*abb21n50+t1*t17*abb21n48+t1*t8*abb21n39+t1*t9*abb2&
         &1n47+t10*t43*abb21n69+t10*t45*abb21n41+t11*t4*abb21n37+t11*t46*abb21n4&
         &1+t11*t47*abb21n40+t11*t5*abb21n46+t12*t4*abb21n74+t12*t46*abb21n70+t1&
         &2*t47*abb21n68+t12*t5*abb21n55+t13*t3*abb21n43+t13*t43*abb21n54+t13*t4&
         &5*abb21n46+t14*t2*abb21n63+t14*t5*abb21n43+t15*t43*abb21n73+t15*t45*ab&
         &b21n37+t16*t3*abb21n49+t16*t4*abb21n36+t16*t43*abb21n61+t16*t44*abb21n&
         &47+t16*t45*abb21n42+t16*t46*abb21n38+t16*t47*abb21n39+t16*t5*abb21n45+&
         &t16*t6*abb21n48+t43*t8*abb21n67+t45*t8*abb21n40+t1*t10*t3*abb21n71+t1*&
         &t14*t4*abb21n75+t1*t14*t46*abb21n71+t1*t14*t47*abb21n72+t1*t14*t7*abb2&
         &1n59+t1*t15*t3*abb21n75+t1*t16*t3*abb21n64+t1*t18*t3*abb21n59+t1*t3*t8&
         &*abb21n72+t16*t3*t4*abb21n75+t16*t3*t46*abb21n71+t16*t3*t47*abb21n72+t&
         &16*t3*t7*abb21n59)
         return
      end if
      t43 = d(iv1,iv2)
      t2 = spvak5k6(iv2)
      t6 = t16*t2
      t19 = k6(iv2)
      t20 = qshift(iv2)
      t21 = t2*t8
      t22 = k1(iv2)
      t23 = t16*t22
      t24 = t10*t2
      t25 = k5(iv2)
      t26 = t16*t25
      t27 = spvak2k6(iv2)
      t28 = spvak5k1(iv2)
      t29 = spvak3k4(iv2)
      t30 = t14*t2
      t31 = t16*t29
      t32 = t15*t2
      t33 = t16*t28
      t34 = t29*t8
      t35 = t14*t22
      t36 = t10*t29
      t37 = t14*t25
      t38 = t18*t29
      t39 = spvak2k1(iv2)
      t40 = t14*t39
      t41 = t14*t28
      t42 = t15*t29
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t43*abb21n44+t6*abb21n35+t1*t43*abb21n61+t3*t6*a&
         &bb21n63+t4*t43*abb21n73+t43*t46*abb21n69+t43*t47*abb21n67+t43*t5*abb21&
         &n54)+t21*abb21n39+t23*abb21n39+t24*abb21n38+t26*abb21n38+t30*abb21n49+&
         &t31*abb21n49+t32*abb21n36+t33*abb21n36+k2(iv2)*t16*abb21n47+spvak2k4(i&
         &v2)*t16*abb21n48+t1*t30*abb21n64+t1*t31*abb21n64+t1*t34*abb21n72+t1*t3&
         &5*abb21n72+t1*t36*abb21n71+t1*t37*abb21n71+t1*t38*abb21n59+t1*t40*abb2&
         &1n59+t1*t41*abb21n75+t1*t42*abb21n75+t10*t19*abb21n41+t10*t20*abb21n70&
         &+t11*t2*abb21n42+t11*t22*abb21n40+t11*t25*abb21n41+t11*t27*abb21n46+t1&
         &1*t28*abb21n37+t12*t2*abb21n62+t12*t22*abb21n68+t12*t25*abb21n70+t12*t&
         &27*abb21n55+t12*t28*abb21n74+t13*t19*abb21n46+t13*t2*abb21n45+t13*t20*&
         &abb21n55+t13*t29*abb21n43+t14*t27*abb21n43+t15*t19*abb21n37+t15*t20*ab&
         &b21n74+t16*t19*abb21n42+t16*t20*abb21n62+t16*t27*abb21n45+t17*t2*abb21&
         &n48+t19*t8*abb21n40+t2*t9*abb21n47+t20*t8*abb21n68+t21*t3*abb21n72+t23&
         &*t3*abb21n72+t24*t3*abb21n71+t26*t3*abb21n71+t3*t32*abb21n75+t3*t33*ab&
         &b21n75+t30*t4*abb21n75+t30*t46*abb21n71+t30*t47*abb21n72+t30*t7*abb21n&
         &59+t31*t4*abb21n75+t31*t46*abb21n71+t31*t47*abb21n72+t31*t7*abb21n59+t&
         &16*t3*t39*abb21n59+t18*t2*t3*abb21n59)
         return
      end if
      t44 = d(iv2,iv3)
      t45 = d(iv1,iv3)
      t1 = k1(iv3)
      t3 = k5(iv3)
      t4 = spvak5k1(iv3)
      t5 = spvak5k6(iv3)
      t6 = spvak3k4(iv3)
      t7 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k6(iv3)*t43*abb21n54+t1*t43*abb21n67+t10*t&
         &44*abb21n69+t13*t44*abb21n54+t15*t44*abb21n73+t16*t44*abb21n61+t2*t45*&
         &abb21n61+t22*t45*abb21n67+t25*t45*abb21n69+t27*t45*abb21n54+t28*t45*ab&
         &b21n73+t3*t43*abb21n69+t30*t5*abb21n63+t31*t5*abb21n63+t4*t43*abb21n73&
         &+t43*t5*abb21n61+t44*t8*abb21n67+t16*t2*t6*abb21n63)+t34*t5*abb21n72+t&
         &35*t5*abb21n72+t36*t5*abb21n71+t37*t5*abb21n71+t38*t5*abb21n59+t40*t5*&
         &abb21n59+t41*t5*abb21n75+t42*t5*abb21n75+t1*t14*t2*abb21n72+t1*t16*t29&
         &*abb21n72+t10*t2*t6*abb21n71+t14*t2*t3*abb21n71+t14*t2*t4*abb21n75+t14&
         &*t2*t7*abb21n59+t15*t2*t6*abb21n75+t16*t22*t6*abb21n72+t16*t25*t6*abb2&
         &1n71+t16*t28*t6*abb21n75+t16*t29*t3*abb21n71+t16*t29*t4*abb21n75+t16*t&
         &29*t7*abb21n59+t16*t39*t6*abb21n59+t18*t2*t6*abb21n59+t2*t6*t8*abb21n7&
         &2)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d21:
   subroutine     reconstruct_d21(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group2
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group2), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_21:
      coeffs%coeffs_21%c0 = derivative(czip)
      coeffs%coeffs_21%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_21%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_21%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_21%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_21%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_21%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_21%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_21%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_21%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_21%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_21%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_21%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_21%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_21%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_21%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_21%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_21%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_21%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_21%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_21%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_21%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_21%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_21%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_21%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_21%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_21%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_21%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_21%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_21%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_21%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_21%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_21%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_21%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_21%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_21:
   end subroutine reconstruct_d21
!---#] subroutine reconstruct_d21:
end module p26_udbar_neepgg_d21h1l1d
