module     p26_udbar_neepgg_d26h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity1/d26h1l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d26
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd26h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      real(ki) :: t40
      real(ki) :: t41
      real(ki) :: t42
      real(ki) :: t43
      real(ki) :: t44
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6+k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t40 = dotproduct(qshift, qshift)
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t3 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t41 = dotproduct(k2, qshift)
      t42 = dotproduct(k5, qshift)
      t43 = dotproduct(k6, qshift)
      t44 = dotproduct(k1, qshift)
      t4 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t7 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t8 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t9 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb26n33+t1*abb26n68+t1*t1*abb26n51+t2*abb26n64+t3*abb26n6&
         &5+t4*abb26n88+t40*abb26n48+t41*abb26n66+t42*abb26n67+t43*abb26n70+t44*&
         &abb26n80+t1*t2*abb26n50+t1*t3*abb26n38+t1*t4*abb26n37+t1*t40*abb26n75+&
         &t1*t41*abb26n54+t1*t42*abb26n54+t1*t43*abb26n52+t1*t5*abb26n42+t1*t6*a&
         &bb26n44+t1*t7*abb26n55+t1*t8*abb26n56+t1*t9*abb26n58+t2*t40*abb26n83+t&
         &2*t43*abb26n45+t2*t44*abb26n46+t3*t40*abb26n98+t3*t41*abb26n37+t3*t42*&
         &abb26n35+t3*t43*abb26n35+t40*t5*abb26n92+t44*t5*abb26n41+t1*t2*t3*abb2&
         &6n101+t1*t2*t6*abb26n94)
         return
      end if
      t10 = k1(iv1)
      t11 = k2(iv1)
      t12 = k5(iv1)
      t13 = k6(iv1)
      t14 = qshift(iv1)
      t15 = spvak3k4(iv1)
      t16 = spvak5k1(iv1)
      t17 = spvak5k6(iv1)
      t18 = spvak6k1(iv1)
      t19 = spvak2k1(iv1)
      t20 = spvak2k5(iv1)
      t21 = spvak2k6(iv1)
      t22 = spvak3k1(iv1)
      t23 = t16*abb26n100
      t24 = spvak5k2(iv1)
      t25 = t17*abb26n73
      if(deg.eq.1) then
         numerator = (t10*abb26n49+t11*abb26n61+t12*abb26n60+t13*abb26n57+t14*ab&
         &b26n81+t15*abb26n63+t16*abb26n62+t17*abb26n59+t18*abb26n43+t23*t42+t23&
         &*t43+t25*t41+t25*t42+t1*t11*abb26n73+t1*t12*abb26n73+t1*t13*abb26n77+t&
         &1*t14*abb26n74+t1*t15*abb26n79+t1*t16*abb26n95+t1*t17*abb26n78+t1*t18*&
         &abb26n96+t1*t19*abb26n87+t1*t20*abb26n71+t1*t21*abb26n72+t1*t22*abb26n&
         &89+t1*t24*abb26n69+t10*t2*abb26n85+t10*t5*abb26n90+t11*t3*abb26n96+t12&
         &*t3*abb26n100+t13*t2*abb26n86+t13*t3*abb26n100+t14*t2*abb26n82+t14*t3*&
         &abb26n97+t14*t5*abb26n91+t15*t40*abb26n47+t15*t43*abb26n86+t15*t44*abb&
         &26n85+t16*t40*abb26n36+t16*t41*abb26n96+t17*t2*abb26n79+t17*t3*abb26n9&
         &5+t17*t4*abb26n96+t17*t40*abb26n53+t17*t43*abb26n77+t17*t5*abb26n89+t1&
         &7*t6*abb26n87+t17*t7*abb26n72+t17*t8*abb26n71+t17*t9*abb26n69+t22*t40*&
         &abb26n40+t22*t44*abb26n90+t1*t15*t3*abb26n34+t1*t15*t6*abb26n39+t1*t16&
         &*t2*abb26n34+t1*t19*t2*abb26n39+t17*t2*t3*abb26n34+t17*t2*t6*abb26n39)
         return
      end if
      t40 = d(iv1,iv2)
      t4 = spvak5k6(iv2)
      t7 = spvak3k1(iv2)
      t8 = spvak3k4(iv2)
      t9 = k1(iv2)
      t23 = spvak5k1(iv2)
      t25 = k2(iv2)
      t26 = k5(iv2)
      t27 = k6(iv2)
      t28 = qshift(iv2)
      t29 = t19*t4
      t30 = spvak2k1(iv2)
      t31 = t17*t30
      t32 = t15*t4
      t33 = t17*t8
      t34 = t16*t4
      t35 = t17*t23
      t36 = t19*t8
      t37 = t15*t30
      t38 = t15*t23
      t39 = t16*t8
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t40*abb26n48+t1*t40*abb26n75+t17*t4*abb26n51+t2*&
         &t40*abb26n83+t3*t40*abb26n98+t40*t5*abb26n92)+t29*abb26n44+t31*abb26n4&
         &4+t32*abb26n50+t33*abb26n50+t34*abb26n38+t35*abb26n38+spvak2k5(iv2)*t1&
         &7*abb26n56+spvak2k6(iv2)*t17*abb26n55+spvak5k2(iv2)*t17*abb26n58+spvak&
         &6k1(iv2)*t17*abb26n37+t1*t36*abb26n94+t1*t37*abb26n94+t1*t38*abb26n101&
         &+t1*t39*abb26n101+t10*t7*abb26n41+t10*t8*abb26n46+t11*t23*abb26n37+t11&
         &*t4*abb26n54+t12*t23*abb26n35+t12*t4*abb26n54+t13*t23*abb26n35+t13*t4*&
         &abb26n52+t13*t8*abb26n45+t14*t23*abb26n99+t14*t4*abb26n76+t14*t7*abb26&
         &n93+t14*t8*abb26n84+t15*t27*abb26n45+t15*t28*abb26n84+t15*t9*abb26n46+&
         &t16*t25*abb26n37+t16*t26*abb26n35+t16*t27*abb26n35+t16*t28*abb26n99+t1&
         &7*t25*abb26n54+t17*t26*abb26n54+t17*t27*abb26n52+t17*t28*abb26n76+t17*&
         &t7*abb26n42+t18*t4*abb26n37+t2*t29*abb26n94+t2*t31*abb26n94+t2*t34*abb&
         &26n101+t2*t35*abb26n101+t20*t4*abb26n56+t21*t4*abb26n55+t22*t28*abb26n&
         &93+t22*t4*abb26n42+t22*t9*abb26n41+t24*t4*abb26n58+t3*t32*abb26n101+t3&
         &*t33*abb26n101+t32*t6*abb26n94+t33*t6*abb26n94)
         return
      end if
      t41 = d(iv2,iv3)
      t42 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t2 = spvak5k1(iv3)
      t3 = spvak5k6(iv3)
      t5 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k1(iv3)*t40*abb26n40+t1*t40*abb26n47+t15*t&
         &41*abb26n47+t16*t41*abb26n36+t17*t41*abb26n53+t2*t40*abb26n36+t22*t41*&
         &abb26n40+t23*t42*abb26n36+t3*t40*abb26n53+t4*t42*abb26n53+t42*t7*abb26&
         &n40+t42*t8*abb26n47)+t3*t36*abb26n39+t3*t37*abb26n39+t3*t38*abb26n34+t&
         &3*t39*abb26n34+t1*t16*t4*abb26n34+t1*t17*t23*abb26n34+t1*t17*t30*abb26&
         &n39+t1*t19*t4*abb26n39+t15*t2*t4*abb26n34+t15*t4*t5*abb26n39+t17*t2*t8&
         &*abb26n34+t17*t5*t8*abb26n39)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d26:
   subroutine     reconstruct_d26(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_26:
      coeffs%coeffs_26%c0 = derivative(czip)
      coeffs%coeffs_26%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_26%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_26%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_26%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_26%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_26%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_26%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_26%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_26%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_26%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_26%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_26%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_26%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_26%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_26%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_26%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_26%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_26%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_26%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_26%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_26%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_26%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_26%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_26%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_26%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_26%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_26%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_26%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_26%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_26%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_26%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_26%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_26%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_26%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_26:
   end subroutine reconstruct_d26
!---#] subroutine reconstruct_d26:
end module p26_udbar_neepgg_d26h1l1d
