module     p26_udbar_neepgg_abbrevd53h3
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_globalsh3
   implicit none
   private
   complex(ki), public :: abb53n1
   complex(ki), public :: abb53n2
   complex(ki), public :: abb53n3
   complex(ki), public :: abb53n4
   complex(ki), public :: abb53n5
   complex(ki), public :: abb53n6
   complex(ki), public :: abb53n7
   complex(ki), public :: abb53n8
   complex(ki), public :: abb53n9
   complex(ki), public :: abb53n10
   complex(ki), public :: abb53n11
   complex(ki), public :: abb53n12
   complex(ki), public :: abb53n13
   complex(ki), public :: abb53n14
   complex(ki), public :: abb53n15
   complex(ki), public :: abb53n16
   complex(ki), public :: rat2d53
   complex(ki), public :: abb53n18
   complex(ki), public :: abb53n19
   complex(ki), public :: abb53n20
   complex(ki), public :: abb53n21
   complex(ki), public :: abb53n22
   complex(ki), public :: abb53n23
   complex(ki), public :: abb53n24
   complex(ki), public :: abb53n25
   complex(ki), public :: abb53n26
   complex(ki), public :: abb53n27
   complex(ki), public :: abb53n28
   complex(ki), public :: abb53n29
   complex(ki), public :: abb53n30
   complex(ki), public :: abb53n31
   complex(ki), public :: abb53n32
   complex(ki), public :: abb53n33
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   complex(ki) :: t44
   complex(ki) :: t45
   complex(ki) :: t46
   real(ki) :: t47
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p26_udbar_neepgg_config, only: deltaOS
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_model
      use p26_udbar_neepgg_color, only: TR
      use p26_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c1*i_*spak2k3
      t3 = spbk6k5*spbk6k5
      t4 = es234*NC*t1*t3
      t5 = t2/t4*spak2k5*spbk4k2*spbk5k1
      t6 = t2/t4*spak2k6*spbk4k2*spbk6k1
      t7 = t2/t4*spak3k5*spbk4k3*spbk5k1
      t8 = t2/t4*spak3k6*spbk4k3*spbk6k1
      t9 = TR*c2*i_*spak2k3
      t10 = t9/t4*spak2k5*spbk4k2*spbk5k1
      t11 = t9/t4*spak2k6*spbk4k2*spbk6k1
      t12 = t9/t4*spak3k5*spbk4k3*spbk5k1
      t13 = t9/t4*spak3k6*spbk4k3*spbk6k1
      t47 = NC*TR
      t14 = t47*c1
      t15 = t14*i_
      t16 = t15*spak2k3
      t17 = t16*spak2k5*spbk4k2
      t18 = t17*spbk5k1
      t19 = es234*t1
      t20 = t19*t3
      t21 = t18/t20
      t22 = t16*spak2k6*spbk4k2
      t23 = t22*spbk6k1
      t24 = t23/t20
      t25 = t16*spak3k5*spbk4k3
      t26 = t25*spbk5k1
      t27 = t26/t20
      t28 = t16*spak3k6*spbk4k3
      t29 = t28*spbk6k1
      t30 = t29/t20
      t31 = t47*c2
      t32 = t31*i_
      t33 = t32*spak2k3
      t34 = t33*spak2k5*spbk4k2
      t35 = t34*spbk5k1
      t36 = t35/t20
      t37 = t33*spak2k6*spbk4k2
      t38 = t37*spbk6k1
      t39 = t38/t20
      t40 = t33*spak3k5*spbk4k3
      t41 = t40*spbk5k1
      t42 = t41/t20
      t43 = t33*spak3k6*spbk4k3
      t44 = t43*spbk6k1
      t45 = t44/t20
      abb53n1 = (t10+t13+t21+t30+t39+t42+t6+t7-(t8+t5+t45+t36+t27+t24+t12+t11))
      t1 = t1*t3
      t3 = es56*t14*i_*spak2k3
      t46 = es56*t31*i_*spak2k3
      t14 = es61*t14*i_*spak2k3
      t31 = es61*t31*i_*spak2k3
      abb53n2 = ((3.0_ki)*(t29/t1+t38/t1+t3/t20*spak2k6*spbk4k2*spbk6k1+t46/t20*&
      &spak3k6*spbk4k3*spbk6k1-(t46/t20*spak2k6*spbk4k2*spbk6k1+t3/t20*spak3k6*s&
      &pbk4k3*spbk6k1+t44/t1+t23/t1))+(2.0_ki)*(t14/t20*spak2k5*spbk4k2*spbk5k1+&
      &t14/t20*spak2k6*spbk4k2*spbk6k1+t31/t20*spak3k5*spbk4k3*spbk5k1+t31/t20*s&
      &pak3k6*spbk4k3*spbk6k1-(t31/t20*spak2k6*spbk4k2*spbk6k1+t31/t20*spak2k5*s&
      &pbk4k2*spbk5k1+t14/t20*spak3k6*spbk4k3*spbk6k1+t14/t20*spak3k5*spbk4k3*sp&
      &bk5k1))+t18/t1+t41/t1+t3/t20*spak3k5*spbk4k3*spbk5k1+t46/t20*spak2k5*spbk&
      &4k2*spbk5k1-(t46/t20*spak3k5*spbk4k3*spbk5k1+t3/t20*spak2k5*spbk4k2*spbk5&
      &k1+t35/t1+t26/t1))
      t1 = t21+t42-(t36+t27)
      t3 = t30+t39-(t45+t24)
      abb53n3 = ((6.0_ki)*t1+(2.0_ki)*t3)
      abb53n4 = ((4.0_ki)*(t21+t30+t39+t42-(t45+t36+t27+t24)))
      abb53n5 = ((2.0_ki)*t1+(6.0_ki)*t3)
      t1 = t19*spbk6k5
      t3 = t15*spak1k2*spak2k3*spbk4k2
      t14 = t15*spak1k3*spak2k3*spbk4k3
      t15 = t32*spak1k2*spak2k3*spbk4k2
      t18 = t32*spak1k3*spak2k3*spbk4k3
      abb53n6 = ((3.0_ki)*(t17/t1+t40/t1-(t34/t1+t25/t1))+t14/t20*spbk6k1+t15/t2&
      &0*spbk6k1-(t3/t20*spbk6k1+t18/t20*spbk6k1))
      abb53n7 = ((3.0_ki)*(t22/t1+t43/t1-(t37/t1+t28/t1))+t18/t20*spbk5k1+t3/t20&
      &*spbk5k1-(t15/t20*spbk5k1+t14/t20*spbk5k1))
      t1 = t2*spak5k6
      t3 = t1*spbk4k2
      t14 = t9*spak5k6
      t15 = t14*spbk4k2
      abb53n8 = ((2.0_ki)*(t3/t4*spbk5k1-t15/t4*spbk5k1))
      t1 = t1*spbk4k3
      t14 = t14*spbk4k3
      abb53n9 = ((2.0_ki)*(t14/t4*spbk5k1-t1/t4*spbk5k1))
      abb53n10 = ((2.0_ki)*(t3/t4*spbk6k1-t15/t4*spbk6k1))
      abb53n11 = ((2.0_ki)*(t11+t12+t24+t27+t36+t45+t5+t8-(t7+t6+t42+t39+t30+t21&
      &+t13+t10)))
      abb53n12 = ((2.0_ki)*(t14/t4*spbk6k1-t1/t4*spbk6k1))
      t1 = t2/t4*spbk4k2
      t3 = t9/t4*spbk4k2
      t5 = t16/t20*spbk4k2
      t6 = t33/t20*spbk4k2
      abb53n13 = ((4.0_ki)*(t3+t6-(t5+t1)))
      abb53n14 = ((4.0_ki)*(t1+t5-(t6+t3)))
      t1 = t2/t4*spbk4k3
      t2 = t9/t4*spbk4k3
      t3 = t16/t20*spbk4k3
      t4 = t33/t20*spbk4k3
      abb53n15 = ((4.0_ki)*(t2+t4-(t3+t1)))
      abb53n16 = ((4.0_ki)*(t1+t3-(t4+t2)))
      rat2d53 = abb53n1
      rat2 = rat2 + rat2d53
      abb53n18 = abb53n2
      abb53n19 = abb53n16
      abb53n20 = abb53n15
      abb53n21 = abb53n14
      abb53n22 = abb53n13
      abb53n23 = abb53n11
      abb53n24 = -(abb53n3)
      abb53n25 = -(abb53n4)
      abb53n26 = -(abb53n5)
      abb53n27 = -(abb53n6)
      abb53n28 = -(abb53n7)
      abb53n29 = -(abb53n8)
      abb53n30 = -(abb53n9)
      abb53n31 = -(abb53n10)
      abb53n32 = ((2.0_ki)*abb53n11)
      abb53n33 = -(abb53n12)
   end subroutine
end module p26_udbar_neepgg_abbrevd53h3
