module     p3_ud_emnebaruu_abbrevd58h0
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_globalsh0
   implicit none
   private
   complex(ki), public :: abb58n1
   complex(ki), public :: abb58n2
   complex(ki), public :: abb58n3
   complex(ki), public :: abb58n4
   complex(ki), public :: abb58n5
   complex(ki), public :: abb58n6
   complex(ki), public :: abb58n7
   complex(ki), public :: abb58n8
   complex(ki), public :: abb58n9
   complex(ki), public :: abb58n10
   complex(ki), public :: abb58n11
   complex(ki), public :: abb58n12
   complex(ki), public :: abb58n13
   complex(ki), public :: abb58n14
   complex(ki), public :: abb58n15
   complex(ki), public :: abb58n16
   complex(ki), public :: abb58n17
   complex(ki), public :: rat2d58
   complex(ki), public :: abb58n19
   complex(ki), public :: abb58n20
   complex(ki), public :: abb58n21
   complex(ki), public :: abb58n22
   complex(ki), public :: abb58n23
   complex(ki), public :: abb58n24
   complex(ki), public :: abb58n25
   complex(ki), public :: abb58n26
   complex(ki), public :: abb58n27
   complex(ki), public :: abb58n28
   complex(ki), public :: abb58n29
   complex(ki), public :: abb58n30
   complex(ki), public :: abb58n31
   complex(ki), public :: abb58n32
   complex(ki), public :: abb58n33
   complex(ki), public :: abb58n34
   complex(ki), public :: abb58n35
   complex(ki), public :: abb58n36
   complex(ki), public :: abb58n37
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   real(ki) :: t19
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p3_ud_emnebaruu_config, only: deltaOS
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_model
      use p3_ud_emnebaruu_color, only: TR
      use p3_ud_emnebaruu_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak2k3
      t19 = TR*TR
      t4 = NC*t1
      t5 = t2*spak3k6
      t6 = c2*i_
      t7 = t6*spak2k3
      t8 = NC*NC*t1
      t9 = t6*spak3k6
      t10 = NC*c1*i_
      t11 = t10*spak2k3
      t12 = t10*spak3k6
      abb58n1 = ((8.0_ki)*(t19*t3/t4*spbk2k1+t19/t4*t5*spbk6k1)+(4.0_ki)*(-(t19/&
      &t8*t9*spbk6k1+t19*t7/t8*spbk2k1+t19*t12/t1*spbk6k1+t19*t11/t1*spbk2k1)))
      t13 = t6*spak2k6
      t14 = t13*spak3k5
      t15 = t2*spak2k6
      t16 = t15*spak3k5
      t17 = t10*spak2k6
      t18 = t17*spak3k5
      abb58n2 = ((8.0_ki)*(t19*(2.0_ki)*t16/t4*spbk2k1*spbk4k2-(t19*t14/t8*spbk2&
      &k1*spbk4k2+t19*t18/t1*spbk2k1*spbk4k2)))
      abb58n3 = ((4.0_ki)*(t19*t17/t1*spbk2k1+t19*t13/t8*spbk2k1-t19*(2.0_ki)*t1&
      &5/t4*spbk2k1))
      t13 = t19/t8*t9*spbk2k1
      t15 = (2.0_ki)*t19/t4*t5*spbk2k1
      t17 = t19*t12/t1*spbk2k1
      abb58n4 = ((8.0_ki)*(t13+t17-t15))
      t13 = t15-(t17+t13)
      abb58n5 = ((4.0_ki)*t13)
      abb58n6 = ((8.0_ki)*t13)
      t13 = t6*spak3k5
      t15 = t2*spak3k5
      t17 = t10*spak3k5
      abb58n7 = ((8.0_ki)*(t19*(2.0_ki)*t15/t4*spbk4k1-(t19*t13/t8*spbk4k1+t19*t&
      &17/t1*spbk4k1)))
      abb58n8 = ((4.0_ki)*(t19*(2.0_ki)*t16/t4*spbk4k2*spbk5k2-(t19*t14/t8*spbk4&
      &k2*spbk5k2+t19*t18/t1*spbk4k2*spbk5k2)))
      t14 = t19*t13/t8*spbk4k2
      t16 = t19*(2.0_ki)*t15/t4*spbk4k2
      t18 = t19*t17/t1*spbk4k2
      abb58n9 = ((8.0_ki)*(t14+t18-t16))
      abb58n10 = ((4.0_ki)*(t16-(t18+t14)))
      t14 = t19/t8*t9*spbk4k2
      t16 = (2.0_ki)*t19/t4*t5*spbk4k2
      t18 = t19*t12/t1*spbk4k2
      abb58n11 = ((8.0_ki)*(t14+t18-t16))
      t14 = t16-(t18+t14)
      abb58n12 = ((4.0_ki)*t14)
      abb58n13 = ((8.0_ki)*t14)
      t14 = t19/t8*t9*spbk6k2
      t16 = (2.0_ki)*t19/t4*t5*spbk6k2
      t18 = t19*t12/t1*spbk6k2
      abb58n14 = ((4.0_ki)*(t14+t18-t16))
      abb58n15 = ((4.0_ki)*(t16-(t18+t14)))
      abb58n16 = ((8.0_ki)*(t19*t15/t4*spbk5k4+t19*t3/t4*spbk4k2-t19/t4*t5*spbk6&
      &k4)+(4.0_ki)*(t19*t12/t1*spbk6k4+t19/t8*t9*spbk6k4-(t19*t7/t8*spbk4k2+t19&
      &*t13/t8*spbk5k4+t19*t17/t1*spbk5k4+t19*t11/t1*spbk4k2)))
      abb58n17 = ((4.0_ki)*((2.0_ki)*t19*t2/t4-(t19*t6/t8+t19*t10/t1)))
      rat2d58 = 0
      rat2 = rat2 + rat2d58
      abb58n19 = abb58n1
      abb58n20 = abb58n16
      abb58n21 = abb58n15
      abb58n22 = abb58n14
      abb58n23 = abb58n13
      abb58n24 = abb58n11
      abb58n25 = abb58n10
      abb58n26 = abb58n9
      abb58n27 = abb58n7
      abb58n28 = abb58n6
      abb58n29 = abb58n4
      abb58n30 = abb58n3
      abb58n31 = -(abb58n2)
      abb58n32 = -(abb58n5)
      abb58n33 = (-2.0_ki)*abb58n5
      abb58n34 = -(abb58n8)
      abb58n35 = -(abb58n12)
      abb58n36 = (-2.0_ki)*abb58n12
      abb58n37 = -(abb58n17)
   end subroutine
end module p3_ud_emnebaruu_abbrevd58h0
