module     p3_ud_emnebaruu_d59h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p3_ud_emnebaruu/helicity1/d59h1l1d.f90
   ! generator: haggies (1.1)
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d59
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p3_ud_emnebaruu_globalsl1, only: epspow
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_abbrevd59h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      real(ki) :: t22
      real(ki) :: t23
      real(ki) :: t24
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t3 = (spvak1k5(1)*qshift(1)-spvak1k5(2)*qshift(2)-spvak1k5(3)*qshift(3)-sp&
      &vak1k5(4)*qshift(4))
      t4 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-sp&
      &vak3k2(4)*qshift(4))
      t22 = dotproduct(k2, qshift)
      t23 = dotproduct(k3, qshift)
      t24 = dotproduct(k4, qshift)
      t5 = (spvak1k4(1)*qshift(1)-spvak1k4(2)*qshift(2)-spvak1k4(3)*qshift(3)-sp&
      &vak1k4(4)*qshift(4))
      t6 = (spvak6k4(1)*qshift(1)-spvak6k4(2)*qshift(2)-spvak6k4(3)*qshift(3)-sp&
      &vak6k4(4)*qshift(4))
      t7 = (spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1k2(3)*qshift(3)-sp&
      &vak1k2(4)*qshift(4))
      t8 = (spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-sp&
      &vak6k2(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb59n28*dotproduct(k1, qshift)+abb59n29*dotproduct(k6, qs&
         &hift)+t1*t2*abb59n16+t1*t3*abb59n18+t2*t22*abb59n26+t2*t23*abb59n27+t2&
         &*t24*abb59n27+t2*t4*abb59n25+t2*t5*abb59n21+t2*t7*abb59n23+t22*t3*abb5&
         &9n19+t23*t3*abb59n20+t24*t3*abb59n20+t3*t4*abb59n17+t3*t6*abb59n22+t3*&
         &t8*abb59n24)
         return
      end if
      t9 = k2(iv1)
      t10 = k3(iv1)
      t11 = k4(iv1)
      t12 = spvak1k2(iv1)
      t13 = spvak1k4(iv1)
      t14 = spvak1k5(iv1)
      t15 = t14*abb59n20
      t16 = spvak3k2(iv1)
      t17 = spvak3k4(iv1)
      t18 = spvak6k2(iv1)
      t19 = spvak6k4(iv1)
      t20 = spvak6k5(iv1)
      t21 = t20*abb59n27
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb59n28+k6(iv1)*abb59n29+t15*t23+t15*t24+t21*t23+&
         &t21*t24+t1*t14*abb59n18+t1*t20*abb59n16+t10*t2*abb59n27+t10*t3*abb59n2&
         &0+t11*t2*abb59n27+t11*t3*abb59n20+t12*t2*abb59n23+t13*t2*abb59n21+t14*&
         &t22*abb59n19+t14*t4*abb59n17+t14*t6*abb59n22+t14*t8*abb59n24+t16*t2*ab&
         &b59n25+t16*t3*abb59n17+t17*t2*abb59n16+t17*t3*abb59n18+t18*t3*abb59n24&
         &+t19*t3*abb59n22+t2*t9*abb59n26+t20*t22*abb59n26+t20*t4*abb59n25+t20*t&
         &5*abb59n21+t20*t7*abb59n23+t3*t9*abb59n19)
         return
      end if
      t1 = spvak1k5(iv2)
      t2 = spvak6k5(iv2)
      t3 = k2(iv2)
      t4 = k3(iv2)
      t5 = k4(iv2)
      t6 = spvak3k2(iv2)
      t7 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = (spvak1k2(iv2)*t20*abb59n23+spvak1k4(iv2)*t20*abb59n21+spva&
         &k6k2(iv2)*t14*abb59n24+spvak6k4(iv2)*t14*abb59n22+t1*t10*abb59n20+t1*t&
         &11*abb59n20+t1*t16*abb59n17+t1*t17*abb59n18+t1*t18*abb59n24+t1*t19*abb&
         &59n22+t1*t9*abb59n19+t10*t2*abb59n27+t11*t2*abb59n27+t12*t2*abb59n23+t&
         &13*t2*abb59n21+t14*t3*abb59n19+t14*t4*abb59n20+t14*t5*abb59n20+t14*t6*&
         &abb59n17+t14*t7*abb59n18+t16*t2*abb59n25+t17*t2*abb59n16+t2*t9*abb59n2&
         &6+t20*t3*abb59n26+t20*t4*abb59n27+t20*t5*abb59n27+t20*t6*abb59n25+t20*&
         &t7*abb59n16)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d59:
   subroutine     reconstruct_d59(coeffs)
      use p3_ud_emnebaruu_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_59:
      coeffs%coeffs_59%c0 = derivative(czip)
      coeffs%coeffs_59%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_59%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_59%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_59%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_59%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_59%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_59%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_59%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_59%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_59%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_59%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_59%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_59%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_59%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_59:
   end subroutine reconstruct_d59
!---#] subroutine reconstruct_d59:
end module p3_ud_emnebaruu_d59h1l1d
