module     p6_dubar_emnebarssbar_d29h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p6_dubar_emnebarssbar/helicity0/d29h0l1d.f90
   ! generator: haggies (1.1)
   use p6_dubar_emnebarssbar_config, only: ki
   use p6_dubar_emnebarssbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d29
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p6_dubar_emnebarssbar_globalsl1, only: epspow
      use p6_dubar_emnebarssbar_kinematics
      use p6_dubar_emnebarssbar_abbrevd29h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      real(ki) :: t25
      real(ki) :: t26
      real(ki) :: t27
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t25 = dotproduct(k1, qshift)
      t26 = dotproduct(k6, qshift)
      t2 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t3 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t4 = (spvak6k4(1)*qshift(1)-spvak6k4(2)*qshift(2)-spvak6k4(3)*qshift(3)-sp&
      &vak6k4(4)*qshift(4))
      t5 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t27 = dotproduct(qshift, qshift)
      t6 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb29n16+t25*abb29n33+t1*t2*abb29n28+t1*t25*abb29n22+t1&
         &*t26*abb29n24+t1*t27*abb29n38+t1*t5*abb29n29+t2*t26*abb29n18+t2*t4*abb&
         &29n25+t25*t3*abb29n21+t25*t5*abb29n26+t26*t3*abb29n19+t27*t3*abb29n43+&
         &t2*t5*t6*abb29n47)
         return
      end if
      t7 = k1(iv1)
      t8 = spvak6k1(iv1)
      t9 = k6(iv1)
      t10 = qshift(iv1)
      t11 = spvak2k1(iv1)
      t12 = spvak3k1(iv1)
      t13 = spvak3k4(iv1)
      t14 = spvak6k4(iv1)
      t15 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t7*abb29n27+t8*abb29n30+t1*t10*abb29n37+t1*t11*abb29n32+t1&
         &*t13*abb29n31+t1*t7*abb29n40+t1*t9*abb29n36+t10*t3*abb29n42+t11*t26*ab&
         &b29n46+t11*t4*abb29n35+t12*t25*abb29n41+t12*t26*abb29n45+t12*t27*abb29&
         &n20+t13*t25*abb29n34+t14*t2*abb29n35+t2*t8*abb29n32+t2*t9*abb29n46+t25&
         &*t8*abb29n40+t26*t8*abb29n36+t27*t8*abb29n23+t3*t7*abb29n41+t3*t9*abb2&
         &9n45+t5*t7*abb29n34+t5*t8*abb29n31+t11*t5*t6*abb29n17+t13*t2*t6*abb29n&
         &17+t15*t2*t5*abb29n17)
         return
      end if
      t25 = d(iv1,iv2)
      t4 = spvak3k1(iv2)
      t16 = spvak3k4(iv2)
      t17 = spvak6k1(iv2)
      t18 = k1(iv2)
      t19 = spvak2k1(iv2)
      t20 = k6(iv2)
      t21 = qshift(iv2)
      t22 = t11*t16
      t23 = spvak6k5(iv2)
      t24 = t13*t19
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t1*t25*abb29n38+t25*t3*abb29n43)+spvak6k4(iv2)*t&
         &11*abb29n25+t10*t17*abb29n39+t10*t4*abb29n44+t11*t17*abb29n28+t11*t20*&
         &abb29n18+t12*t18*abb29n21+t12*t20*abb29n19+t12*t21*abb29n44+t13*t17*ab&
         &b29n29+t13*t18*abb29n26+t14*t19*abb29n25+t16*t7*abb29n26+t16*t8*abb29n&
         &29+t17*t7*abb29n22+t17*t9*abb29n24+t18*t8*abb29n22+t19*t8*abb29n28+t19&
         &*t9*abb29n18+t20*t8*abb29n24+t21*t8*abb29n39+t22*t6*abb29n47+t24*t6*ab&
         &b29n47+t4*t7*abb29n21+t4*t9*abb29n19+t11*t23*t5*abb29n47+t13*t2*t23*ab&
         &b29n47+t15*t16*t2*abb29n47+t15*t19*t5*abb29n47)
         return
      end if
      t26 = d(iv2,iv3)
      t27 = d(iv1,iv3)
      t1 = spvak6k5(iv3)
      t2 = spvak3k4(iv3)
      t3 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k1(iv3)*t25*abb29n20+spvak6k1(iv3)*t25*abb&
         &29n23+t12*t26*abb29n20+t17*t27*abb29n23+t26*t8*abb29n23+t27*t4*abb29n2&
         &0)+t1*t22*abb29n17+t1*t24*abb29n17+t11*t2*t23*abb29n17+t13*t23*t3*abb2&
         &9n17+t15*t16*t3*abb29n17+t15*t19*t2*abb29n17)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d29:
   subroutine     reconstruct_d29(coeffs)
      use p6_dubar_emnebarssbar_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_29:
      coeffs%coeffs_29%c0 = derivative(czip)
      coeffs%coeffs_29%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_29%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_29%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_29%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_29%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_29%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_29%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_29%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_29%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_29%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_29%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_29%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_29%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_29%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_29%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_29%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_29%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_29%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_29%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_29%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_29%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_29%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_29%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_29%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_29%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_29%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_29%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_29%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_29%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_29%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_29%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_29%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_29%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_29%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_29:
   end subroutine reconstruct_d29
!---#] subroutine reconstruct_d29:
end module p6_dubar_emnebarssbar_d29h0l1d
