module     p7_dubar_emnebargg_abbrevd25h0
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_globalsh0
   implicit none
   private
   complex(ki), public :: abb25n1
   complex(ki), public :: abb25n2
   complex(ki), public :: abb25n3
   complex(ki), public :: abb25n4
   complex(ki), public :: abb25n5
   complex(ki), public :: abb25n6
   complex(ki), public :: abb25n7
   complex(ki), public :: abb25n8
   complex(ki), public :: abb25n9
   complex(ki), public :: abb25n10
   complex(ki), public :: abb25n11
   complex(ki), public :: abb25n12
   complex(ki), public :: abb25n13
   complex(ki), public :: abb25n14
   complex(ki), public :: abb25n15
   complex(ki), public :: abb25n16
   complex(ki), public :: abb25n17
   complex(ki), public :: abb25n18
   complex(ki), public :: abb25n19
   complex(ki), public :: abb25n20
   complex(ki), public :: abb25n21
   complex(ki), public :: abb25n22
   complex(ki), public :: rat2d25
   complex(ki), public :: abb25n24
   complex(ki), public :: abb25n25
   complex(ki), public :: abb25n26
   complex(ki), public :: abb25n27
   complex(ki), public :: abb25n28
   complex(ki), public :: abb25n29
   complex(ki), public :: abb25n30
   complex(ki), public :: abb25n31
   complex(ki), public :: abb25n32
   complex(ki), public :: abb25n33
   complex(ki), public :: abb25n34
   complex(ki), public :: abb25n35
   complex(ki), public :: abb25n36
   complex(ki), public :: abb25n37
   complex(ki), public :: abb25n38
   complex(ki), public :: abb25n39
   complex(ki), public :: abb25n40
   complex(ki), public :: abb25n41
   complex(ki), public :: abb25n42
   complex(ki), public :: abb25n43
   complex(ki), public :: abb25n44
   complex(ki), public :: abb25n45
   complex(ki), public :: abb25n46
   complex(ki), public :: abb25n47
   complex(ki), public :: abb25n48
   complex(ki), public :: abb25n49
   complex(ki), public :: abb25n50
   complex(ki), public :: abb25n51
   complex(ki), public :: abb25n52
   complex(ki), public :: abb25n53
   complex(ki), public :: abb25n54
   complex(ki), public :: abb25n55
   complex(ki), public :: abb25n56
   complex(ki), public :: abb25n57
   complex(ki), public :: abb25n58
   complex(ki), public :: abb25n59
   complex(ki), public :: abb25n60
   complex(ki), public :: abb25n61
   complex(ki), public :: abb25n62
   complex(ki), public :: abb25n63
   complex(ki), public :: abb25n64
   complex(ki), public :: abb25n65
   complex(ki), public :: abb25n66
   complex(ki), public :: abb25n67
   complex(ki), public :: abb25n68
   complex(ki), public :: abb25n69
   complex(ki), public :: abb25n70
   complex(ki), public :: abb25n71
   complex(ki), public :: abb25n72
   complex(ki), public :: abb25n73
   complex(ki), public :: abb25n74
   complex(ki), public :: abb25n75
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_dubar_emnebargg_config, only: deltaOS
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_model
      use p7_dubar_emnebargg_color, only: TR
      use p7_dubar_emnebargg_globalsl1, only: epspow
      implicit none
      t1 = TR*c1
      t2 = t1*i_
      t3 = t2*spak2k3
      t4 = t3*spbk6k4
      t5 = NC*(es34+es61-(es345+es234))*(es34+wW*mW*i_-mW*mW)
      t6 = t5*spak5k6*spak5k6
      t7 = es12*t1
      t8 = es234*t1
      t9 = es34*t1
      t10 = es345*t1
      t11 = t8*i_
      t12 = t11*spak2k6
      t13 = t12*spak3k5
      t14 = t9*i_
      t15 = t14*spak2k6
      t16 = t15*spak3k5
      t17 = t10*i_
      t18 = t17*spak2k6
      t19 = t18*spak3k5
      t1 = es61*t1*i_
      t20 = t1*spak2k6
      t21 = t20*spak3k5
      abb25n1 = ((4.0_ki)*(t13/t6*spbk6k4*spbk6k5+t19/t6*spbk6k4*spbk6k5+es61*(2&
      &.0_ki)*t10/t6*i_*spak2k3*spbk6k4+t11/t6*spak1k3*spak2k6*spbk6k1*spbk6k4+t&
      &17/t6*spak1k3*spak2k6*spbk6k1*spbk6k4+es234*t7/t6*i_*spak2k3*spbk6k4+es34&
      &5*t7/t6*i_*spak2k3*spbk6k4+es61*t8/t6*i_*spak2k3*spbk6k4+es345*t9/t6*i_*s&
      &pak2k3*spbk6k4-(es61*t9/t6*i_*spak2k3*spbk6k4+es345*t8/t6*i_*spak2k3*spbk&
      &6k4+es61*t7/t6*i_*spak2k3*spbk6k4+es34*t7/t6*i_*spak2k3*spbk6k4+t14/t6*sp&
      &ak1k3*spak2k6*spbk6k1*spbk6k4+t1/t6*spak1k3*spak2k6*spbk6k1*spbk6k4+t21/t&
      &6*spbk6k4*spbk6k5+t16/t6*spbk6k4*spbk6k5+es61*es61*t4/t6+es345*es345*t4/t&
      &6)))
      t4 = t17*spak2k3*spak2k6
      t1 = t1*spak2k3*spak2k6
      abb25n2 = ((4.0_ki)*(t13/t6*spbk5k1*spbk6k4+t19/t6*spbk5k1*spbk6k4+t4/t6*s&
      &pbk2k1*spbk6k4+t11/t6*spak2k3*spak2k6*spbk2k1*spbk6k4-(t14/t6*spak2k3*spa&
      &k2k6*spbk2k1*spbk6k4+t21/t6*spbk5k1*spbk6k4+t16/t6*spbk5k1*spbk6k4+t1/t6*&
      &spbk2k1*spbk6k4)))
      abb25n3 = ((4.0_ki)*(t12/t6*spbk6k1+t18/t6*spbk6k1-(t20/t6*spbk6k1+t15/t6*&
      &spbk6k1)))
      t8 = t12/t6*spbk6k4
      t9 = t15/t6*spbk6k4
      t10 = t18/t6*spbk6k4
      t11 = t20/t6*spbk6k4
      abb25n4 = ((8.0_ki)*(t11+t9-(t8+t10)))
      abb25n5 = ((4.0_ki)*(t10+t8-(t9+t11)))
      t8 = t2*spak1k3
      t9 = t8*spak2k6
      t5 = t5*spak5k6
      abb25n6 = ((4.0_ki)/t5*t9*spbk5k2*spbk6k1*spbk6k4)
      t3 = t3*spak2k6
      t10 = (8.0_ki)*t3/t6*spbk4k1*spbk5k2
      abb25n7 = t10
      abb25n8 = -(t10)
      t10 = t2*spak2k6
      t11 = t10*spak3k5
      abb25n9 = (-4.0_ki)*t11/t6*spbk4k1*spbk5k2
      t13 = t3*spbk5k2
      abb25n10 = ((8.0_ki)*t13/t5*spbk6k1*spbk6k4)
      t11 = t11*spbk5k2*spbk6k1
      abb25n11 = ((4.0_ki)*t11/t5*spbk6k4)
      t11 = t11/t6
      abb25n12 = ((8.0_ki)*t11)
      abb25n13 = (-4.0_ki)*t11
      abb25n14 = (-4.0_ki)*t10/t6*spak3k6*spbk5k2*spbk6k1
      t10 = t10*spbk5k2
      abb25n15 = ((4.0_ki)*t10/t5*spbk6k1)
      abb25n16 = ((4.0_ki)*(t3/t6*spbk4k2*spbk5k2-t9/t6*spbk4k1*spbk5k2))
      abb25n17 = ((4.0_ki)*t13/t6*spbk5k4)
      t3 = t13/t6*spbk6k4
      abb25n18 = ((8.0_ki)*t3)
      abb25n19 = (-4.0_ki)*t3
      t3 = spak2k6*spak2k6
      abb25n20 = ((4.0_ki)*(t4/t6*spbk5k2*spbk6k4-(t7/t6*i_*spak2k3*spak2k6*spbk&
      &5k2*spbk6k4+t2*t3/t6*spak3k5*spbk5k2*spbk6k4*spbk6k5+t3/t6*t8*spbk5k2*spb&
      &k6k1*spbk6k4+t1/t6*spbk5k2*spbk6k4)))
      abb25n21 = ((4.0_ki)*(t15/t6*spbk5k4+t20/t6*spbk5k4+t2*t3/t6*spbk5k2*spbk6&
      &k4+t2/t6*spak1k2*spak2k6*spbk4k1*spbk5k2-(t18/t6*spbk5k4+t12/t6*spbk5k4))&
      &)
      abb25n22 = (-4.0_ki)*t10/t6
      rat2d25 = 0
      rat2 = rat2 + rat2d25
      abb25n24 = -(abb25n1)
      abb25n25 = abb25n22
      abb25n26 = abb25n21
      abb25n27 = abb25n20
      abb25n28 = abb25n19
      abb25n29 = abb25n18
      abb25n30 = abb25n17
      abb25n31 = abb25n16
      abb25n32 = abb25n15
      abb25n33 = abb25n14
      abb25n34 = abb25n13
      abb25n35 = abb25n12
      abb25n36 = abb25n11
      abb25n37 = abb25n10
      abb25n38 = abb25n9
      abb25n39 = abb25n8
      abb25n40 = abb25n7
      abb25n41 = abb25n6
      abb25n42 = abb25n5
      abb25n43 = abb25n4
      abb25n44 = abb25n3
      abb25n45 = abb25n2
      abb25n46 = abb25n1
      abb25n47 = (-2.0_ki)*abb25n2
      t1 = (2.0_ki)*abb25n3
      abb25n48 = t1
      abb25n49 = -(abb25n3)
      abb25n50 = -(t1)
      abb25n51 = -(abb25n4)
      t1 = (2.0_ki)*abb25n5
      abb25n52 = t1
      abb25n53 = -(abb25n5)
      abb25n54 = -(t1)
      abb25n55 = -(abb25n6)
      abb25n56 = -(abb25n7)
      abb25n57 = -(abb25n8)
      abb25n58 = -(abb25n9)
      abb25n59 = -(abb25n10)
      abb25n60 = -(abb25n11)
      abb25n61 = -(abb25n12)
      t1 = (2.0_ki)*abb25n13
      abb25n62 = t1
      abb25n63 = -(abb25n13)
      abb25n64 = -(t1)
      abb25n65 = -(abb25n14)
      abb25n66 = -(abb25n15)
      abb25n67 = -(abb25n16)
      abb25n68 = -(abb25n17)
      abb25n69 = -(abb25n18)
      t1 = (2.0_ki)*abb25n19
      abb25n70 = t1
      abb25n71 = -(abb25n19)
      abb25n72 = -(t1)
      abb25n73 = -(abb25n20)
      abb25n74 = -(abb25n21)
      abb25n75 = -(abb25n22)
   end subroutine
end module p7_dubar_emnebargg_abbrevd25h0
