module     p7_dubar_emnebargg_d83h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity0/d83h0l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d83
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd83h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      complex(ki) :: t105
      complex(ki) :: t106
      complex(ki) :: t107
      complex(ki) :: t108
      complex(ki) :: t109
      complex(ki) :: t110
      complex(ki) :: t111
      complex(ki) :: t112
      complex(ki) :: t113
      complex(ki) :: t114
      complex(ki) :: t115
      complex(ki) :: t116
      complex(ki) :: t117
      complex(ki) :: t118
      complex(ki) :: t119
      complex(ki) :: t120
      complex(ki) :: t121
      complex(ki) :: t122
      complex(ki) :: t123
      complex(ki) :: t124
      complex(ki) :: t125
      complex(ki) :: t126
      complex(ki) :: t127
      complex(ki) :: t128
      complex(ki) :: t129
      complex(ki) :: t130
      complex(ki) :: t131
      complex(ki) :: t132
      complex(ki) :: t133
      complex(ki) :: t134
      complex(ki) :: t135
      complex(ki) :: t136
      complex(ki) :: t137
      complex(ki) :: t138
      complex(ki) :: t139
      complex(ki) :: t140
      complex(ki) :: t141
      complex(ki) :: t142
      complex(ki) :: t143
      complex(ki) :: t144
      complex(ki) :: t145
      complex(ki) :: t146
      complex(ki) :: t147
      complex(ki) :: t148
      complex(ki) :: t149
      complex(ki) :: t150
      complex(ki) :: t151
      complex(ki) :: t152
      complex(ki) :: t153
      complex(ki) :: t154
      complex(ki) :: t155
      complex(ki) :: t156
      complex(ki) :: t157
      complex(ki) :: t158
      complex(ki) :: t159
      complex(ki) :: t160
      complex(ki) :: t161
      complex(ki) :: t162
      complex(ki) :: t163
      complex(ki) :: t164
      complex(ki) :: t165
      complex(ki) :: t166
      complex(ki) :: t167
      complex(ki) :: t168
      complex(ki) :: t169
      complex(ki) :: t170
      complex(ki) :: t171
      complex(ki) :: t172
      complex(ki) :: t173
      complex(ki) :: t174
      complex(ki) :: t175
      complex(ki) :: t176
      complex(ki) :: t177
      complex(ki) :: t178
      complex(ki) :: t179
      complex(ki) :: t180
      complex(ki) :: t181
      complex(ki) :: t182
      complex(ki) :: t183
      complex(ki) :: t184
      complex(ki) :: t185
      complex(ki) :: t186
      complex(ki) :: t187
      real(ki) :: t188
      real(ki) :: t189
      real(ki) :: t190
      real(ki) :: t191
      real(ki) :: t192
      real(ki) :: t193
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t188 = dotproduct(qshift, qshift)
      t1 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t2 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t3 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t189 = dotproduct(k6, qshift)
      t4 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t5 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t190 = dotproduct(k5, qshift)
      t191 = dotproduct(k1, qshift)
      t192 = dotproduct(k2, qshift)
      t6 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t7 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t8 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t9 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t10 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-s&
      &pvak2k5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb83n93+t1*abb83n185+t188*abb83n162+t188*t188*abb83n130+t&
         &189*abb83n197+t190*abb83n200+t191*abb83n201+t192*abb83n223+t2*abb83n18&
         &7+t3*abb83n189+t4*abb83n198+t5*abb83n199+t1*t188*abb83n299+t1*t189*abb&
         &83n100+t1*t192*abb83n102+t1*t2*abb83n183+t1*t4*abb83n124+t1*t5*abb83n9&
         &9+t188*t189*abb83n257+t188*t191*abb83n212+t188*t192*abb83n251+t188*t2*&
         &abb83n206+t188*t3*abb83n288+t188*t4*abb83n192+t188*t5*abb83n260+t188*t&
         &6*abb83n282+t188*t8*abb83n239+t189*t191*abb83n159+t189*t3*abb83n109+t1&
         &89*t4*abb83n175+t189*t8*abb83n144+t190*t192*abb83n149+t190*t3*abb83n12&
         &3+t190*t5*abb83n177+t190*t6*abb83n113+t190*t8*abb83n138+t191*t192*abb8&
         &3n148+t191*t2*abb83n163+t191*t3*abb83n125+t191*t4*abb83n133+t191*t5*ab&
         &b83n158+t191*t6*abb83n111+t191*t8*abb83n140+t192*t2*abb83n181+t192*t3*&
         &abb83n107+t192*t4*abb83n150+t192*t5*abb83n151+t192*t8*abb83n145+t2*t3*&
         &abb83n179+t2*t4*abb83n166+t2*t5*abb83n173+t2*t8*abb83n165+t3*t5*abb83n&
         &106+t4*t5*abb83n174+t4*t6*abb83n114+t4*t7*abb83n126+t4*t8*abb83n143+t5&
         &*t8*abb83n141+t1*t188*t4*abb83n116+t1*t189*t4*abb83n278+t1*t192*t4*abb&
         &83n274+t1*t4*t5*abb83n272+t10*t2*t5*abb83n247+t188*t2*t5*abb83n147+t18&
         &8*t3*t5*abb83n120+t188*t4*t6*abb83n104+t188*t4*t8*abb83n156+t188*t5*t6&
         &*abb83n97+t188*t5*t9*abb83n136+t189*t4*t6*abb83n292+t189*t4*t8*abb83n2&
         &16+t190*t3*t5*abb83n268+t190*t5*t6*abb83n307+t190*t5*t9*abb83n242+t191&
         &*t2*t5*abb83n231+t191*t3*t5*abb83n273+t191*t4*t5*abb83n210+t191*t5*t6*&
         &abb83n303+t191*t5*t9*abb83n246+t192*t2*t4*abb83n249+t192*t4*t5*abb83n2&
         &10+t192*t4*t6*abb83n296+t192*t4*t8*abb83n220+t2*t3*t5*abb83n202+t2*t4*&
         &t7*abb83n285+t2*t4*t8*abb83n262+t2*t5*t7*abb83n222+t3*t4*t5*abb83n276+&
         &t4*t5*t6*abb83n308+t4*t5*t7*abb83n267+t4*t5*t8*abb83n221+t4*t5*t9*abb8&
         &3n235+t2*t4*t5*t7*abb83n94)
         return
      end if
      t11 = k1(iv1)
      t12 = k2(iv1)
      t13 = k5(iv1)
      t14 = k6(iv1)
      t15 = qshift(iv1)
      t16 = spvak3k4(iv1)
      t17 = spvak5k1(iv1)
      t18 = spvak5k6(iv1)
      t19 = spvak6k1(iv1)
      t20 = spvak6k5(iv1)
      t21 = spvak2k1(iv1)
      t22 = spvak2k6(iv1)
      t23 = spvak3k1(iv1)
      t24 = spvak2k4(iv1)
      t25 = spvak2k5(iv1)
      t26 = t18*abb83n161
      t27 = t20*abb83n161
      if(deg.eq.1) then
         numerator = (t11*abb83n168+t12*abb83n152+t13*abb83n169+t14*abb83n172+t1&
         &5*abb83n209+t16*abb83n180+t17*abb83n182+t18*abb83n170+t19*abb83n178+t2&
         &0*abb83n171+t1*t12*abb83n297+t1*t14*abb83n301+t1*t15*abb83n298+t1*t16*&
         &abb83n184+t1*t18*abb83n302+t1*t20*abb83n265+t11*t188*abb83n160+t11*t18&
         &9*abb83n214+t11*t192*abb83n227+t11*t2*abb83n208+t11*t3*abb83n264+t11*t&
         &4*abb83n248+t11*t5*abb83n215+t11*t6*abb83n284+t11*t8*abb83n237+t12*t18&
         &8*abb83n131+t12*t190*abb83n226+t12*t191*abb83n227+t12*t2*abb83n186+t12&
         &*t3*abb83n290+t12*t4*abb83n225+t12*t5*abb83n224+t12*t8*abb83n232+t13*t&
         &192*abb83n226+t13*t3*abb83n266+t13*t5*abb83n190+t13*t6*abb83n280+t13*t&
         &8*abb83n241+t14*t188*abb83n129+t14*t191*abb83n214+t14*t3*abb83n286+t14&
         &*t4*abb83n194+t14*t8*abb83n233+t15*t188*abb83n255+t15*t189*abb83n256+t&
         &15*t191*abb83n211+t15*t192*abb83n250+t15*t2*abb83n205+t15*t3*abb83n287&
         &+t15*t4*abb83n191+t15*t5*abb83n259+t15*t6*abb83n281+t15*t8*abb83n238+t&
         &16*t188*abb83n164+t16*t191*abb83n208+t16*t192*abb83n186+t16*t3*abb83n1&
         &88+t16*t4*abb83n203+t16*t5*abb83n196+t16*t8*abb83n204+t17*t188*abb83n1&
         &01+t17*t189*abb83n301+t17*t192*abb83n297+t17*t2*abb83n184+t17*t4*abb83&
         &n265+t17*t5*abb83n302+t18*t188*abb83n128+t18*t190*abb83n190+t18*t191*a&
         &bb83n215+t18*t192*abb83n224+t18*t2*abb83n196+t18*t3*abb83n291+t18*t4*a&
         &bb83n195+t18*t8*abb83n236+t188*t19*abb83n108+t188*t20*abb83n176+t188*t&
         &22*abb83n139+t188*t23*abb83n112+t189*t19*abb83n286+t189*t20*abb83n194+&
         &t189*t22*abb83n233+t19*t190*abb83n266+t19*t191*abb83n264+t19*t192*abb8&
         &3n290+t19*t2*abb83n188+t19*t5*abb83n291+t190*t22*abb83n241+t190*t23*ab&
         &b83n280+t191*t20*abb83n248+t191*t22*abb83n237+t191*t23*abb83n284+t191*&
         &t26*t4+t191*t27*t5+t192*t20*abb83n225+t192*t22*abb83n232+t192*t26*t4+t&
         &192*t27*t5+t2*t20*abb83n203+t2*t22*abb83n204+t20*t5*abb83n195+t20*t6*a&
         &bb83n279+t20*t7*abb83n263+t20*t8*abb83n234+t21*t4*abb83n263+t22*t4*abb&
         &83n234+t22*t5*abb83n236+t23*t4*abb83n279+t1*t12*t4*abb83n117+t1*t14*t4&
         &*abb83n115+t1*t15*t4*abb83n277+t1*t18*t4*abb83n119+t1*t188*t20*abb83n2&
         &76+t1*t189*t20*abb83n115+t1*t192*t20*abb83n117+t1*t20*t5*abb83n119+t10&
         &*t16*t5*abb83n134+t10*t18*t2*abb83n134+t11*t2*t5*abb83n146+t11*t3*t5*a&
         &bb83n118+t11*t4*t5*abb83n161+t11*t5*t6*abb83n98+t11*t5*t9*abb83n135+t1&
         &2*t2*t4*abb83n132+t12*t4*t5*abb83n161+t12*t4*t6*abb83n103+t12*t4*t8*ab&
         &b83n155+t13*t3*t5*abb83n121+t13*t5*t6*abb83n96+t13*t5*t9*abb83n137+t14&
         &*t4*t6*abb83n105+t14*t4*t8*abb83n157+t15*t2*t5*abb83n230+t15*t3*t5*abb&
         &83n271+t15*t4*t6*abb83n295+t15*t4*t8*abb83n219+t15*t5*t6*abb83n306+t15&
         &*t5*t9*abb83n245+t16*t188*t5*abb83n229+t16*t191*t5*abb83n146+t16*t192*&
         &t4*abb83n132+t16*t3*t5*abb83n167+t16*t4*t7*abb83n110+t16*t4*t8*abb83n1&
         &27+t16*t5*t7*abb83n153+t17*t188*t4*abb83n276+t17*t189*t4*abb83n115+t17&
         &*t192*t4*abb83n117+t17*t4*t5*abb83n119+t18*t188*t2*abb83n229+t18*t188*&
         &t3*abb83n270+t18*t188*t6*abb83n305+t18*t188*t9*abb83n244+t18*t190*t3*a&
         &bb83n121+t18*t190*t6*abb83n96+t18*t190*t9*abb83n137+t18*t191*t2*abb83n&
         &146+t18*t191*t3*abb83n118+t18*t191*t6*abb83n98+t18*t191*t9*abb83n135+t&
         &18*t2*t3*abb83n167+t18*t2*t7*abb83n153+t18*t3*t4*abb83n116+t18*t4*t6*a&
         &bb83n95+t18*t4*t7*abb83n122+t18*t4*t8*abb83n154+t18*t4*t9*abb83n142+t1&
         &88*t19*t5*abb83n270+t188*t20*t6*abb83n294+t188*t20*t8*abb83n218+t188*t&
         &22*t4*abb83n218+t188*t23*t4*abb83n294+t188*t23*t5*abb83n305+t188*t24*t&
         &5*abb83n244+t189*t20*t6*abb83n105+t189*t20*t8*abb83n157+t189*t22*t4*ab&
         &b83n157+t189*t23*t4*abb83n105+t19*t190*t5*abb83n121+t19*t191*t5*abb83n&
         &118+t19*t2*t5*abb83n167+t19*t4*t5*abb83n116+t190*t23*t5*abb83n96+t190*&
         &t24*t5*abb83n137+t191*t23*t5*abb83n98+t191*t24*t5*abb83n135+t192*t2*t2&
         &0*abb83n132+t192*t20*t6*abb83n103+t192*t20*t8*abb83n155+t192*t22*t4*ab&
         &b83n155+t192*t23*t4*abb83n103+t2*t20*t7*abb83n110+t2*t20*t8*abb83n127+&
         &t2*t21*t4*abb83n110+t2*t21*t5*abb83n153+t2*t22*t4*abb83n127+t2*t25*t5*&
         &abb83n134+t20*t3*t5*abb83n116+t20*t5*t6*abb83n95+t20*t5*t7*abb83n122+t&
         &20*t5*t8*abb83n154+t20*t5*t9*abb83n142+t21*t4*t5*abb83n122+t22*t4*t5*a&
         &bb83n154+t23*t4*t5*abb83n95+t24*t4*t5*abb83n142+t16*t4*t5*t7*abb83n309&
         &+t18*t2*t4*t7*abb83n309+t2*t20*t5*t7*abb83n309+t2*t21*t4*t5*abb83n309)
         return
      end if
      t193 = d(iv1,iv2)
      t26 = qshift(iv2)
      t27 = k2(iv2)
      t28 = k6(iv2)
      t29 = spvak2k6(iv2)
      t30 = spvak3k1(iv2)
      t31 = t11*t30
      t32 = spvak3k4(iv2)
      t33 = t11*t32
      t34 = spvak5k6(iv2)
      t35 = t11*t34
      t36 = spvak6k1(iv2)
      t37 = t11*t36
      t38 = spvak6k5(iv2)
      t39 = t11*t38
      t40 = k1(iv2)
      t41 = t23*t40
      t42 = t16*t40
      t43 = t18*t40
      t44 = t19*t40
      t45 = t20*t40
      t46 = k5(iv2)
      t47 = t12*t29
      t48 = t12*t32
      t49 = spvak5k1(iv2)
      t50 = t12*t49
      t51 = t12*t34
      t52 = t12*t38
      t53 = t22*t27
      t54 = t16*t27
      t55 = t17*t27
      t56 = t18*t27
      t57 = t20*t27
      t58 = t13*t30
      t59 = t13*t34
      t60 = t13*t36
      t61 = t23*t46
      t62 = t18*t46
      t63 = t19*t46
      t64 = t14*t29
      t65 = t14*t49
      t66 = t14*t38
      t67 = t22*t28
      t68 = t17*t28
      t69 = t20*t28
      t70 = t15*t29
      t71 = t15*t30
      t72 = t15*t32
      t73 = t15*t49
      t74 = t15*t34
      t75 = t15*t36
      t76 = t15*t38
      t77 = t22*t26
      t78 = t23*t26
      t79 = t16*t26
      t80 = t17*t26
      t81 = t18*t26
      t82 = t19*t26
      t83 = t20*t26
      t84 = t21*t38
      t85 = spvak2k1(iv2)
      t86 = t20*t85
      t87 = t22*t32
      t88 = t22*t34
      t89 = t22*t38
      t90 = t16*t29
      t91 = t18*t29
      t92 = t20*t29
      t93 = t23*t38
      t94 = t20*t30
      t95 = t16*t34
      t96 = t16*t36
      t97 = t16*t38
      t98 = t18*t32
      t99 = t19*t32
      t100 = t20*t32
      t101 = t17*t34
      t102 = t17*t38
      t103 = t18*t49
      t104 = t20*t49
      t105 = t18*t36
      t106 = t18*t38
      t107 = t19*t34
      t108 = t20*t34
      t109 = spvak2k4(iv2)
      t110 = t109*t11
      t111 = t24*t40
      t112 = t12*t30
      t113 = t23*t27
      t114 = t109*t13
      t115 = t24*t46
      t116 = t14*t30
      t117 = t23*t28
      t118 = t109*t15
      t119 = t24*t26
      t120 = t21*t32
      t121 = t21*t34
      t122 = t16*t85
      t123 = t18*t85
      t124 = t24*t34
      t125 = t109*t18
      t126 = t25*t32
      t127 = spvak2k5(iv2)
      t128 = t127*t16
      t129 = t23*t34
      t130 = t18*t30
      t131 = t106*abb83n210
      t132 = t108*abb83n210
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t193*abb83n162+t1*t193*abb83n299+t15*t26*abb83n2&
         &53+t188*t193*abb83n254+t189*t193*abb83n257+t191*t193*abb83n212+t192*t1&
         &93*abb83n251+t193*t2*abb83n206+t193*t3*abb83n288+t193*t4*abb83n192+t19&
         &3*t5*abb83n260+t193*t6*abb83n282+t193*t8*abb83n239+t1*t193*t4*abb83n11&
         &6+t193*t2*t5*abb83n147+t193*t3*t5*abb83n120+t193*t4*t6*abb83n104+t193*&
         &t4*t8*abb83n156+t193*t5*t6*abb83n97+t193*t5*t9*abb83n136)+t100*abb83n1&
         &66+t101*abb83n99+t102*abb83n124+t103*abb83n99+t104*abb83n124+t105*abb8&
         &3n106+t106*abb83n174+t107*abb83n106+t108*abb83n174+t131*t191+t131*t192&
         &+t132*t191+t132*t192+t31*abb83n111+t33*abb83n163+t35*abb83n158+t37*abb&
         &83n125+t39*abb83n133+t41*abb83n111+t42*abb83n163+t43*abb83n158+t44*abb&
         &83n125+t45*abb83n133+t47*abb83n145+t48*abb83n181+t50*abb83n102+t51*abb&
         &83n151+t52*abb83n150+t53*abb83n145+t54*abb83n181+t55*abb83n102+t56*abb&
         &83n151+t57*abb83n150+t58*abb83n113+t59*abb83n177+t60*abb83n123+t61*abb&
         &83n113+t62*abb83n177+t63*abb83n123+t64*abb83n144+t65*abb83n100+t66*abb&
         &83n175+t67*abb83n144+t68*abb83n100+t69*abb83n175+t70*abb83n240+t71*abb&
         &83n283+t72*abb83n207+t73*abb83n300+t74*abb83n261+t75*abb83n289+t76*abb&
         &83n193+t77*abb83n240+t78*abb83n283+t79*abb83n207+t80*abb83n300+t81*abb&
         &83n261+t82*abb83n289+t83*abb83n193+t84*abb83n126+t86*abb83n126+t87*abb&
         &83n165+t88*abb83n141+t89*abb83n143+t90*abb83n165+t91*abb83n141+t92*abb&
         &83n143+t93*abb83n114+t94*abb83n114+t95*abb83n173+t96*abb83n179+t97*abb&
         &83n166+t98*abb83n173+t99*abb83n179+t1*t106*abb83n272+t1*t108*abb83n272&
         &+t1*t52*abb83n274+t1*t57*abb83n274+t1*t66*abb83n278+t1*t69*abb83n278+t&
         &1*t76*abb83n275+t1*t83*abb83n275+t10*t95*abb83n247+t10*t98*abb83n247+t&
         &100*t192*abb83n249+t100*t7*abb83n285+t100*t8*abb83n262+t101*t4*abb83n2&
         &72+t102*t188*abb83n116+t102*t189*abb83n278+t102*t192*abb83n274+t102*t5&
         &*abb83n272+t103*t4*abb83n272+t104*t188*abb83n116+t104*t189*abb83n278+t&
         &104*t192*abb83n274+t104*t5*abb83n272+t105*t188*abb83n120+t105*t190*abb&
         &83n268+t105*t191*abb83n273+t105*t2*abb83n202+t105*t4*abb83n276+t106*t3&
         &*abb83n276+t106*t6*abb83n308+t106*t7*abb83n267+t106*t8*abb83n221+t106*&
         &t9*abb83n235+t107*t188*abb83n120+t107*t190*abb83n268+t107*t191*abb83n2&
         &73+t107*t2*abb83n202+t107*t4*abb83n276+t108*t3*abb83n276+t108*t6*abb83&
         &n308+t108*t7*abb83n267+t108*t8*abb83n221+t108*t9*abb83n235+t11*t26*abb&
         &83n213+t11*t27*abb83n148+t11*t28*abb83n159+t11*t29*abb83n140+t110*t5*a&
         &bb83n246+t111*t5*abb83n246+t112*t4*abb83n296+t113*t4*abb83n296+t114*t5&
         &*abb83n242+t115*t5*abb83n242+t116*t4*abb83n292+t117*t4*abb83n292+t118*&
         &t5*abb83n243+t119*t5*abb83n243+t12*t26*abb83n252+t12*t36*abb83n107+t12&
         &*t40*abb83n148+t12*t46*abb83n149+t120*t4*abb83n285+t120*t5*abb83n222+t&
         &121*t2*abb83n222+t121*t4*abb83n267+t122*t4*abb83n285+t122*t5*abb83n222&
         &+t123*t2*abb83n222+t123*t4*abb83n267+t124*t188*abb83n136+t124*t190*abb&
         &83n242+t124*t191*abb83n246+t124*t4*abb83n235+t125*t188*abb83n136+t125*&
         &t190*abb83n242+t125*t191*abb83n246+t125*t4*abb83n235+t126*t5*abb83n247&
         &+t128*t5*abb83n247+t129*t188*abb83n97+t129*t190*abb83n307+t129*t191*ab&
         &b83n303+t129*t4*abb83n308+t13*t27*abb83n149+t13*t29*abb83n138+t130*t18&
         &8*abb83n97+t130*t190*abb83n307+t130*t191*abb83n303+t130*t4*abb83n308+t&
         &14*t26*abb83n258+t14*t36*abb83n109+t14*t40*abb83n159+t15*t27*abb83n252&
         &+t15*t28*abb83n258+t15*t40*abb83n213+t16*t49*abb83n183+t17*t32*abb83n1&
         &83+t188*t89*abb83n156+t188*t92*abb83n156+t188*t93*abb83n104+t188*t94*a&
         &bb83n104+t188*t95*abb83n147+t188*t98*abb83n147+t189*t89*abb83n216+t189&
         &*t92*abb83n216+t189*t93*abb83n292+t189*t94*abb83n292+t19*t27*abb83n107&
         &+t19*t28*abb83n109+t191*t95*abb83n231+t191*t98*abb83n231+t192*t89*abb8&
         &3n220+t192*t92*abb83n220+t192*t93*abb83n296+t192*t94*abb83n296+t192*t9&
         &7*abb83n249+t2*t35*abb83n231+t2*t43*abb83n231+t2*t52*abb83n249+t2*t57*&
         &abb83n249+t2*t74*abb83n228+t2*t81*abb83n228+t2*t84*abb83n285+t2*t86*ab&
         &b83n285+t2*t89*abb83n262+t2*t92*abb83n262+t22*t40*abb83n140+t22*t46*ab&
         &b83n138+t3*t35*abb83n273+t3*t43*abb83n273+t3*t59*abb83n268+t3*t62*abb8&
         &3n268+t3*t74*abb83n269+t3*t81*abb83n269+t3*t95*abb83n202+t3*t98*abb83n&
         &202+t31*t5*abb83n303+t33*t5*abb83n231+t35*t4*abb83n210+t35*t6*abb83n30&
         &3+t35*t9*abb83n246+t37*t5*abb83n273+t39*t5*abb83n210+t4*t43*abb83n210+&
         &t4*t47*abb83n220+t4*t48*abb83n249+t4*t50*abb83n274+t4*t51*abb83n210+t4&
         &*t53*abb83n220+t4*t54*abb83n249+t4*t55*abb83n274+t4*t56*abb83n210+t4*t&
         &64*abb83n216+t4*t65*abb83n278+t4*t67*abb83n216+t4*t68*abb83n278+t4*t70&
         &*abb83n217+t4*t71*abb83n293+t4*t73*abb83n275+t4*t77*abb83n217+t4*t78*a&
         &bb83n293+t4*t80*abb83n275+t4*t87*abb83n262+t4*t88*abb83n221+t4*t90*abb&
         &83n262+t4*t91*abb83n221+t41*t5*abb83n303+t42*t5*abb83n231+t43*t6*abb83&
         &n303+t43*t9*abb83n246+t44*t5*abb83n273+t45*t5*abb83n210+t5*t52*abb83n2&
         &10+t5*t57*abb83n210+t5*t58*abb83n307+t5*t60*abb83n268+t5*t61*abb83n307&
         &+t5*t63*abb83n268+t5*t71*abb83n304+t5*t72*abb83n228+t5*t75*abb83n269+t&
         &5*t78*abb83n304+t5*t79*abb83n228+t5*t82*abb83n269+t5*t84*abb83n267+t5*&
         &t86*abb83n267+t5*t89*abb83n221+t5*t92*abb83n221+t5*t93*abb83n308+t5*t9&
         &4*abb83n308+t5*t96*abb83n202+t5*t99*abb83n202+t52*t6*abb83n296+t52*t8*&
         &abb83n220+t57*t6*abb83n296+t57*t8*abb83n220+t59*t6*abb83n307+t59*t9*ab&
         &b83n242+t6*t62*abb83n307+t6*t66*abb83n292+t6*t69*abb83n292+t6*t74*abb8&
         &3n304+t6*t76*abb83n293+t6*t81*abb83n304+t6*t83*abb83n293+t62*t9*abb83n&
         &242+t66*t8*abb83n216+t69*t8*abb83n216+t7*t95*abb83n222+t7*t97*abb83n28&
         &5+t7*t98*abb83n222+t74*t9*abb83n243+t76*t8*abb83n217+t8*t83*abb83n217+&
         &t8*t97*abb83n262+t81*t9*abb83n243+t100*t5*t7*abb83n94+t106*t2*t7*abb83&
         &n94+t108*t2*t7*abb83n94+t109*t20*t5*abb83n235+t120*t4*t5*abb83n94+t121&
         &*t2*t4*abb83n94+t122*t4*t5*abb83n94+t123*t2*t4*abb83n94+t127*t18*t2*ab&
         &b83n247+t19*t38*t5*abb83n276+t2*t25*t34*abb83n247+t2*t5*t84*abb83n94+t&
         &2*t5*t86*abb83n94+t20*t36*t5*abb83n276+t24*t38*t5*abb83n235+t4*t7*t95*&
         &abb83n94+t4*t7*t98*abb83n94+t5*t7*t97*abb83n94)
         return
      end if
      t188 = d(iv2,iv3)
      t189 = d(iv1,iv3)
      t10 = k1(iv3)
      t37 = k2(iv3)
      t39 = k6(iv3)
      t44 = qshift(iv3)
      t45 = t188*t22
      t52 = t189*t29
      t57 = spvak2k6(iv3)
      t60 = t193*t57
      t63 = t188*t23
      t66 = t189*t30
      t69 = spvak3k1(iv3)
      t75 = t193*t69
      t76 = t16*t188
      t82 = t189*t32
      t83 = spvak3k4(iv3)
      t84 = t193*t83
      t86 = t17*t188
      t96 = t189*t49
      t97 = spvak5k1(iv3)
      t99 = t193*t97
      t100 = t18*t188
      t106 = t189*t34
      t108 = spvak5k6(iv3)
      t131 = t108*t193
      t132 = t188*t19
      t133 = t189*t36
      t134 = spvak6k1(iv3)
      t135 = t134*t193
      t136 = t188*t20
      t137 = t189*t38
      t138 = spvak6k5(iv3)
      t139 = t138*t193
      t140 = spvak2k4(iv3)
      t141 = t108*t11
      t142 = t108*t40
      t143 = t10*t18
      t144 = t10*t34
      t145 = k5(iv3)
      t146 = t15*t69
      t147 = t26*t69
      t148 = t23*t44
      t149 = t30*t44
      t150 = t108*t120
      t151 = t120*t138
      t152 = t21*t83
      t153 = t152*t34
      t154 = t152*t38
      t121 = t121*t138
      t155 = t108*t21*t38
      t156 = t108*t122
      t157 = t122*t138
      t158 = t83*t85
      t159 = t158*t18
      t160 = t158*t20
      t123 = t123*t138
      t161 = t108*t20*t85
      t162 = spvak2k1(iv3)
      t163 = t16*t162
      t164 = t163*t34
      t165 = t163*t38
      t166 = t162*t32
      t167 = t166*t18
      t168 = t166*t20
      t169 = t162*t18*t38
      t170 = t162*t20*t34
      t171 = t108*t24
      t172 = t108*t109
      t173 = t140*t18
      t174 = t140*t34
      t175 = spvak2k5(iv3)
      t176 = t108*t23
      t177 = t108*t30
      t178 = t18*t69
      t179 = t34*t69
      t180 = t108*t16
      t181 = t108*t32
      t182 = t18*t83
      t183 = t34*t83
      t184 = t134*t18
      t185 = t134*t34
      t186 = t108*t19
      t187 = t108*t36
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t100*abb83n128+t106*abb83n128+t131*abb83n128+t13&
         &2*abb83n108+t133*abb83n108+t135*abb83n108+t136*abb83n176+t137*abb83n17&
         &6+t139*abb83n176+t45*abb83n139+t52*abb83n139+t60*abb83n139+t63*abb83n1&
         &12+t66*abb83n112+t75*abb83n112+t76*abb83n164+t82*abb83n164+t84*abb83n1&
         &64+t86*abb83n101+t96*abb83n101+t99*abb83n101+t1*t136*abb83n276+t1*t137&
         &*abb83n276+t1*t139*abb83n276+t10*t193*abb83n160+t100*t2*abb83n229+t100&
         &*t3*abb83n270+t100*t6*abb83n305+t100*t9*abb83n244+t106*t2*abb83n229+t1&
         &06*t3*abb83n270+t106*t6*abb83n305+t106*t9*abb83n244+t11*t188*abb83n160&
         &+t12*t188*abb83n131+t131*t2*abb83n229+t131*t3*abb83n270+t131*t6*abb83n&
         &305+t131*t9*abb83n244+t132*t5*abb83n270+t133*t5*abb83n270+t135*t5*abb8&
         &3n270+t136*t6*abb83n294+t136*t8*abb83n218+t137*t6*abb83n294+t137*t8*ab&
         &b83n218+t139*t6*abb83n294+t139*t8*abb83n218+t14*t188*abb83n129+t15*t18&
         &8*abb83n255+t189*t26*abb83n255+t189*t27*abb83n131+t189*t28*abb83n129+t&
         &189*t40*abb83n160+t193*t37*abb83n131+t193*t39*abb83n129+t193*t44*abb83&
         &n255+t4*t45*abb83n218+t4*t52*abb83n218+t4*t60*abb83n218+t4*t63*abb83n2&
         &94+t4*t66*abb83n294+t4*t75*abb83n294+t4*t86*abb83n276+t4*t96*abb83n276&
         &+t4*t99*abb83n276+t5*t63*abb83n305+t5*t66*abb83n305+t5*t75*abb83n305+t&
         &5*t76*abb83n229+t5*t82*abb83n229+t5*t84*abb83n229+t109*t189*t5*abb83n2&
         &44+t140*t193*t5*abb83n244+t188*t24*t5*abb83n244)+t121*abb83n122+t123*a&
         &bb83n122+t150*abb83n153+t151*abb83n110+t153*abb83n153+t154*abb83n110+t&
         &155*abb83n122+t156*abb83n153+t157*abb83n110+t159*abb83n153+t160*abb83n&
         &110+t161*abb83n122+t164*abb83n153+t165*abb83n110+t167*abb83n153+t168*a&
         &bb83n110+t169*abb83n122+t170*abb83n122+t101*t138*abb83n119+t103*t138*a&
         &bb83n119+t105*t138*abb83n116+t107*t138*abb83n116+t108*t110*abb83n135+t&
         &108*t111*abb83n135+t108*t114*abb83n137+t108*t115*abb83n137+t108*t118*a&
         &bb83n245+t108*t119*abb83n245+t108*t126*abb83n134+t108*t128*abb83n134+t&
         &108*t31*abb83n98+t108*t33*abb83n146+t108*t41*abb83n98+t108*t42*abb83n1&
         &46+t108*t58*abb83n96+t108*t61*abb83n96+t108*t71*abb83n306+t108*t72*abb&
         &83n230+t108*t78*abb83n306+t108*t79*abb83n230+t112*t138*abb83n103+t113*&
         &t138*abb83n103+t116*t138*abb83n105+t117*t138*abb83n105+t121*t2*abb83n3&
         &09+t123*t2*abb83n309+t124*t138*abb83n142+t125*t138*abb83n142+t129*t138&
         &*abb83n95+t130*t138*abb83n95+t134*t35*abb83n118+t134*t43*abb83n118+t13&
         &4*t59*abb83n121+t134*t62*abb83n121+t134*t74*abb83n271+t134*t81*abb83n2&
         &71+t134*t95*abb83n167+t134*t98*abb83n167+t138*t35*abb83n161+t138*t43*a&
         &bb83n161+t138*t47*abb83n155+t138*t48*abb83n132+t138*t50*abb83n117+t138&
         &*t51*abb83n161+t138*t53*abb83n155+t138*t54*abb83n132+t138*t55*abb83n11&
         &7+t138*t56*abb83n161+t138*t64*abb83n157+t138*t65*abb83n115+t138*t67*ab&
         &b83n157+t138*t68*abb83n115+t138*t70*abb83n219+t138*t71*abb83n295+t138*&
         &t73*abb83n277+t138*t77*abb83n219+t138*t78*abb83n295+t138*t80*abb83n277&
         &+t138*t87*abb83n127+t138*t88*abb83n154+t138*t90*abb83n127+t138*t91*abb&
         &83n154+t141*t36*abb83n118+t141*t38*abb83n161+t142*t19*abb83n118+t142*t&
         &20*abb83n161+t143*t36*abb83n118+t143*t38*abb83n161+t144*t19*abb83n118+&
         &t144*t20*abb83n161+t146*t34*abb83n306+t146*t38*abb83n295+t147*t18*abb8&
         &3n306+t147*t20*abb83n295+t148*t34*abb83n306+t148*t38*abb83n295+t149*t1&
         &8*abb83n306+t149*t20*abb83n295+t150*t4*abb83n309+t151*t5*abb83n309+t15&
         &3*t4*abb83n309+t154*t5*abb83n309+t155*t2*abb83n309+t156*t4*abb83n309+t&
         &157*t5*abb83n309+t159*t4*abb83n309+t160*t5*abb83n309+t161*t2*abb83n309&
         &+t164*t4*abb83n309+t165*t5*abb83n309+t167*t4*abb83n309+t168*t5*abb83n3&
         &09+t169*t2*abb83n309+t170*t2*abb83n309+t171*t38*abb83n142+t172*t20*abb&
         &83n142+t173*t38*abb83n142+t174*t20*abb83n142+t176*t38*abb83n95+t177*t2&
         &0*abb83n95+t178*t38*abb83n95+t179*t20*abb83n95+t180*t36*abb83n167+t181&
         &*t19*abb83n167+t182*t36*abb83n167+t183*t19*abb83n167+t184*t38*abb83n11&
         &6+t185*t20*abb83n116+t186*t38*abb83n116+t187*t20*abb83n116+t10*t109*t1&
         &8*abb83n135+t10*t16*t34*abb83n146+t10*t18*t30*abb83n98+t10*t18*t32*abb&
         &83n146+t10*t23*t34*abb83n98+t10*t24*t34*abb83n135+t108*t12*t38*abb83n1&
         &61+t108*t13*t36*abb83n121+t108*t15*t36*abb83n271+t108*t17*t38*abb83n11&
         &9+t108*t19*t26*abb83n271+t108*t19*t46*abb83n121+t108*t20*t27*abb83n161&
         &+t108*t20*t29*abb83n154+t108*t20*t49*abb83n119+t108*t22*t38*abb83n154+&
         &t109*t145*t18*abb83n137+t109*t18*t44*abb83n245+t11*t140*t34*abb83n135+&
         &t11*t34*t69*abb83n98+t11*t34*t83*abb83n146+t12*t38*t57*abb83n155+t12*t&
         &38*t69*abb83n103+t12*t38*t83*abb83n132+t12*t38*t97*abb83n117+t127*t18*&
         &t83*abb83n134+t13*t140*t34*abb83n137+t13*t34*t69*abb83n96+t138*t7*t95*&
         &abb83n309+t138*t7*t98*abb83n309+t14*t38*t57*abb83n157+t14*t38*t69*abb8&
         &3n105+t14*t38*t97*abb83n115+t140*t15*t34*abb83n245+t140*t18*t26*abb83n&
         &245+t140*t18*t40*abb83n135+t140*t18*t46*abb83n137+t145*t18*t30*abb83n9&
         &6+t145*t18*t36*abb83n121+t145*t19*t34*abb83n121+t145*t23*t34*abb83n96+&
         &t145*t24*t34*abb83n137+t15*t34*t83*abb83n230+t15*t38*t57*abb83n219+t15&
         &*t38*t97*abb83n277+t16*t175*t34*abb83n134+t16*t34*t44*abb83n230+t16*t3&
         &7*t38*abb83n132+t16*t38*t57*abb83n127+t17*t37*t38*abb83n117+t17*t38*t3&
         &9*abb83n115+t17*t38*t44*abb83n277+t175*t18*t32*abb83n134+t18*t26*t83*a&
         &bb83n230+t18*t32*t44*abb83n230+t18*t36*t44*abb83n271+t18*t37*t38*abb83&
         &n161+t18*t38*t57*abb83n154+t18*t38*t97*abb83n119+t18*t40*t69*abb83n98+&
         &t18*t40*t83*abb83n146+t18*t46*t69*abb83n96+t180*t38*t7*abb83n309+t181*&
         &t20*t7*abb83n309+t182*t38*t7*abb83n309+t183*t20*t7*abb83n309+t19*t34*t&
         &44*abb83n271+t20*t26*t57*abb83n219+t20*t26*t97*abb83n277+t20*t27*t57*a&
         &bb83n155+t20*t27*t69*abb83n103+t20*t27*t83*abb83n132+t20*t27*t97*abb83&
         &n117+t20*t28*t57*abb83n157+t20*t28*t69*abb83n105+t20*t28*t97*abb83n115&
         &+t20*t29*t37*abb83n155+t20*t29*t39*abb83n157+t20*t29*t44*abb83n219+t20&
         &*t29*t83*abb83n127+t20*t30*t37*abb83n103+t20*t30*t39*abb83n105+t20*t32&
         &*t37*abb83n132+t20*t32*t57*abb83n127+t20*t34*t37*abb83n161+t20*t34*t57&
         &*abb83n154+t20*t34*t97*abb83n119+t20*t37*t49*abb83n117+t20*t39*t49*abb&
         &83n115+t20*t44*t49*abb83n277+t22*t37*t38*abb83n155+t22*t38*t39*abb83n1&
         &57+t22*t38*t44*abb83n219+t22*t38*t83*abb83n127+t23*t37*t38*abb83n103+t&
         &23*t38*t39*abb83n105+t24*t34*t44*abb83n245+t25*t34*t83*abb83n134)
         return
      end if
      t190 = d(iv3,iv4)
      t191 = d(iv2,iv4)
      t192 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t2 = spvak2k4(iv4)
      t3 = spvak6k5(iv4)
      t4 = spvak2k6(iv4)
      t5 = spvak3k1(iv4)
      t6 = spvak3k4(iv4)
      t7 = spvak5k1(iv4)
      t8 = spvak6k1(iv4)
      t9 = t21*t6
      t10 = t6*t85
      t11 = t162*t6
      t12 = spvak2k1(iv4)
      t13 = t12*t16
      t14 = t12*t32
      t12 = t12*t83
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t188*t192*abb83n130+t189*t191*abb83n130+t190*t19&
         &3*abb83n130)+(2.0_ki)*(t102*t190*abb83n116+t104*t190*abb83n116+t105*t1&
         &90*abb83n120+t107*t190*abb83n120+t124*t190*abb83n136+t125*t190*abb83n1&
         &36+t129*t190*abb83n97+t130*t190*abb83n97+t171*t191*abb83n136+t172*t192&
         &*abb83n136+t173*t191*abb83n136+t174*t192*abb83n136+t176*t191*abb83n97+&
         &t177*t192*abb83n97+t178*t191*abb83n97+t179*t192*abb83n97+t180*t191*abb&
         &83n147+t181*t192*abb83n147+t182*t191*abb83n147+t183*t192*abb83n147+t18&
         &4*t191*abb83n120+t185*t192*abb83n120+t186*t191*abb83n120+t187*t192*abb&
         &83n120+t190*t89*abb83n156+t190*t92*abb83n156+t190*t93*abb83n104+t190*t&
         &94*abb83n104+t190*t95*abb83n147+t190*t98*abb83n147+t1*t109*t189*abb83n&
         &136+t1*t134*t193*abb83n120+t1*t140*t193*abb83n136+t1*t16*t188*abb83n14&
         &7+t1*t188*t19*abb83n120+t1*t188*t23*abb83n97+t1*t188*t24*abb83n136+t1*&
         &t189*t30*abb83n97+t1*t189*t32*abb83n147+t1*t189*t36*abb83n120+t1*t193*&
         &t69*abb83n97+t1*t193*t83*abb83n147+t108*t193*t2*abb83n136+t108*t193*t5&
         &*abb83n97+t108*t193*t6*abb83n147+t108*t193*t8*abb83n120+t138*t17*t191*&
         &abb83n116+t138*t191*t22*abb83n156+t138*t191*t23*abb83n104+t138*t192*t2&
         &9*abb83n156+t138*t192*t30*abb83n104+t138*t192*t49*abb83n116+t138*t193*&
         &t4*abb83n156+t138*t193*t5*abb83n104+t138*t193*t7*abb83n116+t17*t188*t3&
         &*abb83n116+t18*t188*t2*abb83n136+t18*t188*t5*abb83n97+t18*t188*t6*abb8&
         &3n147+t18*t188*t8*abb83n120+t188*t20*t4*abb83n156+t188*t20*t5*abb83n10&
         &4+t188*t20*t7*abb83n116+t188*t22*t3*abb83n156+t188*t23*t3*abb83n104+t1&
         &89*t2*t34*abb83n136+t189*t29*t3*abb83n156+t189*t3*t30*abb83n104+t189*t&
         &3*t49*abb83n116+t189*t34*t5*abb83n97+t189*t34*t6*abb83n147+t189*t34*t8&
         &*abb83n120+t189*t38*t4*abb83n156+t189*t38*t5*abb83n104+t189*t38*t7*abb&
         &83n116+t191*t20*t57*abb83n156+t191*t20*t69*abb83n104+t191*t20*t97*abb8&
         &3n116+t192*t38*t57*abb83n156+t192*t38*t69*abb83n104+t192*t38*t97*abb83&
         &n116+t193*t3*t57*abb83n156+t193*t3*t69*abb83n104+t193*t3*t97*abb83n116&
         &)+t150*t3*abb83n94+t153*t3*abb83n94+t156*t3*abb83n94+t159*t3*abb83n94+&
         &t164*t3*abb83n94+t167*t3*abb83n94+t1*t120*t138*abb83n94+t1*t122*t138*a&
         &bb83n94+t1*t152*t38*abb83n94+t1*t158*t20*abb83n94+t1*t163*t38*abb83n94&
         &+t1*t166*t20*abb83n94+t10*t108*t20*abb83n94+t10*t138*t18*abb83n94+t108&
         &*t13*t38*abb83n94+t108*t14*t20*abb83n94+t108*t38*t9*abb83n94+t11*t18*t&
         &38*abb83n94+t11*t20*t34*abb83n94+t12*t18*t38*abb83n94+t12*t20*t34*abb8&
         &3n94+t13*t138*t34*abb83n94+t138*t14*t18*abb83n94+t138*t34*t9*abb83n94)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d83:
   subroutine     reconstruct_d83(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group10
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group10), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_83:
      coeffs%coeffs_83%c0 = derivative(czip)
      coeffs%coeffs_83%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_83%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_83%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_83%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_83%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_83%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_83%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_83%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_83%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_83%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_83%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_83%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_83%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_83%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_83%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_83%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_83%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_83%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_83%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_83%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_83%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_83%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_83%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_83%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_83%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_83%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_83%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_83%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_83%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_83%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_83%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_83%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_83%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_83%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_83%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_83%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_83%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_83%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_83%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_83%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_83%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_83%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_83%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_83%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_83%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_83%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_83%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_83%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_83%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_83%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_83%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_83%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_83%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_83%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_83%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_83%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_83%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_83%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_83%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_83%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_83%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_83%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_83%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_83%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_83%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_83%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_83%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_83%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_83%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_83:
   end subroutine reconstruct_d83
!---#] subroutine reconstruct_d83:
end module p7_dubar_emnebargg_d83h0l1d
