module     p7_dubar_emnebargg_d87h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity0/d87h0l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d87
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd87h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      complex(ki) :: t105
      complex(ki) :: t106
      complex(ki) :: t107
      complex(ki) :: t108
      complex(ki) :: t109
      complex(ki) :: t110
      complex(ki) :: t111
      complex(ki) :: t112
      complex(ki) :: t113
      complex(ki) :: t114
      complex(ki) :: t115
      complex(ki) :: t116
      complex(ki) :: t117
      complex(ki) :: t118
      complex(ki) :: t119
      complex(ki) :: t120
      complex(ki) :: t121
      complex(ki) :: t122
      complex(ki) :: t123
      complex(ki) :: t124
      complex(ki) :: t125
      complex(ki) :: t126
      complex(ki) :: t127
      complex(ki) :: t128
      complex(ki) :: t129
      complex(ki) :: t130
      complex(ki) :: t131
      complex(ki) :: t132
      complex(ki) :: t133
      complex(ki) :: t134
      complex(ki) :: t135
      complex(ki) :: t136
      complex(ki) :: t137
      complex(ki) :: t138
      complex(ki) :: t139
      complex(ki) :: t140
      complex(ki) :: t141
      complex(ki) :: t142
      complex(ki) :: t143
      complex(ki) :: t144
      complex(ki) :: t145
      complex(ki) :: t146
      complex(ki) :: t147
      complex(ki) :: t148
      complex(ki) :: t149
      complex(ki) :: t150
      complex(ki) :: t151
      complex(ki) :: t152
      complex(ki) :: t153
      complex(ki) :: t154
      complex(ki) :: t155
      complex(ki) :: t156
      complex(ki) :: t157
      complex(ki) :: t158
      complex(ki) :: t159
      complex(ki) :: t160
      complex(ki) :: t161
      real(ki) :: t162
      real(ki) :: t163
      real(ki) :: t164
      real(ki) :: t165
      real(ki) :: t166
      real(ki) :: t167
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k6-k5-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t1 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t162 = dotproduct(qshift, qshift)
      t2 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t3 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t163 = dotproduct(k2, qshift)
      t164 = dotproduct(k5, qshift)
      t4 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t5 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t165 = dotproduct(k6, qshift)
      t6 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t7 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t8 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t9 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t10 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-s&
      &pvak3k1(4)*qshift(4))
      t166 = dotproduct(k1, qshift)
      if(deg.eq.0) then
         numerator = (t1*abb87n55+t162*abb87n84+t162*t162*abb87n73+t163*abb87n90&
         &+t2*abb87n86+t3*abb87n87+t1*t162*abb87n114+t1*t164*abb87n62+t1*t165*ab&
         &b87n66+t1*t4*abb87n63+t1*t5*abb87n78+t1*t6*abb87n80+t162*t163*abb87n10&
         &6+t162*t164*abb87n99+t162*t165*abb87n99+t162*t2*abb87n91+t162*t3*abb87&
         &n93+t162*t4*abb87n97+t162*t6*abb87n88+t163*t165*abb87n70+t163*t4*abb87&
         &n69+t163*t5*abb87n72+t164*t2*abb87n59+t164*t8*abb87n82+t165*t2*abb87n7&
         &6+t165*t3*abb87n75+t2*t4*abb87n60+t2*t5*abb87n65+t2*t6*abb87n79+t3*t4*&
         &abb87n74+t3*t5*abb87n77+t4*t8*abb87n83+t6*t7*abb87n81+t1*t162*t5*abb87&
         &n64+t1*t162*t6*abb87n61+t1*t164*t5*abb87n118+t1*t165*t5*abb87n118+t1*t&
         &165*t6*abb87n120+t1*t4*t5*abb87n119+t10*t162*t5*abb87n58+t10*t164*t5*a&
         &bb87n122+t10*t165*t5*abb87n122+t10*t4*t5*abb87n124+t162*t2*t6*abb87n57&
         &+t162*t4*t6*abb87n68+t162*t5*t8*abb87n71+t162*t6*t7*abb87n67+t163*t4*t&
         &5*abb87n95+t164*t5*t8*abb87n104+t165*t2*t6*abb87n126+t165*t5*t8*abb87n&
         &104+t165*t6*t7*abb87n110+t166*t4*t5*abb87n96+t2*t4*t5*abb87n117+t3*t4*&
         &t5*abb87n113+t4*t5*t8*abb87n109+t4*t6*t9*abb87n112+t5*t6*t7*abb87n105+&
         &t3*t4*t5*t6*abb87n56)
         return
      end if
      t11 = k2(iv1)
      t12 = qshift(iv1)
      t13 = spvak2k1(iv1)
      t14 = spvak5k1(iv1)
      t15 = spvak6k1(iv1)
      t16 = k5(iv1)
      t17 = k6(iv1)
      t18 = t12*abb87n100
      t19 = spvak2k4(iv1)
      t20 = spvak2k5(iv1)
      t21 = spvak3k4(iv1)
      t22 = spvak5k6(iv1)
      t23 = spvak6k5(iv1)
      t24 = k1(iv1)
      t25 = t19*abb87n104
      t26 = spvak2k6(iv1)
      t27 = spvak3k1(iv1)
      t28 = t27*abb87n122
      t29 = t22*abb87n104
      t30 = t22*abb87n118
      t31 = t22*abb87n122
      t32 = t15*abb87n118
      if(deg.eq.1) then
         numerator = (t11*abb87n90+t12*abb87n85+t13*abb87n87+t14*abb87n86+t15*ab&
         &b87n55+t164*t18+t165*t18+t1*t12*abb87n115+t1*t16*abb87n62+t1*t164*t30+&
         &t1*t165*t30+t1*t17*abb87n66+t1*t21*abb87n80+t1*t22*abb87n78+t1*t23*abb&
         &87n63+t10*t164*t31+t10*t165*t31+t11*t162*abb87n106+t11*t165*abb87n70+t&
         &11*t4*abb87n69+t11*t5*abb87n72+t12*t162*abb87n101+t12*t163*abb87n107+t&
         &12*t2*abb87n92+t12*t3*abb87n94+t12*t4*abb87n98+t12*t6*abb87n89+t13*t16&
         &2*abb87n93+t13*t165*abb87n75+t13*t4*abb87n74+t13*t5*abb87n77+t14*t162*&
         &abb87n91+t14*t164*abb87n59+t14*t165*abb87n76+t14*t4*abb87n60+t14*t5*ab&
         &b87n65+t14*t6*abb87n79+t15*t162*abb87n114+t15*t164*abb87n62+t15*t165*a&
         &bb87n66+t15*t4*abb87n63+t15*t5*abb87n78+t15*t6*abb87n80+t16*t162*abb87&
         &n99+t16*t2*abb87n59+t16*t8*abb87n82+t162*t17*abb87n99+t162*t21*abb87n8&
         &8+t162*t23*abb87n97+t163*t17*abb87n70+t163*t22*abb87n72+t163*t23*abb87&
         &n69+t164*t19*abb87n82+t164*t25*t5+t164*t28*t5+t164*t29*t8+t164*t32*t5+&
         &t165*t25*t5+t165*t28*t5+t165*t29*t8+t165*t32*t5+t17*t2*abb87n76+t17*t3&
         &*abb87n75+t19*t4*abb87n83+t2*t21*abb87n79+t2*t22*abb87n65+t2*t23*abb87&
         &n60+t20*t6*abb87n81+t21*t7*abb87n81+t22*t3*abb87n77+t23*t3*abb87n74+t2&
         &3*t8*abb87n83+t1*t12*t5*abb87n116+t1*t12*t6*abb87n121+t1*t16*t5*abb87n&
         &118+t1*t162*t21*abb87n61+t1*t162*t22*abb87n64+t1*t165*t21*abb87n120+t1&
         &*t17*t5*abb87n118+t1*t17*t6*abb87n120+t1*t22*t4*abb87n119+t1*t23*t5*ab&
         &b87n119+t10*t12*t5*abb87n123+t10*t16*t5*abb87n122+t10*t162*t22*abb87n5&
         &8+t10*t17*t5*abb87n122+t10*t22*t4*abb87n124+t10*t23*t5*abb87n124+t11*t&
         &4*t5*abb87n95+t12*t2*t6*abb87n125+t12*t4*t6*abb87n108+t12*t5*t8*abb87n&
         &103+t12*t6*t7*abb87n111+t13*t4*t5*abb87n113+t14*t162*t6*abb87n57+t14*t&
         &165*t6*abb87n126+t14*t4*t5*abb87n117+t15*t162*t5*abb87n64+t15*t162*t6*&
         &abb87n61+t15*t165*t6*abb87n120+t15*t4*t5*abb87n119+t16*t5*t8*abb87n104&
         &+t162*t19*t5*abb87n71+t162*t2*t21*abb87n57+t162*t20*t6*abb87n67+t162*t&
         &21*t4*abb87n68+t162*t21*t7*abb87n67+t162*t22*t8*abb87n71+t162*t23*t6*a&
         &bb87n68+t162*t27*t5*abb87n58+t163*t22*t4*abb87n95+t163*t23*t5*abb87n95&
         &+t165*t2*t21*abb87n126+t165*t20*t6*abb87n110+t165*t21*t7*abb87n110+t16&
         &6*t22*t4*abb87n96+t166*t23*t5*abb87n96+t17*t2*t6*abb87n126+t17*t5*t8*a&
         &bb87n104+t17*t6*t7*abb87n110+t19*t4*t5*abb87n109+t2*t22*t4*abb87n117+t&
         &2*t23*t5*abb87n117+t20*t5*t6*abb87n105+t21*t4*t9*abb87n112+t21*t5*t7*a&
         &bb87n105+t22*t3*t4*abb87n113+t22*t4*t8*abb87n109+t22*t6*t7*abb87n105+t&
         &23*t3*t5*abb87n113+t23*t5*t8*abb87n109+t23*t6*t9*abb87n112+t24*t4*t5*a&
         &bb87n96+t26*t4*t6*abb87n112+t27*t4*t5*abb87n124+t13*t4*t5*t6*abb87n56+&
         &t21*t3*t4*t5*abb87n56+t22*t3*t4*t6*abb87n56+t23*t3*t5*t6*abb87n56)
         return
      end if
      t167 = d(iv1,iv2)
      t18 = qshift(iv2)
      t25 = t167*abb87n99
      t28 = k6(iv2)
      t29 = spvak5k6(iv2)
      t30 = t11*t29
      t31 = spvak6k5(iv2)
      t32 = t11*t31
      t33 = k2(iv2)
      t34 = t22*t33
      t35 = t23*t33
      t36 = spvak2k4(iv2)
      t37 = t16*t36
      t38 = spvak5k1(iv2)
      t39 = spvak6k1(iv2)
      t40 = t16*t39
      t41 = k5(iv2)
      t42 = t19*t41
      t43 = t15*t41
      t44 = spvak2k1(iv2)
      t45 = t17*t38
      t46 = t17*t39
      t47 = t14*t28
      t48 = t15*t28
      t49 = spvak3k4(iv2)
      t50 = t12*t49
      t51 = t12*t38
      t52 = t12*t39
      t53 = t12*t31
      t54 = t18*t21
      t55 = t14*t18
      t56 = t15*t18
      t57 = t18*t23
      t58 = t13*t29
      t59 = t13*t31
      t60 = t22*t44
      t61 = t23*t44
      t62 = t19*t31
      t63 = t23*t36
      t64 = t20*t49
      t65 = spvak2k5(iv2)
      t66 = t21*t65
      t67 = t21*t38
      t68 = t21*t39
      t69 = t14*t49
      t70 = t15*t49
      t71 = t14*t29
      t72 = t14*t31
      t73 = t22*t38
      t74 = t23*t38
      t75 = t22*t39
      t76 = t15*t29
      t77 = t15*t31
      t78 = t23*t39
      t79 = t24*t29
      t80 = k1(iv2)
      t81 = t22*t80
      t82 = spvak3k1(iv2)
      t83 = t16*t82
      t84 = t16*t29
      t85 = t27*t41
      t86 = t22*t41
      t87 = t17*t36
      t88 = t17*t65
      t89 = t17*t82
      t90 = t17*t49
      t91 = t17*t29
      t92 = t19*t28
      t93 = t20*t28
      t94 = t27*t28
      t95 = t21*t28
      t96 = t22*t28
      t97 = t12*t36
      t98 = t12*t65
      t99 = t12*t82
      t100 = t12*t29
      t101 = t18*t19
      t102 = t18*t20
      t103 = t18*t27
      t104 = t18*t22
      t105 = t19*t29
      t106 = t105*abb87n104
      t107 = t22*t36
      t108 = t107*abb87n104
      t109 = t26*t49
      t110 = spvak2k6(iv2)
      t111 = t110*t21
      t112 = t27*t29
      t113 = t112*abb87n122
      t114 = t22*t82
      t115 = t114*abb87n122
      t116 = t21*t29
      t117 = t21*t31
      t118 = t22*t49
      t119 = t23*t49
      t120 = t75*abb87n118
      t121 = t22*t31
      t122 = t76*abb87n118
      t123 = t23*t29
      t124 = t13*t49
      t125 = t21*t44
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t164*t25+t165*t25+t167*abb87n84+t1*t167*abb87n11&
         &4+t12*t18*abb87n101+t162*t167*abb87n102+t163*t167*abb87n106+t167*t2*ab&
         &b87n91+t167*t3*abb87n93+t167*t4*abb87n97+t167*t6*abb87n88+t1*t167*t5*a&
         &bb87n64+t1*t167*t6*abb87n61+t10*t167*t5*abb87n58+t167*t2*t6*abb87n57+t&
         &167*t4*t6*abb87n68+t167*t5*t8*abb87n71+t167*t6*t7*abb87n67)+t106*t164+&
         &t106*t165+t108*t164+t108*t165+t113*t164+t113*t165+t115*t164+t115*t165+&
         &t120*t164+t120*t165+t122*t164+t122*t165+t30*abb87n72+t32*abb87n69+t34*&
         &abb87n72+t35*abb87n69+t37*abb87n82+t40*abb87n62+t42*abb87n82+t43*abb87&
         &n62+t45*abb87n76+t46*abb87n66+t47*abb87n76+t48*abb87n66+t50*abb87n89+t&
         &51*abb87n92+t52*abb87n115+t53*abb87n98+t54*abb87n89+t55*abb87n92+t56*a&
         &bb87n115+t57*abb87n98+t58*abb87n77+t59*abb87n74+t60*abb87n77+t61*abb87&
         &n74+t62*abb87n83+t63*abb87n83+t64*abb87n81+t66*abb87n81+t67*abb87n79+t&
         &68*abb87n80+t69*abb87n79+t70*abb87n80+t71*abb87n65+t72*abb87n60+t73*ab&
         &b87n65+t74*abb87n60+t75*abb87n78+t76*abb87n78+t77*abb87n63+t78*abb87n6&
         &3+t1*t100*abb87n116+t1*t104*abb87n116+t1*t121*abb87n119+t1*t123*abb87n&
         &119+t1*t50*abb87n121+t1*t54*abb87n121+t1*t84*abb87n118+t1*t86*abb87n11&
         &8+t1*t90*abb87n120+t1*t91*abb87n118+t1*t95*abb87n120+t1*t96*abb87n118+&
         &t10*t100*abb87n123+t10*t104*abb87n123+t10*t121*abb87n124+t10*t123*abb8&
         &7n124+t10*t84*abb87n122+t10*t86*abb87n122+t10*t91*abb87n122+t10*t96*ab&
         &b87n122+t100*t8*abb87n103+t101*t5*abb87n103+t102*t6*abb87n111+t103*t5*&
         &abb87n123+t104*t8*abb87n103+t105*t162*abb87n71+t105*t4*abb87n109+t107*&
         &t162*abb87n71+t107*t4*abb87n109+t109*t4*abb87n112+t11*t18*abb87n107+t1&
         &1*t28*abb87n70+t111*t4*abb87n112+t112*t162*abb87n58+t112*t4*abb87n124+&
         &t114*t162*abb87n58+t114*t4*abb87n124+t116*t7*abb87n105+t117*t162*abb87&
         &n68+t117*t9*abb87n112+t118*t7*abb87n105+t119*t162*abb87n68+t119*t9*abb&
         &87n112+t12*t28*abb87n100+t12*t33*abb87n107+t12*t41*abb87n100+t12*t44*a&
         &bb87n94+t121*t163*abb87n95+t121*t166*abb87n96+t121*t2*abb87n117+t121*t&
         &3*abb87n113+t121*t8*abb87n109+t123*t163*abb87n95+t123*t166*abb87n96+t1&
         &23*t2*abb87n117+t123*t3*abb87n113+t123*t8*abb87n109+t13*t18*abb87n94+t&
         &13*t28*abb87n75+t14*t41*abb87n59+t16*t18*abb87n100+t16*t38*abb87n59+t1&
         &62*t64*abb87n67+t162*t66*abb87n67+t162*t67*abb87n57+t162*t68*abb87n61+&
         &t162*t69*abb87n57+t162*t70*abb87n61+t162*t75*abb87n64+t162*t76*abb87n6&
         &4+t165*t64*abb87n110+t165*t66*abb87n110+t165*t67*abb87n126+t165*t68*ab&
         &b87n120+t165*t69*abb87n126+t165*t70*abb87n120+t17*t18*abb87n100+t17*t3&
         &3*abb87n70+t17*t44*abb87n75+t2*t50*abb87n125+t2*t54*abb87n125+t2*t90*a&
         &bb87n126+t2*t95*abb87n126+t30*t4*abb87n95+t32*t5*abb87n95+t34*t4*abb87&
         &n95+t35*t5*abb87n95+t37*t5*abb87n104+t4*t50*abb87n108+t4*t54*abb87n108&
         &+t4*t58*abb87n113+t4*t60*abb87n113+t4*t71*abb87n117+t4*t73*abb87n117+t&
         &4*t75*abb87n119+t4*t76*abb87n119+t4*t79*abb87n96+t4*t81*abb87n96+t40*t&
         &5*abb87n118+t42*t5*abb87n104+t43*t5*abb87n118+t45*t6*abb87n126+t46*t5*&
         &abb87n118+t46*t6*abb87n120+t47*t6*abb87n126+t48*t5*abb87n118+t48*t6*ab&
         &b87n120+t5*t52*abb87n116+t5*t56*abb87n116+t5*t59*abb87n113+t5*t61*abb8&
         &7n113+t5*t62*abb87n109+t5*t63*abb87n109+t5*t64*abb87n105+t5*t66*abb87n&
         &105+t5*t72*abb87n117+t5*t74*abb87n117+t5*t77*abb87n119+t5*t78*abb87n11&
         &9+t5*t83*abb87n122+t5*t85*abb87n122+t5*t87*abb87n104+t5*t89*abb87n122+&
         &t5*t92*abb87n104+t5*t94*abb87n122+t5*t97*abb87n103+t5*t99*abb87n123+t5&
         &0*t7*abb87n111+t51*t6*abb87n125+t52*t6*abb87n121+t53*t6*abb87n108+t54*&
         &t7*abb87n111+t55*t6*abb87n125+t56*t6*abb87n121+t57*t6*abb87n108+t6*t88&
         &*abb87n110+t6*t93*abb87n110+t6*t98*abb87n111+t7*t90*abb87n110+t7*t95*a&
         &bb87n110+t8*t84*abb87n104+t8*t86*abb87n104+t8*t91*abb87n104+t8*t96*abb&
         &87n104+t110*t23*t6*abb87n112+t116*t3*t4*abb87n56+t117*t3*t5*abb87n56+t&
         &118*t3*t4*abb87n56+t119*t3*t5*abb87n56+t121*t3*t6*abb87n56+t123*t3*t6*&
         &abb87n56+t124*t4*t5*abb87n56+t125*t4*t5*abb87n56+t20*t29*t6*abb87n105+&
         &t22*t6*t65*abb87n105+t23*t5*t80*abb87n96+t23*t5*t82*abb87n124+t24*t31*&
         &t5*abb87n96+t26*t31*t6*abb87n112+t27*t31*t5*abb87n124+t4*t58*t6*abb87n&
         &56+t4*t6*t60*abb87n56+t5*t59*t6*abb87n56+t5*t6*t61*abb87n56)
         return
      end if
      t162 = d(iv2,iv3)
      t163 = d(iv1,iv3)
      t9 = k2(iv3)
      t25 = k5(iv3)
      t32 = k6(iv3)
      t35 = qshift(iv3)
      t40 = spvak2k1(iv3)
      t43 = t162*t21
      t45 = t163*t49
      t46 = spvak3k4(iv3)
      t47 = t167*t46
      t48 = t14*t162
      t51 = t163*t38
      t52 = spvak5k1(iv3)
      t53 = t167*t52
      t55 = t15*t162
      t56 = t163*t39
      t57 = spvak6k1(iv3)
      t59 = t167*t57
      t61 = t162*t23
      t62 = t163*t31
      t63 = spvak6k5(iv3)
      t72 = t167*t63
      t74 = spvak2k4(iv3)
      t77 = spvak2k5(iv3)
      t78 = spvak3k1(iv3)
      t106 = t162*t22
      t108 = t163*t29
      t113 = spvak5k6(iv3)
      t115 = t113*t167
      t120 = k1(iv3)
      t121 = t17*t46
      t122 = t28*t46
      t123 = t21*t32
      t126 = t32*t49
      t127 = t12*t46
      t128 = t18*t46
      t129 = t21*t35
      t130 = t35*t49
      t58 = t58*t63
      t131 = t113*t13*t31
      t60 = t60*t63
      t132 = t113*t23*t44
      t133 = t22*t31*t40
      t134 = t23*t29*t40
      t135 = t113*t19
      t136 = t113*t36
      t137 = t22*t74
      t138 = t29*t74
      t139 = t20*t46
      t140 = t46*t65
      t141 = t21*t77
      t142 = t49*t77
      t143 = spvak2k6(iv3)
      t144 = t113*t27
      t145 = t113*t82
      t146 = t22*t78
      t147 = t29*t78
      t148 = t22*t57
      t149 = t29*t57
      t150 = t113*t15
      t151 = t113*t39
      t152 = t113*t124
      t153 = t13*t46
      t154 = t153*t29
      t155 = t113*t125
      t156 = t44*t46
      t157 = t156*t22
      t158 = t21*t40
      t159 = t158*t29
      t160 = t40*t49
      t161 = t160*t22
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t43*abb87n88+t45*abb87n88+t47*abb87n88+t48*abb87&
         &n91+t51*abb87n91+t53*abb87n91+t55*abb87n114+t56*abb87n114+t59*abb87n11&
         &4+t61*abb87n97+t62*abb87n97+t72*abb87n97+t1*t106*abb87n64+t1*t108*abb8&
         &7n64+t1*t115*abb87n64+t1*t43*abb87n61+t1*t45*abb87n61+t1*t47*abb87n61+&
         &t10*t106*abb87n58+t10*t108*abb87n58+t10*t115*abb87n58+t106*t8*abb87n71&
         &+t108*t8*abb87n71+t11*t162*abb87n106+t115*t8*abb87n71+t12*t162*abb87n1&
         &01+t13*t162*abb87n93+t16*t162*abb87n99+t162*t17*abb87n99+t163*t18*abb8&
         &7n101+t163*t28*abb87n99+t163*t33*abb87n106+t163*t41*abb87n99+t163*t44*&
         &abb87n93+t167*t25*abb87n99+t167*t32*abb87n99+t167*t35*abb87n101+t167*t&
         &40*abb87n93+t167*t9*abb87n106+t2*t43*abb87n57+t2*t45*abb87n57+t2*t47*a&
         &bb87n57+t4*t43*abb87n68+t4*t45*abb87n68+t4*t47*abb87n68+t43*t7*abb87n6&
         &7+t45*t7*abb87n67+t47*t7*abb87n67+t48*t6*abb87n57+t5*t55*abb87n64+t5*t&
         &56*abb87n64+t5*t59*abb87n64+t51*t6*abb87n57+t53*t6*abb87n57+t55*t6*abb&
         &87n61+t56*t6*abb87n61+t59*t6*abb87n61+t6*t61*abb87n68+t6*t62*abb87n68+&
         &t6*t72*abb87n68+t162*t19*t5*abb87n71+t162*t20*t6*abb87n67+t162*t27*t5*&
         &abb87n58+t163*t36*t5*abb87n71+t163*t5*t82*abb87n58+t163*t6*t65*abb87n6&
         &7+t167*t5*t74*abb87n71+t167*t5*t78*abb87n58+t167*t6*t77*abb87n67)+t131&
         &*abb87n113+t132*abb87n113+t133*abb87n113+t134*abb87n113+t58*abb87n113+&
         &t60*abb87n113+t100*t57*abb87n116+t101*t113*abb87n103+t102*t46*abb87n11&
         &1+t103*t113*abb87n123+t104*t57*abb87n116+t105*t63*abb87n109+t107*t63*a&
         &bb87n109+t109*t63*abb87n112+t111*t63*abb87n112+t112*t63*abb87n124+t113&
         &*t37*abb87n104+t113*t42*abb87n104+t113*t64*abb87n105+t113*t66*abb87n10&
         &5+t113*t83*abb87n122+t113*t85*abb87n122+t113*t87*abb87n104+t113*t89*ab&
         &b87n122+t113*t92*abb87n104+t113*t94*abb87n122+t113*t97*abb87n103+t113*&
         &t99*abb87n123+t114*t63*abb87n124+t121*t38*abb87n126+t121*t39*abb87n120&
         &+t122*t14*abb87n126+t122*t15*abb87n120+t123*t38*abb87n126+t123*t39*abb&
         &87n120+t126*t14*abb87n126+t126*t15*abb87n120+t127*t31*abb87n108+t127*t&
         &38*abb87n125+t127*t39*abb87n121+t128*t14*abb87n125+t128*t15*abb87n121+&
         &t128*t23*abb87n108+t129*t31*abb87n108+t129*t38*abb87n125+t129*t39*abb8&
         &7n121+t130*t14*abb87n125+t130*t15*abb87n121+t130*t23*abb87n108+t131*t6&
         &*abb87n56+t132*t6*abb87n56+t133*t6*abb87n56+t134*t6*abb87n56+t135*t31*&
         &abb87n109+t136*t23*abb87n109+t137*t31*abb87n109+t138*t23*abb87n109+t13&
         &9*t29*abb87n105+t140*t22*abb87n105+t141*t29*abb87n105+t142*t22*abb87n1&
         &05+t144*t31*abb87n124+t145*t23*abb87n124+t146*t31*abb87n124+t147*t23*a&
         &bb87n124+t148*t31*abb87n119+t149*t23*abb87n119+t150*t31*abb87n119+t151&
         &*t23*abb87n119+t152*t4*abb87n56+t154*t4*abb87n56+t155*t4*abb87n56+t157&
         &*t4*abb87n56+t159*t4*abb87n56+t161*t4*abb87n56+t30*t63*abb87n95+t34*t6&
         &3*abb87n95+t46*t88*abb87n110+t46*t93*abb87n110+t46*t98*abb87n111+t50*t&
         &52*abb87n125+t50*t57*abb87n121+t50*t63*abb87n108+t52*t54*abb87n125+t52&
         &*t90*abb87n126+t52*t95*abb87n126+t54*t57*abb87n121+t54*t63*abb87n108+t&
         &57*t84*abb87n118+t57*t86*abb87n118+t57*t90*abb87n120+t57*t91*abb87n118&
         &+t57*t95*abb87n120+t57*t96*abb87n118+t58*t6*abb87n56+t6*t60*abb87n56+t&
         &63*t71*abb87n117+t63*t73*abb87n117+t63*t75*abb87n119+t63*t76*abb87n119&
         &+t63*t79*abb87n96+t63*t81*abb87n96+t11*t113*t31*abb87n95+t110*t23*t46*&
         &abb87n112+t113*t12*t39*abb87n116+t113*t14*t31*abb87n117+t113*t15*t18*a&
         &bb87n116+t113*t15*t28*abb87n118+t113*t15*t41*abb87n118+t113*t16*t39*ab&
         &b87n118+t113*t17*t39*abb87n118+t113*t23*t33*abb87n95+t113*t23*t38*abb8&
         &7n117+t113*t23*t80*abb87n96+t113*t24*t31*abb87n96+t116*t3*t63*abb87n56&
         &+t118*t3*t63*abb87n56+t12*t29*t74*abb87n103+t12*t29*t78*abb87n123+t12*&
         &t49*t77*abb87n111+t120*t22*t31*abb87n96+t120*t23*t29*abb87n96+t124*t5*&
         &t63*abb87n56+t125*t5*t63*abb87n56+t143*t21*t31*abb87n112+t143*t23*t49*&
         &abb87n112+t15*t25*t29*abb87n118+t15*t29*t32*abb87n118+t15*t29*t35*abb8&
         &7n116+t153*t31*t5*abb87n56+t156*t23*t5*abb87n56+t158*t31*t5*abb87n56+t&
         &16*t29*t74*abb87n104+t16*t29*t78*abb87n122+t160*t23*t5*abb87n56+t17*t2&
         &9*t74*abb87n104+t17*t29*t78*abb87n122+t17*t49*t77*abb87n110+t18*t21*t7&
         &7*abb87n111+t18*t22*t74*abb87n103+t18*t22*t78*abb87n123+t19*t25*t29*ab&
         &b87n104+t19*t29*t32*abb87n104+t19*t29*t35*abb87n103+t20*t32*t49*abb87n&
         &110+t20*t35*t49*abb87n111+t21*t28*t77*abb87n110+t21*t32*t65*abb87n110+&
         &t21*t35*t65*abb87n111+t22*t25*t36*abb87n104+t22*t25*t39*abb87n118+t22*&
         &t25*t82*abb87n122+t22*t28*t74*abb87n104+t22*t28*t78*abb87n122+t22*t31*&
         &t52*abb87n117+t22*t31*t9*abb87n95+t22*t32*t36*abb87n104+t22*t32*t39*ab&
         &b87n118+t22*t32*t82*abb87n122+t22*t35*t36*abb87n103+t22*t35*t39*abb87n&
         &116+t22*t35*t82*abb87n123+t22*t41*t74*abb87n104+t22*t41*t78*abb87n122+&
         &t23*t29*t52*abb87n117+t23*t29*t9*abb87n95+t25*t27*t29*abb87n122+t26*t3&
         &1*t46*abb87n112+t27*t29*t32*abb87n122+t27*t29*t35*abb87n123+t113*t21*t&
         &3*t31*abb87n56+t113*t23*t3*t49*abb87n56+t22*t3*t31*t46*abb87n56+t23*t2&
         &9*t3*t46*abb87n56)
         return
      end if
      t164 = d(iv3,iv4)
      t165 = d(iv2,iv4)
      t166 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t2 = spvak2k4(iv4)
      t3 = spvak3k4(iv4)
      t4 = spvak2k5(iv4)
      t5 = spvak3k1(iv4)
      t6 = spvak5k1(iv4)
      t7 = spvak6k1(iv4)
      t8 = spvak6k5(iv4)
      t9 = t13*t3
      t10 = t3*t44
      t11 = t3*t40
      t12 = spvak2k1(iv4)
      t13 = t12*t21
      t16 = t12*t49
      t12 = t12*t46
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t162*t166*abb87n73+t163*t165*abb87n73+t164*t167*&
         &abb87n73)+(2.0_ki)*(t105*t164*abb87n71+t107*t164*abb87n71+t112*t164*ab&
         &b87n58+t114*t164*abb87n58+t117*t164*abb87n68+t119*t164*abb87n68+t135*t&
         &165*abb87n71+t136*t166*abb87n71+t137*t165*abb87n71+t138*t166*abb87n71+&
         &t139*t165*abb87n67+t140*t166*abb87n67+t141*t165*abb87n67+t142*t166*abb&
         &87n67+t144*t165*abb87n58+t145*t166*abb87n58+t146*t165*abb87n58+t147*t1&
         &66*abb87n58+t148*t165*abb87n64+t149*t166*abb87n64+t150*t165*abb87n64+t&
         &151*t166*abb87n64+t164*t64*abb87n67+t164*t66*abb87n67+t164*t67*abb87n5&
         &7+t164*t68*abb87n61+t164*t69*abb87n57+t164*t70*abb87n61+t164*t75*abb87&
         &n64+t164*t76*abb87n64+t1*t15*t162*abb87n64+t1*t162*t19*abb87n71+t1*t16&
         &2*t27*abb87n58+t1*t163*t36*abb87n71+t1*t163*t39*abb87n64+t1*t163*t82*a&
         &bb87n58+t1*t167*t57*abb87n64+t1*t167*t74*abb87n71+t1*t167*t78*abb87n58&
         &+t113*t167*t2*abb87n71+t113*t167*t5*abb87n58+t113*t167*t7*abb87n64+t14&
         &*t162*t3*abb87n57+t14*t165*t46*abb87n57+t15*t162*t3*abb87n61+t15*t165*&
         &t46*abb87n61+t162*t2*t22*abb87n71+t162*t20*t3*abb87n67+t162*t21*t4*abb&
         &87n67+t162*t21*t6*abb87n57+t162*t21*t7*abb87n61+t162*t21*t8*abb87n68+t&
         &162*t22*t5*abb87n58+t162*t22*t7*abb87n64+t162*t23*t3*abb87n68+t163*t2*&
         &t29*abb87n71+t163*t29*t5*abb87n58+t163*t29*t7*abb87n64+t163*t3*t31*abb&
         &87n68+t163*t3*t38*abb87n57+t163*t3*t39*abb87n61+t163*t3*t65*abb87n67+t&
         &163*t4*t49*abb87n67+t163*t49*t6*abb87n57+t163*t49*t7*abb87n61+t163*t49&
         &*t8*abb87n68+t165*t21*t52*abb87n57+t165*t21*t57*abb87n61+t165*t21*t63*&
         &abb87n68+t165*t23*t46*abb87n68+t166*t31*t46*abb87n68+t166*t38*t46*abb8&
         &7n57+t166*t39*t46*abb87n61+t166*t49*t52*abb87n57+t166*t49*t57*abb87n61&
         &+t166*t49*t63*abb87n68+t167*t3*t52*abb87n57+t167*t3*t57*abb87n61+t167*&
         &t3*t63*abb87n68+t167*t3*t77*abb87n67+t167*t4*t46*abb87n67+t167*t46*t6*&
         &abb87n57+t167*t46*t7*abb87n61+t167*t46*t8*abb87n68)+t152*t8*abb87n56+t&
         &154*t8*abb87n56+t155*t8*abb87n56+t157*t8*abb87n56+t159*t8*abb87n56+t16&
         &1*t8*abb87n56+t1*t124*t63*abb87n56+t1*t125*t63*abb87n56+t1*t153*t31*ab&
         &b87n56+t1*t156*t23*abb87n56+t1*t158*t31*abb87n56+t1*t160*t23*abb87n56+&
         &t10*t113*t23*abb87n56+t10*t22*t63*abb87n56+t11*t22*t31*abb87n56+t11*t2&
         &3*t29*abb87n56+t113*t13*t31*abb87n56+t113*t16*t23*abb87n56+t113*t31*t9&
         &*abb87n56+t12*t22*t31*abb87n56+t12*t23*t29*abb87n56+t13*t29*t63*abb87n&
         &56+t16*t22*t63*abb87n56+t29*t63*t9*abb87n56)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d87:
   subroutine     reconstruct_d87(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group11
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group11), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_87:
      coeffs%coeffs_87%c0 = derivative(czip)
      coeffs%coeffs_87%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_87%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_87%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_87%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_87%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_87%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_87%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_87%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_87%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_87%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_87%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_87%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_87%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_87%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_87%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_87%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_87%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_87%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_87%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_87%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_87%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_87%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_87%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_87%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_87%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_87%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_87%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_87%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_87%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_87%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_87%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_87%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_87%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_87%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_87%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_87%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_87%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_87%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_87%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_87%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_87%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_87%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_87%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_87%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_87%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_87%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_87%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_87%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_87%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_87%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_87%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_87%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_87%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_87%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_87%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_87%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_87%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_87%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_87%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_87%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_87%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_87%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_87%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_87%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_87%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_87%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_87%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_87%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_87%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_87:
   end subroutine reconstruct_d87
!---#] subroutine reconstruct_d87:
end module p7_dubar_emnebargg_d87h0l1d
