module     p7_dubar_emnebargg_d17h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity1/d17h1l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d17
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd17h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      real(ki) :: t47
      real(ki) :: t48
      real(ki) :: t49
      real(ki) :: t50
      real(ki) :: t51
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = t1*t1
      t47 = dotproduct(k1, qshift)
      t48 = dotproduct(k6, qshift)
      t49 = dotproduct(qshift, qshift)
      t50 = dotproduct(k5, qshift)
      t51 = dotproduct(k2, qshift)
      t3 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t4 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t5 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t6 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t7 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb17n42+t1*abb17n66+t2*abb17n43+t3*abb17n74+t47*abb17n76+&
         &t47*t47*abb17n47+t48*abb17n78+t48*t48*abb17n47+t49*abb17n51+t50*abb17n&
         &64+t51*abb17n67+t1*t3*abb17n54+t1*t47*abb17n44+t1*t48*abb17n45+t1*t49*&
         &abb17n84+t1*t5*abb17n59+t1*t50*abb17n46+t1*t51*abb17n50+t1*t6*abb17n56&
         &+t2*t5*abb17n89+t3*t47*abb17n53+t3*t48*abb17n52+t3*t49*abb17n72+t3*t5*&
         &abb17n63+t3*t50*abb17n52+t4*t5*abb17n55+t47*t48*abb17n49+t47*t49*abb17&
         &n81+t47*t5*abb17n61+t47*t50*abb17n48+t47*t6*abb17n58+t48*t49*abb17n79+&
         &t48*t5*abb17n60+t48*t50*abb17n47+t48*t6*abb17n57+t49*t5*abb17n68+t49*t&
         &6*abb17n70+t5*t7*abb17n62+t50*t6*abb17n57+t1*t3*t5*abb17n65+t1*t4*t5*a&
         &bb17n91+t1*t47*t5*abb17n86+t1*t48*t5*abb17n87+t1*t5*t7*abb17n75)
         return
      end if
      t8 = k1(iv1)
      t9 = k2(iv1)
      t10 = k5(iv1)
      t11 = k6(iv1)
      t12 = qshift(iv1)
      t13 = spvak5k1(iv1)
      t14 = spvak5k6(iv1)
      t15 = spvak2k1(iv1)
      t16 = spvak2k4(iv1)
      t17 = t16*abb17n57
      t18 = spvak2k6(iv1)
      t19 = spvak3k4(iv1)
      t20 = t13*abb17n52
      if(deg.eq.1) then
         numerator = (t10*abb17n64+t11*abb17n78+t12*abb17n77+t13*abb17n74+t14*ab&
         &b17n66+t17*t48+t17*t50+t20*t48+t20*t50+t8*abb17n76+t9*abb17n67+t1*t10*&
         &abb17n46+t1*t11*abb17n45+t1*t12*abb17n85+t1*t13*abb17n54+t1*t14*abb17n&
         &88+t1*t16*abb17n56+t1*t19*abb17n59+t1*t8*abb17n44+t1*t9*abb17n50+t10*t&
         &3*abb17n52+t10*t47*abb17n48+t10*t48*abb17n47+t10*t6*abb17n57+t11*t3*ab&
         &b17n52+t11*t47*abb17n49+t11*t48*abb17n83+t11*t49*abb17n79+t11*t5*abb17&
         &n60+t11*t50*abb17n47+t11*t6*abb17n57+t12*t3*abb17n73+t12*t47*abb17n82+&
         &t12*t48*abb17n80+t12*t5*abb17n69+t12*t6*abb17n71+t13*t47*abb17n53+t13*&
         &t49*abb17n72+t13*t5*abb17n63+t14*t3*abb17n54+t14*t47*abb17n44+t14*t48*&
         &abb17n45+t14*t49*abb17n84+t14*t5*abb17n59+t14*t50*abb17n46+t14*t51*abb&
         &17n50+t14*t6*abb17n56+t15*t5*abb17n62+t16*t47*abb17n58+t16*t49*abb17n7&
         &0+t18*t5*abb17n55+t19*t2*abb17n89+t19*t3*abb17n63+t19*t4*abb17n55+t19*&
         &t47*abb17n61+t19*t48*abb17n60+t19*t49*abb17n68+t19*t7*abb17n62+t3*t8*a&
         &bb17n53+t47*t8*abb17n83+t48*t8*abb17n49+t49*t8*abb17n81+t5*t8*abb17n61&
         &+t50*t8*abb17n48+t6*t8*abb17n58+t1*t11*t5*abb17n87+t1*t13*t5*abb17n65+&
         &t1*t14*t5*abb17n90+t1*t15*t5*abb17n75+t1*t18*t5*abb17n91+t1*t19*t3*abb&
         &17n65+t1*t19*t4*abb17n91+t1*t19*t47*abb17n86+t1*t19*t48*abb17n87+t1*t1&
         &9*t7*abb17n75+t1*t5*t8*abb17n86+t14*t3*t5*abb17n65+t14*t4*t5*abb17n91+&
         &t14*t47*t5*abb17n86+t14*t48*t5*abb17n87+t14*t5*t7*abb17n75)
         return
      end if
      t49 = d(iv1,iv2)
      t2 = k1(iv2)
      t17 = k6(iv2)
      t20 = spvak5k6(iv2)
      t21 = t14*t20
      t22 = k5(iv2)
      t23 = qshift(iv2)
      t24 = spvak2k4(iv2)
      t25 = spvak3k4(iv2)
      t26 = t25*t8
      t27 = spvak5k1(iv2)
      t28 = t20*t8
      t29 = t19*t2
      t30 = t14*t2
      t31 = t11*t25
      t32 = t11*t20
      t33 = t17*t19
      t34 = t14*t17
      t35 = t15*t25
      t36 = spvak2k1(iv2)
      t37 = t19*t36
      t38 = t18*t25
      t39 = spvak2k6(iv2)
      t40 = t19*t39
      t41 = t19*t27
      t42 = t19*t20
      t43 = t13*t25
      t44 = t14*t25
      t45 = t13*t20
      t46 = t14*t27
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t21*abb17n43+t49*abb17n51+t1*t49*abb17n84+t11*t1&
         &7*abb17n47+t2*t8*abb17n47+t21*t5*abb17n89+t3*t49*abb17n72+t47*t49*abb1&
         &7n81+t48*t49*abb17n79+t49*t5*abb17n68+t49*t6*abb17n70)+t26*abb17n61+t2&
         &8*abb17n44+t29*abb17n61+t30*abb17n44+t31*abb17n60+t32*abb17n45+t33*abb&
         &17n60+t34*abb17n45+t35*abb17n62+t37*abb17n62+t38*abb17n55+t40*abb17n55&
         &+t41*abb17n63+t42*abb17n59+t43*abb17n63+t44*abb17n59+t45*abb17n54+t46*&
         &abb17n54+k2(iv2)*t14*abb17n50+t1*t26*abb17n86+t1*t29*abb17n86+t1*t31*a&
         &bb17n87+t1*t33*abb17n87+t1*t35*abb17n75+t1*t37*abb17n75+t1*t38*abb17n9&
         &1+t1*t40*abb17n91+t1*t41*abb17n65+t1*t42*abb17n90+t1*t43*abb17n65+t1*t&
         &44*abb17n90+t10*t17*abb17n47+t10*t2*abb17n48+t10*t20*abb17n46+t10*t24*&
         &abb17n57+t10*t27*abb17n52+t11*t2*abb17n49+t11*t22*abb17n47+t11*t23*abb&
         &17n80+t11*t24*abb17n57+t11*t27*abb17n52+t12*t17*abb17n80+t12*t2*abb17n&
         &82+t12*t20*abb17n85+t12*t24*abb17n71+t12*t25*abb17n69+t12*t27*abb17n73&
         &+t13*t17*abb17n52+t13*t2*abb17n53+t13*t22*abb17n52+t13*t23*abb17n73+t1&
         &4*t22*abb17n46+t14*t23*abb17n85+t14*t24*abb17n56+t16*t17*abb17n57+t16*&
         &t2*abb17n58+t16*t20*abb17n56+t16*t22*abb17n57+t16*t23*abb17n71+t17*t8*&
         &abb17n49+t19*t23*abb17n69+t20*t9*abb17n50+t22*t8*abb17n48+t23*t8*abb17&
         &n82+t24*t8*abb17n58+t27*t8*abb17n53+t28*t5*abb17n86+t3*t42*abb17n65+t3&
         &*t44*abb17n65+t30*t5*abb17n86+t32*t5*abb17n87+t34*t5*abb17n87+t4*t42*a&
         &bb17n91+t4*t44*abb17n91+t42*t47*abb17n86+t42*t48*abb17n87+t42*t7*abb17&
         &n75+t44*t47*abb17n86+t44*t48*abb17n87+t44*t7*abb17n75+t45*t5*abb17n65+&
         &t46*t5*abb17n65+t14*t36*t5*abb17n75+t14*t39*t5*abb17n91+t15*t20*t5*abb&
         &17n75+t18*t20*t5*abb17n91)
         return
      end if
      t47 = d(iv2,iv3)
      t48 = d(iv1,iv3)
      t1 = k1(iv3)
      t3 = k6(iv3)
      t4 = spvak3k4(iv3)
      t5 = spvak5k1(iv3)
      t6 = spvak5k6(iv3)
      t7 = spvak2k1(iv3)
      t9 = spvak2k6(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k4(iv3)*t49*abb17n70+t1*t49*abb17n81+t11*t&
         &47*abb17n79+t13*t47*abb17n72+t14*t47*abb17n84+t16*t47*abb17n70+t17*t48&
         &*abb17n79+t19*t47*abb17n68+t2*t48*abb17n81+t20*t48*abb17n84+t24*t48*ab&
         &b17n70+t25*t48*abb17n68+t27*t48*abb17n72+t3*t49*abb17n79+t4*t49*abb17n&
         &68+t42*t6*abb17n89+t44*t6*abb17n89+t47*t8*abb17n81+t49*t5*abb17n72+t49&
         &*t6*abb17n84+t14*t20*t4*abb17n89)+t26*t6*abb17n86+t29*t6*abb17n86+t31*&
         &t6*abb17n87+t33*t6*abb17n87+t35*t6*abb17n75+t37*t6*abb17n75+t38*t6*abb&
         &17n91+t40*t6*abb17n91+t41*t6*abb17n65+t43*t6*abb17n65+t1*t14*t25*abb17&
         &n86+t1*t19*t20*abb17n86+t11*t20*t4*abb17n87+t13*t20*t4*abb17n65+t14*t1&
         &7*t4*abb17n87+t14*t2*t4*abb17n86+t14*t25*t3*abb17n87+t14*t25*t5*abb17n&
         &65+t14*t25*t7*abb17n75+t14*t25*t9*abb17n91+t14*t27*t4*abb17n65+t14*t36&
         &*t4*abb17n75+t14*t39*t4*abb17n91+t15*t20*t4*abb17n75+t18*t20*t4*abb17n&
         &91+t19*t20*t3*abb17n87+t19*t20*t5*abb17n65+t19*t20*t7*abb17n75+t19*t20&
         &*t9*abb17n91+t20*t4*t8*abb17n86)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d17:
   subroutine     reconstruct_d17(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group11
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group11), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_17:
      coeffs%coeffs_17%c0 = derivative(czip)
      coeffs%coeffs_17%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_17%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_17%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_17%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_17%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_17%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_17%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_17%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_17%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_17%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_17%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_17%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_17%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_17%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_17%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_17%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_17%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_17%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_17%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_17%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_17%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_17%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_17%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_17%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_17%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_17%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_17%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_17%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_17%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_17%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_17%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_17%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_17%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_17%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_17:
   end subroutine reconstruct_d17
!---#] subroutine reconstruct_d17:
end module p7_dubar_emnebargg_d17h1l1d
