module     p7_dubar_emnebargg_d105h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity3/d105h3l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d105
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd105h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      real(ki) :: t39
      real(ki) :: t40
      real(ki) :: t41
      real(ki) :: t42
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6+k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t39 = dotproduct(qshift, qshift)
      t40 = dotproduct(k6, qshift)
      t41 = dotproduct(k1, qshift)
      t1 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t42 = dotproduct(k5, qshift)
      t2 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t3 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t4 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t5 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t6 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t7 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t8 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb105n34+t1*abb105n72+t2*abb105n79+t3*abb105n80+t39*abb10&
         &5n58+t40*abb105n66+t41*abb105n67+t42*abb105n78+t1*t3*abb105n46+t1*t39*&
         &abb105n106+t1*t40*abb105n39+t1*t42*abb105n47+t2*t3*abb105n49+t2*t39*ab&
         &b105n84+t2*t41*abb105n50+t2*t42*abb105n51+t2*t5*abb105n48+t3*t39*abb10&
         &5n97+t3*t40*abb105n53+t3*t41*abb105n54+t39*t4*abb105n100+t39*t5*abb105&
         &n109+t39*t6*abb105n94+t39*t7*abb105n74+t39*t8*abb105n70+t4*t40*abb105n&
         &41+t40*t5*abb105n36+t40*t6*abb105n45+t41*t7*abb105n59+t41*t8*abb105n63&
         &+t2*t3*t7*abb105n112+t2*t3*t8*abb105n103)
         return
      end if
      t9 = k1(iv1)
      t10 = k5(iv1)
      t11 = k6(iv1)
      t12 = qshift(iv1)
      t13 = spvak5k6(iv1)
      t14 = spvak6k1(iv1)
      t15 = spvak6k5(iv1)
      t16 = spvak2k1(iv1)
      t17 = spvak2k6(iv1)
      t18 = spvak3k1(iv1)
      t19 = spvak3k6(iv1)
      t20 = spvak5k1(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb105n57+t11*abb105n65+t12*abb105n77+t13*abb105n55+t1&
         &4*abb105n61+t15*abb105n56+t9*abb105n64+t1*t10*abb105n90+t1*t11*abb105n&
         &104+t1*t12*abb105n105+t1*t13*abb105n91+t10*t2*abb105n86+t11*t3*abb105n&
         &82+t11*t4*abb105n102+t11*t5*abb105n111+t11*t6*abb105n92+t12*t2*abb105n&
         &83+t12*t3*abb105n96+t12*t4*abb105n99+t12*t5*abb105n108+t12*t6*abb105n9&
         &3+t12*t7*abb105n73+t12*t8*abb105n69+t13*t2*abb105n88+t13*t39*abb105n43&
         &+t13*t40*abb105n82+t13*t41*abb105n81+t14*t3*abb105n91+t14*t39*abb105n3&
         &8+t14*t40*abb105n104+t14*t42*abb105n90+t15*t3*abb105n88+t15*t39*abb105&
         &n52+t15*t41*abb105n87+t15*t42*abb105n86+t15*t5*abb105n89+t16*t39*abb10&
         &5n62+t16*t41*abb105n68+t17*t39*abb105n44+t17*t40*abb105n92+t18*t39*abb&
         &105n60+t18*t41*abb105n76+t19*t39*abb105n42+t19*t40*abb105n102+t2*t20*a&
         &bb105n89+t2*t9*abb105n87+t20*t39*abb105n37+t20*t40*abb105n111+t3*t9*ab&
         &b105n81+t7*t9*abb105n76+t8*t9*abb105n68+t13*t2*t7*abb105n35+t13*t2*t8*&
         &abb105n40+t15*t3*t7*abb105n35+t15*t3*t8*abb105n40+t16*t2*t3*abb105n40+&
         &t18*t2*t3*abb105n35)
         return
      end if
      t39 = d(iv1,iv2)
      t21 = spvak2k1(iv2)
      t22 = spvak3k1(iv2)
      t23 = spvak5k6(iv2)
      t24 = spvak6k5(iv2)
      t25 = k1(iv2)
      t26 = spvak6k1(iv2)
      t27 = k5(iv2)
      t28 = spvak2k6(iv2)
      t29 = spvak3k6(iv2)
      t30 = spvak5k1(iv2)
      t31 = k6(iv2)
      t32 = qshift(iv2)
      t33 = t13*t24
      t34 = t15*t23
      t35 = t16*t23
      t36 = t13*t21
      t37 = t18*t23
      t38 = t13*t22
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t39*abb105n58+t1*t39*abb105n106+t2*t39*abb105n84&
         &+t3*t39*abb105n97+t39*t4*abb105n100+t39*t5*abb105n109+t39*t6*abb105n94&
         &+t39*t7*abb105n74+t39*t8*abb105n70)+t33*abb105n49+t34*abb105n49+t10*t2&
         &4*abb105n51+t10*t26*abb105n47+t11*t23*abb105n53+t11*t26*abb105n39+t11*&
         &t28*abb105n45+t11*t29*abb105n41+t11*t30*abb105n36+t12*t21*abb105n71+t1&
         &2*t22*abb105n75+t12*t23*abb105n98+t12*t24*abb105n85+t12*t26*abb105n107&
         &+t12*t28*abb105n95+t12*t29*abb105n101+t12*t30*abb105n110+t13*t25*abb10&
         &5n54+t13*t26*abb105n46+t13*t31*abb105n53+t13*t32*abb105n98+t14*t23*abb&
         &105n46+t14*t27*abb105n47+t14*t31*abb105n39+t14*t32*abb105n107+t15*t25*&
         &abb105n50+t15*t27*abb105n51+t15*t30*abb105n48+t15*t32*abb105n85+t16*t2&
         &5*abb105n63+t16*t32*abb105n71+t17*t31*abb105n45+t17*t32*abb105n95+t18*&
         &t25*abb105n59+t18*t32*abb105n75+t19*t31*abb105n41+t19*t32*abb105n101+t&
         &2*t35*abb105n103+t2*t36*abb105n103+t2*t37*abb105n112+t2*t38*abb105n112&
         &+t20*t24*abb105n48+t20*t31*abb105n36+t20*t32*abb105n110+t21*t9*abb105n&
         &63+t22*t9*abb105n59+t23*t9*abb105n54+t24*t9*abb105n50+t33*t7*abb105n11&
         &2+t33*t8*abb105n103+t34*t7*abb105n112+t34*t8*abb105n103+t15*t21*t3*abb&
         &105n103+t15*t22*t3*abb105n112+t16*t24*t3*abb105n103+t18*t24*t3*abb105n&
         &112)
         return
      end if
      t40 = d(iv2,iv3)
      t41 = d(iv1,iv3)
      t1 = spvak2k1(iv3)
      t2 = spvak3k1(iv3)
      t3 = spvak5k6(iv3)
      t4 = spvak6k5(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k6(iv3)*t39*abb105n44+spvak3k6(iv3)*t39*ab&
         &b105n42+spvak5k1(iv3)*t39*abb105n37+spvak6k1(iv3)*t39*abb105n38+t1*t39&
         &*abb105n62+t13*t40*abb105n43+t14*t40*abb105n38+t15*t40*abb105n52+t16*t&
         &40*abb105n62+t17*t40*abb105n44+t18*t40*abb105n60+t19*t40*abb105n42+t2*&
         &t39*abb105n60+t20*t40*abb105n37+t21*t41*abb105n62+t22*t41*abb105n60+t2&
         &3*t41*abb105n43+t24*t41*abb105n52+t26*t41*abb105n38+t28*t41*abb105n44+&
         &t29*t41*abb105n42+t3*t39*abb105n43+t30*t41*abb105n37+t39*t4*abb105n52)&
         &+t35*t4*abb105n40+t36*t4*abb105n40+t37*t4*abb105n35+t38*t4*abb105n35+t&
         &1*t13*t24*abb105n40+t1*t15*t23*abb105n40+t13*t2*t24*abb105n35+t15*t2*t&
         &23*abb105n35+t15*t21*t3*abb105n40+t15*t22*t3*abb105n35+t16*t24*t3*abb1&
         &05n40+t18*t24*t3*abb105n35)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d105:
   subroutine     reconstruct_d105(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_105:
      coeffs%coeffs_105%c0 = derivative(czip)
      coeffs%coeffs_105%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_105%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_105%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_105%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_105%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_105%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_105%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_105%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_105%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_105%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_105%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_105%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_105%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_105%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_105%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_105%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_105%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_105%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_105%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_105%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_105%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_105%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_105%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_105%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_105%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_105%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_105%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_105%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_105%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_105%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_105%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_105%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_105%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_105%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_105:
   end subroutine reconstruct_d105
!---#] subroutine reconstruct_d105:
end module p7_dubar_emnebargg_d105h3l1d
