module     p7_dubar_emnebargg_d29h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity3/d29h3l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d29
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd29h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      real(ki) :: t44
      real(ki) :: t45
      real(ki) :: t46
      real(ki) :: t47
      real(ki) :: t48
      real(ki) :: t49
      real(ki) :: t50
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t44 = dotproduct(k2, qshift)
      t45 = dotproduct(k1, qshift)
      t1 = (spvak4k1(1)*qshift(1)-spvak4k1(2)*qshift(2)-spvak4k1(3)*qshift(3)-sp&
      &vak4k1(4)*qshift(4))
      t46 = dotproduct(qshift, qshift)
      t47 = dotproduct(k6, qshift)
      t48 = dotproduct(k5, qshift)
      t49 = dotproduct(k3, qshift)
      t50 = dotproduct(k4, qshift)
      t2 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t3 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t4 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t5 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t6 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t7 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t8 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t9 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb29n47+t1*abb29n128+t2*abb29n96+t3*abb29n99+t44*abb29n11&
         &0+t45*abb29n125+t46*abb29n65+t47*abb29n93+t48*abb29n94+t49*abb29n95+t5&
         &0*abb29n95+t1*t2*abb29n51+t2*t3*abb29n54+t2*t4*abb29n68+t2*t44*abb29n6&
         &4+t2*t45*abb29n64+t2*t5*abb29n67+t2*t6*abb29n56+t2*t7*abb29n55+t2*t9*a&
         &bb29n91+t3*t45*abb29n50+t3*t46*abb29n144+t3*t47*abb29n86+t3*t48*abb29n&
         &85+t3*t49*abb29n53+t3*t50*abb29n53+t4*t45*abb29n74+t4*t46*abb29n115+t4&
         &*t49*abb29n72+t4*t50*abb29n72+t45*t47*abb29n81+t45*t48*abb29n78+t45*t5&
         &*abb29n69+t45*t6*abb29n60+t45*t7*abb29n59+t46*t47*abb29n104+t46*t48*ab&
         &b29n107+t46*t5*abb29n120+t46*t6*abb29n131+t46*t7*abb29n136+t47*t8*abb2&
         &9n75+t47*t9*abb29n82+t48*t8*abb29n76+t48*t9*abb29n83+t49*t5*abb29n71+t&
         &49*t6*abb29n62+t49*t7*abb29n57+t5*t50*abb29n71+t50*t6*abb29n62+t50*t7*&
         &abb29n57+t2*t47*t9*abb29n149+t2*t48*t9*abb29n148)
         return
      end if
      t10 = k1(iv1)
      t11 = k2(iv1)
      t12 = k3(iv1)
      t13 = k4(iv1)
      t14 = k5(iv1)
      t15 = k6(iv1)
      t16 = qshift(iv1)
      t17 = spvak3k1(iv1)
      t18 = spvak3k4(iv1)
      t19 = spvak4k1(iv1)
      t20 = spvak2k1(iv1)
      t21 = spvak2k4(iv1)
      t22 = spvak2k5(iv1)
      t23 = t22*abb29n117
      t24 = spvak2k6(iv1)
      t25 = t24*abb29n118
      t26 = t17*abb29n142
      t27 = t18*abb29n127
      t28 = spvak5k1(iv1)
      t29 = t28*abb29n129
      t30 = spvak6k1(iv1)
      t31 = t30*abb29n138
      if(deg.eq.1) then
         numerator = (t10*abb29n66+t11*abb29n77+t12*abb29n88+t13*abb29n88+t14*ab&
         &b29n89+t15*abb29n90+t16*abb29n126+t17*abb29n84+t18*abb29n87+t19*abb29n&
         &63+t23*t49+t23*t50+t25*t49+t25*t50+t26*t49+t26*t50+t27*t44+t27*t45+t29&
         &*t49+t29*t50+t31*t49+t31*t50+t1*t18*abb29n146+t10*t2*abb29n127+t10*t3*&
         &abb29n147+t10*t4*abb29n113+t10*t47*abb29n102+t10*t48*abb29n109+t10*t5*&
         &abb29n122+t10*t6*abb29n133+t10*t7*abb29n134+t11*t2*abb29n127+t12*t3*ab&
         &b29n142+t12*t4*abb29n117+t12*t5*abb29n118+t12*t6*abb29n129+t12*t7*abb2&
         &9n138+t13*t3*abb29n142+t13*t4*abb29n117+t13*t5*abb29n118+t13*t6*abb29n&
         &129+t13*t7*abb29n138+t14*t3*abb29n98+t14*t45*abb29n109+t14*t46*abb29n7&
         &9+t14*t8*abb29n111+t14*t9*abb29n100+t15*t3*abb29n97+t15*t45*abb29n102+&
         &t15*t46*abb29n80+t15*t8*abb29n112+t15*t9*abb29n101+t16*t3*abb29n143+t1&
         &6*t4*abb29n114+t16*t47*abb29n103+t16*t48*abb29n106+t16*t5*abb29n119+t1&
         &6*t6*abb29n130+t16*t7*abb29n135+t17*t2*abb29n141+t17*t45*abb29n147+t17&
         &*t46*abb29n52+t17*t47*abb29n97+t17*t48*abb29n98+t18*t3*abb29n141+t18*t&
         &4*abb29n123+t18*t5*abb29n124+t18*t6*abb29n139+t18*t7*abb29n140+t18*t9*&
         &abb29n92+t19*t2*abb29n146+t2*t20*abb29n92+t2*t22*abb29n123+t2*t24*abb2&
         &9n124+t2*t28*abb29n139+t2*t30*abb29n140+t20*t47*abb29n101+t20*t48*abb2&
         &9n100+t21*t47*abb29n112+t21*t48*abb29n111+t22*t45*abb29n113+t22*t46*ab&
         &b29n73+t24*t45*abb29n122+t24*t46*abb29n70+t28*t45*abb29n133+t28*t46*ab&
         &b29n61+t30*t45*abb29n134+t30*t46*abb29n58+t14*t2*t9*abb29n49+t15*t2*t9&
         &*abb29n48+t18*t47*t9*abb29n48+t18*t48*t9*abb29n49+t2*t20*t47*abb29n48+&
         &t2*t20*t48*abb29n49)
         return
      end if
      t44 = d(iv1,iv2)
      t1 = k5(iv2)
      t8 = k6(iv2)
      t23 = spvak2k5(iv2)
      t25 = spvak2k6(iv2)
      t26 = spvak3k1(iv2)
      t27 = spvak3k4(iv2)
      t29 = spvak5k1(iv2)
      t31 = spvak6k1(iv2)
      t32 = k1(iv2)
      t33 = k3(iv2)
      t34 = k4(iv2)
      t35 = qshift(iv2)
      t36 = spvak2k1(iv2)
      t37 = t14*t36
      t38 = spvak2k4(iv2)
      t39 = t1*t20
      t40 = t15*t36
      t41 = t20*t8
      t42 = t20*t27
      t43 = t18*t36
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t44*abb29n65+t3*t44*abb29n144+t4*t44*abb29n115+t&
         &44*t47*abb29n104+t44*t48*abb29n107+t44*t5*abb29n120+t44*t6*abb29n131+t&
         &44*t7*abb29n136)+t37*abb29n83+t39*abb29n83+t40*abb29n82+t41*abb29n82+t&
         &42*abb29n91+t43*abb29n91+k2(iv2)*t18*abb29n64+spvak4k1(iv2)*t18*abb29n&
         &51+t1*t10*abb29n78+t1*t16*abb29n108+t1*t17*abb29n85+t1*t21*abb29n76+t1&
         &0*t23*abb29n74+t10*t25*abb29n69+t10*t26*abb29n50+t10*t27*abb29n64+t10*&
         &t29*abb29n60+t10*t31*abb29n59+t10*t8*abb29n81+t11*t27*abb29n64+t12*t23&
         &*abb29n72+t12*t25*abb29n71+t12*t26*abb29n53+t12*t29*abb29n62+t12*t31*a&
         &bb29n57+t13*t23*abb29n72+t13*t25*abb29n71+t13*t26*abb29n53+t13*t29*abb&
         &29n62+t13*t31*abb29n57+t14*t26*abb29n85+t14*t32*abb29n78+t14*t35*abb29&
         &n108+t14*t38*abb29n76+t15*t26*abb29n86+t15*t32*abb29n81+t15*t35*abb29n&
         &105+t15*t38*abb29n75+t16*t23*abb29n116+t16*t25*abb29n121+t16*t26*abb29&
         &n145+t16*t29*abb29n132+t16*t31*abb29n137+t16*t8*abb29n105+t17*t27*abb2&
         &9n54+t17*t32*abb29n50+t17*t33*abb29n53+t17*t34*abb29n53+t17*t35*abb29n&
         &145+t17*t8*abb29n86+t18*t23*abb29n68+t18*t25*abb29n67+t18*t26*abb29n54&
         &+t18*t29*abb29n56+t18*t31*abb29n55+t18*t32*abb29n64+t19*t27*abb29n51+t&
         &2*t37*abb29n148+t2*t39*abb29n148+t2*t40*abb29n149+t2*t41*abb29n149+t21&
         &*t8*abb29n75+t22*t27*abb29n68+t22*t32*abb29n74+t22*t33*abb29n72+t22*t3&
         &4*abb29n72+t22*t35*abb29n116+t24*t27*abb29n67+t24*t32*abb29n69+t24*t33&
         &*abb29n71+t24*t34*abb29n71+t24*t35*abb29n121+t27*t28*abb29n56+t27*t30*&
         &abb29n55+t28*t32*abb29n60+t28*t33*abb29n62+t28*t34*abb29n62+t28*t35*ab&
         &b29n132+t30*t32*abb29n59+t30*t33*abb29n57+t30*t34*abb29n57+t30*t35*abb&
         &29n137+t42*t47*abb29n149+t42*t48*abb29n148+t43*t47*abb29n149+t43*t48*a&
         &bb29n148+t1*t18*t9*abb29n148+t14*t27*t9*abb29n148+t15*t27*t9*abb29n149&
         &+t18*t8*t9*abb29n149)
         return
      end if
      t45 = d(iv2,iv3)
      t46 = d(iv1,iv3)
      t2 = k5(iv3)
      t3 = k6(iv3)
      t4 = spvak3k4(iv3)
      t5 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k5(iv3)*t44*abb29n73+spvak2k6(iv3)*t44*abb&
         &29n70+spvak3k1(iv3)*t44*abb29n52+spvak5k1(iv3)*t44*abb29n61+spvak6k1(i&
         &v3)*t44*abb29n58+t1*t46*abb29n79+t14*t45*abb29n79+t15*t45*abb29n80+t17&
         &*t45*abb29n52+t2*t44*abb29n79+t22*t45*abb29n73+t23*t46*abb29n73+t24*t4&
         &5*abb29n70+t25*t46*abb29n70+t26*t46*abb29n52+t28*t45*abb29n61+t29*t46*&
         &abb29n61+t3*t44*abb29n80+t30*t45*abb29n58+t31*t46*abb29n58+t46*t8*abb2&
         &9n80)+t37*t4*abb29n49+t39*t4*abb29n49+t4*t40*abb29n48+t4*t41*abb29n48+&
         &t1*t18*t5*abb29n49+t14*t27*t5*abb29n49+t15*t27*t5*abb29n48+t18*t2*t36*&
         &abb29n49+t18*t3*t36*abb29n48+t18*t5*t8*abb29n48+t2*t20*t27*abb29n49+t2&
         &0*t27*t3*abb29n48)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d29:
   subroutine     reconstruct_d29(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_29:
      coeffs%coeffs_29%c0 = derivative(czip)
      coeffs%coeffs_29%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_29%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_29%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_29%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_29%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_29%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_29%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_29%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_29%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_29%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_29%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_29%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_29%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_29%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_29%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_29%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_29%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_29%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_29%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_29%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_29%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_29%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_29%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_29%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_29%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_29%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_29%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_29%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_29%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_29%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_29%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_29%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_29%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_29%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_29:
   end subroutine reconstruct_d29
!---#] subroutine reconstruct_d29:
end module p7_dubar_emnebargg_d29h3l1d
