module     p0_dd_emnebardu_abbrevd64h0
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_globalsh0
   implicit none
   private
   complex(ki), public :: abb64n1
   complex(ki), public :: abb64n2
   complex(ki), public :: abb64n3
   complex(ki), public :: rat2d64
   complex(ki), public :: abb64n5
   complex(ki), public :: abb64n6
   complex(ki), public :: abb64n7
   complex(ki), public :: abb64n8
   complex(ki), public :: abb64n9
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   real(ki) :: t12
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_dd_emnebardu_config, only: deltaOS
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_model
      use p0_dd_emnebardu_color, only: TR
      use p0_dd_emnebardu_globalsl1, only: epspow
      implicit none
      t1 = c1*i_
      t2 = TR*spbk2k1
      t2 = t2*t2
      t3 = (es12+es34-(es56+es345))*(es34+wW*mW*i_-mW*mW)
      t4 = NC*t3
      t5 = t1*spak1k5
      t6 = c2*i_
      t7 = t2*t6*spak1k3*spak2k5*spak3k6*spbk4k3
      t8 = t6*spak1k5
      t9 = t2*t8*spak2k3*spak3k6*spbk4k3
      t8 = t2*t8*spak2k6*spak3k6*spbk6k4
      t10 = t2*t6*spak1k6*spak2k5*spak3k6*spbk6k4
      t11 = NC*NC*t3
      abb64n1 = ((8.0_ki)*(t2/t4*t5*spak2k3*spak3k6*spbk4k3+t1*t2/t4*spak1k6*spa&
      &k2k5*spak3k6*spbk6k4-(t1*t2/t4*spak1k3*spak2k5*spak3k6*spbk4k3+t2/t4*t5*s&
      &pak2k6*spak3k6*spbk6k4))+(4.0_ki)*(t7/t11+t8/t11+t7/t3+t8/t3-(t9/t3+t9/t1&
      &1+t10/t3+t10/t11)))
      t12 = TR*TR
      t2 = t12*t1/t4*spak3k5*spak3k6*spbk2k1*spbk4k3
      t1 = t12*t1/t4*spak3k6*spak5k6*spbk2k1*spbk6k4
      t4 = t12*t6*spak3k5*spak3k6*spbk2k1*spbk4k3
      t5 = t4/t3
      t6 = t12*t6*spak3k6*spak5k6*spbk2k1*spbk6k4
      t3 = t6/t3
      t4 = t4/t11
      t6 = t6/t11
      abb64n2 = ((16.0_ki)*(-(t2+t1))+(8.0_ki)*(t3+t4+t5+t6))
      abb64n3 = ((16.0_ki)*(t1+t2)+(8.0_ki)*(-(t6+t5+t4+t3)))
      rat2d64 = 0
      rat2 = rat2 + rat2d64
      abb64n5 = abb64n1
      abb64n6 = abb64n3
      abb64n7 = -(abb64n2)
      abb64n8 = ((2.0_ki)*abb64n3)
      abb64n9 = -(abb64n3)
   end subroutine
end module p0_dd_emnebardu_abbrevd64h0
