module     p0_dd_emnebardu_d1h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p0_dd_emnebardu/helicity1/d1h1l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d1
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd1h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      real(ki) :: t33
      real(ki) :: t34
      real(ki) :: t35
      real(ki) :: t36
      real(ki) :: t37
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t33 = dotproduct(qshift, qshift)
      t34 = dotproduct(k6, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t35 = dotproduct(k1, qshift)
      t36 = dotproduct(k5, qshift)
      t37 = dotproduct(k2, qshift)
      t2 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t3 = (spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1k2(3)*qshift(3)-sp&
      &vak1k2(4)*qshift(4))
      t4 = (spvak1k5(1)*qshift(1)-spvak1k5(2)*qshift(2)-spvak1k5(3)*qshift(3)-sp&
      &vak1k5(4)*qshift(4))
      t5 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-sp&
      &vak3k2(4)*qshift(4))
      t6 = (spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-sp&
      &vak6k2(4)*qshift(4))
      t7 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t8 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb1n32+t1*abb1n50+t2*abb1n57+t3*abb1n60+t33*abb1n45+t34*a&
         &bb1n49+t35*abb1n51+t36*abb1n52+t37*abb1n53+t4*abb1n61+t1*t3*abb1n46+t1&
         &*t33*abb1n55+t1*t35*abb1n42+t1*t36*abb1n44+t1*t37*abb1n43+t1*t4*abb1n3&
         &7+t2*t4*abb1n35+t3*t33*abb1n64+t3*t34*abb1n36+t3*t35*abb1n35+t3*t36*ab&
         &b1n36+t3*t4*abb1n47+t33*t4*abb1n62+t33*t5*abb1n58+t34*t4*abb1n38+t35*t&
         &4*abb1n38+t36*t4*abb1n39+t37*t5*abb1n41+t4*t5*abb1n33+t4*t6*abb1n34+t4&
         &*t7*abb1n40+t4*t8*abb1n48+t1*t4*t6*abb1n66)
         return
      end if
      t9 = k1(iv1)
      t10 = k2(iv1)
      t11 = k5(iv1)
      t12 = k6(iv1)
      t13 = qshift(iv1)
      t14 = spvak1k2(iv1)
      t15 = spvak1k5(iv1)
      t16 = spvak3k4(iv1)
      t17 = spvak5k2(iv1)
      t18 = t14*abb1n36
      t19 = t15*abb1n38
      t20 = spvak3k2(iv1)
      t21 = spvak6k1(iv1)
      t22 = spvak6k2(iv1)
      t23 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb1n53+t11*abb1n52+t12*abb1n49+t13*abb1n54+t14*abb1n6&
         &0+t15*abb1n61+t16*abb1n50+t17*abb1n57+t18*t34+t18*t36+t19*t34+t19*t35+&
         &t9*abb1n51+t1*t10*abb1n43+t1*t11*abb1n44+t1*t13*abb1n56+t1*t14*abb1n46&
         &+t1*t15*abb1n37+t1*t9*abb1n42+t10*t5*abb1n41+t11*t3*abb1n36+t11*t4*abb&
         &1n39+t12*t3*abb1n36+t12*t4*abb1n38+t13*t3*abb1n65+t13*t4*abb1n63+t13*t&
         &5*abb1n59+t14*t33*abb1n64+t14*t35*abb1n35+t14*t4*abb1n47+t15*t2*abb1n3&
         &5+t15*t3*abb1n47+t15*t33*abb1n62+t15*t36*abb1n39+t15*t5*abb1n33+t15*t6&
         &*abb1n34+t15*t7*abb1n40+t15*t8*abb1n48+t16*t3*abb1n46+t16*t33*abb1n55+&
         &t16*t35*abb1n42+t16*t36*abb1n44+t16*t37*abb1n43+t16*t4*abb1n37+t17*t4*&
         &abb1n35+t20*t33*abb1n58+t20*t37*abb1n41+t20*t4*abb1n33+t21*t4*abb1n48+&
         &t22*t4*abb1n34+t23*t4*abb1n40+t3*t9*abb1n35+t4*t9*abb1n38+t1*t15*t6*ab&
         &b1n66+t1*t22*t4*abb1n66+t16*t4*t6*abb1n66)
         return
      end if
      t33 = d(iv1,iv2)
      t2 = spvak1k2(iv2)
      t7 = spvak1k5(iv2)
      t8 = spvak3k4(iv2)
      t18 = k1(iv2)
      t19 = spvak3k2(iv2)
      t24 = k2(iv2)
      t25 = k5(iv2)
      t26 = k6(iv2)
      t27 = qshift(iv2)
      t28 = t15*t8
      t29 = spvak6k2(iv2)
      t30 = t15*t29
      t31 = t16*t7
      t32 = t22*t7
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t33*abb1n45+t1*t33*abb1n55+t3*t33*abb1n64+t33*t4&
         &*abb1n62+t33*t5*abb1n58)+t28*abb1n37+t30*abb1n34+t31*abb1n37+t32*abb1n&
         &34+spvak5k2(iv2)*t15*abb1n35+spvak6k1(iv2)*t15*abb1n48+spvak6k5(iv2)*t&
         &15*abb1n40+t1*t30*abb1n66+t1*t32*abb1n66+t10*t19*abb1n41+t10*t8*abb1n4&
         &3+t11*t2*abb1n36+t11*t7*abb1n39+t11*t8*abb1n44+t12*t2*abb1n36+t12*t7*a&
         &bb1n38+t13*t19*abb1n59+t13*t2*abb1n65+t13*t7*abb1n63+t13*t8*abb1n56+t1&
         &4*t18*abb1n35+t14*t25*abb1n36+t14*t26*abb1n36+t14*t27*abb1n65+t14*t7*a&
         &bb1n47+t14*t8*abb1n46+t15*t18*abb1n38+t15*t19*abb1n33+t15*t2*abb1n47+t&
         &15*t25*abb1n39+t15*t26*abb1n38+t15*t27*abb1n63+t16*t18*abb1n42+t16*t2*&
         &abb1n46+t16*t24*abb1n43+t16*t25*abb1n44+t16*t27*abb1n56+t17*t7*abb1n35&
         &+t2*t9*abb1n35+t20*t24*abb1n41+t20*t27*abb1n59+t20*t7*abb1n33+t21*t7*a&
         &bb1n48+t23*t7*abb1n40+t28*t6*abb1n66+t31*t6*abb1n66+t7*t9*abb1n38+t8*t&
         &9*abb1n42+t16*t29*t4*abb1n66+t22*t4*t8*abb1n66)
         return
      end if
      t34 = d(iv2,iv3)
      t35 = d(iv1,iv3)
      t1 = spvak1k5(iv3)
      t3 = spvak3k4(iv3)
      t4 = spvak6k2(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak1k2(iv3)*t33*abb1n64+spvak3k2(iv3)*t33*abb1&
         &n58+t1*t33*abb1n62+t14*t34*abb1n64+t15*t34*abb1n62+t16*t34*abb1n55+t19&
         &*t35*abb1n58+t2*t35*abb1n64+t20*t34*abb1n58+t3*t33*abb1n55+t35*t7*abb1&
         &n62+t35*t8*abb1n55)+t28*t4*abb1n66+t31*t4*abb1n66+t1*t16*t29*abb1n66+t&
         &1*t22*t8*abb1n66+t15*t29*t3*abb1n66+t22*t3*t7*abb1n66)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d1:
   subroutine     reconstruct_d1(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_1:
      coeffs%coeffs_1%c0 = derivative(czip)
      coeffs%coeffs_1%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_1%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_1%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_1%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_1%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_1%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_1%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_1%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_1%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_1%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_1%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_1%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_1%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_1%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_1%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_1%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_1%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_1%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_1%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_1%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_1%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_1%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_1%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_1%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_1%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_1%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_1%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_1%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_1%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_1%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_1%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_1%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_1%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_1%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_1:
   end subroutine reconstruct_d1
!---#] subroutine reconstruct_d1:
end module p0_dd_emnebardu_d1h1l1d
