module     p17_ddbar_neepdubar_abbrevd3h0
   use p17_ddbar_neepdubar_config, only: ki
   use p17_ddbar_neepdubar_globalsh0
   implicit none
   private
   complex(ki), public :: abb3n1
   complex(ki), public :: abb3n2
   complex(ki), public :: abb3n3
   complex(ki), public :: abb3n4
   complex(ki), public :: abb3n5
   complex(ki), public :: abb3n6
   complex(ki), public :: abb3n7
   complex(ki), public :: abb3n8
   complex(ki), public :: abb3n9
   complex(ki), public :: abb3n10
   complex(ki), public :: abb3n11
   complex(ki), public :: abb3n12
   complex(ki), public :: abb3n13
   complex(ki), public :: abb3n14
   complex(ki), public :: abb3n15
   complex(ki), public :: abb3n16
   complex(ki), public :: abb3n17
   complex(ki), public :: abb3n18
   complex(ki), public :: abb3n19
   complex(ki), public :: abb3n20
   complex(ki), public :: abb3n21
   complex(ki), public :: abb3n22
   complex(ki), public :: abb3n23
   complex(ki), public :: abb3n24
   complex(ki), public :: abb3n25
   complex(ki), public :: abb3n26
   complex(ki), public :: abb3n27
   complex(ki), public :: abb3n28
   complex(ki), public :: rat2d3
   complex(ki), public :: abb3n30
   complex(ki), public :: abb3n31
   complex(ki), public :: abb3n32
   complex(ki), public :: abb3n33
   complex(ki), public :: abb3n34
   complex(ki), public :: abb3n35
   complex(ki), public :: abb3n36
   complex(ki), public :: abb3n37
   complex(ki), public :: abb3n38
   complex(ki), public :: abb3n39
   complex(ki), public :: abb3n40
   complex(ki), public :: abb3n41
   complex(ki), public :: abb3n42
   complex(ki), public :: abb3n43
   complex(ki), public :: abb3n44
   complex(ki), public :: abb3n45
   complex(ki), public :: abb3n46
   complex(ki), public :: abb3n47
   complex(ki), public :: abb3n48
   complex(ki), public :: abb3n49
   complex(ki), public :: abb3n50
   complex(ki), public :: abb3n51
   complex(ki), public :: abb3n52
   complex(ki), public :: abb3n53
   complex(ki), public :: abb3n54
   complex(ki), public :: abb3n55
   complex(ki), public :: abb3n56
   complex(ki), public :: abb3n57
   complex(ki), public :: abb3n58
   complex(ki), public :: abb3n59
   complex(ki), public :: abb3n60
   complex(ki), public :: abb3n61
   complex(ki), public :: abb3n62
   complex(ki), public :: abb3n63
   complex(ki), public :: abb3n64
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   real(ki) :: t28
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p17_ddbar_neepdubar_config, only: deltaOS
      use p17_ddbar_neepdubar_kinematics
      use p17_ddbar_neepdubar_model
      use p17_ddbar_neepdubar_color, only: TR
      use p17_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = es56*c1*i_
      t28 = TR*TR
      t3 = es12*NC*NC*t1
      t4 = t2*spak1k5
      t5 = es56*c2*i_
      t1 = es12*NC*t1
      t6 = t5*spak1k5
      abb3n1 = ((4.0_ki)*(t28/t1*t6*spak3k5*spbk5k2*spbk6k4+t28*t2/t3*spak1k3*sp&
      &ak1k5*spbk2k1*spbk6k4-(t28/t1*t5*spak1k3*spak1k5*spbk2k1*spbk6k4+t28/t3*t&
      &4*spak3k5*spbk5k2*spbk6k4)))
      t7 = c1*i_
      t8 = t7*spak1k2
      t9 = t8*spak5k6
      t10 = TR*spbk6k2
      t10 = t10*t10
      t11 = c2*i_
      t12 = t11*spak1k2
      t13 = t12*spak5k6
      abb3n2 = ((4.0_ki)*(t10/t1*t13-t10/t3*t9))
      t10 = t7*spak1k5
      t14 = t10*spak3k5
      t15 = t11*spak1k5
      t16 = t15*spak3k5
      abb3n3 = ((4.0_ki)*(t28*t16/t1*spbk2k1*spbk5k4-t28*t14/t3*spbk2k1*spbk5k4)&
      &)
      t17 = t7*spak1k3
      t18 = t17*spak5k6
      t19 = t28*t18/t3*spbk6k2*spbk6k4
      t20 = t11*spak1k3
      t21 = t20*spak5k6
      t22 = t28*t21/t1*spbk6k2*spbk6k4
      abb3n4 = ((8.0_ki)*(t19-t22))
      t23 = t28*t17/t3*spbk6k4
      t24 = t28*t20/t1*spbk6k4
      t25 = t23-t24
      abb3n5 = ((8.0_ki)*t25)
      abb3n6 = ((4.0_ki)*t25)
      abb3n7 = ((8.0_ki)*(t24-t23))
      t23 = t7*spak3k5
      t24 = t11*spak3k5
      abb3n8 = ((4.0_ki)*(t28*t24/t1*spbk4k1-t28*t23/t3*spbk4k1))
      t25 = t28*t10/t3*spbk4k2
      t26 = t28*t15/t1*spbk4k2
      t27 = t25-t26
      abb3n9 = ((8.0_ki)*t27)
      abb3n10 = ((4.0_ki)*t27)
      abb3n11 = ((8.0_ki)*(t26-t25))
      t25 = t14*spbk5k2
      t26 = t16*spbk5k2
      abb3n12 = ((4.0_ki)*(t28*t26/t1*spbk5k4-t28*t25/t3*spbk5k4))
      abb3n13 = ((8.0_ki)*(t22+t28*t25/t3*spbk6k4+t28*t20/t1*spak1k5*spbk2k1*spb&
      &k6k4-(t28*t17/t3*spak1k5*spbk2k1*spbk6k4+t28*t26/t1*spbk6k4+t19)))
      abb3n14 = ((8.0_ki)*(t28*t15/t1*spbk5k2-t28*t10/t3*spbk5k2))
      abb3n15 = ((4.0_ki)*(t22+t28*t14/t3*spbk4k2*spbk6k5+t28*t14/t3*spbk5k4*spb&
      &k6k2+t28/t3*t8*spak3k5*spbk4k2*spbk6k2-(t28*t12/t1*spak3k5*spbk4k2*spbk6k&
      &2+t28*t16/t1*spbk5k4*spbk6k2+t28*t16/t1*spbk4k2*spbk6k5+t19)))
      t14 = TR*spak1k5
      t14 = t14*t14
      abb3n16 = ((4.0_ki)*(t28/t3*t4*spbk4k2+t14/t3*t7*spbk2k1*spbk5k4+t28/t3*t9&
      &*spbk4k2*spbk6k2+t28*t10/t3*spak5k6*spbk5k4*spbk6k2-(t28*t15/t1*spak5k6*s&
      &pbk5k4*spbk6k2+t28*t13/t1*spbk4k2*spbk6k2+t11/t1*t14*spbk2k1*spbk5k4+t28/&
      &t1*t6*spbk4k2)))
      abb3n17 = ((8.0_ki)*(t28*t10/t3*spbk6k2-t28*t15/t1*spbk6k2))
      abb3n18 = ((4.0_ki)*(t28*t15/t1*spbk6k5+t28/t3*t8*spbk6k2-(t28*t10/t3*spbk&
      &6k5+t28*t12/t1*spbk6k2)))
      t4 = t7*spak2k3
      t6 = t11*spak2k3
      abb3n19 = ((4.0_ki)*(t28*t21/t1*spbk6k1*spbk6k4+t28/t1*t5*spak3k5*spbk6k4+&
      &t28/t1*t6*spak5k6*spbk6k2*spbk6k4-(t28/t3*t4*spak5k6*spbk6k2*spbk6k4+t28*&
      &t2/t3*spak3k5*spbk6k4+t28*t18/t3*spbk6k1*spbk6k4)))
      abb3n20 = ((4.0_ki)*(t28/t3*t4*spbk6k4-t28/t1*t6*spbk6k4))
      t2 = t28*t23/t3*spbk4k2
      t4 = t28*t24/t1*spbk4k2
      abb3n21 = ((8.0_ki)*(t2-t4))
      t2 = t4-t2
      abb3n22 = ((4.0_ki)*t2)
      abb3n23 = ((8.0_ki)*t2)
      abb3n24 = ((4.0_ki)*(t28*t24/t1*spbk5k4-t28*t23/t3*spbk5k4))
      t2 = t28*t23/t3*spbk6k4-t28*t24/t1*spbk6k4
      abb3n25 = ((8.0_ki)*t2)
      abb3n26 = ((4.0_ki)*t2)
      abb3n27 = ((4.0_ki)*(t28*t10/t3*spbk4k1+t28/t3*t7*spak2k5*spbk4k2+t28/t3*t&
      &7*spak5k6*spbk6k4-(t28*t11/t1*spak5k6*spbk6k4+t28*t11/t1*spak2k5*spbk4k2+&
      &t28*t15/t1*spbk4k1)))
      abb3n28 = ((4.0_ki)*(t28*t11/t1-t28/t3*t7))
      rat2d3 = 0
      rat2 = rat2 + rat2d3
      abb3n30 = abb3n1
      abb3n31 = abb3n27
      abb3n32 = abb3n25
      abb3n33 = abb3n24
      abb3n34 = abb3n23
      abb3n35 = abb3n22
      abb3n36 = abb3n21
      abb3n37 = abb3n20
      abb3n38 = abb3n18
      abb3n39 = abb3n17
      abb3n40 = abb3n15
      abb3n41 = abb3n14
      abb3n42 = abb3n11
      abb3n43 = abb3n9
      abb3n44 = abb3n8
      abb3n45 = abb3n7
      abb3n46 = abb3n6
      abb3n47 = abb3n5
      abb3n48 = -(abb3n2)
      abb3n49 = -(abb3n3)
      abb3n50 = -(abb3n4)
      abb3n51 = -(abb3n6)
      abb3n52 = (-2.0_ki)*abb3n6
      abb3n53 = -(abb3n10)
      abb3n54 = (-2.0_ki)*abb3n10
      abb3n55 = -(abb3n12)
      abb3n56 = -(abb3n13)
      abb3n57 = ((2.0_ki)*abb3n15)
      abb3n58 = -(abb3n16)
      abb3n59 = -(abb3n19)
      abb3n60 = -(abb3n22)
      abb3n61 = (-2.0_ki)*abb3n22
      abb3n62 = -(abb3n26)
      abb3n63 = (-2.0_ki)*abb3n26
      abb3n64 = -(abb3n28)
   end subroutine
end module p17_ddbar_neepdubar_abbrevd3h0
