module     p17_ddbar_neepdubar_abbrevd5h1
   use p17_ddbar_neepdubar_config, only: ki
   use p17_ddbar_neepdubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb5n1
   complex(ki), public :: abb5n2
   complex(ki), public :: abb5n3
   complex(ki), public :: abb5n4
   complex(ki), public :: abb5n5
   complex(ki), public :: abb5n6
   complex(ki), public :: abb5n7
   complex(ki), public :: abb5n8
   complex(ki), public :: abb5n9
   complex(ki), public :: abb5n10
   complex(ki), public :: abb5n11
   complex(ki), public :: abb5n12
   complex(ki), public :: abb5n13
   complex(ki), public :: abb5n14
   complex(ki), public :: abb5n15
   complex(ki), public :: abb5n16
   complex(ki), public :: abb5n17
   complex(ki), public :: abb5n18
   complex(ki), public :: abb5n19
   complex(ki), public :: abb5n20
   complex(ki), public :: abb5n21
   complex(ki), public :: abb5n22
   complex(ki), public :: abb5n23
   complex(ki), public :: abb5n24
   complex(ki), public :: abb5n25
   complex(ki), public :: abb5n26
   complex(ki), public :: abb5n27
   complex(ki), public :: abb5n28
   complex(ki), public :: abb5n29
   complex(ki), public :: abb5n30
   complex(ki), public :: rat2d5
   complex(ki), public :: abb5n32
   complex(ki), public :: abb5n33
   complex(ki), public :: abb5n34
   complex(ki), public :: abb5n35
   complex(ki), public :: abb5n36
   complex(ki), public :: abb5n37
   complex(ki), public :: abb5n38
   complex(ki), public :: abb5n39
   complex(ki), public :: abb5n40
   complex(ki), public :: abb5n41
   complex(ki), public :: abb5n42
   complex(ki), public :: abb5n43
   complex(ki), public :: abb5n44
   complex(ki), public :: abb5n45
   complex(ki), public :: abb5n46
   complex(ki), public :: abb5n47
   complex(ki), public :: abb5n48
   complex(ki), public :: abb5n49
   complex(ki), public :: abb5n50
   complex(ki), public :: abb5n51
   complex(ki), public :: abb5n52
   complex(ki), public :: abb5n53
   complex(ki), public :: abb5n54
   complex(ki), public :: abb5n55
   complex(ki), public :: abb5n56
   complex(ki), public :: abb5n57
   complex(ki), public :: abb5n58
   complex(ki), public :: abb5n59
   complex(ki), public :: abb5n60
   complex(ki), public :: abb5n61
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   real(ki) :: t34
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p17_ddbar_neepdubar_config, only: deltaOS
      use p17_ddbar_neepdubar_kinematics
      use p17_ddbar_neepdubar_model
      use p17_ddbar_neepdubar_color, only: TR
      use p17_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = es12*c2*i_
      t2 = t1*spak2k3
      t34 = TR*TR
      t3 = (es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t4 = NC*NC*t3
      t1 = t1*spak2k5
      t5 = es345*c2*i_
      t6 = t5*spak2k3
      t5 = t5*spak2k5
      t7 = es61*c2*i_
      t8 = t7*spak2k3
      t7 = t7*spak2k5
      t9 = es12*c1*i_
      t10 = t9*spak2k3
      t3 = NC*t3
      t9 = t9*spak2k5
      t11 = es345*c1*i_
      t12 = t11*spak2k3
      t11 = t11*spak2k5
      t13 = es61*c1*i_
      t14 = t13*spak2k3
      t13 = t13*spak2k5
      abb5n1 = ((4.0_ki)*(t34*t1/t4*spak3k5*spbk5k1*spbk6k4+t34*t11/t3*spak3k5*s&
      &pbk5k1*spbk6k4+t34*t12/t3*spak2k5*spbk2k1*spbk6k4+t34*t2/t4*spak2k5*spbk2&
      &k1*spbk6k4+t34/t4*t7*spak3k5*spbk5k1*spbk6k4+t34/t4*t8*spak2k5*spbk2k1*sp&
      &bk6k4-(t34/t4*t6*spak2k5*spbk2k1*spbk6k4+t34/t4*t5*spak3k5*spbk5k1*spbk6k&
      &4+t34/t3*t9*spak3k5*spbk5k1*spbk6k4+t34*t14/t3*spak2k5*spbk2k1*spbk6k4+t3&
      &4*t13/t3*spak3k5*spbk5k1*spbk6k4+t34*t10/t3*spak2k5*spbk2k1*spbk6k4)))
      t15 = c2*i_
      t16 = t15*spak2k3
      t17 = t16*spak2k5
      t18 = t17*spbk2k1
      t19 = c1*i_
      t20 = t19*spak2k3
      t21 = t20*spak2k5
      t22 = t21*spbk2k1
      abb5n2 = ((4.0_ki)*(t34*t22/t3*spbk4k2-t34*t18/t4*spbk4k2))
      t23 = t15*spak2k5
      t24 = t19*spak2k5
      abb5n3 = ((8.0_ki)*(t34*t23/t4*spbk2k1-t34*t24/t3*spbk2k1))
      t25 = t15*spak1k3
      t26 = t19*spak1k3
      abb5n4 = ((4.0_ki)*(t34*t26/t3*spbk6k4-t34*t25/t4*spbk6k4))
      t27 = t34*t16/t4*spbk4k1
      t28 = t34*t20/t3*spbk4k1
      abb5n5 = ((8.0_ki)*(t27-t28))
      t27 = t28-t27
      abb5n6 = ((4.0_ki)*t27)
      abb5n7 = ((8.0_ki)*t27)
      t27 = t34*t23/t4*spbk4k1
      t28 = t34*t24/t3*spbk4k1
      t29 = t27-t28
      abb5n8 = ((8.0_ki)*t29)
      abb5n9 = ((4.0_ki)*t29)
      abb5n10 = ((8.0_ki)*(t28-t27))
      t27 = t15*spak1k5
      t28 = t27*spak2k6
      t29 = TR*spbk6k1
      t29 = t29*t29
      t30 = t19*spak1k5
      t31 = t30*spak2k6
      abb5n11 = ((4.0_ki)*(t29/t3*t31-t28*t29/t4))
      t29 = t17*spbk4k2
      t32 = t21*spbk4k2
      abb5n12 = ((4.0_ki)*(t34*t29/t4*spbk5k1-t34*t32/t3*spbk5k1))
      t33 = TR*spak2k5
      t33 = t33*t33
      abb5n13 = ((4.0_ki)*(t34*t13/t3*spbk4k1+t34/t3*t9*spbk4k1+t34/t4*t5*spbk4k&
      &1+t19/t3*t33*spbk4k2*spbk5k1+t34*t28/t4*spbk4k1*spbk6k1+t34*t23/t4*spak2k&
      &6*spbk4k2*spbk6k1-(t34*t24/t3*spak2k6*spbk4k2*spbk6k1+t34*t31/t3*spbk4k1*&
      &spbk6k1+t15*t33/t4*spbk4k2*spbk5k1+t34/t4*t7*spbk4k1+t34*t11/t3*spbk4k1+t&
      &34*t1/t4*spbk4k1)))
      abb5n14 = ((8.0_ki)*(t34*t24/t3*spbk6k1-t34*t23/t4*spbk6k1))
      t1 = t15*spak2k6
      t5 = t1*spak3k5
      t7 = t34/t4*t5*spbk6k1*spbk6k4
      t9 = t19*spak2k6
      t11 = t9*spak3k5
      t13 = t34*t11/t3*spbk6k1*spbk6k4
      abb5n15 = ((8.0_ki)*(t7-t13))
      abb5n16 = ((8.0_ki)*(t7+t34*t22/t3*spbk6k4+t34*t24/t3*spak3k5*spbk5k1*spbk&
      &6k4-(t34*t23/t4*spak3k5*spbk5k1*spbk6k4+t34*t18/t4*spbk6k4+t13)))
      abb5n17 = ((4.0_ki)*(t13+t34*t32/t3*spbk6k1+t34*t17/t4*spbk4k1*spbk6k2+t34&
      &*t30/t3*spak2k3*spbk4k1*spbk6k1-(t34*t27/t4*spak2k3*spbk4k1*spbk6k1+t34*t&
      &21/t3*spbk4k1*spbk6k2+t34*t29/t4*spbk6k1+t7)))
      abb5n18 = ((8.0_ki)*(t13-t7))
      abb5n19 = ((4.0_ki)*(t34*t20/t3*spbk4k2-t34*t16/t4*spbk4k2))
      abb5n20 = ((4.0_ki)*(t34*t20/t3*spbk5k4-t34*t16/t4*spbk5k4))
      t7 = t34*t16/t4*spbk6k4
      t13 = t34*t20/t3*spbk6k4
      abb5n21 = ((4.0_ki)*(t7-t13))
      abb5n22 = ((8.0_ki)*(t13-t7))
      abb5n23 = ((4.0_ki)*(t34*t23/t4*spbk6k2+t34*t27/t4*spbk6k1-(t34*t30/t3*spb&
      &k6k1+t34*t24/t3*spbk6k2)))
      abb5n24 = ((4.0_ki)*(t34*t12/t3*spbk6k4+t34*t2/t4*spbk6k4+t34/t4*t8*spbk6k&
      &4+t34/t4*t5*spbk6k4*spbk6k5+t34*t25/t4*spak2k6*spbk6k1*spbk6k4-(t34*t26/t&
      &3*spak2k6*spbk6k1*spbk6k4+t34*t11/t3*spbk6k4*spbk6k5+t34/t4*t6*spbk6k4+t3&
      &4*t14/t3*spbk6k4+t34*t10/t3*spbk6k4)))
      abb5n25 = ((4.0_ki)*(t34*t23/t4*spbk5k4+t34/t3*t9*spbk6k4+t34*t19/t3*spak1&
      &k2*spbk4k1-(t34*t15/t4*spak1k2*spbk4k1+t34*t24/t3*spbk5k4+t34*t1/t4*spbk6&
      &k4)))
      t1 = t34*t15/t4*spak3k5*spbk6k4
      t2 = t34*t19/t3*spak3k5*spbk6k4
      t5 = t1-t2
      abb5n26 = ((8.0_ki)*t5)
      abb5n27 = ((4.0_ki)*t5)
      t1 = t2-t1
      abb5n28 = ((4.0_ki)*t1)
      abb5n29 = ((8.0_ki)*t1)
      abb5n30 = ((4.0_ki)*(t34*t15/t4-t34*t19/t3))
      rat2d5 = 0
      rat2 = rat2 + rat2d5
      abb5n32 = abb5n1
      abb5n33 = abb5n30
      abb5n34 = abb5n29
      abb5n35 = abb5n28
      abb5n36 = abb5n27
      abb5n37 = abb5n26
      abb5n38 = abb5n25
      abb5n39 = abb5n24
      abb5n40 = abb5n23
      abb5n41 = abb5n22
      abb5n42 = abb5n21
      abb5n43 = abb5n20
      abb5n44 = abb5n19
      abb5n45 = abb5n18
      abb5n46 = abb5n17
      abb5n47 = abb5n16
      abb5n48 = abb5n15
      abb5n49 = abb5n14
      abb5n50 = abb5n13
      abb5n51 = abb5n12
      abb5n52 = abb5n11
      abb5n53 = abb5n10
      abb5n54 = abb5n9
      abb5n55 = abb5n8
      abb5n56 = abb5n7
      abb5n57 = abb5n6
      abb5n58 = abb5n5
      abb5n59 = abb5n4
      abb5n60 = abb5n3
      abb5n61 = abb5n2
   end subroutine
end module p17_ddbar_neepdubar_abbrevd5h1
