module     p18_ddbar_neepscbar_abbrevd34h0
   use p18_ddbar_neepscbar_config, only: ki
   use p18_ddbar_neepscbar_globalsh0
   implicit none
   private
   complex(ki), public :: abb34n1
   complex(ki), public :: abb34n2
   complex(ki), public :: abb34n3
   complex(ki), public :: abb34n4
   complex(ki), public :: abb34n5
   complex(ki), public :: abb34n6
   complex(ki), public :: abb34n7
   complex(ki), public :: abb34n8
   complex(ki), public :: abb34n9
   complex(ki), public :: abb34n10
   complex(ki), public :: abb34n11
   complex(ki), public :: abb34n12
   complex(ki), public :: rat2d34
   complex(ki), public :: abb34n14
   complex(ki), public :: abb34n15
   complex(ki), public :: abb34n16
   complex(ki), public :: abb34n17
   complex(ki), public :: abb34n18
   complex(ki), public :: abb34n19
   complex(ki), public :: abb34n20
   complex(ki), public :: abb34n21
   complex(ki), public :: abb34n22
   complex(ki), public :: abb34n23
   complex(ki), public :: abb34n24
   complex(ki), public :: abb34n25
   complex(ki), public :: abb34n26
   complex(ki), public :: abb34n27
   complex(ki), public :: abb34n28
   complex(ki), public :: abb34n29
   complex(ki), public :: abb34n30
   complex(ki), public :: abb34n31
   complex(ki), public :: abb34n32
   complex(ki), public :: abb34n33
   complex(ki), public :: abb34n34
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   complex(ki) :: t44
   complex(ki) :: t45
   complex(ki) :: t46
   complex(ki) :: t47
   complex(ki) :: t48
   complex(ki) :: t49
   complex(ki) :: t50
   complex(ki) :: t51
   complex(ki) :: t52
   complex(ki) :: t53
   complex(ki) :: t54
   complex(ki) :: t55
   complex(ki) :: t56
   real(ki) :: t57
   real(ki) :: t58
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p18_ddbar_neepscbar_config, only: deltaOS
      use p18_ddbar_neepscbar_kinematics
      use p18_ddbar_neepscbar_model
      use p18_ddbar_neepscbar_color, only: TR
      use p18_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak1k5
      t4 = t3*spak3k4
      t57 = TR*TR
      t5 = t57*t4*spbk4k2*spbk6k4
      t6 = (es12+es34-(es56+es345))*t1
      t7 = es12*t6
      t8 = t5/t7
      t9 = t3*spak3k6
      t10 = t57*t9*spbk6k2*spbk6k4
      t11 = t10/t7
      t12 = t2*spak1k3*spak3k5
      t13 = t12*spbk4k3
      t14 = t57*t13*spbk6k2
      t15 = es345*es12*t1
      t16 = t14/t15
      t3 = t3*spak3k5
      t17 = t3*spbk5k4
      t18 = t57*t17*spbk6k2
      t19 = t18/t15
      t58 = NC*NC
      t20 = t58*t7
      t21 = t5/t20
      t22 = t10/t20
      t23 = c2*i_
      t24 = t23*spak1k5
      t25 = t24*spak3k4
      t26 = t57*t25*spbk4k2*spbk6k4
      t27 = NC*t6
      t28 = es12*t27
      t29 = t26/t28
      t30 = t24*spak3k6
      t31 = t57*t30*spbk6k2*spbk6k4
      t32 = t31/t28
      t33 = NC*c2*i_
      t34 = t33*spak1k5
      t35 = t34*spak3k4
      t36 = t57*t35/t7*spbk4k2*spbk6k4
      t37 = t34*spak3k6
      t38 = t57*t37/t7*spbk6k2*spbk6k4
      t39 = t58*t15
      t40 = t14/t39
      t41 = t18/t39
      t42 = t23*spak1k3*spak3k5
      t43 = t57*t42*spbk4k3*spbk6k2
      t44 = NC*t1
      t45 = es345*es12*t44
      t46 = t43/t45
      t24 = t24*spak3k5
      t47 = t57*t24*spbk5k4*spbk6k2
      t48 = t47/t45
      t49 = t33*spak1k3*spak3k5
      t50 = t49*spbk4k3
      t51 = t57*t50/t15*spbk6k2
      t34 = t34*spak3k5
      t52 = t34*spbk5k4
      t53 = t57*t52/t15*spbk6k2
      abb34n1 = ((2.0_ki)*(t19+t21+t22+t36+t38+t40+t48+t51-(t8+t53+t46+t41+t32+t&
      &29+t16+t11)))
      t54 = t2*spak3k5
      t55 = t33*spak3k5
      abb34n2 = ((8.0_ki)*(t57*t54/t7*spbk6k4-t57*t55/t7*spbk6k4))
      abb34n3 = ((4.0_ki)*(t57*t55/t7*spbk6k3+t57*t33/t7*spak4k5*spbk6k4-(t57*t2&
      &/t7*spak4k5*spbk6k4+t57*t54/t7*spbk6k3)))
      t56 = t57*t4*spbk2k1*spbk6k4
      abb34n4 = ((4.0_ki)*(t56/t7+t57*t25/t28*spbk2k1*spbk6k4-(t57*t35/t7*spbk2k&
      &1*spbk6k4+t56/t20)))
      abb34n5 = ((4.0_ki)*(t57*t2/t20*spak3k4*spbk6k4-t57*t23/t28*spak3k4*spbk6k&
      &4))
      t6 = t58*t6
      t1 = es345*t58*t1
      t25 = es345*t44
      abb34n6 = ((4.0_ki)*(t14/t1+t10/t6+t47/t25+t5/t6-(t31/t27+t26/t27+t43/t25+&
      &t18/t1)))
      t1 = t57*t9*spbk2k1*spbk6k4
      t5 = t57*t12*spbk2k1*spbk4k3
      t3 = t57*t3*spbk2k1*spbk5k4
      abb34n7 = ((4.0_ki)*(t1/t7+t5/t15+t3/t39+t57*t34/t15*spbk2k1*spbk5k4+t57*t&
      &30/t28*spbk2k1*spbk6k4+t57*t42/t45*spbk2k1*spbk4k3-(t57*t37/t7*spbk2k1*sp&
      &bk6k4+t57*t24/t45*spbk2k1*spbk5k4+t57*t49/t15*spbk2k1*spbk4k3+t5/t39+t3/t&
      &15+t1/t20)))
      t1 = t11+t16+t29+t32+t41+t46+t53+t8-(t51+t48+t40+t38+t36+t22+t21+t19)
      abb34n8 = ((8.0_ki)*t1)
      abb34n9 = ((4.0_ki)*t1)
      t1 = t2*spak2k5
      t3 = t57*t1*spak3k4*spbk4k2*spbk6k4
      t5 = t57*t1*spak3k6*spbk6k2*spbk6k4
      t6 = t23*spak2k5
      t8 = t57*t2*spak2k3*spak3k5*spbk4k3*spbk6k2
      t1 = t57*t1*spak3k5*spbk5k4*spbk6k2
      t10 = t33*spak2k5
      abb34n10 = ((4.0_ki)*(t3/t20+t5/t20+t8/t39+t57/t45*t6*spak3k5*spbk5k4*spbk&
      &6k2-(t57*t23/t45*spak2k3*spak3k5*spbk4k3*spbk6k2+t57/t28*t6*spak3k6*spbk6&
      &k2*spbk6k4+t57/t28*t6*spak3k4*spbk4k2*spbk6k4+t1/t39))+(2.0_ki)*(t1/t15+t&
      &57*t17/t15*spbk6k1+t57*t50/t15*spbk6k1+t57*t35/t7*spbk4k1*spbk6k4+t57*t37&
      &/t7*spbk6k1*spbk6k4+t57*t10/t7*spak3k4*spbk4k2*spbk6k4+t57*t10/t7*spak3k6&
      &*spbk6k2*spbk6k4+t57*t33/t15*spak2k3*spak3k5*spbk4k3*spbk6k2-(t57*t10/t15&
      &*spak3k5*spbk5k4*spbk6k2+t57/t7*t9*spbk6k1*spbk6k4+t57*t4/t7*spbk4k1*spbk&
      &6k4+t57*t52/t15*spbk6k1+t57*t13/t15*spbk6k1+t5/t7+t3/t7+t8/t15)))
      t1 = t57*t54*spbk4k3
      t3 = t57*t55*spbk4k3
      t4 = t23*spak3k5
      abb34n11 = ((4.0_ki)*(t1/t15+t1/t39+t1/t7+t57*t2/t7*spak5k6*spbk6k4-(t57*t&
      &33/t7*spak5k6*spbk6k4+t57*t4/t45*spbk4k3+t3/t7+t3/t15)))
      t1 = t57*t54*spbk5k4
      abb34n12 = ((4.0_ki)*(t57*t55/t15*spbk5k4+t57*t4/t45*spbk5k4+t57*t2/t20*sp&
      &ak3k6*spbk6k4-(t57*t23/t28*spak3k6*spbk6k4+t1/t39+t1/t15)))
      rat2d34 = abb34n1
      rat2 = rat2 + rat2d34
      abb34n14 = abb34n6
      abb34n15 = abb34n12
      abb34n16 = abb34n11
      abb34n17 = abb34n10
      abb34n18 = abb34n9
      abb34n19 = abb34n8
      abb34n20 = abb34n7
      abb34n21 = abb34n5
      abb34n22 = abb34n4
      abb34n23 = abb34n3
      abb34n24 = abb34n2
      abb34n25 = -(abb34n2)
      abb34n26 = -(abb34n3)
      abb34n27 = -(abb34n4)
      abb34n28 = -(abb34n5)
      abb34n29 = -(abb34n7)
      abb34n30 = -(abb34n8)
      abb34n31 = (-2.0_ki)*abb34n9
      abb34n32 = -(abb34n10)
      abb34n33 = -(abb34n11)
      abb34n34 = -(abb34n12)
   end subroutine
end module p18_ddbar_neepscbar_abbrevd34h0
