module     p24_udbar_neepuubar_abbrevd62h0
   use p24_udbar_neepuubar_config, only: ki
   use p24_udbar_neepuubar_globalsh0
   implicit none
   private
   complex(ki), public :: abb62n1
   complex(ki), public :: abb62n2
   complex(ki), public :: abb62n3
   complex(ki), public :: abb62n4
   complex(ki), public :: abb62n5
   complex(ki), public :: abb62n6
   complex(ki), public :: abb62n7
   complex(ki), public :: abb62n8
   complex(ki), public :: abb62n9
   complex(ki), public :: rat2d62
   complex(ki), public :: abb62n11
   complex(ki), public :: abb62n12
   complex(ki), public :: abb62n13
   complex(ki), public :: abb62n14
   complex(ki), public :: abb62n15
   complex(ki), public :: abb62n16
   complex(ki), public :: abb62n17
   complex(ki), public :: abb62n18
   complex(ki), public :: abb62n19
   complex(ki), public :: abb62n20
   complex(ki), public :: abb62n21
   complex(ki), public :: abb62n22
   complex(ki), public :: abb62n23
   complex(ki), public :: abb62n24
   complex(ki), public :: abb62n25
   complex(ki), public :: abb62n26
   complex(ki), public :: abb62n27
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   real(ki) :: t25
   real(ki) :: t26
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p24_udbar_neepuubar_config, only: deltaOS
      use p24_udbar_neepuubar_kinematics
      use p24_udbar_neepuubar_model
      use p24_udbar_neepuubar_color, only: TR
      use p24_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_
      t3 = t2*spak2k3
      t25 = TR*TR
      t4 = t25*t3*spak2k6*spbk4k2*spbk5k1
      t5 = NC*t1
      t6 = t25*t3*spak3k6*spbk4k3*spbk5k1
      t7 = es56*c2*i_*spak2k3
      t8 = es234*t5
      t9 = es61*c2*i_*spak2k3
      t10 = c1*i_
      t11 = t10*spak2k3
      t12 = t25*t11*spak2k6*spbk4k2*spbk5k1
      t26 = NC*NC
      t13 = t26*t1
      t14 = t25*t11*spak3k6*spbk4k3*spbk5k1
      t15 = NC*c2
      t16 = t15*i_
      t17 = t16*spak2k3
      t18 = t25*t17*spak2k6*spbk4k2*spbk5k1
      t19 = t25*t17*spak3k6*spbk4k3*spbk5k1
      t20 = es56*c1*i_*spak2k3
      t21 = es234*t1
      t22 = t26*t21
      t23 = es61*c1*i_*spak2k3
      t24 = es56*t15*i_*spak2k3
      t15 = es61*t15*i_*spak2k3
      abb62n1 = ((8.0_ki)*(t6/t5+t25*t7/t8*spak2k6*spbk4k2*spbk5k1+t25/t8*t9*spa&
      &k2k6*spbk4k2*spbk5k1-(t25/t8*t9*spak3k6*spbk4k3*spbk5k1+t25*t7/t8*spak3k6&
      &*spbk4k3*spbk5k1+t4/t5))+(4.0_ki)*(t18/t1+t12/t13+t25*t15/t21*spak3k6*spb&
      &k4k3*spbk5k1+t25*t20/t22*spak3k6*spbk4k3*spbk5k1+t25*t24/t21*spak3k6*spbk&
      &4k3*spbk5k1+t25*t23/t22*spak3k6*spbk4k3*spbk5k1-(t25*t23/t22*spak2k6*spbk&
      &4k2*spbk5k1+t25*t24/t21*spak2k6*spbk4k2*spbk5k1+t25*t20/t22*spak2k6*spbk4&
      &k2*spbk5k1+t25*t15/t21*spak2k6*spbk4k2*spbk5k1+t14/t13+t19/t1)))
      abb62n2 = ((8.0_ki)*(t25*t2/t8*spak1k3*spak2k3*spbk4k3*spbk5k1-t25*t2/t8*s&
      &pak1k2*spak2k3*spbk4k2*spbk5k1)+(4.0_ki)*(t25*t10/t22*spak1k2*spak2k3*spb&
      &k4k2*spbk5k1+t25*t16/t21*spak1k2*spak2k3*spbk4k2*spbk5k1-(t25*t16/t21*spa&
      &k1k3*spak2k3*spbk4k3*spbk5k1+t25*t10/t22*spak1k3*spak2k3*spbk4k3*spbk5k1)&
      &))
      t1 = t10*spak1k6*spak2k3
      t2 = t2*spak1k6*spak2k3
      t5 = t16*spak1k6*spak2k3
      abb62n3 = ((4.0_ki)*(t25*(2.0_ki)*t2/t8*spbk4k2*spbk5k1-(t25/t21*t5*spbk4k&
      &2*spbk5k1+t25*t1/t22*spbk4k2*spbk5k1)))
      abb62n4 = ((4.0_ki)*(t25*t1/t22*spbk4k3*spbk5k1+t25/t21*t5*spbk4k3*spbk5k1&
      &-t25*(2.0_ki)*t2/t8*spbk4k3*spbk5k1))
      abb62n5 = ((16.0_ki)*(t4/t8-t6/t8)+(8.0_ki)*(t14/t22+t19/t21-(t18/t21+t12/&
      &t22)))
      t1 = t25*t11/t22*spbk4k2
      t2 = (2.0_ki)*t25*t3/t8*spbk4k2
      t4 = t25*t17/t21*spbk4k2
      abb62n6 = ((8.0_ki)*(t1+t4-t2))
      abb62n7 = ((8.0_ki)*(t2-(t4+t1)))
      t1 = t25*t11/t22*spbk4k3
      t2 = (2.0_ki)*t25*t3/t8*spbk4k3
      t3 = t25*t17/t21*spbk4k3
      abb62n8 = ((8.0_ki)*(t1+t3-t2))
      abb62n9 = ((8.0_ki)*(t2-(t3+t1)))
      rat2d62 = 0
      rat2 = rat2 + rat2d62
      abb62n11 = abb62n1
      abb62n12 = abb62n9
      abb62n13 = abb62n8
      abb62n14 = abb62n7
      abb62n15 = abb62n6
      abb62n16 = abb62n5
      abb62n17 = abb62n4
      abb62n18 = abb62n3
      abb62n19 = abb62n2
      abb62n20 = -(abb62n2)
      abb62n21 = -(abb62n3)
      abb62n22 = -(abb62n4)
      abb62n23 = -(abb62n5)
      abb62n24 = -(abb62n6)
      abb62n25 = -(abb62n7)
      abb62n26 = -(abb62n8)
      abb62n27 = -(abb62n9)
   end subroutine
end module p24_udbar_neepuubar_abbrevd62h0
