module     p24_udbar_neepuubar_abbrevd11h1
   use p24_udbar_neepuubar_config, only: ki
   use p24_udbar_neepuubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb11n1
   complex(ki), public :: abb11n2
   complex(ki), public :: abb11n3
   complex(ki), public :: abb11n4
   complex(ki), public :: abb11n5
   complex(ki), public :: abb11n6
   complex(ki), public :: abb11n7
   complex(ki), public :: abb11n8
   complex(ki), public :: abb11n9
   complex(ki), public :: abb11n10
   complex(ki), public :: abb11n11
   complex(ki), public :: abb11n12
   complex(ki), public :: abb11n13
   complex(ki), public :: abb11n14
   complex(ki), public :: abb11n15
   complex(ki), public :: abb11n16
   complex(ki), public :: rat2d11
   complex(ki), public :: abb11n18
   complex(ki), public :: abb11n19
   complex(ki), public :: abb11n20
   complex(ki), public :: abb11n21
   complex(ki), public :: abb11n22
   complex(ki), public :: abb11n23
   complex(ki), public :: abb11n24
   complex(ki), public :: abb11n25
   complex(ki), public :: abb11n26
   complex(ki), public :: abb11n27
   complex(ki), public :: abb11n28
   complex(ki), public :: abb11n29
   complex(ki), public :: abb11n30
   complex(ki), public :: abb11n31
   complex(ki), public :: abb11n32
   complex(ki), public :: abb11n33
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   real(ki) :: t39
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p24_udbar_neepuubar_config, only: deltaOS
      use p24_udbar_neepuubar_kinematics
      use p24_udbar_neepuubar_model
      use p24_udbar_neepuubar_color, only: TR
      use p24_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = c2*i_
      t2 = t1*spak2k5
      t3 = t2*spak3k4
      t39 = TR*TR
      t4 = t39*t3*spbk4k1*spbk6k4
      t5 = (es12+es34-(es56+es345))*(es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t6 = t4/t5
      t7 = t2*spak3k6
      t8 = t39*t7*spbk6k1*spbk6k4
      t9 = t8/t5
      t10 = -(t9+t6)
      t11 = NC*NC*t5
      t4 = t4/t11
      t8 = t8/t11
      t12 = c1*i_
      t13 = t12*spak2k5
      t14 = t13*spak3k4
      t15 = NC*t5
      t16 = t39*t14/t15*spbk4k1*spbk6k4
      t13 = t13*spak3k6
      t17 = t39*t13/t15*spbk6k1*spbk6k4
      t18 = NC*c1
      t19 = t18*i_
      t20 = t19*spak2k5
      t21 = t20*spak3k4
      t22 = t39*t21/t5*spbk4k1*spbk6k4
      t23 = t20*spak3k6
      t24 = t39*t23/t5*spbk6k1*spbk6k4
      abb11n1 = ((2.0_ki)*(t10+t22+t24+t4+t8-(t17+t16)))
      t25 = es234*c2*i_*spak2k5
      t26 = es34*c2*i_*spak2k5
      t27 = es345*c2*i_*spak2k5
      t28 = es61*c2*i_*spak2k5
      t29 = es234*t18*i_*spak2k5
      t30 = es34*t18*i_*spak2k5
      t31 = es345*t18*i_*spak2k5
      t32 = es61*t18*i_*spak2k5
      t33 = es12*c2*i_*spak2k5
      t34 = t1*spak3k4
      t35 = TR*spak2k5
      t35 = t35*t35
      t36 = t1*spak3k6
      t18 = es12*t18*i_*spak2k5
      t37 = t19*spak3k4
      t38 = t19*spak3k6
      abb11n2 = ((2.0_ki)*(t39*t18/t5*spak3k4*spbk4k1*spbk6k4+t39*t18/t5*spak3k6&
      &*spbk6k1*spbk6k4+t35*t36/t5*spbk2k1*spbk6k4*spbk6k5+t35*t37/t5*spbk2k1*sp&
      &bk5k4*spbk6k4-(t35*t38/t5*spbk2k1*spbk6k4*spbk6k5+t34*t35/t5*spbk2k1*spbk&
      &5k4*spbk6k4+t39*t33/t5*spak3k6*spbk6k1*spbk6k4+t39*t33/t5*spak3k4*spbk4k1&
      &*spbk6k4))+(4.0_ki)*(t39*t25/t5*spak3k4*spbk4k1*spbk6k4+t39*t25/t5*spak3k&
      &6*spbk6k1*spbk6k4+t39*t27/t5*spak3k4*spbk4k1*spbk6k4+t39*t27/t5*spak3k6*s&
      &pbk6k1*spbk6k4+t39*t30/t5*spak3k4*spbk4k1*spbk6k4+t39*t30/t5*spak3k6*spbk&
      &6k1*spbk6k4+t39*t32/t5*spak3k4*spbk4k1*spbk6k4+t39*t32/t5*spak3k6*spbk6k1&
      &*spbk6k4-(t39*t31/t5*spak3k6*spbk6k1*spbk6k4+t39*t31/t5*spak3k4*spbk4k1*s&
      &pbk6k4+t39*t29/t5*spak3k6*spbk6k1*spbk6k4+t39*t29/t5*spak3k4*spbk4k1*spbk&
      &6k4+t39*t28/t5*spak3k6*spbk6k1*spbk6k4+t39*t28/t5*spak3k4*spbk4k1*spbk6k4&
      &+t39*t26/t5*spak3k6*spbk6k1*spbk6k4+t39*t26/t5*spak3k4*spbk4k1*spbk6k4)))
      t18 = t2*spak3k5
      t25 = t18*spbk5k1
      t26 = t20*spak3k5
      t27 = t26*spbk5k1
      t28 = t1*spak2k3
      t29 = t28*spak2k5*spbk2k1
      t30 = t19*spak2k3
      t31 = t30*spak2k5*spbk2k1
      abb11n3 = ((12.0_ki)*(t39*t27/t5*spbk6k4-t39*t25/t5*spbk6k4)+(4.0_ki)*(t39&
      &*t29/t5*spbk6k4-t39*t31/t5*spbk6k4))
      t32 = t1*spak2k4
      t33 = t19*spak2k4
      abb11n4 = ((6.0_ki)*(t39*t25/t5*spbk6k3+t39*t2/t5*spak4k5*spbk5k1*spbk6k4-&
      &(t39*t20/t5*spak4k5*spbk5k1*spbk6k4+t39*t27/t5*spbk6k3))+(2.0_ki)*(t39*t3&
      &1/t5*spbk6k3+t39*t33/t5*spak2k5*spbk2k1*spbk6k4-(t39*t32/t5*spak2k5*spbk2&
      &k1*spbk6k4+t39*t29/t5*spbk6k3)))
      abb11n5 = ((2.0_ki)*(t39*t29/t5*spbk4k3+t39*t20/t5*spak2k6*spbk2k1*spbk6k4&
      &-(t39*t2/t5*spak2k6*spbk2k1*spbk6k4+t39*t31/t5*spbk4k3))+(6.0_ki)*(t39*t2&
      &6/t5*spbk4k3*spbk5k1+t39*t20/t5*spak5k6*spbk5k1*spbk6k4-(t39*t2/t5*spak5k&
      &6*spbk5k1*spbk6k4+t39*t18/t5*spbk4k3*spbk5k1)))
      t2 = (4.0_ki)*(t10+t22+t24)
      abb11n6 = t2
      t10 = t1*spak1k5
      t18 = t12*spak1k5
      abb11n7 = ((4.0_ki)*(t39*t10/t11*spak3k4*spbk4k1*spbk6k4+t39*t10/t11*spak3&
      &k6*spbk6k1*spbk6k4-(t39*t18/t15*spak3k6*spbk6k1*spbk6k4+t39*t18/t15*spak3&
      &k4*spbk4k1*spbk6k4)))
      t6 = t6+t9
      abb11n8 = ((4.0_ki)*(t6-(t24+t22))+(8.0_ki)*(t4+t8-(t17+t16)))
      abb11n9 = ((4.0_ki)*(t16+t17+t6-(t8+t4+t24+t22)))
      abb11n10 = ((8.0_ki)*(t16+t17-(t8+t4))+t2)
      t2 = t39*t28*spbk6k4
      t4 = t12*spak2k3
      abb11n11 = ((16.0_ki)*(t2/t11+t2/t5-(t39*t30/t5*spbk6k4+t39/t15*t4*spbk6k4&
      &)))
      t2 = t39*t28*spbk6k3
      t6 = t39*t32*spbk6k4
      abb11n12 = ((8.0_ki)*(t39/t15*t4*spbk6k3+t39*t30/t5*spbk6k3+t39*t33/t5*spb&
      &k6k4+t39*t12/t15*spak2k4*spbk6k4-(t6/t5+t2/t5+t6/t11+t2/t11)))
      t2 = t1*spak1k2
      t6 = t39*t2*spak3k4*spbk4k1*spbk6k4
      t2 = t39*t2*spak3k6*spbk6k1*spbk6k4
      t3 = t39*t3*spbk5k4*spbk6k4
      t7 = t39*t7*spbk6k4*spbk6k5
      t8 = t12*spak1k2
      t9 = t19*spak1k2
      abb11n13 = ((4.0_ki)*(t3/t11+t3/t5+t39*t13/t15*spbk6k4*spbk6k5+t39*t23/t5*&
      &spbk6k4*spbk6k5+t39/t15*t8*spak3k4*spbk4k1*spbk6k4+t39/t15*t8*spak3k6*spb&
      &k6k1*spbk6k4+t39/t5*t9*spak3k4*spbk4k1*spbk6k4+t39/t5*t9*spak3k6*spbk6k1*&
      &spbk6k4-(t39*t21/t5*spbk5k4*spbk6k4+t39*t14/t15*spbk5k4*spbk6k4+t7/t5+t6/&
      &t5+t2/t5+t7/t11+t6/t11+t2/t11)))
      t2 = t39*t28*spbk4k3
      t1 = t39*t1*spak2k6*spbk6k4
      abb11n14 = ((8.0_ki)*(t2/t11+t2/t5+t39*t12/t15*spak2k6*spbk6k4+t39*t19/t5*&
      &spak2k6*spbk6k4-(t39*t30/t5*spbk4k3+t39/t15*t4*spbk4k3+t1/t5+t1/t11)))
      t1 = t39*t34*spbk6k4
      abb11n15 = ((4.0_ki)*(t1/t11+t1/t5-(t39*t12/t15*spak3k4*spbk6k4+t39*t37/t5&
      &*spbk6k4)))
      t1 = t39*t36*spbk6k4
      abb11n16 = ((4.0_ki)*(t1/t11+t1/t5-(t39*t12/t15*spak3k6*spbk6k4+t39*t38/t5&
      &*spbk6k4)))
      rat2d11 = abb11n1
      rat2 = rat2 + rat2d11
      abb11n18 = abb11n2
      abb11n19 = abb11n16
      abb11n20 = abb11n15
      abb11n21 = abb11n14
      abb11n22 = abb11n12
      abb11n23 = abb11n11
      abb11n24 = abb11n9
      abb11n25 = -(abb11n3)
      abb11n26 = -(abb11n4)
      abb11n27 = -(abb11n5)
      abb11n28 = -(abb11n6)
      abb11n29 = -(abb11n7)
      abb11n30 = -(abb11n8)
      abb11n31 = ((2.0_ki)*abb11n9)
      abb11n32 = -(abb11n10)
      abb11n33 = -(abb11n13)
   end subroutine
end module p24_udbar_neepuubar_abbrevd11h1
