module     p24_udbar_neepuubar_abbrevd55h1
   use p24_udbar_neepuubar_config, only: ki
   use p24_udbar_neepuubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb55n1
   complex(ki), public :: abb55n2
   complex(ki), public :: abb55n3
   complex(ki), public :: abb55n4
   complex(ki), public :: abb55n5
   complex(ki), public :: abb55n6
   complex(ki), public :: abb55n7
   complex(ki), public :: abb55n8
   complex(ki), public :: abb55n9
   complex(ki), public :: abb55n10
   complex(ki), public :: abb55n11
   complex(ki), public :: abb55n12
   complex(ki), public :: abb55n13
   complex(ki), public :: abb55n14
   complex(ki), public :: abb55n15
   complex(ki), public :: abb55n16
   complex(ki), public :: abb55n17
   complex(ki), public :: abb55n18
   complex(ki), public :: abb55n19
   complex(ki), public :: rat2d55
   complex(ki), public :: abb55n21
   complex(ki), public :: abb55n22
   complex(ki), public :: abb55n23
   complex(ki), public :: abb55n24
   complex(ki), public :: abb55n25
   complex(ki), public :: abb55n26
   complex(ki), public :: abb55n27
   complex(ki), public :: abb55n28
   complex(ki), public :: abb55n29
   complex(ki), public :: abb55n30
   complex(ki), public :: abb55n31
   complex(ki), public :: abb55n32
   complex(ki), public :: abb55n33
   complex(ki), public :: abb55n34
   complex(ki), public :: abb55n35
   complex(ki), public :: abb55n36
   complex(ki), public :: abb55n37
   complex(ki), public :: abb55n38
   complex(ki), public :: abb55n39
   complex(ki), public :: abb55n40
   complex(ki), public :: abb55n41
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   real(ki) :: t23
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p24_udbar_neepuubar_config, only: deltaOS
      use p24_udbar_neepuubar_kinematics
      use p24_udbar_neepuubar_model
      use p24_udbar_neepuubar_color, only: TR
      use p24_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_
      t3 = t2*spak2k3
      t23 = TR*TR
      t4 = NC*NC*t1
      t5 = t23*t3/t4*spbk6k4
      t6 = c1*i_
      t7 = t6*spak2k3
      t8 = NC*t1
      t9 = (2.0_ki)*t23*t7/t8*spbk6k4
      t10 = NC*c1*i_
      t11 = t10*spak2k3
      t12 = t23*t11/t1*spbk6k4
      t13 = t9-(t5+t12)
      abb55n1 = ((4.0_ki)*t13)
      t14 = t23*t3/t4*spbk4k1
      t15 = (2.0_ki)*t23*t7/t8*spbk4k1
      t16 = t23*t11/t1*spbk4k1
      abb55n2 = ((8.0_ki)*(t14+t16-t15))
      abb55n3 = ((8.0_ki)*(t15-(t16+t14)))
      t14 = t3*spak5k6
      t15 = t7*spak5k6
      t16 = t11*spak5k6
      abb55n4 = ((8.0_ki)*(t23*t16/t1*spbk6k1*spbk6k4+t23*t14/t4*spbk6k1*spbk6k4&
      &-t23*(2.0_ki)*t15/t8*spbk6k1*spbk6k4))
      t17 = t2*spak3k5
      t18 = t23*t17/t4*spbk6k1
      t19 = t6*spak3k5
      t20 = t23*(2.0_ki)*t19/t8*spbk6k1
      t21 = t10*spak3k5
      t22 = t23*t21/t1*spbk6k1
      abb55n5 = ((8.0_ki)*(t18+t22-t20))
      abb55n6 = ((4.0_ki)*(t20-(t22+t18)))
      abb55n7 = ((8.0_ki)*(t23*t19/t8*spbk5k1+t23*t6/t8*spak3k6*spbk6k1)+(4.0_ki&
      &)*(-(t23*t2/t4*spak3k6*spbk6k1+t23*t10/t1*spak3k6*spbk6k1+t23*t17/t4*spbk&
      &5k1+t23*t21/t1*spbk5k1)))
      abb55n8 = ((4.0_ki)*(t23*t10/t1*spak5k6*spbk6k1+t23*t2/t4*spak5k6*spbk6k1-&
      &(2.0_ki)*t23*t6/t8*spak5k6*spbk6k1))
      abb55n9 = ((8.0_ki)*(t23*t6/t8*spak1k3*spbk4k1-t23*t7/t8*spbk4k2)+(4.0_ki)&
      &*(t23*t11/t1*spbk4k2+t23*t3/t4*spbk4k2-(t23*t2/t4*spak1k3*spbk4k1+t23*t10&
      &/t1*spak1k3*spbk4k1)))
      abb55n10 = ((4.0_ki)*(t23*(2.0_ki)*t15/t8*spbk6k2*spbk6k4-(t23*t14/t4*spbk&
      &6k2*spbk6k4+t23*t16/t1*spbk6k2*spbk6k4)))
      abb55n11 = ((4.0_ki)*((2.0_ki)*t23*t7/t8*spbk5k4-(t23*t3/t4*spbk5k4+t23*t1&
      &1/t1*spbk5k4)))
      abb55n12 = ((4.0_ki)*(t12+t5-t9))
      abb55n13 = ((8.0_ki)*t13)
      abb55n14 = ((8.0_ki)*(-(t23*t6/t8*spak2k6*spbk6k4+t23*t6/t8*spak2k5*spbk5k&
      &4+t23*t6/t8*spak1k2*spbk4k1))+(4.0_ki)*(t23*t10/t1*spak1k2*spbk4k1+t23*t1&
      &0/t1*spak2k5*spbk5k4+t23*t10/t1*spak2k6*spbk6k4+t23*t2/t4*spak1k2*spbk4k1&
      &+t23*t2/t4*spak2k5*spbk5k4+t23*t2/t4*spak2k6*spbk6k4))
      t3 = t23*t17/t4*spbk6k4
      t5 = t23*(2.0_ki)*t19/t8*spbk6k4
      t7 = t23*t21/t1*spbk6k4
      abb55n15 = ((4.0_ki)*(t3+t7-t5))
      abb55n16 = ((8.0_ki)*(t5-(t7+t3)))
      t3 = t23*t17/t4*spbk6k5
      t5 = t23*(2.0_ki)*t19/t8*spbk6k5
      t7 = t23*t21/t1*spbk6k5
      abb55n17 = ((4.0_ki)*(t3+t7-t5))
      abb55n18 = ((4.0_ki)*(t5-(t7+t3)))
      abb55n19 = ((4.0_ki)*((2.0_ki)*t23*t6/t8-(t23*t2/t4+t23*t10/t1)))
      rat2d55 = 0
      rat2 = rat2 + rat2d55
      abb55n21 = abb55n1
      abb55n22 = abb55n18
      abb55n23 = abb55n17
      abb55n24 = abb55n16
      abb55n25 = abb55n14
      abb55n26 = abb55n13
      abb55n27 = abb55n12
      abb55n28 = abb55n11
      abb55n29 = abb55n9
      abb55n30 = abb55n8
      abb55n31 = abb55n7
      abb55n32 = abb55n5
      abb55n33 = abb55n3
      abb55n34 = abb55n2
      abb55n35 = -(abb55n4)
      abb55n36 = -(abb55n6)
      abb55n37 = (-2.0_ki)*abb55n6
      abb55n38 = -(abb55n10)
      abb55n39 = -(abb55n15)
      abb55n40 = (-2.0_ki)*abb55n15
      abb55n41 = -(abb55n19)
   end subroutine
end module p24_udbar_neepuubar_abbrevd55h1
