module     p24_udbar_neepuubar_abbrevd61h1
   use p24_udbar_neepuubar_config, only: ki
   use p24_udbar_neepuubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb61n1
   complex(ki), public :: abb61n2
   complex(ki), public :: rat2d61
   complex(ki), public :: abb61n4
   complex(ki), public :: abb61n5
   complex(ki), public :: abb61n6
   complex(ki), public :: abb61n7
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   real(ki) :: t8
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p24_udbar_neepuubar_config, only: deltaOS
      use p24_udbar_neepuubar_kinematics
      use p24_udbar_neepuubar_model
      use p24_udbar_neepuubar_color, only: TR
      use p24_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_*spak2k3
      t8 = TR*TR
      t3 = es234*NC*t1
      t4 = t8*t2/t3*spak2k5*spbk4k2*spbk6k1
      t2 = t8*t2/t3*spak3k5*spbk4k3*spbk6k1
      t3 = c2*i_*spak2k3
      t5 = t8*t3*spak2k5*spbk4k2*spbk6k1
      t1 = es234*t1
      t6 = t5/t1
      t3 = t8*t3*spak3k5*spbk4k3*spbk6k1
      t7 = t3/t1
      t1 = NC*NC*t1
      t5 = t5/t1
      t1 = t3/t1
      abb61n1 = ((16.0_ki)*(t2-t4)+(8.0_ki)*(t5+t6-(t7+t1)))
      abb61n2 = ((16.0_ki)*(t4-t2)+(8.0_ki)*(t1+t7-(t6+t5)))
      rat2d61 = 0
      rat2 = rat2 + rat2d61
      abb61n4 = -(abb61n1)
      abb61n5 = abb61n1
      abb61n6 = ((2.0_ki)*abb61n1)
      abb61n7 = -(abb61n2)
   end subroutine
end module p24_udbar_neepuubar_abbrevd61h1
