module     p24_udbar_neepuubar_abbrevd6h1
   use p24_udbar_neepuubar_config, only: ki
   use p24_udbar_neepuubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb6n1
   complex(ki), public :: abb6n2
   complex(ki), public :: abb6n3
   complex(ki), public :: abb6n4
   complex(ki), public :: abb6n5
   complex(ki), public :: abb6n6
   complex(ki), public :: abb6n7
   complex(ki), public :: abb6n8
   complex(ki), public :: abb6n9
   complex(ki), public :: abb6n10
   complex(ki), public :: abb6n11
   complex(ki), public :: abb6n12
   complex(ki), public :: abb6n13
   complex(ki), public :: abb6n14
   complex(ki), public :: abb6n15
   complex(ki), public :: abb6n16
   complex(ki), public :: abb6n17
   complex(ki), public :: abb6n18
   complex(ki), public :: abb6n19
   complex(ki), public :: abb6n20
   complex(ki), public :: abb6n21
   complex(ki), public :: abb6n22
   complex(ki), public :: abb6n23
   complex(ki), public :: abb6n24
   complex(ki), public :: abb6n25
   complex(ki), public :: abb6n26
   complex(ki), public :: abb6n27
   complex(ki), public :: abb6n28
   complex(ki), public :: abb6n29
   complex(ki), public :: abb6n30
   complex(ki), public :: rat2d6
   complex(ki), public :: abb6n32
   complex(ki), public :: abb6n33
   complex(ki), public :: abb6n34
   complex(ki), public :: abb6n35
   complex(ki), public :: abb6n36
   complex(ki), public :: abb6n37
   complex(ki), public :: abb6n38
   complex(ki), public :: abb6n39
   complex(ki), public :: abb6n40
   complex(ki), public :: abb6n41
   complex(ki), public :: abb6n42
   complex(ki), public :: abb6n43
   complex(ki), public :: abb6n44
   complex(ki), public :: abb6n45
   complex(ki), public :: abb6n46
   complex(ki), public :: abb6n47
   complex(ki), public :: abb6n48
   complex(ki), public :: abb6n49
   complex(ki), public :: abb6n50
   complex(ki), public :: abb6n51
   complex(ki), public :: abb6n52
   complex(ki), public :: abb6n53
   complex(ki), public :: abb6n54
   complex(ki), public :: abb6n55
   complex(ki), public :: abb6n56
   complex(ki), public :: abb6n57
   complex(ki), public :: abb6n58
   complex(ki), public :: abb6n59
   complex(ki), public :: abb6n60
   complex(ki), public :: abb6n61
   complex(ki), public :: abb6n62
   complex(ki), public :: abb6n63
   complex(ki), public :: abb6n64
   complex(ki), public :: abb6n65
   complex(ki), public :: abb6n66
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   real(ki) :: t22
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p24_udbar_neepuubar_config, only: deltaOS
      use p24_udbar_neepuubar_kinematics
      use p24_udbar_neepuubar_model
      use p24_udbar_neepuubar_color, only: TR
      use p24_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = es12*c1*i_
      t3 = t2*spak2k3
      t22 = TR*TR
      t4 = es56*NC*NC*t1
      t5 = es12*c2*i_
      t6 = t5*spak2k3
      t1 = es56*NC*t1
      abb6n1 = ((4.0_ki)*(t22/t1*t6*spak3k5*spbk4k3*spbk6k1+t22*t3/t4*spak2k5*sp&
      &bk4k2*spbk6k1-(t22*t3/t4*spak3k5*spbk4k3*spbk6k1+t22/t1*t6*spak2k5*spbk4k&
      &2*spbk6k1)))
      t7 = c1*i_
      t8 = t7*spak1k2
      t9 = t8*spak3k4
      t10 = TR*spbk4k1
      t10 = t10*t10
      t11 = c2*i_
      t12 = t11*spak1k2
      t13 = t12*spak3k4
      abb6n2 = ((4.0_ki)*(t10/t4*t9-t10/t1*t13))
      t10 = t8*spak3k5
      t14 = t22*t10/t4*spbk4k1*spbk6k1
      t15 = t12*spak3k5
      t16 = t22*t15/t1*spbk4k1*spbk6k1
      abb6n3 = ((8.0_ki)*(t16-t14))
      abb6n4 = ((4.0_ki)*(t22/t1*t5*spak2k5*spbk6k1+t22*t10/t4*spbk3k1*spbk6k1+t&
      &22/t4*t8*spak4k5*spbk4k1*spbk6k1-(t22*t12/t1*spak4k5*spbk4k1*spbk6k1+t22*&
      &t2/t4*spak2k5*spbk6k1+t22*t15/t1*spbk3k1*spbk6k1)))
      t2 = t7*spak2k3
      t5 = t11*spak2k3
      abb6n5 = ((8.0_ki)*(t22/t1*t5*spbk4k1-t22*t2/t4*spbk4k1))
      t10 = t2*spak2k5
      t15 = t7*spak2k5
      t17 = t5*spak2k5
      t18 = t11*spak2k5
      abb6n6 = ((4.0_ki)*(t16+t22*t17/t1*spbk4k1*spbk6k2+t22*t10/t4*spbk2k1*spbk&
      &6k4+t22*t18/t1*spak3k4*spbk4k1*spbk6k4-(t22*t15/t4*spak3k4*spbk4k1*spbk6k&
      &4+t22*t10/t4*spbk4k1*spbk6k2+t22*t17/t1*spbk2k1*spbk6k4+t14)))
      abb6n7 = ((4.0_ki)*(t22*t2/t4*spbk2k1+t22/t4*t7*spak3k4*spbk4k1-(t22*t11/t&
      &1*spak3k4*spbk4k1+t22/t1*t5*spbk2k1)))
      t19 = t10*spbk4k2
      t20 = t17*spbk4k2
      abb6n8 = ((8.0_ki)*(t14+t22*t19/t4*spbk6k1+t22/t1*t5*spak3k5*spbk4k3*spbk6&
      &k1-(t22*t2/t4*spak3k5*spbk4k3*spbk6k1+t22*t20/t1*spbk6k1+t16)))
      t14 = t22*t15/t4*spbk6k1
      t16 = t22*t18/t1*spbk6k1
      abb6n9 = ((4.0_ki)*(t14-t16))
      abb6n10 = ((8.0_ki)*(t16-t14))
      t14 = t22/t4*t7*spak3k5*spbk6k1
      t16 = t22*t11/t1*spak3k5*spbk6k1
      t21 = t14-t16
      abb6n11 = ((8.0_ki)*t21)
      abb6n12 = ((4.0_ki)*t21)
      t14 = t16-t14
      abb6n13 = ((4.0_ki)*t14)
      abb6n14 = ((8.0_ki)*t14)
      abb6n15 = ((4.0_ki)*(t22/t4*t7*spak4k5*spbk6k1-t22*t11/t1*spak4k5*spbk6k1)&
      &)
      t14 = TR*spak2k3
      t14 = t14*t14
      abb6n16 = ((4.0_ki)*(t22/t1*t6*spbk6k4+t11/t1*t14*spbk4k3*spbk6k2+t22/t4*t&
      &9*spbk4k1*spbk6k4+t22/t4*t8*spak2k3*spbk4k1*spbk6k2-(t22*t12/t1*spak2k3*s&
      &pbk4k1*spbk6k2+t14/t4*t7*spbk4k3*spbk6k2+t22*t13/t1*spbk4k1*spbk6k4+t22*t&
      &3/t4*spbk6k4)))
      abb6n17 = ((4.0_ki)*(t22*t20/t1*spbk6k2-t22*t19/t4*spbk6k2))
      abb6n18 = ((8.0_ki)*(t22*t2/t4*spbk4k2-t22/t1*t5*spbk4k2))
      abb6n19 = ((4.0_ki)*(t22*t10/t4*spbk4k3*spbk6k2-t22*t17/t1*spbk4k3*spbk6k2&
      &))
      t3 = t22*t2/t4*spbk6k4
      t6 = t22/t1*t5*spbk6k4
      abb6n20 = ((8.0_ki)*(t3-t6))
      t3 = t6-t3
      abb6n21 = ((4.0_ki)*t3)
      abb6n22 = ((8.0_ki)*t3)
      abb6n23 = ((4.0_ki)*(t22*t12/t1*spbk6k1+t22*t2/t4*spbk6k3+t22/t4*t7*spak2k&
      &4*spbk6k4-(t22*t11/t1*spak2k4*spbk6k4+t22/t4*t8*spbk6k1+t22/t1*t5*spbk6k3&
      &)))
      abb6n24 = ((4.0_ki)*(t22*t15/t4*spbk6k2-t22*t18/t1*spbk6k2))
      abb6n25 = ((4.0_ki)*(t22*t18/t1*spbk6k3-t22*t15/t4*spbk6k3))
      t2 = t22*t15/t4*spbk6k4
      t3 = t22*t18/t1*spbk6k4
      t5 = t2-t3
      abb6n26 = ((8.0_ki)*t5)
      abb6n27 = ((4.0_ki)*t5)
      t2 = t3-t2
      abb6n28 = ((4.0_ki)*t2)
      abb6n29 = ((8.0_ki)*t2)
      abb6n30 = ((4.0_ki)*(t22*t11/t1-t22/t4*t7))
      rat2d6 = 0
      rat2 = rat2 + rat2d6
      abb6n32 = abb6n1
      abb6n33 = abb6n29
      abb6n34 = abb6n28
      abb6n35 = abb6n26
      abb6n36 = abb6n25
      abb6n37 = abb6n24
      abb6n38 = abb6n23
      abb6n39 = abb6n22
      abb6n40 = abb6n20
      abb6n41 = abb6n18
      abb6n42 = abb6n15
      abb6n43 = abb6n14
      abb6n44 = abb6n12
      abb6n45 = abb6n11
      abb6n46 = abb6n10
      abb6n47 = abb6n7
      abb6n48 = abb6n6
      abb6n49 = abb6n5
      abb6n50 = -(abb6n2)
      abb6n51 = -(abb6n3)
      abb6n52 = -(abb6n4)
      abb6n53 = ((2.0_ki)*abb6n6)
      abb6n54 = -(abb6n8)
      abb6n55 = -(abb6n9)
      abb6n56 = (-2.0_ki)*abb6n9
      abb6n57 = -(abb6n13)
      abb6n58 = (-2.0_ki)*abb6n13
      abb6n59 = -(abb6n16)
      abb6n60 = -(abb6n17)
      abb6n61 = -(abb6n19)
      abb6n62 = -(abb6n21)
      abb6n63 = (-2.0_ki)*abb6n21
      abb6n64 = -(abb6n27)
      abb6n65 = (-2.0_ki)*abb6n27
      abb6n66 = -(abb6n30)
   end subroutine
end module p24_udbar_neepuubar_abbrevd6h1
