module     p24_udbar_neepuubar_abbrevd8h1
   use p24_udbar_neepuubar_config, only: ki
   use p24_udbar_neepuubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb8n1
   complex(ki), public :: abb8n2
   complex(ki), public :: abb8n3
   complex(ki), public :: abb8n4
   complex(ki), public :: abb8n5
   complex(ki), public :: abb8n6
   complex(ki), public :: abb8n7
   complex(ki), public :: abb8n8
   complex(ki), public :: abb8n9
   complex(ki), public :: abb8n10
   complex(ki), public :: abb8n11
   complex(ki), public :: rat2d8
   complex(ki), public :: abb8n13
   complex(ki), public :: abb8n14
   complex(ki), public :: abb8n15
   complex(ki), public :: abb8n16
   complex(ki), public :: abb8n17
   complex(ki), public :: abb8n18
   complex(ki), public :: abb8n19
   complex(ki), public :: abb8n20
   complex(ki), public :: abb8n21
   complex(ki), public :: abb8n22
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   real(ki) :: t42
   real(ki) :: t43
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p24_udbar_neepuubar_config, only: deltaOS
      use p24_udbar_neepuubar_kinematics
      use p24_udbar_neepuubar_model
      use p24_udbar_neepuubar_color, only: TR
      use p24_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_
      t3 = t2*spak1k5
      t4 = t3*spak2k3
      t42 = TR*TR
      t5 = t42*t4*spbk4k1*spbk6k1
      t6 = (es234-(es61+es56))*t1
      t7 = es234*t6
      t8 = t5/t7
      t9 = t2*spak2k3*spak5k6*spbk6k1
      t10 = t42*t9*spbk6k4
      t11 = t10/t7
      t12 = c1*i_
      t13 = t12*spak1k5
      t14 = t13*spak2k3
      t15 = t42*t14*spbk4k1*spbk6k1
      t16 = es56*es234*t1
      t17 = t15/t16
      t18 = t12*spak2k3*spak5k6*spbk6k1
      t19 = t42*t18*spbk6k4
      t20 = t19/t16
      t43 = NC*NC
      t21 = t43*t7
      t22 = t5/t21
      t23 = t10/t21
      t6 = es234*NC*t6
      t24 = t15/t6
      t25 = t19/t6
      t26 = NC*c1*i_
      t27 = t26*spak1k5
      t28 = t27*spak2k3
      t29 = t42*t28/t7*spbk4k1*spbk6k1
      t30 = t26*spak2k3*spak5k6*spbk6k1
      t31 = t42*t30/t7*spbk6k4
      t32 = t43*t16
      t15 = t15/t32
      t19 = t19/t32
      t1 = es56*es234*NC*t1
      t5 = t5/t1
      t10 = t10/t1
      t33 = NC*c2*i_
      t34 = t33*spak1k5
      t35 = t34*spak2k3
      t36 = t42*t35/t16*spbk4k1*spbk6k1
      t37 = t33*spak2k3*spak5k6*spbk6k1
      t38 = t42*t37/t16*spbk6k4
      t39 = t17+t19+t23+t24+t31+t38+t5+t8-(t36+t29+t25+t22+t20+t15+t11+t10)
      abb8n1 = ((2.0_ki)*t39)
      t40 = t42*t3*spbk6k1
      t41 = t42*t13*spbk6k1
      abb8n2 = ((4.0_ki)*(t40/t21+t41/t32+t42*t34/t16*spbk6k1+t42*t27/t7*spbk6k1&
      &-(t41/t6+t40/t7+t41/t16+t40/t1)))
      abb8n3 = ((8.0_ki)*t39)
      abb8n4 = ((4.0_ki)*(t10+t11+t15+t20+t22+t25+t29+t36-(t8+t5+t38+t31+t24+t23&
      &+t19+t17)))
      t4 = t42*t4*spbk3k1*spbk6k1
      t5 = t42*t3*spak2k4*spbk4k1*spbk6k1
      t8 = t42*t9*spbk6k3
      t9 = t42*t2*spak2k4*spak5k6*spbk6k1*spbk6k4
      t10 = t42*t14*spbk3k1*spbk6k1
      t11 = t42*t13*spak2k4*spbk4k1*spbk6k1
      t14 = t42*t18*spbk6k3
      t15 = t42*t12*spak2k4*spak5k6*spbk6k1*spbk6k4
      abb8n5 = ((4.0_ki)*(t8/t1+t9/t1+t10/t32+t11/t32+t14/t16+t14/t6+t15/t16+t15&
      &/t6+t4/t21+t5/t21+t8/t7+t9/t7+t42*t35/t16*spbk3k1*spbk6k1+t42*t28/t7*spbk&
      &3k1*spbk6k1+t42*t34/t16*spak2k4*spbk4k1*spbk6k1+t42*t27/t7*spak2k4*spbk4k&
      &1*spbk6k1-(t42*t26/t7*spak2k4*spak5k6*spbk6k1*spbk6k4+t42*t33/t16*spak2k4&
      &*spak5k6*spbk6k1*spbk6k4+t42*t30/t7*spbk6k3+t42*t37/t16*spbk6k3+t5/t7+t4/&
      &t7+t9/t21+t8/t21+t15/t32+t14/t32+t11/t6+t11/t16+t10/t6+t10/t16+t5/t1+t4/t&
      &1)))
      t4 = t2*spak2k5
      t5 = t42*t4*spbk6k1
      t8 = t5/t7
      t9 = t12*spak2k5
      t10 = t42*t9*spbk6k1
      t11 = t10/t16
      t14 = t5/t21
      t15 = t10/t6
      t17 = t26*spak2k5
      t18 = t42*t17/t7*spbk6k1
      t10 = t10/t32
      t5 = t5/t1
      t19 = t33*spak2k5
      t20 = t42*t19/t16*spbk6k1
      abb8n6 = ((16.0_ki)*(t10+t14+t18+t20-(t8+t5+t15+t11)))
      abb8n7 = ((16.0_ki)*(t11+t15+t5+t8-(t20+t18+t14+t10)))
      t5 = t42*t4*spbk5k1
      t8 = t42*t2*spak2k6*spbk6k1
      t10 = t42*t9*spbk5k1
      t11 = t42*t12*spak2k6*spbk6k1
      abb8n8 = ((8.0_ki)*(t5/t1+t8/t1+t10/t16+t10/t6+t11/t16+t11/t6+t5/t7+t8/t7-&
      &(t42*t26/t7*spak2k6*spbk6k1+t42*t33/t16*spak2k6*spbk6k1+t42*t17/t7*spbk5k&
      &1+t42*t19/t16*spbk5k1+t8/t21+t5/t21+t11/t32+t10/t32)))
      t3 = t42*t3*spak3k4*spbk4k1*spbk6k1
      t5 = t42*t2*spak3k4*spak5k6*spbk6k1*spbk6k4
      t8 = t42*t13*spak3k4*spbk4k1*spbk6k1
      t10 = t42*t12*spak3k4*spak5k6*spbk6k1*spbk6k4
      abb8n9 = ((4.0_ki)*(t3/t1+t10/t32+t8/t16+t5/t21+t3/t7+t8/t6+t42*t33/t16*sp&
      &ak3k4*spak5k6*spbk6k1*spbk6k4+t42*t26/t7*spak3k4*spak5k6*spbk6k1*spbk6k4-&
      &(t42*t27/t7*spak3k4*spbk4k1*spbk6k1+t42*t34/t16*spak3k4*spbk4k1*spbk6k1+t&
      &5/t7+t8/t32+t3/t21+t10/t6+t10/t16+t5/t1)))
      t3 = t42*t2*spak5k6*spbk6k1
      t5 = t42*t12*spak5k6*spbk6k1
      abb8n10 = ((4.0_ki)*(t3/t21+t5/t32+t42*t33/t16*spak5k6*spbk6k1+t42*t26/t7*&
      &spak5k6*spbk6k1-(t5/t6+t3/t7+t5/t16+t3/t1)))
      t2 = t42*t2*spak1k2*spbk6k1
      t3 = t42*t4*spbk6k5
      t4 = t42*t12*spak1k2*spbk6k1
      t5 = t42*t9*spbk6k5
      abb8n11 = ((8.0_ki)*(t2/t1+t3/t1+t4/t16+t5/t16+t2/t7+t3/t7+t4/t6+t5/t6-(t4&
      &2*t26/t7*spak1k2*spbk6k1+t42*t33/t16*spak1k2*spbk6k1+t42*t17/t7*spbk6k5+t&
      &42*t19/t16*spbk6k5+t5/t32+t4/t32+t3/t21+t2/t21)))
      rat2d8 = abb8n1
      rat2 = rat2 + rat2d8
      abb8n13 = abb8n5
      abb8n14 = abb8n11
      abb8n15 = abb8n10
      abb8n16 = abb8n9
      abb8n17 = abb8n8
      abb8n18 = abb8n7
      abb8n19 = abb8n6
      abb8n20 = abb8n4
      abb8n21 = abb8n3
      abb8n22 = abb8n2
   end subroutine
end module p24_udbar_neepuubar_abbrevd8h1
