module     p24_udbar_neepuubar_d5h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p24_udbar_neepuubar/helicity1/d5h1l1d.f90
   ! generator: haggies (1.1)
   use p24_udbar_neepuubar_config, only: ki
   use p24_udbar_neepuubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d5
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p24_udbar_neepuubar_globalsl1, only: epspow
      use p24_udbar_neepuubar_kinematics
      use p24_udbar_neepuubar_abbrevd5h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      real(ki) :: t34
      real(ki) :: t35
      real(ki) :: t36
      real(ki) :: t37
      real(ki) :: t38
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t34 = dotproduct(qshift, qshift)
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t35 = dotproduct(k3, qshift)
      t36 = dotproduct(k4, qshift)
      t2 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t3 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t37 = dotproduct(k2, qshift)
      t38 = dotproduct(k1, qshift)
      t4 = (spvak4k1(1)*qshift(1)-spvak4k1(2)*qshift(2)-spvak4k1(3)*qshift(3)-sp&
      &vak4k1(4)*qshift(4))
      t5 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t6 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t7 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t8 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb5n32+t1*abb5n62+t2*abb5n64+t3*abb5n66+t34*abb5n46+t35*a&
         &bb5n63+t36*abb5n63+t37*abb5n72+t38*abb5n80+t4*abb5n83+t1*t3*abb5n58+t1&
         &*t34*abb5n69+t1*t38*abb5n54+t1*t5*abb5n56+t1*t8*abb5n52+t2*t3*abb5n38+&
         &t2*t37*abb5n45+t2*t38*abb5n45+t2*t4*abb5n36+t2*t5*abb5n39+t2*t6*abb5n4&
         &0+t2*t7*abb5n48+t3*t34*abb5n95+t3*t35*abb5n34+t3*t36*abb5n34+t3*t38*ab&
         &b5n37+t34*t6*abb5n86+t34*t7*abb5n76+t35*t6*abb5n43+t35*t7*abb5n49+t36*&
         &t6*abb5n43+t36*t7*abb5n49+t38*t6*abb5n41+t38*t7*abb5n51+t1*t2*t5*abb5n&
         &98)
         return
      end if
      t9 = k1(iv1)
      t10 = k2(iv1)
      t11 = k3(iv1)
      t12 = k4(iv1)
      t13 = qshift(iv1)
      t14 = spvak3k1(iv1)
      t15 = spvak3k4(iv1)
      t16 = spvak4k1(iv1)
      t17 = spvak5k6(iv1)
      t18 = spvak2k1(iv1)
      t19 = spvak2k4(iv1)
      t20 = spvak2k6(iv1)
      t21 = t20*abb5n78
      t22 = t14*abb5n97
      t23 = t15*abb5n82
      t24 = spvak5k1(iv1)
      t25 = t24*abb5n84
      if(deg.eq.1) then
         numerator = (t10*abb5n53+t11*abb5n60+t12*abb5n60+t13*abb5n81+t14*abb5n5&
         &7+t15*abb5n59+t16*abb5n44+t17*abb5n61+t21*t35+t21*t36+t22*t35+t22*t36+&
         &t23*t37+t23*t38+t25*t35+t25*t36+t9*abb5n47+t1*t13*abb5n68+t1*t14*abb5n&
         &65+t1*t18*abb5n67+t1*t19*abb5n73+t1*t9*abb5n71+t10*t2*abb5n82+t11*t3*a&
         &bb5n97+t11*t6*abb5n84+t11*t7*abb5n78+t12*t3*abb5n97+t12*t6*abb5n84+t12&
         &*t7*abb5n78+t13*t3*abb5n94+t13*t6*abb5n85+t13*t7*abb5n75+t14*t2*abb5n9&
         &1+t14*t34*abb5n35+t14*t38*abb5n92+t15*t3*abb5n91+t15*t4*abb5n93+t15*t5&
         &*abb5n90+t15*t6*abb5n89+t15*t7*abb5n79+t16*t2*abb5n93+t17*t3*abb5n65+t&
         &17*t34*abb5n55+t17*t38*abb5n71+t17*t5*abb5n67+t17*t8*abb5n73+t18*t2*ab&
         &b5n90+t2*t20*abb5n79+t2*t24*abb5n89+t2*t9*abb5n82+t20*t34*abb5n50+t20*&
         &t38*abb5n74+t24*t34*abb5n42+t24*t38*abb5n88+t3*t9*abb5n92+t6*t9*abb5n8&
         &8+t7*t9*abb5n74+t1*t15*t5*abb5n33+t1*t18*t2*abb5n33+t17*t2*t5*abb5n33)
         return
      end if
      t34 = d(iv1,iv2)
      t4 = spvak2k6(iv2)
      t8 = spvak3k1(iv2)
      t21 = spvak3k4(iv2)
      t22 = spvak5k1(iv2)
      t23 = spvak5k6(iv2)
      t25 = k1(iv2)
      t26 = k3(iv2)
      t27 = k4(iv2)
      t28 = qshift(iv2)
      t29 = t18*t21
      t30 = t18*t23
      t31 = spvak2k1(iv2)
      t32 = t15*t31
      t33 = t17*t31
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t34*abb5n46+t1*t34*abb5n69+t3*t34*abb5n95+t34*t6&
         &*abb5n86+t34*t7*abb5n76)+t29*abb5n39+t30*abb5n56+t32*abb5n39+t33*abb5n&
         &56+k2(iv2)*t15*abb5n45+spvak2k4(iv2)*t17*abb5n52+spvak4k1(iv2)*t15*abb&
         &5n36+t1*t29*abb5n98+t1*t32*abb5n98+t10*t21*abb5n45+t11*t22*abb5n43+t11&
         &*t4*abb5n49+t11*t8*abb5n34+t12*t22*abb5n43+t12*t4*abb5n49+t12*t8*abb5n&
         &34+t13*t22*abb5n87+t13*t23*abb5n70+t13*t4*abb5n77+t13*t8*abb5n96+t14*t&
         &21*abb5n38+t14*t23*abb5n58+t14*t25*abb5n37+t14*t26*abb5n34+t14*t27*abb&
         &5n34+t14*t28*abb5n96+t15*t22*abb5n40+t15*t25*abb5n45+t15*t4*abb5n48+t1&
         &5*t8*abb5n38+t16*t21*abb5n36+t17*t25*abb5n54+t17*t28*abb5n70+t17*t8*ab&
         &b5n58+t19*t23*abb5n52+t2*t30*abb5n98+t2*t33*abb5n98+t20*t21*abb5n48+t2&
         &0*t25*abb5n51+t20*t26*abb5n49+t20*t27*abb5n49+t20*t28*abb5n77+t21*t24*&
         &abb5n40+t21*t9*abb5n45+t22*t9*abb5n41+t23*t9*abb5n54+t24*t25*abb5n41+t&
         &24*t26*abb5n43+t24*t27*abb5n43+t24*t28*abb5n87+t4*t9*abb5n51+t8*t9*abb&
         &5n37+t15*t23*t5*abb5n98+t17*t21*t5*abb5n98)
         return
      end if
      t35 = d(iv2,iv3)
      t36 = d(iv1,iv3)
      t1 = spvak5k6(iv3)
      t2 = spvak3k4(iv3)
      t3 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k6(iv3)*t34*abb5n50+spvak3k1(iv3)*t34*abb5&
         &n35+spvak5k1(iv3)*t34*abb5n42+t1*t34*abb5n55+t14*t35*abb5n35+t17*t35*a&
         &bb5n55+t20*t35*abb5n50+t22*t36*abb5n42+t23*t36*abb5n55+t24*t35*abb5n42&
         &+t36*t4*abb5n50+t36*t8*abb5n35)+t1*t29*abb5n33+t1*t32*abb5n33+t15*t23*&
         &t3*abb5n33+t17*t2*t31*abb5n33+t17*t21*t3*abb5n33+t18*t2*t23*abb5n33)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d5:
   subroutine     reconstruct_d5(coeffs)
      use p24_udbar_neepuubar_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_5:
      coeffs%coeffs_5%c0 = derivative(czip)
      coeffs%coeffs_5%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_5%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_5%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_5%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_5%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_5%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_5%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_5%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_5%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_5%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_5%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_5%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_5%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_5%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_5%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_5%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_5%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_5%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_5%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_5%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_5%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_5%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_5%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_5%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_5%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_5%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_5%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_5%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_5%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_5%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_5%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_5%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_5%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_5%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_5:
   end subroutine reconstruct_d5
!---#] subroutine reconstruct_d5:
end module p24_udbar_neepuubar_d5h1l1d
