module     p24_udbar_neepuubar_d66h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p24_udbar_neepuubar/helicity1/d66h1l1d.f90
   ! generator: haggies (1.1)
   use p24_udbar_neepuubar_config, only: ki
   use p24_udbar_neepuubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d66
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p24_udbar_neepuubar_globalsl1, only: epspow
      use p24_udbar_neepuubar_kinematics
      use p24_udbar_neepuubar_abbrevd66h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      real(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak4k1(1)*qshift(1)-spvak4k1(2)*qshift(2)-spvak4k1(3)*qshift(3)-sp&
      &vak4k1(4)*qshift(4))
      t3 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t4 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t15 = dotproduct(k3, qshift)
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t16 = dotproduct(k4, qshift)
      t17 = dotproduct(k6, qshift)
      if(deg.eq.0) then
         numerator = (abb66n13*(spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spva&
         &k5k6(3)*qshift(3)-spvak5k6(4)*qshift(4))+abb66n20*dotproduct(qshift, q&
         &shift)+abb66n25*(spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(&
         &3)*qshift(3)-spvak2k4(4)*qshift(4))+abb66n26*(spvak2k6(1)*qshift(1)-sp&
         &vak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-spvak2k6(4)*qshift(4))+abb66&
         &n27*(spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5k4(3)*qshift(3)&
         &-spvak5k4(4)*qshift(4))+abb66n29*(spvak2k1(1)*qshift(1)-spvak2k1(2)*qs&
         &hift(2)-spvak2k1(3)*qshift(3)-spvak2k1(4)*qshift(4))+abb66n31*(spvak5k&
         &1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-spvak5k1(4)&
         &*qshift(4))+t1*t2*abb66n14+t1*t5*abb66n16+t15*t5*abb66n15+t16*t5*abb66&
         &n15+t17*t5*abb66n15+t3*t4*abb66n14+t3*t5*abb66n18)
         return
      end if
      t6 = k3(iv1)
      t7 = k4(iv1)
      t8 = k6(iv1)
      t9 = spvak3k1(iv1)
      t10 = t9*abb66n33
      t11 = spvak3k4(iv1)
      t12 = spvak3k6(iv1)
      t13 = spvak4k1(iv1)
      t14 = spvak6k1(iv1)
      if(deg.eq.1) then
         numerator = (qshift(iv1)*abb66n28+spvak2k1(iv1)*abb66n19+spvak2k4(iv1)*&
         &abb66n23+spvak2k6(iv1)*abb66n22+spvak5k1(iv1)*abb66n17+spvak5k4(iv1)*a&
         &bb66n21+spvak5k6(iv1)*abb66n24+t10*t15+t10*t16+t10*t17+t1*t13*abb66n34&
         &+t1*t9*abb66n32+t11*t2*abb66n34+t11*t5*abb66n32+t12*t4*abb66n34+t12*t5&
         &*abb66n30+t14*t3*abb66n34+t3*t9*abb66n30+t5*t6*abb66n33+t5*t7*abb66n33&
         &+t5*t8*abb66n33)
         return
      end if
      t1 = spvak3k1(iv2)
      t2 = spvak3k4(iv2)
      t3 = spvak3k6(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb66n20+k3(iv2)*t9*abb66n15+k4(iv2)*t&
         &9*abb66n15+k6(iv2)*t9*abb66n15+spvak4k1(iv2)*t11*abb66n14+spvak6k1(iv2&
         &)*t12*abb66n14+t1*t11*abb66n16+t1*t12*abb66n18+t1*t6*abb66n15+t1*t7*ab&
         &b66n15+t1*t8*abb66n15+t13*t2*abb66n14+t14*t3*abb66n14+t2*t9*abb66n16+t&
         &3*t9*abb66n18)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d66:
   subroutine     reconstruct_d66(coeffs)
      use p24_udbar_neepuubar_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_66:
      coeffs%coeffs_66%c0 = derivative(czip)
      coeffs%coeffs_66%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_66%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_66%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_66%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_66%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_66%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_66%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_66%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_66%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_66%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_66%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_66%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_66%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_66%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_66:
   end subroutine reconstruct_d66
!---#] subroutine reconstruct_d66:
end module p24_udbar_neepuubar_d66h1l1d
