module     p25_udbar_neepssbar_abbrevd31h0
   use p25_udbar_neepssbar_config, only: ki
   use p25_udbar_neepssbar_globalsh0
   implicit none
   private
   complex(ki), public :: abb31n1
   complex(ki), public :: abb31n2
   complex(ki), public :: abb31n3
   complex(ki), public :: abb31n4
   complex(ki), public :: abb31n5
   complex(ki), public :: abb31n6
   complex(ki), public :: abb31n7
   complex(ki), public :: abb31n8
   complex(ki), public :: abb31n9
   complex(ki), public :: abb31n10
   complex(ki), public :: abb31n11
   complex(ki), public :: abb31n12
   complex(ki), public :: abb31n13
   complex(ki), public :: abb31n14
   complex(ki), public :: abb31n15
   complex(ki), public :: abb31n16
   complex(ki), public :: abb31n17
   complex(ki), public :: abb31n18
   complex(ki), public :: abb31n19
   complex(ki), public :: rat2d31
   complex(ki), public :: abb31n21
   complex(ki), public :: abb31n22
   complex(ki), public :: abb31n23
   complex(ki), public :: abb31n24
   complex(ki), public :: abb31n25
   complex(ki), public :: abb31n26
   complex(ki), public :: abb31n27
   complex(ki), public :: abb31n28
   complex(ki), public :: abb31n29
   complex(ki), public :: abb31n30
   complex(ki), public :: abb31n31
   complex(ki), public :: abb31n32
   complex(ki), public :: abb31n33
   complex(ki), public :: abb31n34
   complex(ki), public :: abb31n35
   complex(ki), public :: abb31n36
   complex(ki), public :: abb31n37
   complex(ki), public :: abb31n38
   complex(ki), public :: abb31n39
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   real(ki) :: t19
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p25_udbar_neepssbar_config, only: deltaOS
      use p25_udbar_neepssbar_kinematics
      use p25_udbar_neepssbar_model
      use p25_udbar_neepssbar_color, only: TR
      use p25_udbar_neepssbar_globalsl1, only: epspow
      implicit none
      t1 = es12*c2*i_
      t19 = TR*TR
      t2 = (es34+es56-(es234+es12))*(es34+wW*mW*i_-mW*mW)
      t3 = NC*t2
      t4 = es345*c2*i_
      t5 = es61*c2*i_
      t6 = es12*c1*i_
      t7 = NC*NC*t2
      t8 = es345*c1*i_
      t9 = es61*c1*i_
      t10 = NC*c2
      t11 = es12*t10*i_
      t12 = es345*t10*i_
      t13 = es61*t10*i_
      abb31n1 = ((8.0_ki)*(t19/t3*t4*spak1k3*spak2k6*spbk4k1*spbk5k1+t19/t3*t4*s&
      &pak2k6*spak3k4*spbk4k1*spbk5k4-(t19/t3*t5*spak2k6*spak3k4*spbk4k1*spbk5k4&
      &+t19/t3*t5*spak1k3*spak2k6*spbk4k1*spbk5k1+t19*t1/t3*spak2k6*spak3k4*spbk&
      &4k1*spbk5k4+t19*t1/t3*spak1k3*spak2k6*spbk4k1*spbk5k1))+(4.0_ki)*(t19*t11&
      &/t2*spak1k3*spak2k6*spbk4k1*spbk5k1+t19*t11/t2*spak2k6*spak3k4*spbk4k1*sp&
      &bk5k4+t19*t13/t2*spak1k3*spak2k6*spbk4k1*spbk5k1+t19*t13/t2*spak2k6*spak3&
      &k4*spbk4k1*spbk5k4+t19*t6/t7*spak1k3*spak2k6*spbk4k1*spbk5k1+t19*t6/t7*sp&
      &ak2k6*spak3k4*spbk4k1*spbk5k4+t19/t7*t9*spak1k3*spak2k6*spbk4k1*spbk5k1+t&
      &19/t7*t9*spak2k6*spak3k4*spbk4k1*spbk5k4-(t19/t7*t8*spak2k6*spak3k4*spbk4&
      &k1*spbk5k4+t19/t7*t8*spak1k3*spak2k6*spbk4k1*spbk5k1+t19*t12/t2*spak2k6*s&
      &pak3k4*spbk4k1*spbk5k4+t19*t12/t2*spak1k3*spak2k6*spbk4k1*spbk5k1)))
      t1 = c1*i_
      t4 = t1*spak1k3
      t5 = t19*t4/t7*spbk4k1
      t6 = c2*i_
      t8 = t6*spak1k3
      t9 = (2.0_ki)*t19/t3*t8*spbk4k1
      t10 = t10*i_
      t11 = t10*spak1k3
      t12 = t19*t11/t2*spbk4k1
      abb31n2 = ((4.0_ki)*(t12+t5-t9))
      abb31n3 = ((4.0_ki)*(t9-(t5+t12)))
      t5 = t1*spak2k3
      t9 = t19*t5/t7*spbk4k1
      t12 = t6*spak2k3
      t13 = t19*(2.0_ki)*t12/t3*spbk4k1
      t14 = t10*spak2k3
      t15 = t19*t14/t2*spbk4k1
      abb31n4 = ((8.0_ki)*(t15+t9-t13))
      abb31n5 = ((8.0_ki)*(t13-(t9+t15)))
      abb31n6 = ((8.0_ki)*(-(t19/t3*t6*spak2k4*spbk4k1+t19*t12/t3*spbk3k1))+(4.0&
      &_ki)*(t19*t14/t2*spbk3k1+t19*t5/t7*spbk3k1+t19*t1/t7*spak2k4*spbk4k1+t19*&
      &t10/t2*spak2k4*spbk4k1))
      t8 = t8*spak2k6*spbk4k1
      t9 = t6*spak2k6
      t13 = t9*spak3k4*spbk4k1
      t4 = t4*spak2k6*spbk4k1
      t15 = t1*spak2k6
      t16 = t15*spak3k4*spbk4k1
      t11 = t11*spak2k6*spbk4k1
      t17 = t10*spak2k6
      t18 = t17*spak3k4*spbk4k1
      abb31n7 = ((16.0_ki)*(-(t19/t3*t8*spbk5k1+t19*t13/t3*spbk5k4))+(8.0_ki)*(t&
      &19*t11/t2*spbk5k1+t19*t16/t7*spbk5k4+t19*t18/t2*spbk5k4+t19*t4/t7*spbk5k1&
      &))
      abb31n8 = ((8.0_ki)*(-(t19/t3*t8*spbk6k1+t19*t13/t3*spbk6k4))+(4.0_ki)*(t1&
      &9*t11/t2*spbk6k1+t19*t16/t7*spbk6k4+t19*t18/t2*spbk6k4+t19*t4/t7*spbk6k1)&
      &)
      t4 = t15*spak3k6
      t8 = t19*t4/t7*spbk4k1*spbk6k5
      t11 = t9*spak3k6
      t13 = t19*(2.0_ki)*t11/t3*spbk4k1*spbk6k5
      t16 = t17*spak3k6
      t18 = t19*t16/t2*spbk4k1*spbk6k5
      abb31n9 = ((8.0_ki)*(t18+t8-t13))
      abb31n10 = ((8.0_ki)*(t13-(t8+t18)))
      abb31n11 = ((8.0_ki)*(-(t19/t3*t9*spak4k6*spbk4k1*spbk6k5+t19*t11/t3*spbk3&
      &k1*spbk6k5))+(4.0_ki)*(t19*t16/t2*spbk3k1*spbk6k5+t19*t4/t7*spbk3k1*spbk6&
      &k5+t19*t15/t7*spak4k6*spbk4k1*spbk6k5+t19*t17/t2*spak4k6*spbk4k1*spbk6k5)&
      &)
      t8 = t19*t1/t7*spak3k4*spbk4k1
      t9 = (2.0_ki)*t19/t3*t6*spak3k4*spbk4k1
      t13 = t19*t10/t2*spak3k4*spbk4k1
      abb31n12 = ((4.0_ki)*(t13+t8-t9))
      abb31n13 = ((4.0_ki)*(t9-(t8+t13)))
      t8 = t1*spak3k6
      t9 = t19/t7*t8*spbk4k1
      t13 = t6*spak3k6
      t15 = t19*(2.0_ki)*t13/t3*spbk4k1
      t17 = t10*spak3k6
      t18 = t19*t17/t2*spbk4k1
      abb31n14 = ((8.0_ki)*(t18+t9-t15))
      abb31n15 = ((8.0_ki)*(t15-(t9+t18)))
      abb31n16 = ((8.0_ki)*(-(t19/t3*t6*spak4k6*spbk4k1+t19*t13/t3*spbk3k1))+(4.&
      &0_ki)*(t19*t17/t2*spbk3k1+t19/t7*t8*spbk3k1+t19*t1/t7*spak4k6*spbk4k1+t19&
      &*t10/t2*spak4k6*spbk4k1))
      abb31n17 = ((8.0_ki)*(-(t19/t3*t6*spak1k2*spbk4k1+t19*t12/t3*spbk4k3))+(4.&
      &0_ki)*(t19*t14/t2*spbk4k3+t19*t5/t7*spbk4k3+t19*t1/t7*spak1k2*spbk4k1+t19&
      &*t10/t2*spak1k2*spbk4k1))
      t5 = t6*spak1k6
      t1 = t1*spak1k6
      t6 = t10*spak1k6
      abb31n18 = ((8.0_ki)*(t19/t3*t5*spak2k6*spbk4k1*spbk6k5-t19*t11/t3*spbk4k3&
      &*spbk6k5)+(4.0_ki)*(t19*t16/t2*spbk4k3*spbk6k5+t19*t4/t7*spbk4k3*spbk6k5-&
      &(t19/t2*t6*spak2k6*spbk4k1*spbk6k5+t19*t1/t7*spak2k6*spbk4k1*spbk6k5)))
      abb31n19 = ((8.0_ki)*(t19/t3*t5*spbk4k1-t19*t13/t3*spbk4k3)+(4.0_ki)*(t19*&
      &t17/t2*spbk4k3+t19/t7*t8*spbk4k3-(t19/t2*t6*spbk4k1+t19*t1/t7*spbk4k1)))
      rat2d31 = 0
      rat2 = rat2 + rat2d31
      abb31n21 = abb31n1
      abb31n22 = abb31n19
      abb31n23 = abb31n17
      abb31n24 = abb31n16
      abb31n25 = abb31n15
      abb31n26 = abb31n14
      abb31n27 = abb31n13
      abb31n28 = abb31n12
      abb31n29 = abb31n6
      abb31n30 = abb31n5
      abb31n31 = abb31n4
      abb31n32 = abb31n3
      abb31n33 = abb31n2
      abb31n34 = -(abb31n7)
      abb31n35 = -(abb31n8)
      abb31n36 = -(abb31n9)
      abb31n37 = -(abb31n10)
      abb31n38 = -(abb31n11)
      abb31n39 = -(abb31n18)
   end subroutine
end module p25_udbar_neepssbar_abbrevd31h0
