module     p26_udbar_neepgg_abbrevd43h0
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_globalsh0
   implicit none
   private
   complex(ki), public :: abb43n1
   complex(ki), public :: abb43n2
   complex(ki), public :: abb43n3
   complex(ki), public :: abb43n4
   complex(ki), public :: abb43n5
   complex(ki), public :: abb43n6
   complex(ki), public :: abb43n7
   complex(ki), public :: abb43n8
   complex(ki), public :: abb43n9
   complex(ki), public :: abb43n10
   complex(ki), public :: abb43n11
   complex(ki), public :: abb43n12
   complex(ki), public :: abb43n13
   complex(ki), public :: abb43n14
   complex(ki), public :: abb43n15
   complex(ki), public :: abb43n16
   complex(ki), public :: abb43n17
   complex(ki), public :: abb43n18
   complex(ki), public :: abb43n19
   complex(ki), public :: rat2d43
   complex(ki), public :: abb43n21
   complex(ki), public :: abb43n22
   complex(ki), public :: abb43n23
   complex(ki), public :: abb43n24
   complex(ki), public :: abb43n25
   complex(ki), public :: abb43n26
   complex(ki), public :: abb43n27
   complex(ki), public :: abb43n28
   complex(ki), public :: abb43n29
   complex(ki), public :: abb43n30
   complex(ki), public :: abb43n31
   complex(ki), public :: abb43n32
   complex(ki), public :: abb43n33
   complex(ki), public :: abb43n34
   complex(ki), public :: abb43n35
   complex(ki), public :: abb43n36
   complex(ki), public :: abb43n37
   complex(ki), public :: abb43n38
   complex(ki), public :: abb43n39
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   real(ki) :: t38
   real(ki) :: t39
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p26_udbar_neepgg_config, only: deltaOS
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_model
      use p26_udbar_neepgg_color, only: TR
      use p26_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = TR*c2
      t2 = es56*t1*i_*spak2k3
      t3 = (es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t4 = es234*NC*t3
      t5 = spak5k6*spak5k6
      t6 = t4*t5
      t7 = t2/t6*spak2k5*spbk4k2*spbk5k1
      t8 = t2/t6*spak3k5*spbk4k3*spbk5k1
      t9 = es61*t1*i_*spak2k3
      t10 = t9/t6*spak2k5*spbk4k2*spbk5k1
      t11 = t9/t6*spak3k5*spbk4k3*spbk5k1
      t12 = NC*TR*c2
      t13 = es56*t12
      t14 = t13*i_
      t15 = t14*spak2k3
      t16 = t15*spak2k5*spbk4k2
      t17 = es234*t3
      t18 = t17*t5
      t19 = t16/t18*spbk5k1
      t20 = t15*spak3k5*spbk4k3
      t21 = t20/t18*spbk5k1
      t22 = es61*t12*i_
      t23 = t22*spak2k3
      t24 = t23*spak2k5*spbk4k2
      t25 = t24/t18*spbk5k1
      t26 = t23*spak3k5*spbk4k3
      t27 = t26/t18*spbk5k1
      abb43n1 = ((2.0_ki)*(t10+t21+t27+t7-(t8+t25+t19+t11)))
      t13 = es61*t13*i_*spak2k3
      t12 = t12*i_
      t28 = t12*spak2k3
      t29 = t28*spak2k5*spbk4k2
      t30 = t29*spbk5k1
      t38 = es56*es56
      t31 = t28*spak3k5*spbk4k3
      t32 = t31*spbk5k1
      t39 = es61*es61
      t33 = t15*spak2k6*spbk4k2
      t3 = t3*t5
      t5 = t15*spak3k6*spbk4k3
      t15 = t23*spak2k6*spbk4k2
      t23 = t23*spak3k6*spbk4k3
      t34 = t28*spak2k6*spbk4k2
      t35 = t34*spbk6k1
      t36 = t28*spak3k6*spbk4k3
      t37 = t36*spbk6k1
      abb43n2 = ((8.0_ki)*(t13/t18*spak3k5*spbk4k3*spbk5k1-t13/t18*spak2k5*spbk4&
      &k2*spbk5k1)+(4.0_ki)*(t38*t32/t18+t39*t32/t18+t13/t18*spak3k6*spbk4k3*spb&
      &k6k1-(t13/t18*spak2k6*spbk4k2*spbk6k1+t39*t30/t18+t38*t30/t18))+(2.0_ki)*&
      &(t15/t3*spbk6k1+t38*t37/t18+t39*t37/t18+t33/t3*spbk6k1-(t5/t3*spbk6k1+t23&
      &/t3*spbk6k1+t39*t35/t18+t38*t35/t18)))
      t13 = t12*spak1k2*spak2k3*spbk4k2
      t35 = t12*spak1k3*spak2k3*spbk4k3
      abb43n3 = ((2.0_ki)*(t13/t3*spbk6k1+t14/t18*spak1k3*spak2k3*spbk4k3*spbk6k&
      &1+t22/t18*spak1k3*spak2k3*spbk4k3*spbk6k1-(t22/t18*spak1k2*spak2k3*spbk4k&
      &2*spbk6k1+t14/t18*spak1k2*spak2k3*spbk4k2*spbk6k1+t35/t3*spbk6k1)))
      t14 = t19-t21
      abb43n4 = ((8.0_ki)*(t14+t25-t27))
      abb43n5 = ((2.0_ki)*(t20/t18*spbk6k1+t26/t18*spbk6k1+t29/t3*spbk6k1-(t31/t&
      &3*spbk6k1+t24/t18*spbk6k1+t16/t18*spbk6k1)))
      t3 = t13*spbk5k1
      t16 = t17*spak5k6
      t17 = t3/t16*spbk6k1
      t20 = t35*spbk5k1
      t22 = t20/t16*spbk6k1
      abb43n6 = ((8.0_ki)*(t25-t27)+(4.0_ki)*(t14+t22-t17))
      abb43n7 = ((8.0_ki)*(t27-t25)+(4.0_ki)*(t17+t21-(t22+t19)))
      t14 = spbk5k1*spbk5k1
      t12 = t12*spak1k6*spak2k3
      abb43n8 = ((2.0_ki)*(t13*t14/t16+t23/t18*spbk5k1+t5/t18*spbk5k1+t12*t14/t1&
      &8*spak2k5*spbk4k2-(t12*t14/t18*spak3k5*spbk4k3+t33/t18*spbk5k1+t15/t18*sp&
      &bk5k1+t14/t16*t35)))
      t4 = t4*spak5k6
      abb43n9 = ((4.0_ki)*(t2/t4*spbk4k2*spbk5k1+t9/t4*spbk4k2*spbk5k1))
      abb43n10 = ((4.0_ki)*(t11+t19+t25+t8-(t7+t27+t21+t10)))
      abb43n11 = ((4.0_ki)*(-(t9/t4*spbk4k3*spbk5k1+t2/t4*spbk4k3*spbk5k1)))
      t1 = t1*i_
      abb43n12 = ((8.0_ki)*(t20/t18+t1/t6*spak1k3*spak2k3*spbk4k3*spbk5k1-(t1/t6&
      &*spak1k2*spak2k3*spbk4k2*spbk5k1+t3/t18)))
      t2 = t1*spak1k6*spak2k3
      abb43n13 = ((4.0_ki)*(t12/t18*spbk4k2*spbk5k1+t2/t6*spbk4k2*spbk5k1))
      abb43n14 = ((4.0_ki)*(-(t2/t6*spbk4k3*spbk5k1+t12/t18*spbk4k3*spbk5k1)))
      t1 = t1*spak2k3
      abb43n15 = ((4.0_ki)*(-(t28/t16*spbk4k2*spbk5k1+t1/t4*spbk4k2*spbk5k1)))
      abb43n16 = ((8.0_ki)*(t32/t18+t1/t6*spak3k5*spbk4k3*spbk5k1-(t1/t6*spak2k5&
      &*spbk4k2*spbk5k1+t30/t18)))
      t2 = t1/t6*spak2k6*spbk4k2*spbk5k1
      t3 = t1/t6*spak3k6*spbk4k3*spbk5k1
      t5 = t34/t18*spbk5k1
      t6 = t36/t18*spbk5k1
      abb43n17 = ((16.0_ki)*(t3+t6-(t5+t2)))
      abb43n18 = ((16.0_ki)*(t2+t5-(t6+t3)))
      abb43n19 = ((4.0_ki)*(t1/t4*spbk4k3*spbk5k1+t28/t16*spbk4k3*spbk5k1))
      rat2d43 = abb43n1
      rat2 = rat2 + rat2d43
      abb43n21 = abb43n2
      abb43n22 = abb43n19
      abb43n23 = abb43n18
      abb43n24 = abb43n17
      abb43n25 = abb43n16
      abb43n26 = abb43n15
      abb43n27 = abb43n14
      abb43n28 = abb43n13
      abb43n29 = abb43n12
      abb43n30 = abb43n10
      abb43n31 = -(abb43n3)
      abb43n32 = -(abb43n4)
      abb43n33 = -(abb43n5)
      abb43n34 = -(abb43n6)
      abb43n35 = -(abb43n7)
      abb43n36 = -(abb43n8)
      abb43n37 = -(abb43n9)
      abb43n38 = ((2.0_ki)*abb43n10)
      abb43n39 = -(abb43n11)
   end subroutine
end module p26_udbar_neepgg_abbrevd43h0
