module     p26_udbar_neepgg_abbrevd22h1
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_globalsh1
   implicit none
   private
   complex(ki), public :: abb22n1
   complex(ki), public :: abb22n2
   complex(ki), public :: abb22n3
   complex(ki), public :: abb22n4
   complex(ki), public :: abb22n5
   complex(ki), public :: abb22n6
   complex(ki), public :: abb22n7
   complex(ki), public :: abb22n8
   complex(ki), public :: abb22n9
   complex(ki), public :: abb22n10
   complex(ki), public :: abb22n11
   complex(ki), public :: abb22n12
   complex(ki), public :: abb22n13
   complex(ki), public :: abb22n14
   complex(ki), public :: abb22n15
   complex(ki), public :: abb22n16
   complex(ki), public :: abb22n17
   complex(ki), public :: abb22n18
   complex(ki), public :: abb22n19
   complex(ki), public :: abb22n20
   complex(ki), public :: abb22n21
   complex(ki), public :: abb22n22
   complex(ki), public :: abb22n23
   complex(ki), public :: abb22n24
   complex(ki), public :: abb22n25
   complex(ki), public :: abb22n26
   complex(ki), public :: abb22n27
   complex(ki), public :: abb22n28
   complex(ki), public :: abb22n29
   complex(ki), public :: abb22n30
   complex(ki), public :: abb22n31
   complex(ki), public :: abb22n32
   complex(ki), public :: abb22n33
   complex(ki), public :: abb22n34
   complex(ki), public :: abb22n35
   complex(ki), public :: rat2d22
   complex(ki), public :: abb22n37
   complex(ki), public :: abb22n38
   complex(ki), public :: abb22n39
   complex(ki), public :: abb22n40
   complex(ki), public :: abb22n41
   complex(ki), public :: abb22n42
   complex(ki), public :: abb22n43
   complex(ki), public :: abb22n44
   complex(ki), public :: abb22n45
   complex(ki), public :: abb22n46
   complex(ki), public :: abb22n47
   complex(ki), public :: abb22n48
   complex(ki), public :: abb22n49
   complex(ki), public :: abb22n50
   complex(ki), public :: abb22n51
   complex(ki), public :: abb22n52
   complex(ki), public :: abb22n53
   complex(ki), public :: abb22n54
   complex(ki), public :: abb22n55
   complex(ki), public :: abb22n56
   complex(ki), public :: abb22n57
   complex(ki), public :: abb22n58
   complex(ki), public :: abb22n59
   complex(ki), public :: abb22n60
   complex(ki), public :: abb22n61
   complex(ki), public :: abb22n62
   complex(ki), public :: abb22n63
   complex(ki), public :: abb22n64
   complex(ki), public :: abb22n65
   complex(ki), public :: abb22n66
   complex(ki), public :: abb22n67
   complex(ki), public :: abb22n68
   complex(ki), public :: abb22n69
   complex(ki), public :: abb22n70
   complex(ki), public :: abb22n71
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p26_udbar_neepgg_config, only: deltaOS
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_model
      use p26_udbar_neepgg_color, only: TR
      use p26_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = NC*TR*c2
      t2 = es12*t1*i_
      t3 = t2*spak1k5*spak2k3
      t4 = spbk6k1*spbk6k1
      t5 = (es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t6 = t5*spbk6k5
      t7 = es345*t1*i_
      t8 = t7*spak1k5*spak2k3
      t9 = es61*t1*i_
      t10 = t9*spak1k5
      t11 = t10*spak2k3
      t12 = spak1k5*spbk6k1
      t12 = t12*t12
      t5 = t5*spak5k6
      t13 = t5*spbk6k5
      t14 = t9*spak2k3
      t15 = t14*spbk4k1
      t16 = t1*i_
      t17 = t16*spak1k5
      t18 = t17*spak2k3
      t19 = t18*spak2k5
      t20 = t19*spbk5k4
      abb22n1 = ((2.0_ki)*(t11/t13*spak2k5*spbk4k1*spbk6k1*spbk6k2-t20*t4/t6*spb&
      &k6k2)+(4.0_ki)*(t12/t13*t15+t4/t6*t8*spbk6k4+t12/t13*t2*spak2k3*spbk4k1-(&
      &t12/t13*t7*spak2k3*spbk4k1+t3*t4/t6*spbk6k4+t11*t4/t6*spbk6k4)))
      t2 = t18*spbk4k1
      t7 = t2/t13*spbk6k1
      abb22n2 = ((4.0_ki)*t7)
      t21 = t16*spak2k6
      t22 = es56*t1*i_
      abb22n3 = ((2.0_ki)*(t10/t13*t4*spak2k5+(2.0_ki)*t12/t13*t21*spbk6k1+t22/t&
      &13*t4*spak1k5*spak2k5))
      t10 = t16*spak2k3
      t12 = t10*t12/t13*spbk4k1-t18*t4/t6*spbk6k4
      abb22n4 = ((4.0_ki)*t12)
      t23 = t17*spak2k5
      t24 = t23/t13*t4
      t25 = (4.0_ki)*t24
      abb22n5 = t25
      abb22n6 = (-2.0_ki)*t24
      abb22n7 = -(t25)
      t1 = es234*t1*i_
      t24 = t1*spak2k5
      t25 = t24/t13*spak3k5*spbk6k1*spbk6k4
      t26 = t22*spak2k5
      t27 = t26*spak3k5
      t28 = t27/t13*spbk6k1*spbk6k4
      t29 = t9*spak2k5
      t30 = t29*spak3k5
      t31 = t30/t13*spbk6k1*spbk6k4
      t32 = t17*spak2k6
      t33 = t32*spak3k5
      t34 = t33/t13*t4*spbk6k4
      t35 = t19*spbk4k1
      t36 = t35/t13*spbk6k1*spbk6k2
      abb22n8 = ((4.0_ki)*(t28+t31+(2.0_ki)*t34+t36-t25))
      t23 = t23/t13*t4*spak3k6*spbk6k4
      abb22n9 = ((4.0_ki)*(t34-t23)+(2.0_ki)*(t12+t25-(t36+t31+t28)))
      abb22n10 = ((2.0_ki)*(t24/t13*spbk6k1-((4.0_ki)/t13*t32*t4+t29/t13*spbk6k1&
      &+t26/t13*spbk6k1)))
      abb22n11 = ((4.0_ki)*(t17/t13*t4*spak3k6+t22/t13*spak3k5*spbk6k1+t9/t13*sp&
      &ak3k5*spbk6k1-t1/t13*spak3k5*spbk6k1))
      t12 = t18/t13*spbk6k1*spbk6k4
      abb22n12 = (-4.0_ki)*t12
      t24 = t22*spak2k3
      t25 = t24*spak2k5
      t26 = t14*spak2k5
      t29 = t16*spak1k3
      abb22n13 = ((2.0_ki)*(t35/t5*spbk6k2+t20/t13*spbk6k1*spbk6k2-(t9/t13*spak1&
      &k3*spak2k5*spbk6k1*spbk6k4+t22/t13*spak1k3*spak2k5*spbk6k1*spbk6k4+t30/t5&
      &*spbk6k4+t27/t5*spbk6k4))+(4.0_ki)*(t8/t13*spbk6k1*spbk6k4-(t29/t13*t4*sp&
      &ak1k5*spak2k6*spbk6k4+t33/t5*spbk6k1*spbk6k4+t3/t13*spbk6k1*spbk6k4+t26/t&
      &13*spbk6k2*spbk6k4+t25/t13*spbk6k2*spbk6k4+t11/t13*spbk6k1*spbk6k4)))
      abb22n14 = ((4.0_ki)/t13*t17*spbk6k1)
      t17 = t10*spak2k5
      t20 = t29*spak2k5
      t30 = t1*spak2k3
      abb22n15 = ((2.0_ki)*(t25/t13*spbk4k1*spbk6k2+t26/t13*spbk4k1*spbk6k2-(t20&
      &/t6*spbk5k1*spbk6k1*spbk6k4+t30/t13*spak2k5*spbk4k1*spbk6k2+t27/t13*spbk5&
      &k1*spbk6k4))+(4.0_ki)*(t8/t13*spbk4k1*spbk6k1+t19/t13*spbk2k1*spbk5k4*spb&
      &k6k1+t1/t13*spak2k6*spak3k5*spbk6k1*spbk6k4+t18/t13*spak2k6*spbk2k1*spbk6&
      &k1*spbk6k4-(t9/t13*spak2k6*spak3k5*spbk6k1*spbk6k4+t22/t13*spak2k6*spak3k&
      &5*spbk6k1*spbk6k4+t17/t6*spbk5k1*spbk6k2*spbk6k4+t32/t13*t4*spak3k6*spbk6&
      &k4+(2.0_ki)/t13*t3*spbk4k1*spbk6k1+t11/t13*spbk4k1*spbk6k1)))
      t1 = t16*spak2k5
      t3 = t1*spak3k5
      t8 = t3*spbk5k1
      t9 = t8/t13*spbk6k4
      abb22n16 = ((4.0_ki)*((2.0_ki)*t7+t9))
      abb22n17 = ((2.0_ki)*(t7+t9))
      abb22n18 = (-8.0_ki)*t1/t13*spbk5k1
      t7 = t16*spak1k2
      t11 = t7*spak3k5*spbk4k1
      t16 = t17*spbk4k2
      t19 = t21*spak3k5
      abb22n19 = ((4.0_ki)*(t15/t13+t11/t13*spbk5k1+t24/t13*spbk4k1-(t19/t13*spb&
      &k5k1*spbk6k4+t10/t6*spbk5k1*spbk6k4+t8/t13*spbk5k4+t30/t13*spbk4k1+t16/t1&
      &3*spbk5k1)))
      t8 = t17/t6*spbk6k1*spbk6k2*spbk6k4
      t4 = t20*t4/t6*spbk6k4
      abb22n20 = ((8.0_ki)*(t34+t8)+(4.0_ki)*(t28+t4-(t36+t23)))
      abb22n21 = ((8.0_ki)*(-(t8+t34))+(4.0_ki)*(t23+t36-(t4+t28)))
      t4 = t3/t13*spbk6k1*spbk6k4
      abb22n22 = ((16.0_ki)*t4)
      t8 = (8.0_ki)*t4
      abb22n23 = t8
      t4 = (4.0_ki)*t4
      abb22n24 = t4
      abb22n25 = -(t4)
      abb22n26 = -(t8)
      t4 = (16.0_ki)*t1/t13*spbk6k1
      abb22n27 = t4
      abb22n28 = -(t4)
      t4 = t10/t6*spbk6k1*spbk6k4
      t6 = t11/t13*spbk6k1
      t8 = t16/t13*spbk6k1
      t10 = t3*spbk5k4
      t15 = t10/t13*spbk6k1
      t17 = t19/t13*spbk6k1*spbk6k4
      t9 = (4.0_ki)*t9
      abb22n29 = ((8.0_ki)*(t15+t17+t4+t8-t6)+t9)
      abb22n30 = ((8.0_ki)*(t6-(t8+t4+t17+t15))-t9)
      t3 = t3/t5*spbk6k4
      t4 = t20/t13*spbk6k1*spbk6k4
      t6 = t3+t4
      abb22n31 = ((4.0_ki)*t6)
      abb22n32 = ((2.0_ki)*(t6-t12))
      abb22n33 = ((4.0_ki)*(-(t4+t3)))
      abb22n34 = ((8.0_ki)*(-(t7/t13*spbk6k1+t1/t5)))
      abb22n35 = ((4.0_ki)*(t11/t5+t2/t5+t18/t13*spbk5k4*spbk6k1+t7/t13*spak1k3*&
      &spbk4k1*spbk6k1-(t7/t13*spak2k3*spbk4k2*spbk6k1+t29/t13*spak2k6*spbk6k1*s&
      &pbk6k4+t20/t13*spbk5k4*spbk6k1+t19/t5*spbk6k4+t24/t13*spbk6k4+t14/t13*spb&
      &k6k4+t16/t5+t10/t5)))
      rat2d22 = 0
      rat2 = rat2 + rat2d22
      abb22n37 = abb22n1
      abb22n38 = abb22n35
      abb22n39 = abb22n33
      abb22n40 = abb22n31
      abb22n41 = abb22n30
      abb22n42 = abb22n29
      abb22n43 = abb22n26
      abb22n44 = abb22n23
      abb22n45 = abb22n22
      abb22n46 = abb22n19
      abb22n47 = abb22n16
      abb22n48 = abb22n12
      abb22n49 = abb22n11
      abb22n50 = abb22n10
      abb22n51 = abb22n9
      abb22n52 = abb22n7
      abb22n53 = abb22n5
      abb22n54 = abb22n2
      abb22n55 = -(abb22n3)
      abb22n56 = -(abb22n4)
      abb22n57 = -(abb22n6)
      abb22n58 = -(abb22n8)
      abb22n59 = -(abb22n13)
      abb22n60 = -(abb22n14)
      abb22n61 = -(abb22n15)
      abb22n62 = -(abb22n17)
      abb22n63 = -(abb22n18)
      abb22n64 = -(abb22n20)
      abb22n65 = -(abb22n21)
      abb22n66 = -(abb22n24)
      abb22n67 = -(abb22n25)
      abb22n68 = -(abb22n27)
      abb22n69 = -(abb22n28)
      abb22n70 = -(abb22n32)
      abb22n71 = -(abb22n34)
   end subroutine
end module p26_udbar_neepgg_abbrevd22h1
