module     p26_udbar_neepgg_abbrevd37h1
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_globalsh1
   implicit none
   private
   complex(ki), public :: abb37n1
   complex(ki), public :: abb37n2
   complex(ki), public :: abb37n3
   complex(ki), public :: abb37n4
   complex(ki), public :: abb37n5
   complex(ki), public :: abb37n6
   complex(ki), public :: abb37n7
   complex(ki), public :: abb37n8
   complex(ki), public :: rat2d37
   complex(ki), public :: abb37n10
   complex(ki), public :: abb37n11
   complex(ki), public :: abb37n12
   complex(ki), public :: abb37n13
   complex(ki), public :: abb37n14
   complex(ki), public :: abb37n15
   complex(ki), public :: abb37n16
   complex(ki), public :: abb37n17
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   real(ki) :: t31
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p26_udbar_neepgg_config, only: deltaOS
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_model
      use p26_udbar_neepgg_color, only: TR
      use p26_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t31 = es234-(es61+es56)
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c2*i_
      t3 = t2*spak1k5*spak2k3
      t4 = t3*spak2k5
      t5 = spbk6k1*spbk6k1
      t6 = t31*t1
      t7 = es234*NC*t6*spak5k6
      t8 = t7*spbk6k5
      t9 = t4*t5/t8*spbk4k2
      t3 = t3*t5/t8*spak3k5*spbk4k3
      t10 = NC*TR*c2
      t11 = t10*i_
      t12 = t11*spak1k5*spak2k3
      t13 = t12*spak2k5
      t14 = t13*spbk4k2
      t15 = t14*t5
      t16 = es234*t6*spak5k6
      t17 = t16*spbk6k5
      t18 = t15/t17
      t12 = t12*spak3k5*spbk4k3
      t19 = t12*t5
      t20 = t19/t17
      t1 = t31*(es345-(es61+es12))*t1
      t21 = NC*t1*spak5k6*spbk6k5
      t4 = t4/t21*spbk4k1*spbk6k1*spbk6k2
      t22 = t13*spbk4k1
      t1 = t1*spak5k6
      t23 = t1*spbk6k5
      t24 = t22/t23*spbk6k1*spbk6k2
      abb37n1 = ((2.0_ki)*(t18+t24+t3-(t9+t4+t20)))
      t6 = t6*spak5k6*spbk6k5
      t25 = es56*t10*i_
      t26 = t25*spak1k5*spak2k3
      t27 = t26*spak2k5
      t28 = es61*t10*i_
      t29 = t28*spak1k5*spak2k3
      t30 = t29*spak2k5
      t10 = es234*t10*i_
      abb37n2 = ((2.0_ki)*(t15/t6+t26/t17*t5*spak3k5*spbk4k3+t29/t17*t5*spak3k5*&
      &spbk4k3+t10/t23*spak1k5*spak2k3*spak2k5*spbk4k1*spbk6k1*spbk6k2-(t30/t23*&
      &spbk4k1*spbk6k1*spbk6k2+t27/t23*spbk4k1*spbk6k1*spbk6k2+t30/t17*t5*spbk4k&
      &2+t27/t17*t5*spbk4k2+t19/t6)))
      t5 = t11*spak2k3
      t11 = t5*spak2k5
      t15 = t11*spbk4k2
      t19 = t15*spbk6k1
      t5 = t5*spak3k5*spbk4k3
      t26 = t5*spbk6k1
      t25 = t25*spak2k3
      t27 = t25*spak2k5
      t28 = t28*spak2k3
      t29 = t28*spak2k5
      abb37n3 = ((2.0_ki)*(t19/t6+t25/t17*spak3k5*spbk4k3*spbk6k1+t28/t17*spak3k&
      &5*spbk4k3*spbk6k1+t10/t23*spak2k3*spak2k5*spbk4k1*spbk6k2-(t29/t23*spbk4k&
      &1*spbk6k2+t27/t23*spbk4k1*spbk6k2+t29/t17*spbk4k2*spbk6k1+t27/t17*spbk4k2&
      &*spbk6k1+t26/t6)))
      abb37n4 = ((8.0_ki)*(t18+t24-t20))
      abb37n5 = ((2.0_ki)*(t13/t23*spbk5k4*spbk6k1*spbk6k2-(3.0_ki)/t1*t22*spbk6&
      &k2)+(8.0_ki)*(t12/t16*spbk6k1-t14/t16*spbk6k1))
      abb37n6 = ((4.0_ki)*(t20+t4+t9-(t3+t24+t18)))
      t1 = t2*spak2k3
      t2 = t1*spak2k5
      t3 = t2*spbk4k2
      t1 = t1*spak3k5*spbk4k3
      abb37n7 = ((8.0_ki)*(t26/t17+t1/t8*spbk6k1-(t2/t21*spbk4k1*spbk6k2+t11/t23&
      &*spbk4k1*spbk6k2+t3/t8*spbk6k1+t19/t17)))
      abb37n8 = ((4.0_ki)*(t15/t16+t3/t7-(t2/t21*spbk5k4*spbk6k2+t11/t23*spbk5k4&
      &*spbk6k2+t5/t16+t1/t7)))
      rat2d37 = abb37n1
      rat2 = rat2 + rat2d37
      abb37n10 = abb37n2
      abb37n11 = abb37n8
      abb37n12 = abb37n7
      abb37n13 = abb37n6
      abb37n14 = -(abb37n3)
      abb37n15 = -(abb37n4)
      abb37n16 = -(abb37n5)
      abb37n17 = ((2.0_ki)*abb37n6)
   end subroutine
end module p26_udbar_neepgg_abbrevd37h1
