module     p26_udbar_neepgg_d25h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity3/d25h3l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d25
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd25h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      real(ki) :: t44
      real(ki) :: t45
      real(ki) :: t46
      real(ki) :: t47
      real(ki) :: t48
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3+k2-k6-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t44 = dotproduct(qshift, qshift)
      t1 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t2 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t3 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t45 = dotproduct(k6, qshift)
      t4 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t5 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t6 = (spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5k4(3)*qshift(3)-sp&
      &vak5k4(4)*qshift(4))
      t7 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t46 = dotproduct(k5, qshift)
      t47 = dotproduct(k1, qshift)
      t8 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t9 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t48 = dotproduct(k2, qshift)
      t10 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-s&
      &pvak3k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t44*abb25n47+t1*t2*abb25n25+t1*t44*abb25n78+t1*t45*abb25n2&
         &9+t10*t44*abb25n51+t2*t3*abb25n28+t2*t4*abb25n31+t2*t46*abb25n39+t2*t4&
         &7*abb25n40+t2*t48*abb25n43+t2*t5*abb25n32+t2*t6*abb25n33+t2*t7*abb25n3&
         &4+t2*t8*abb25n41+t2*t9*abb25n42+t4*t44*abb25n54+t4*t45*abb25n44+t44*t6&
         &*abb25n67+t44*t7*abb25n64+t45*t6*abb25n35+t45*t7*abb25n38+t10*t2*t3*ab&
         &b25n80+t10*t2*t5*abb25n74)
         return
      end if
      t11 = qshift(iv1)
      t12 = k1(iv1)
      t13 = k2(iv1)
      t14 = k5(iv1)
      t15 = k6(iv1)
      t16 = spvak2k1(iv1)
      t17 = spvak2k4(iv1)
      t18 = spvak2k5(iv1)
      t19 = spvak3k1(iv1)
      t20 = spvak3k4(iv1)
      t21 = spvak5k1(iv1)
      t22 = spvak5k2(iv1)
      t23 = spvak5k4(iv1)
      t24 = spvak6k1(iv1)
      t25 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t11*abb25n49+t1*t11*abb25n77+t1*t15*abb25n75+t1*t25*abb25n&
         &48+t10*t11*abb25n50+t11*t4*abb25n53+t11*t6*abb25n66+t11*t7*abb25n63+t1&
         &2*t2*abb25n60+t13*t2*abb25n57+t14*t2*abb25n61+t15*t4*abb25n56+t15*t6*a&
         &bb25n69+t15*t7*abb25n62+t16*t2*abb25n72+t17*t2*abb25n70+t17*t44*abb25n&
         &37+t17*t45*abb25n62+t18*t2*abb25n59+t19*t2*abb25n73+t19*t44*abb25n45+t&
         &19*t45*abb25n56+t2*t21*abb25n76+t2*t22*abb25n58+t2*t23*abb25n71+t2*t24&
         &*abb25n48+t20*t44*abb25n46+t23*t44*abb25n36+t23*t45*abb25n69+t24*t44*a&
         &bb25n27+t24*t45*abb25n75+t25*t3*abb25n76+t25*t4*abb25n73+t25*t46*abb25&
         &n61+t25*t47*abb25n60+t25*t48*abb25n57+t25*t5*abb25n72+t25*t6*abb25n71+&
         &t25*t7*abb25n70+t25*t8*abb25n59+t25*t9*abb25n58+t10*t16*t2*abb25n30+t1&
         &0*t2*t21*abb25n26+t10*t25*t3*abb25n26+t10*t25*t5*abb25n30+t2*t20*t3*ab&
         &b25n26+t2*t20*t5*abb25n30)
         return
      end if
      t44 = d(iv1,iv2)
      t8 = spvak6k5(iv2)
      t9 = spvak2k4(iv2)
      t26 = spvak3k1(iv2)
      t27 = spvak5k4(iv2)
      t28 = spvak6k1(iv2)
      t29 = k6(iv2)
      t30 = spvak3k4(iv2)
      t31 = qshift(iv2)
      t32 = t16*t8
      t33 = spvak2k1(iv2)
      t34 = t25*t33
      t35 = t21*t8
      t36 = spvak5k1(iv2)
      t37 = t25*t36
      t38 = t16*t30
      t39 = t20*t33
      t40 = t20*t36
      t41 = t20*t8
      t42 = t21*t30
      t43 = t25*t30
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t44*abb25n47+t1*t44*abb25n78+t10*t44*abb25n51+t4&
         &*t44*abb25n54+t44*t6*abb25n67+t44*t7*abb25n64)+t32*abb25n32+t34*abb25n&
         &32+t35*abb25n28+t37*abb25n28+k1(iv2)*t25*abb25n40+k2(iv2)*t25*abb25n43&
         &+k5(iv2)*t25*abb25n39+spvak2k5(iv2)*t25*abb25n41+spvak5k2(iv2)*t25*abb&
         &25n42+t10*t32*abb25n74+t10*t34*abb25n74+t10*t35*abb25n80+t10*t37*abb25&
         &n80+t11*t26*abb25n55+t11*t27*abb25n68+t11*t28*abb25n79+t11*t30*abb25n5&
         &2+t11*t9*abb25n65+t12*t8*abb25n40+t13*t8*abb25n43+t14*t8*abb25n39+t15*&
         &t26*abb25n44+t15*t27*abb25n35+t15*t28*abb25n29+t15*t9*abb25n38+t17*t29&
         &*abb25n38+t17*t31*abb25n65+t17*t8*abb25n34+t18*t8*abb25n41+t19*t29*abb&
         &25n44+t19*t31*abb25n55+t19*t8*abb25n31+t2*t38*abb25n74+t2*t39*abb25n74&
         &+t2*t40*abb25n80+t2*t42*abb25n80+t20*t31*abb25n52+t22*t8*abb25n42+t23*&
         &t29*abb25n35+t23*t31*abb25n68+t23*t8*abb25n33+t24*t29*abb25n29+t24*t31&
         &*abb25n79+t24*t8*abb25n25+t25*t26*abb25n31+t25*t27*abb25n33+t25*t28*ab&
         &b25n25+t25*t9*abb25n34+t3*t41*abb25n80+t3*t43*abb25n80+t41*t5*abb25n74&
         &+t43*t5*abb25n74)
         return
      end if
      t45 = d(iv2,iv3)
      t46 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t2 = spvak6k5(iv3)
      t3 = spvak2k1(iv3)
      t4 = spvak5k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k4(iv3)*t44*abb25n37+spvak3k1(iv3)*t44*abb&
         &25n45+spvak5k4(iv3)*t44*abb25n36+spvak6k1(iv3)*t44*abb25n27+t1*t44*abb&
         &25n46+t17*t45*abb25n37+t19*t45*abb25n45+t20*t45*abb25n46+t23*t45*abb25&
         &n36+t24*t45*abb25n27+t26*t46*abb25n45+t27*t46*abb25n36+t28*t46*abb25n2&
         &7+t30*t46*abb25n46+t46*t9*abb25n37)+t2*t38*abb25n30+t2*t39*abb25n30+t2&
         &*t40*abb25n26+t2*t42*abb25n26+t1*t16*t8*abb25n30+t1*t21*t8*abb25n26+t1&
         &*t25*t33*abb25n30+t1*t25*t36*abb25n26+t20*t3*t8*abb25n30+t20*t4*t8*abb&
         &25n26+t25*t3*t30*abb25n30+t25*t30*t4*abb25n26)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d25:
   subroutine     reconstruct_d25(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_25:
      coeffs%coeffs_25%c0 = derivative(czip)
      coeffs%coeffs_25%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_25%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_25%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_25%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_25%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_25%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_25%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_25%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_25%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_25%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_25%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_25%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_25%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_25%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_25%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_25%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_25%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_25%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_25%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_25%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_25%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_25%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_25%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_25%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_25%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_25%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_25%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_25%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_25%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_25%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_25%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_25%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_25%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_25%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_25:
   end subroutine reconstruct_d25
!---#] subroutine reconstruct_d25:
end module p26_udbar_neepgg_d25h3l1d
