module     p26_udbar_neepgg_d92h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity3/d92h3l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d92
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd92h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      complex(ki) :: t105
      complex(ki) :: t106
      complex(ki) :: t107
      complex(ki) :: t108
      complex(ki) :: t109
      complex(ki) :: t110
      complex(ki) :: t111
      complex(ki) :: t112
      complex(ki) :: t113
      complex(ki) :: t114
      complex(ki) :: t115
      complex(ki) :: t116
      complex(ki) :: t117
      complex(ki) :: t118
      complex(ki) :: t119
      complex(ki) :: t120
      complex(ki) :: t121
      complex(ki) :: t122
      complex(ki) :: t123
      complex(ki) :: t124
      complex(ki) :: t125
      complex(ki) :: t126
      complex(ki) :: t127
      complex(ki) :: t128
      complex(ki) :: t129
      complex(ki) :: t130
      complex(ki) :: t131
      complex(ki) :: t132
      complex(ki) :: t133
      complex(ki) :: t134
      complex(ki) :: t135
      complex(ki) :: t136
      complex(ki) :: t137
      complex(ki) :: t138
      complex(ki) :: t139
      complex(ki) :: t140
      complex(ki) :: t141
      complex(ki) :: t142
      complex(ki) :: t143
      complex(ki) :: t144
      complex(ki) :: t145
      complex(ki) :: t146
      complex(ki) :: t147
      complex(ki) :: t148
      complex(ki) :: t149
      complex(ki) :: t150
      complex(ki) :: t151
      complex(ki) :: t152
      complex(ki) :: t153
      complex(ki) :: t154
      complex(ki) :: t155
      complex(ki) :: t156
      complex(ki) :: t157
      complex(ki) :: t158
      complex(ki) :: t159
      complex(ki) :: t160
      complex(ki) :: t161
      complex(ki) :: t162
      complex(ki) :: t163
      complex(ki) :: t164
      complex(ki) :: t165
      complex(ki) :: t166
      complex(ki) :: t167
      complex(ki) :: t168
      complex(ki) :: t169
      complex(ki) :: t170
      complex(ki) :: t171
      complex(ki) :: t172
      complex(ki) :: t173
      complex(ki) :: t174
      complex(ki) :: t175
      complex(ki) :: t176
      complex(ki) :: t177
      complex(ki) :: t178
      complex(ki) :: t179
      complex(ki) :: t180
      real(ki) :: t181
      real(ki) :: t182
      real(ki) :: t183
      real(ki) :: t184
      real(ki) :: t185
      real(ki) :: t186
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t181 = dotproduct(qshift, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t182 = dotproduct(k5, qshift)
      t183 = dotproduct(k6, qshift)
      t2 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t3 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t184 = dotproduct(k2, qshift)
      t4 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t185 = dotproduct(k1, qshift)
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t7 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t8 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t9 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t10 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-s&
      &pvak2k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb92n76+t1*abb92n112+t181*abb92n97+t181*t181*abb92n102+t1&
         &82*abb92n113+t183*abb92n114+t184*abb92n120+t185*abb92n140+t2*abb92n115&
         &+t3*abb92n119+t4*abb92n121+t1*t181*abb92n116+t1*t183*abb92n107+t1*t184&
         &*abb92n111+t1*t185*abb92n107+t1*t2*abb92n109+t1*t3*abb92n108+t1*t4*abb&
         &92n110+t181*t182*abb92n124+t181*t183*abb92n134+t181*t184*abb92n136+t18&
         &1*t185*abb92n130+t181*t2*abb92n144+t181*t3*abb92n164+t181*t4*abb92n146&
         &+t181*t5*abb92n156+t182*t183*abb92n105+t182*t185*abb92n105+t182*t2*abb&
         &92n93+t182*t3*abb92n81+t183*t184*abb92n103+t183*t2*abb92n98+t183*t4*ab&
         &b92n100+t183*t5*abb92n84+t184*t185*abb92n101+t184*t2*abb92n94+t184*t3*&
         &abb92n80+t185*t4*abb92n92+t185*t5*abb92n85+t2*t3*abb92n88+t2*t4*abb92n&
         &91+t2*t5*abb92n86+t2*t6*abb92n89+t2*t7*abb92n90+t2*t8*abb92n96+t3*t4*a&
         &bb92n79+t1*t181*t2*abb92n95+t1*t181*t3*abb92n82+t1*t181*t4*abb92n99+t1&
         &*t183*t4*abb92n139+t1*t184*t2*abb92n143+t1*t184*t3*abb92n163+t1*t185*t&
         &4*abb92n139+t1*t2*t4*abb92n148+t1*t2*t7*abb92n158+t1*t2*t8*abb92n118+t&
         &1*t3*t4*abb92n170+t10*t2*t4*abb92n149+t181*t2*t4*abb92n106+t181*t2*t5*&
         &abb92n83+t181*t2*t6*abb92n87+t181*t2*t8*abb92n104+t181*t4*t5*abb92n78+&
         &t182*t2*t5*abb92n159+t182*t2*t6*abb92n155+t182*t2*t8*abb92n126+t183*t2&
         &*t4*abb92n123+t183*t4*t5*abb92n168+t184*t2*t4*abb92n123+t184*t2*t5*abb&
         &92n161+t184*t2*t6*abb92n152+t184*t2*t8*abb92n129+t185*t4*t5*abb92n166+&
         &t2*t3*t4*abb92n154+t2*t4*t5*abb92n169+t2*t4*t6*abb92n151+t2*t4*t7*abb9&
         &2n150+t2*t4*t9*abb92n128+t1*t2*t4*t7*abb92n77)
         return
      end if
      t11 = k1(iv1)
      t12 = k2(iv1)
      t13 = k5(iv1)
      t14 = k6(iv1)
      t15 = qshift(iv1)
      t16 = spvak3k4(iv1)
      t17 = spvak5k6(iv1)
      t18 = spvak6k1(iv1)
      t19 = spvak6k5(iv1)
      t20 = t13*abb92n105
      t21 = spvak2k1(iv1)
      t22 = spvak2k6(iv1)
      t23 = spvak3k1(iv1)
      t24 = t16*abb92n107
      t25 = spvak5k1(iv1)
      t26 = spvak2k4(iv1)
      t27 = spvak2k5(iv1)
      t28 = t16*abb92n139
      t29 = t17*abb92n123
      t30 = t17*abb92n139
      t31 = t19*abb92n123
      if(deg.eq.1) then
         numerator = (t11*abb92n140+t12*abb92n120+t13*abb92n113+t14*abb92n114+t1&
         &5*abb92n141+t16*abb92n112+t17*abb92n121+t18*abb92n119+t183*t20+t183*t2&
         &4+t185*t20+t185*t24+t19*abb92n115+t1*t11*abb92n107+t1*t12*abb92n111+t1&
         &*t14*abb92n107+t1*t15*abb92n117+t1*t17*abb92n110+t1*t18*abb92n108+t1*t&
         &183*t30+t1*t185*t30+t1*t19*abb92n109+t11*t181*abb92n130+t11*t182*abb92&
         &n105+t11*t184*abb92n101+t11*t4*abb92n92+t11*t5*abb92n85+t12*t181*abb92&
         &n136+t12*t183*abb92n103+t12*t185*abb92n101+t12*t2*abb92n94+t12*t3*abb9&
         &2n80+t13*t181*abb92n124+t13*t2*abb92n93+t13*t3*abb92n81+t14*t181*abb92&
         &n134+t14*t182*abb92n105+t14*t184*abb92n103+t14*t2*abb92n98+t14*t4*abb9&
         &2n100+t14*t5*abb92n84+t15*t181*abb92n132+t15*t182*abb92n125+t15*t183*a&
         &bb92n135+t15*t184*abb92n137+t15*t185*abb92n131+t15*t2*abb92n145+t15*t3&
         &*abb92n165+t15*t4*abb92n147+t15*t5*abb92n157+t16*t181*abb92n116+t16*t1&
         &84*abb92n111+t16*t2*abb92n109+t16*t3*abb92n108+t16*t4*abb92n110+t17*t1&
         &81*abb92n146+t17*t183*abb92n100+t17*t185*abb92n92+t17*t2*abb92n91+t17*&
         &t3*abb92n79+t18*t181*abb92n164+t18*t182*abb92n81+t18*t184*abb92n80+t18&
         &*t2*abb92n88+t18*t4*abb92n79+t181*t19*abb92n144+t181*t23*abb92n156+t18&
         &2*t19*abb92n93+t183*t19*abb92n98+t183*t2*t29+t183*t23*abb92n84+t183*t2&
         &8*t4+t183*t31*t4+t184*t19*abb92n94+t184*t2*t29+t184*t31*t4+t185*t23*ab&
         &b92n85+t185*t28*t4+t19*t3*abb92n88+t19*t4*abb92n91+t19*t5*abb92n86+t19&
         &*t6*abb92n89+t19*t7*abb92n90+t19*t8*abb92n96+t2*t21*abb92n90+t2*t22*ab&
         &b92n96+t2*t23*abb92n86+t2*t25*abb92n89+t1*t11*t4*abb92n139+t1*t12*t2*a&
         &bb92n143+t1*t12*t3*abb92n163+t1*t14*t4*abb92n139+t1*t15*t2*abb92n142+t&
         &1*t15*t3*abb92n162+t1*t15*t4*abb92n138+t1*t17*t181*abb92n99+t1*t17*t2*&
         &abb92n148+t1*t17*t3*abb92n170+t1*t18*t181*abb92n82+t1*t18*t184*abb92n1&
         &63+t1*t18*t4*abb92n170+t1*t181*t19*abb92n95+t1*t184*t19*abb92n143+t1*t&
         &19*t4*abb92n148+t1*t19*t7*abb92n158+t1*t19*t8*abb92n118+t1*t2*t21*abb9&
         &2n158+t1*t2*t22*abb92n118+t10*t17*t2*abb92n149+t10*t19*t4*abb92n149+t1&
         &1*t4*t5*abb92n166+t12*t2*t4*abb92n123+t12*t2*t5*abb92n161+t12*t2*t6*ab&
         &b92n152+t12*t2*t8*abb92n129+t13*t2*t5*abb92n159+t13*t2*t6*abb92n155+t1&
         &3*t2*t8*abb92n126+t14*t2*t4*abb92n123+t14*t4*t5*abb92n168+t15*t2*t4*ab&
         &b92n122+t15*t2*t5*abb92n160+t15*t2*t6*abb92n153+t15*t2*t8*abb92n127+t1&
         &5*t4*t5*abb92n167+t16*t181*t2*abb92n95+t16*t181*t3*abb92n82+t16*t181*t&
         &4*abb92n99+t16*t184*t2*abb92n143+t16*t184*t3*abb92n163+t16*t2*t4*abb92&
         &n148+t16*t2*t7*abb92n158+t16*t2*t8*abb92n118+t16*t3*t4*abb92n170+t17*t&
         &181*t2*abb92n106+t17*t181*t5*abb92n78+t17*t183*t5*abb92n168+t17*t185*t&
         &5*abb92n166+t17*t2*t3*abb92n154+t17*t2*t5*abb92n169+t17*t2*t6*abb92n15&
         &1+t17*t2*t7*abb92n150+t17*t2*t9*abb92n128+t18*t2*t4*abb92n154+t181*t19&
         &*t4*abb92n106+t181*t19*t5*abb92n83+t181*t19*t6*abb92n87+t181*t19*t8*ab&
         &b92n104+t181*t2*t22*abb92n104+t181*t2*t23*abb92n83+t181*t2*t25*abb92n8&
         &7+t181*t23*t4*abb92n78+t182*t19*t5*abb92n159+t182*t19*t6*abb92n155+t18&
         &2*t19*t8*abb92n126+t182*t2*t22*abb92n126+t182*t2*t23*abb92n159+t182*t2&
         &*t25*abb92n155+t183*t23*t4*abb92n168+t184*t19*t5*abb92n161+t184*t19*t6&
         &*abb92n152+t184*t19*t8*abb92n129+t184*t2*t22*abb92n129+t184*t2*t23*abb&
         &92n161+t184*t2*t25*abb92n152+t185*t23*t4*abb92n166+t19*t3*t4*abb92n154&
         &+t19*t4*t5*abb92n169+t19*t4*t6*abb92n151+t19*t4*t7*abb92n150+t19*t4*t9&
         &*abb92n128+t2*t21*t4*abb92n150+t2*t23*t4*abb92n169+t2*t25*t4*abb92n151&
         &+t2*t26*t4*abb92n149+t2*t27*t4*abb92n128+t1*t17*t2*t7*abb92n77+t1*t19*&
         &t4*t7*abb92n77+t1*t2*t21*t4*abb92n77+t16*t2*t4*t7*abb92n77)
         return
      end if
      t186 = d(iv1,iv2)
      t20 = qshift(iv2)
      t24 = k2(iv2)
      t28 = k5(iv2)
      t29 = spvak3k1(iv2)
      t30 = t11*t29
      t31 = spvak3k4(iv2)
      t32 = t11*t31
      t33 = spvak5k6(iv2)
      t34 = t11*t33
      t35 = k1(iv2)
      t36 = t23*t35
      t37 = t16*t35
      t38 = t17*t35
      t39 = k6(iv2)
      t40 = t12*t31
      t41 = spvak6k1(iv2)
      t42 = t12*t41
      t43 = spvak6k5(iv2)
      t44 = t12*t43
      t45 = t16*t24
      t46 = t18*t24
      t47 = t19*t24
      t48 = t13*t43
      t49 = t19*t28
      t50 = t14*t29
      t51 = t14*t31
      t52 = t14*t33
      t53 = t14*t43
      t54 = t23*t39
      t55 = t16*t39
      t56 = t17*t39
      t57 = t19*t39
      t58 = t15*t29
      t59 = t15*t31
      t60 = t15*t33
      t61 = t15*t41
      t62 = t15*t43
      t63 = t20*t23
      t64 = t16*t20
      t65 = t17*t20
      t66 = t18*t20
      t67 = t19*t20
      t68 = t21*t43
      t69 = spvak2k1(iv2)
      t70 = t19*t69
      t71 = t22*t43
      t72 = spvak2k6(iv2)
      t73 = t19*t72
      t74 = t23*t43
      t75 = t19*t29
      t76 = t16*t33
      t77 = t16*t41
      t78 = t16*t43
      t79 = t17*t31
      t80 = t18*t31
      t81 = t19*t31
      t82 = t25*t43
      t83 = spvak5k1(iv2)
      t84 = t19*t83
      t85 = t17*t41
      t86 = t17*t43
      t87 = t18*t33
      t88 = t19*t33
      t89 = t18*t43
      t90 = t19*t41
      t91 = t12*t72
      t92 = t12*t29
      t93 = t12*t83
      t94 = t12*t33
      t95 = t22*t24
      t96 = t23*t24
      t97 = t24*t25
      t98 = t17*t24
      t99 = t13*t72
      t100 = t13*t29
      t101 = t13*t83
      t102 = t22*t28
      t103 = t23*t28
      t104 = t25*t28
      t105 = t15*t72
      t106 = t15*t83
      t107 = t20*t22
      t108 = t20*t25
      t109 = t21*t31
      t110 = t21*t33
      t111 = t16*t69
      t112 = t17*t69
      t113 = t26*t33
      t114 = spvak2k4(iv2)
      t115 = t114*t17
      t116 = t27*t33
      t117 = spvak2k5(iv2)
      t118 = t117*t17
      t119 = t22*t31
      t120 = t16*t72
      t121 = t23*t33
      t122 = t17*t29
      t123 = t76*abb92n139
      t124 = t79*abb92n139
      t125 = t25*t33
      t126 = t17*t83
      t127 = t86*abb92n123
      t128 = t88*abb92n123
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t186*abb92n97+t1*t186*abb92n116+t15*t20*abb92n13&
         &2+t181*t186*abb92n133+t182*t186*abb92n124+t183*t186*abb92n134+t184*t18&
         &6*abb92n136+t185*t186*abb92n130+t186*t2*abb92n144+t186*t3*abb92n164+t1&
         &86*t4*abb92n146+t186*t5*abb92n156+t1*t186*t2*abb92n95+t1*t186*t3*abb92&
         &n82+t1*t186*t4*abb92n99+t186*t2*t4*abb92n106+t186*t2*t5*abb92n83+t186*&
         &t2*t6*abb92n87+t186*t2*t8*abb92n104+t186*t4*t5*abb92n78)+t123*t183+t12&
         &3*t185+t124*t183+t124*t185+t127*t183+t127*t184+t128*t183+t128*t184+t30&
         &*abb92n85+t32*abb92n107+t34*abb92n92+t36*abb92n85+t37*abb92n107+t38*ab&
         &b92n92+t40*abb92n111+t42*abb92n80+t44*abb92n94+t45*abb92n111+t46*abb92&
         &n80+t47*abb92n94+t48*abb92n93+t49*abb92n93+t50*abb92n84+t51*abb92n107+&
         &t52*abb92n100+t53*abb92n98+t54*abb92n84+t55*abb92n107+t56*abb92n100+t5&
         &7*abb92n98+t58*abb92n157+t59*abb92n117+t60*abb92n147+t61*abb92n165+t62&
         &*abb92n145+t63*abb92n157+t64*abb92n117+t65*abb92n147+t66*abb92n165+t67&
         &*abb92n145+t68*abb92n90+t70*abb92n90+t71*abb92n96+t73*abb92n96+t74*abb&
         &92n86+t75*abb92n86+t76*abb92n110+t77*abb92n108+t78*abb92n109+t79*abb92&
         &n110+t80*abb92n108+t81*abb92n109+t82*abb92n89+t84*abb92n89+t85*abb92n7&
         &9+t86*abb92n91+t87*abb92n79+t88*abb92n91+t89*abb92n88+t90*abb92n88+t1*&
         &t34*abb92n139+t1*t38*abb92n139+t1*t42*abb92n163+t1*t44*abb92n143+t1*t4&
         &6*abb92n163+t1*t47*abb92n143+t1*t52*abb92n139+t1*t56*abb92n139+t1*t60*&
         &abb92n138+t1*t61*abb92n162+t1*t62*abb92n142+t1*t65*abb92n138+t1*t66*ab&
         &b92n162+t1*t67*abb92n142+t1*t68*abb92n158+t1*t70*abb92n158+t1*t71*abb9&
         &2n118+t1*t73*abb92n118+t1*t85*abb92n170+t1*t86*abb92n148+t1*t87*abb92n&
         &170+t1*t88*abb92n148+t10*t86*abb92n149+t10*t88*abb92n149+t100*t2*abb92&
         &n159+t101*t2*abb92n155+t102*t2*abb92n126+t103*t2*abb92n159+t104*t2*abb&
         &92n155+t105*t2*abb92n127+t106*t2*abb92n153+t107*t2*abb92n127+t108*t2*a&
         &bb92n153+t109*t2*abb92n158+t11*t20*abb92n131+t11*t24*abb92n101+t11*t28&
         &*abb92n105+t110*t2*abb92n150+t111*t2*abb92n158+t112*t2*abb92n150+t113*&
         &t2*abb92n149+t115*t2*abb92n149+t116*t2*abb92n128+t118*t2*abb92n128+t11&
         &9*t2*abb92n118+t12*t20*abb92n137+t12*t35*abb92n101+t12*t39*abb92n103+t&
         &120*t2*abb92n118+t121*t181*abb92n78+t121*t183*abb92n168+t121*t185*abb9&
         &2n166+t121*t2*abb92n169+t122*t181*abb92n78+t122*t183*abb92n168+t122*t1&
         &85*abb92n166+t122*t2*abb92n169+t125*t2*abb92n151+t126*t2*abb92n151+t13&
         &*t20*abb92n125+t13*t35*abb92n105+t13*t39*abb92n105+t13*t41*abb92n81+t1&
         &4*t20*abb92n135+t14*t24*abb92n103+t14*t28*abb92n105+t15*t24*abb92n137+&
         &t15*t28*abb92n125+t15*t35*abb92n131+t15*t39*abb92n135+t18*t28*abb92n81&
         &+t181*t71*abb92n104+t181*t73*abb92n104+t181*t74*abb92n83+t181*t75*abb9&
         &2n83+t181*t76*abb92n99+t181*t77*abb92n82+t181*t78*abb92n95+t181*t79*ab&
         &b92n99+t181*t80*abb92n82+t181*t81*abb92n95+t181*t82*abb92n87+t181*t84*&
         &abb92n87+t181*t86*abb92n106+t181*t88*abb92n106+t182*t71*abb92n126+t182&
         &*t73*abb92n126+t182*t74*abb92n159+t182*t75*abb92n159+t182*t82*abb92n15&
         &5+t182*t84*abb92n155+t184*t71*abb92n129+t184*t73*abb92n129+t184*t74*ab&
         &b92n161+t184*t75*abb92n161+t184*t77*abb92n163+t184*t78*abb92n143+t184*&
         &t80*abb92n163+t184*t81*abb92n143+t184*t82*abb92n152+t184*t84*abb92n152&
         &+t2*t40*abb92n143+t2*t45*abb92n143+t2*t52*abb92n123+t2*t56*abb92n123+t&
         &2*t58*abb92n160+t2*t59*abb92n142+t2*t60*abb92n122+t2*t63*abb92n160+t2*&
         &t64*abb92n142+t2*t65*abb92n122+t2*t76*abb92n148+t2*t79*abb92n148+t2*t8&
         &5*abb92n154+t2*t87*abb92n154+t2*t91*abb92n129+t2*t92*abb92n161+t2*t93*&
         &abb92n152+t2*t94*abb92n123+t2*t95*abb92n129+t2*t96*abb92n161+t2*t97*ab&
         &b92n152+t2*t98*abb92n123+t2*t99*abb92n126+t3*t40*abb92n163+t3*t45*abb9&
         &2n163+t3*t59*abb92n162+t3*t64*abb92n162+t3*t76*abb92n170+t3*t79*abb92n&
         &170+t3*t86*abb92n154+t3*t88*abb92n154+t30*t4*abb92n166+t32*t4*abb92n13&
         &9+t34*t5*abb92n166+t36*t4*abb92n166+t37*t4*abb92n139+t38*t5*abb92n166+&
         &t4*t44*abb92n123+t4*t47*abb92n123+t4*t50*abb92n168+t4*t51*abb92n139+t4&
         &*t53*abb92n123+t4*t54*abb92n168+t4*t55*abb92n139+t4*t57*abb92n123+t4*t&
         &58*abb92n167+t4*t59*abb92n138+t4*t62*abb92n122+t4*t63*abb92n167+t4*t64&
         &*abb92n138+t4*t67*abb92n122+t4*t68*abb92n150+t4*t70*abb92n150+t4*t74*a&
         &bb92n169+t4*t75*abb92n169+t4*t77*abb92n170+t4*t78*abb92n148+t4*t80*abb&
         &92n170+t4*t81*abb92n148+t4*t82*abb92n151+t4*t84*abb92n151+t4*t89*abb92&
         &n154+t4*t90*abb92n154+t44*t5*abb92n161+t44*t6*abb92n152+t44*t8*abb92n1&
         &29+t47*t5*abb92n161+t47*t6*abb92n152+t47*t8*abb92n129+t48*t5*abb92n159&
         &+t48*t6*abb92n155+t48*t8*abb92n126+t49*t5*abb92n159+t49*t6*abb92n155+t&
         &49*t8*abb92n126+t5*t52*abb92n168+t5*t56*abb92n168+t5*t60*abb92n167+t5*&
         &t62*abb92n160+t5*t65*abb92n167+t5*t67*abb92n160+t5*t86*abb92n169+t5*t8&
         &8*abb92n169+t6*t62*abb92n153+t6*t67*abb92n153+t6*t86*abb92n151+t6*t88*&
         &abb92n151+t62*t8*abb92n127+t67*t8*abb92n127+t7*t78*abb92n158+t7*t81*ab&
         &b92n158+t7*t86*abb92n150+t7*t88*abb92n150+t78*t8*abb92n118+t8*t81*abb9&
         &2n118+t86*t9*abb92n128+t88*t9*abb92n128+t1*t110*t2*abb92n77+t1*t112*t2&
         &*abb92n77+t1*t4*t68*abb92n77+t1*t4*t70*abb92n77+t1*t7*t86*abb92n77+t1*&
         &t7*t88*abb92n77+t109*t2*t4*abb92n77+t111*t2*t4*abb92n77+t114*t19*t4*ab&
         &b92n149+t117*t19*t4*abb92n128+t2*t7*t76*abb92n77+t2*t7*t79*abb92n77+t2&
         &6*t4*t43*abb92n149+t27*t4*t43*abb92n128+t4*t7*t78*abb92n77+t4*t7*t81*a&
         &bb92n77)
         return
      end if
      t181 = d(iv2,iv3)
      t182 = d(iv1,iv3)
      t9 = k1(iv3)
      t10 = k2(iv3)
      t34 = k5(iv3)
      t38 = k6(iv3)
      t42 = qshift(iv3)
      t44 = t181*t23
      t46 = t182*t29
      t47 = spvak3k1(iv3)
      t48 = t186*t47
      t49 = t16*t181
      t53 = t182*t31
      t57 = spvak3k4(iv3)
      t61 = t186*t57
      t62 = t17*t181
      t66 = t182*t33
      t67 = spvak5k6(iv3)
      t68 = t186*t67
      t70 = t18*t181
      t89 = t182*t41
      t90 = spvak6k1(iv3)
      t123 = t186*t90
      t124 = t181*t19
      t127 = t182*t43
      t128 = spvak6k5(iv3)
      t129 = t128*t186
      t130 = spvak2k6(iv3)
      t131 = spvak5k1(iv3)
      t132 = t12*t57
      t133 = t24*t57
      t134 = t10*t16
      t135 = t10*t31
      t136 = t15*t47
      t137 = t15*t57
      t138 = t20*t47
      t139 = t20*t57
      t140 = t23*t42
      t141 = t29*t42
      t142 = t16*t42
      t143 = t31*t42
      t144 = t109*t128
      t145 = t21*t57
      t146 = t145*t43
      t110 = t110*t128
      t147 = t21*t43*t67
      t148 = t111*t128
      t149 = t57*t69
      t150 = t149*t19
      t112 = t112*t128
      t151 = t19*t67*t69
      t152 = spvak2k1(iv3)
      t153 = t152*t16
      t154 = t153*t43
      t155 = t152*t31
      t156 = t155*t19
      t157 = t152*t17*t43
      t158 = t152*t19*t33
      t159 = spvak2k4(iv3)
      t160 = spvak2k5(iv3)
      t161 = t23*t67
      t162 = t29*t67
      t163 = t17*t47
      t164 = t33*t47
      t165 = t128*t76
      t166 = t16*t67
      t167 = t166*t43
      t168 = t128*t79
      t169 = t31*t67
      t170 = t169*t19
      t171 = t17*t57
      t172 = t171*t43
      t173 = t33*t57
      t174 = t173*t19
      t175 = t109*t67
      t176 = t145*t33
      t177 = t111*t67
      t178 = t149*t17
      t179 = t153*t33
      t180 = t155*t17
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t123*abb92n164+t124*abb92n144+t127*abb92n144+t12&
         &9*abb92n144+t44*abb92n156+t46*abb92n156+t48*abb92n156+t49*abb92n116+t5&
         &3*abb92n116+t61*abb92n116+t62*abb92n146+t66*abb92n146+t68*abb92n146+t7&
         &0*abb92n164+t89*abb92n164+t1*t123*abb92n82+t1*t124*abb92n95+t1*t127*ab&
         &b92n95+t1*t129*abb92n95+t1*t62*abb92n99+t1*t66*abb92n99+t1*t68*abb92n9&
         &9+t1*t70*abb92n82+t1*t89*abb92n82+t10*t186*abb92n136+t11*t181*abb92n13&
         &0+t12*t181*abb92n136+t124*t4*abb92n106+t124*t5*abb92n83+t124*t6*abb92n&
         &87+t124*t8*abb92n104+t127*t4*abb92n106+t127*t5*abb92n83+t127*t6*abb92n&
         &87+t127*t8*abb92n104+t129*t4*abb92n106+t129*t5*abb92n83+t129*t6*abb92n&
         &87+t129*t8*abb92n104+t13*t181*abb92n124+t14*t181*abb92n134+t15*t181*ab&
         &b92n132+t182*t20*abb92n132+t182*t24*abb92n136+t182*t28*abb92n124+t182*&
         &t35*abb92n130+t182*t39*abb92n134+t186*t34*abb92n124+t186*t38*abb92n134&
         &+t186*t42*abb92n132+t186*t9*abb92n130+t2*t44*abb92n83+t2*t46*abb92n83+&
         &t2*t48*abb92n83+t2*t49*abb92n95+t2*t53*abb92n95+t2*t61*abb92n95+t2*t62&
         &*abb92n106+t2*t66*abb92n106+t2*t68*abb92n106+t3*t49*abb92n82+t3*t53*ab&
         &b92n82+t3*t61*abb92n82+t4*t44*abb92n78+t4*t46*abb92n78+t4*t48*abb92n78&
         &+t4*t49*abb92n99+t4*t53*abb92n99+t4*t61*abb92n99+t5*t62*abb92n78+t5*t6&
         &6*abb92n78+t5*t68*abb92n78+t130*t186*t2*abb92n104+t131*t186*t2*abb92n8&
         &7+t181*t2*t22*abb92n104+t181*t2*t25*abb92n87+t182*t2*t72*abb92n104+t18&
         &2*t2*t83*abb92n87)+t110*abb92n150+t112*abb92n150+t144*abb92n158+t146*a&
         &bb92n158+t147*abb92n150+t148*abb92n158+t150*abb92n158+t151*abb92n150+t&
         &154*abb92n158+t156*abb92n158+t157*abb92n150+t158*abb92n150+t165*abb92n&
         &148+t167*abb92n148+t168*abb92n148+t170*abb92n148+t172*abb92n148+t174*a&
         &bb92n148+t1*t110*abb92n77+t1*t112*abb92n77+t1*t147*abb92n77+t1*t151*ab&
         &b92n77+t1*t157*abb92n77+t1*t158*abb92n77+t100*t128*abb92n159+t101*t128&
         &*abb92n155+t102*t128*abb92n126+t103*t128*abb92n159+t104*t128*abb92n155&
         &+t105*t128*abb92n127+t106*t128*abb92n153+t107*t128*abb92n127+t108*t128&
         &*abb92n153+t113*t128*abb92n149+t115*t128*abb92n149+t116*t128*abb92n128&
         &+t118*t128*abb92n128+t119*t128*abb92n118+t120*t128*abb92n118+t121*t128&
         &*abb92n169+t122*t128*abb92n169+t125*t128*abb92n151+t126*t128*abb92n151&
         &+t128*t40*abb92n143+t128*t45*abb92n143+t128*t52*abb92n123+t128*t56*abb&
         &92n123+t128*t58*abb92n160+t128*t59*abb92n142+t128*t60*abb92n122+t128*t&
         &63*abb92n160+t128*t64*abb92n142+t128*t65*abb92n122+t128*t85*abb92n154+&
         &t128*t87*abb92n154+t128*t91*abb92n129+t128*t92*abb92n161+t128*t93*abb9&
         &2n152+t128*t94*abb92n123+t128*t95*abb92n129+t128*t96*abb92n161+t128*t9&
         &7*abb92n152+t128*t98*abb92n123+t128*t99*abb92n126+t132*t41*abb92n163+t&
         &132*t43*abb92n143+t133*t18*abb92n163+t133*t19*abb92n143+t134*t41*abb92&
         &n163+t134*t43*abb92n143+t135*t18*abb92n163+t135*t19*abb92n143+t136*t33&
         &*abb92n167+t136*t43*abb92n160+t137*t33*abb92n138+t137*t41*abb92n162+t1&
         &37*t43*abb92n142+t138*t17*abb92n167+t138*t19*abb92n160+t139*t17*abb92n&
         &138+t139*t18*abb92n162+t139*t19*abb92n142+t140*t33*abb92n167+t140*t43*&
         &abb92n160+t141*t17*abb92n167+t141*t19*abb92n160+t142*t33*abb92n138+t14&
         &2*t41*abb92n162+t142*t43*abb92n142+t143*t17*abb92n138+t143*t18*abb92n1&
         &62+t143*t19*abb92n142+t144*t4*abb92n77+t146*t4*abb92n77+t148*t4*abb92n&
         &77+t150*t4*abb92n77+t154*t4*abb92n77+t156*t4*abb92n77+t161*t43*abb92n1&
         &69+t162*t19*abb92n169+t163*t43*abb92n169+t164*t19*abb92n169+t165*t7*ab&
         &b92n77+t166*t41*abb92n170+t167*t7*abb92n77+t168*t7*abb92n77+t169*t18*a&
         &bb92n170+t170*t7*abb92n77+t171*t41*abb92n170+t172*t7*abb92n77+t173*t18&
         &*abb92n170+t174*t7*abb92n77+t175*t2*abb92n77+t176*t2*abb92n77+t177*t2*&
         &abb92n77+t178*t2*abb92n77+t179*t2*abb92n77+t180*t2*abb92n77+t30*t67*ab&
         &b92n166+t32*t67*abb92n139+t36*t67*abb92n166+t37*t67*abb92n139+t40*t90*&
         &abb92n163+t45*t90*abb92n163+t50*t67*abb92n168+t51*t67*abb92n139+t54*t6&
         &7*abb92n168+t55*t67*abb92n139+t58*t67*abb92n167+t59*t67*abb92n138+t59*&
         &t90*abb92n162+t63*t67*abb92n167+t64*t67*abb92n138+t64*t90*abb92n162+t7&
         &6*t90*abb92n170+t79*t90*abb92n170+t10*t17*t43*abb92n123+t10*t19*t29*ab&
         &b92n161+t10*t19*t33*abb92n123+t10*t19*t72*abb92n129+t10*t19*t83*abb92n&
         &152+t10*t22*t43*abb92n129+t10*t23*t43*abb92n161+t10*t25*t43*abb92n152+&
         &t11*t33*t47*abb92n166+t11*t33*t57*abb92n139+t114*t19*t67*abb92n149+t11&
         &7*t19*t67*abb92n128+t12*t130*t43*abb92n129+t12*t131*t43*abb92n152+t12*&
         &t43*t47*abb92n161+t12*t43*t67*abb92n123+t13*t130*t43*abb92n126+t13*t13&
         &1*t43*abb92n155+t13*t43*t47*abb92n159+t130*t15*t43*abb92n127+t130*t16*&
         &t43*abb92n118+t130*t19*t20*abb92n127+t130*t19*t24*abb92n129+t130*t19*t&
         &28*abb92n126+t130*t19*t31*abb92n118+t131*t15*t43*abb92n153+t131*t17*t4&
         &3*abb92n151+t131*t19*t20*abb92n153+t131*t19*t24*abb92n152+t131*t19*t28&
         &*abb92n155+t131*t19*t33*abb92n151+t14*t33*t47*abb92n168+t14*t33*t57*ab&
         &b92n139+t14*t43*t67*abb92n123+t15*t43*t67*abb92n122+t159*t17*t43*abb92&
         &n149+t159*t19*t33*abb92n149+t16*t33*t38*abb92n139+t16*t33*t9*abb92n139&
         &+t160*t17*t43*abb92n128+t160*t19*t33*abb92n128+t17*t29*t38*abb92n168+t&
         &17*t29*t9*abb92n166+t17*t31*t38*abb92n139+t17*t31*t9*abb92n139+t17*t35&
         &*t47*abb92n166+t17*t35*t57*abb92n139+t17*t38*t43*abb92n123+t17*t39*t47&
         &*abb92n168+t17*t39*t57*abb92n139+t17*t42*t43*abb92n122+t17*t43*t90*abb&
         &92n154+t18*t43*t67*abb92n154+t19*t20*t67*abb92n122+t19*t24*t47*abb92n1&
         &61+t19*t24*t67*abb92n123+t19*t28*t47*abb92n159+t19*t29*t34*abb92n159+t&
         &19*t33*t38*abb92n123+t19*t33*t42*abb92n122+t19*t33*t90*abb92n154+t19*t&
         &34*t72*abb92n126+t19*t34*t83*abb92n155+t19*t39*t67*abb92n123+t19*t41*t&
         &67*abb92n154+t19*t42*t72*abb92n127+t19*t42*t83*abb92n153+t19*t57*t72*a&
         &bb92n118+t19*t67*t83*abb92n151+t22*t34*t43*abb92n126+t22*t42*t43*abb92&
         &n127+t22*t43*t57*abb92n118+t23*t33*t38*abb92n168+t23*t33*t9*abb92n166+&
         &t23*t34*t43*abb92n159+t25*t34*t43*abb92n155+t25*t42*t43*abb92n153+t25*&
         &t43*t67*abb92n151+t26*t43*t67*abb92n149+t27*t43*t67*abb92n128)
         return
      end if
      t183 = d(iv3,iv4)
      t184 = d(iv2,iv4)
      t185 = d(iv1,iv4)
      t1 = spvak6k5(iv4)
      t2 = spvak2k6(iv4)
      t3 = spvak5k6(iv4)
      t4 = spvak3k1(iv4)
      t5 = spvak6k1(iv4)
      t6 = spvak3k4(iv4)
      t7 = spvak5k1(iv4)
      t8 = t21*t6
      t9 = t6*t69
      t10 = t152*t6
      t11 = spvak2k1(iv4)
      t12 = t11*t16
      t13 = t11*t31
      t11 = t11*t57
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t181*t185*abb92n102+t182*t184*abb92n102+t183*t18&
         &6*abb92n102)+(2.0_ki)*(t121*t183*abb92n78+t122*t183*abb92n78+t161*t184&
         &*abb92n78+t162*t185*abb92n78+t163*t184*abb92n78+t164*t185*abb92n78+t16&
         &6*t184*abb92n99+t169*t185*abb92n99+t171*t184*abb92n99+t173*t185*abb92n&
         &99+t183*t71*abb92n104+t183*t73*abb92n104+t183*t74*abb92n83+t183*t75*ab&
         &b92n83+t183*t76*abb92n99+t183*t77*abb92n82+t183*t78*abb92n95+t183*t79*&
         &abb92n99+t183*t80*abb92n82+t183*t81*abb92n95+t183*t82*abb92n87+t183*t8&
         &4*abb92n87+t183*t86*abb92n106+t183*t88*abb92n106+t1*t130*t186*abb92n10&
         &4+t1*t131*t186*abb92n87+t1*t16*t181*abb92n95+t1*t17*t181*abb92n106+t1*&
         &t181*t22*abb92n104+t1*t181*t23*abb92n83+t1*t181*t25*abb92n87+t1*t182*t&
         &29*abb92n83+t1*t182*t31*abb92n95+t1*t182*t33*abb92n106+t1*t182*t72*abb&
         &92n104+t1*t182*t83*abb92n87+t1*t186*t47*abb92n83+t1*t186*t57*abb92n95+&
         &t1*t186*t67*abb92n106+t128*t16*t184*abb92n95+t128*t17*t184*abb92n106+t&
         &128*t184*t22*abb92n104+t128*t184*t23*abb92n83+t128*t184*t25*abb92n87+t&
         &128*t185*t29*abb92n83+t128*t185*t31*abb92n95+t128*t185*t33*abb92n106+t&
         &128*t185*t72*abb92n104+t128*t185*t83*abb92n87+t128*t186*t2*abb92n104+t&
         &128*t186*t3*abb92n106+t128*t186*t4*abb92n83+t128*t186*t6*abb92n95+t128&
         &*t186*t7*abb92n87+t130*t184*t19*abb92n104+t130*t185*t43*abb92n104+t131&
         &*t184*t19*abb92n87+t131*t185*t43*abb92n87+t16*t181*t3*abb92n99+t16*t18&
         &1*t5*abb92n82+t16*t184*t90*abb92n82+t17*t181*t4*abb92n78+t17*t181*t6*a&
         &bb92n99+t18*t181*t6*abb92n82+t18*t184*t57*abb92n82+t181*t19*t2*abb92n1&
         &04+t181*t19*t3*abb92n106+t181*t19*t4*abb92n83+t181*t19*t6*abb92n95+t18&
         &1*t19*t7*abb92n87+t181*t23*t3*abb92n78+t182*t2*t43*abb92n104+t182*t29*&
         &t3*abb92n78+t182*t3*t31*abb92n99+t182*t3*t43*abb92n106+t182*t31*t5*abb&
         &92n82+t182*t33*t4*abb92n78+t182*t33*t6*abb92n99+t182*t4*t43*abb92n83+t&
         &182*t41*t6*abb92n82+t182*t43*t6*abb92n95+t182*t43*t7*abb92n87+t184*t19&
         &*t47*abb92n83+t184*t19*t57*abb92n95+t184*t19*t67*abb92n106+t185*t31*t9&
         &0*abb92n82+t185*t41*t57*abb92n82+t185*t43*t47*abb92n83+t185*t43*t57*ab&
         &b92n95+t185*t43*t67*abb92n106+t186*t3*t47*abb92n78+t186*t3*t57*abb92n9&
         &9+t186*t4*t67*abb92n78+t186*t5*t57*abb92n82+t186*t6*t67*abb92n99+t186*&
         &t6*t90*abb92n82)+t1*t175*abb92n77+t1*t176*abb92n77+t1*t177*abb92n77+t1&
         &*t178*abb92n77+t1*t179*abb92n77+t1*t180*abb92n77+t10*t17*t43*abb92n77+&
         &t10*t19*t33*abb92n77+t109*t128*t3*abb92n77+t11*t17*t43*abb92n77+t11*t1&
         &9*t33*abb92n77+t111*t128*t3*abb92n77+t12*t128*t33*abb92n77+t12*t43*t67&
         &*abb92n77+t128*t13*t17*abb92n77+t128*t17*t9*abb92n77+t128*t33*t8*abb92&
         &n77+t13*t19*t67*abb92n77+t145*t3*t43*abb92n77+t149*t19*t3*abb92n77+t15&
         &3*t3*t43*abb92n77+t155*t19*t3*abb92n77+t19*t67*t9*abb92n77+t43*t67*t8*&
         &abb92n77)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d92:
   subroutine     reconstruct_d92(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group1
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group1), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_92:
      coeffs%coeffs_92%c0 = derivative(czip)
      coeffs%coeffs_92%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_92%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_92%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_92%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_92%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_92%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_92%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_92%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_92%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_92%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_92%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_92%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_92%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_92%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_92%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_92%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_92%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_92%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_92%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_92%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_92%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_92%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_92%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_92%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_92%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_92%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_92%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_92%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_92%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_92%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_92%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_92%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_92%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_92%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_92%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_92%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_92%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_92%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_92%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_92%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_92%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_92%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_92%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_92%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_92%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_92%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_92%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_92%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_92%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_92%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_92%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_92%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_92%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_92%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_92%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_92%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_92%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_92%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_92%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_92%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_92%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_92%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_92%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_92%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_92%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_92%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_92%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_92%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_92%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_92:
   end subroutine reconstruct_d92
!---#] subroutine reconstruct_d92:
end module p26_udbar_neepgg_d92h3l1d
