module     p3_ud_emnebaruu_abbrevd51h0
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_globalsh0
   implicit none
   private
   complex(ki), public :: abb51n1
   complex(ki), public :: abb51n2
   complex(ki), public :: abb51n3
   complex(ki), public :: abb51n4
   complex(ki), public :: abb51n5
   complex(ki), public :: abb51n6
   complex(ki), public :: abb51n7
   complex(ki), public :: abb51n8
   complex(ki), public :: abb51n9
   complex(ki), public :: rat2d51
   complex(ki), public :: abb51n11
   complex(ki), public :: abb51n12
   complex(ki), public :: abb51n13
   complex(ki), public :: abb51n14
   complex(ki), public :: abb51n15
   complex(ki), public :: abb51n16
   complex(ki), public :: abb51n17
   complex(ki), public :: abb51n18
   complex(ki), public :: abb51n19
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   real(ki) :: t33
   real(ki) :: t34
   real(ki) :: t35
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p3_ud_emnebaruu_config, only: deltaOS
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_model
      use p3_ud_emnebaruu_color, only: TR
      use p3_ud_emnebaruu_globalsl1, only: epspow
      implicit none
      t33 = es12+es34-(es56+es345)
      t1 = es34*c1*i_
      t34 = TR*TR
      t2 = t34*t1*spak3k5*spak3k6*spbk2k1*spbk4k3
      t3 = (es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t35 = t33*t33
      t4 = t35*t3
      t1 = t34*t1*spak3k6*spak5k6*spbk2k1*spbk6k4
      t5 = es345*c1*i_
      t6 = t34*t5*spak3k5*spak3k6*spbk2k1*spbk4k3
      t5 = t34*t5*spak3k6*spak5k6*spbk2k1*spbk6k4
      t7 = es56*c1*i_
      t8 = t34*t7*spak3k5*spak3k6*spbk2k1*spbk4k3
      t7 = t34*t7*spak3k6*spak5k6*spbk2k1*spbk6k4
      t9 = c1*i_
      t10 = t9*spak1k3
      t11 = TR*spbk2k1
      t11 = t11*t11
      t12 = t10*t11*spak2k5*spak3k6*spbk4k3
      t13 = t9*spak1k5
      t14 = t11*t13*spak2k3*spak3k6*spbk4k3
      t15 = t11*t13*spak2k6*spak3k6*spbk6k4
      t16 = t9*spak1k6
      t17 = t11*t16*spak2k5*spak3k6*spbk6k4
      t33 = t33*NC
      t18 = t33*t33*t3
      t19 = es34*c2*i_
      t3 = NC*t35*t3
      t20 = es345*c2*i_
      t21 = es56*c2*i_
      t22 = c2*i_
      t23 = t22*spak1k3
      t24 = t22*spak1k5
      t25 = t22*spak1k6
      t26 = NC*c2
      t27 = es34*t26*i_
      t28 = es345*t26*i_
      t29 = es56*t26*i_
      t26 = t26*i_
      t30 = t26*spak1k3
      t31 = t26*spak1k5
      t32 = t26*spak1k6
      abb51n1 = ((4.0_ki)*(t1/t4+t12/t4+t14/t18+t15/t4+t17/t18+t5/t18+t6/t18+t7/&
      &t18+t8/t18+t2/t4+t11*t23/t3*spak2k5*spak3k6*spbk4k3+t11*t24/t3*spak2k6*sp&
      &ak3k6*spbk6k4+t11*t31/t4*spak2k3*spak3k6*spbk4k3+t11*t32/t4*spak2k5*spak3&
      &k6*spbk6k4+t34*t19/t3*spak3k5*spak3k6*spbk2k1*spbk4k3+t34*t19/t3*spak3k6*&
      &spak5k6*spbk2k1*spbk6k4+t34*t28/t4*spak3k5*spak3k6*spbk2k1*spbk4k3+t34*t2&
      &8/t4*spak3k6*spak5k6*spbk2k1*spbk6k4+t34*t29/t4*spak3k5*spak3k6*spbk2k1*s&
      &pbk4k3+t34*t29/t4*spak3k6*spak5k6*spbk2k1*spbk6k4-(t34*t27/t4*spak3k6*spa&
      &k5k6*spbk2k1*spbk6k4+t34*t27/t4*spak3k5*spak3k6*spbk2k1*spbk4k3+t34*t21/t&
      &3*spak3k6*spak5k6*spbk2k1*spbk6k4+t34*t21/t3*spak3k5*spak3k6*spbk2k1*spbk&
      &4k3+t34*t20/t3*spak3k6*spak5k6*spbk2k1*spbk6k4+t34*t20/t3*spak3k5*spak3k6&
      &*spbk2k1*spbk4k3+t11*t31/t4*spak2k6*spak3k6*spbk6k4+t11*t30/t4*spak2k5*sp&
      &ak3k6*spbk4k3+t11*t25/t3*spak2k5*spak3k6*spbk6k4+t11*t24/t3*spak2k3*spak3&
      &k6*spbk4k3+t8/t4+t7/t4+t6/t4+t5/t4+t2/t18+t17/t4+t15/t18+t14/t4+t12/t18+t&
      &1/t18)))
      t1 = t13*spak3k6*spbk2k1
      t2 = t34*t1*spbk4k3
      t5 = t24*spak3k6*spbk2k1
      t6 = t31*spak3k6*spbk2k1
      abb51n2 = ((4.0_ki)*(t2/t4+t34/t3*t5*spbk4k3-(t34/t4*t6*spbk4k3+t2/t18)))
      t1 = t34*t1*spbk6k4
      abb51n3 = ((4.0_ki)*(t1/t18+t34/t4*t6*spbk6k4-(t34/t3*t5*spbk6k4+t1/t4)))
      t1 = t9*spak2k5*spak3k6*spbk2k1
      t2 = t34*t1*spbk4k3
      t5 = t22*spak2k5*spak3k6*spbk2k1
      t6 = t26*spak2k5*spak3k6*spbk2k1
      abb51n4 = ((4.0_ki)*(t2/t4+t34/t3*t5*spbk4k3-(t34/t4*t6*spbk4k3+t2/t18)))
      t1 = t34*t1*spbk6k4
      abb51n5 = ((4.0_ki)*(t1/t18+t34/t4*t6*spbk6k4-(t34/t3*t5*spbk6k4+t1/t4)))
      t1 = t9*spak3k5*spak3k6
      t2 = t34*t1*spbk2k1*spbk4k3
      t5 = t2/t4
      t6 = t9*spak3k6*spak5k6
      t7 = t34*t6*spbk2k1*spbk6k4
      t8 = t7/t4
      t2 = t2/t18
      t7 = t7/t18
      t11 = t22*spak3k5*spak3k6
      t12 = t34*t11/t3*spbk2k1*spbk4k3
      t13 = t22*spak3k6*spak5k6
      t14 = t34*t13/t3*spbk2k1*spbk6k4
      t15 = t26*spak3k5*spak3k6
      t17 = t34*t15/t4*spbk2k1*spbk4k3
      t19 = t26*spak3k6*spak5k6
      t20 = t34*t19/t4*spbk2k1*spbk6k4
      abb51n6 = ((16.0_ki)*(t17+t2+t20+t7-(t8+t5+t14+t12)))
      abb51n7 = ((16.0_ki)*(t12+t14+t5+t8-(t7+t20+t2+t17)))
      t2 = t34*t9*spak2k3*spak3k6*spbk2k1*spbk4k3
      t5 = t34*t9*spak2k6*spak3k6*spbk2k1*spbk6k4
      t1 = t1*spbk4k3
      t7 = t34*t1*spbk5k1
      t8 = t34*t6*spbk5k1*spbk6k4
      t9 = t11*spbk4k3
      t11 = t15*spbk4k3
      abb51n8 = ((8.0_ki)*(t2/t18+t7/t18+t8/t18+t5/t4+t34*t11/t4*spbk5k1+t34*t19&
      &/t4*spbk5k1*spbk6k4+t34*t22/t3*spak2k6*spak3k6*spbk2k1*spbk6k4+t34*t26/t4&
      &*spak2k3*spak3k6*spbk2k1*spbk4k3-(t34*t26/t4*spak2k6*spak3k6*spbk2k1*spbk&
      &6k4+t34*t22/t3*spak2k3*spak3k6*spbk2k1*spbk4k3+t34*t13/t3*spbk5k1*spbk6k4&
      &+t34/t3*t9*spbk5k1+t8/t4+t7/t4+t2/t4+t5/t18)))
      t2 = t34*t10*spak3k6*spbk2k1*spbk4k3
      t5 = t34*t16*spak3k6*spbk2k1*spbk6k4
      t1 = t34*t1*spbk5k2
      t6 = t34*t6*spbk5k2*spbk6k4
      abb51n9 = ((8.0_ki)*(t1/t4+t2/t18+t5/t4+t6/t4+t34/t3*t9*spbk5k2+t34*t13/t3&
      &*spbk5k2*spbk6k4+t34*t25/t3*spak3k6*spbk2k1*spbk6k4+t34*t30/t4*spak3k6*sp&
      &bk2k1*spbk4k3-(t34*t32/t4*spak3k6*spbk2k1*spbk6k4+t34*t23/t3*spak3k6*spbk&
      &2k1*spbk4k3+t34*t19/t4*spbk5k2*spbk6k4+t34*t11/t4*spbk5k2+t2/t4+t6/t18+t5&
      &/t18+t1/t18)))
      rat2d51 = 0
      rat2 = rat2 + rat2d51
      abb51n11 = abb51n1
      abb51n12 = -(abb51n2)
      abb51n13 = -(abb51n3)
      abb51n14 = -(abb51n4)
      abb51n15 = -(abb51n5)
      abb51n16 = -(abb51n6)
      abb51n17 = -(abb51n7)
      abb51n18 = -(abb51n8)
      abb51n19 = -(abb51n9)
   end subroutine
end module p3_ud_emnebaruu_abbrevd51h0
