module     p3_ud_emnebaruu_abbrevd4h1
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_globalsh1
   implicit none
   private
   complex(ki), public :: abb4n1
   complex(ki), public :: abb4n2
   complex(ki), public :: abb4n3
   complex(ki), public :: abb4n4
   complex(ki), public :: abb4n5
   complex(ki), public :: abb4n6
   complex(ki), public :: abb4n7
   complex(ki), public :: abb4n8
   complex(ki), public :: abb4n9
   complex(ki), public :: abb4n10
   complex(ki), public :: abb4n11
   complex(ki), public :: abb4n12
   complex(ki), public :: abb4n13
   complex(ki), public :: abb4n14
   complex(ki), public :: abb4n15
   complex(ki), public :: abb4n16
   complex(ki), public :: abb4n17
   complex(ki), public :: abb4n18
   complex(ki), public :: abb4n19
   complex(ki), public :: abb4n20
   complex(ki), public :: abb4n21
   complex(ki), public :: abb4n22
   complex(ki), public :: abb4n23
   complex(ki), public :: abb4n24
   complex(ki), public :: abb4n25
   complex(ki), public :: abb4n26
   complex(ki), public :: abb4n27
   complex(ki), public :: abb4n28
   complex(ki), public :: abb4n29
   complex(ki), public :: abb4n30
   complex(ki), public :: rat2d4
   complex(ki), public :: abb4n32
   complex(ki), public :: abb4n33
   complex(ki), public :: abb4n34
   complex(ki), public :: abb4n35
   complex(ki), public :: abb4n36
   complex(ki), public :: abb4n37
   complex(ki), public :: abb4n38
   complex(ki), public :: abb4n39
   complex(ki), public :: abb4n40
   complex(ki), public :: abb4n41
   complex(ki), public :: abb4n42
   complex(ki), public :: abb4n43
   complex(ki), public :: abb4n44
   complex(ki), public :: abb4n45
   complex(ki), public :: abb4n46
   complex(ki), public :: abb4n47
   complex(ki), public :: abb4n48
   complex(ki), public :: abb4n49
   complex(ki), public :: abb4n50
   complex(ki), public :: abb4n51
   complex(ki), public :: abb4n52
   complex(ki), public :: abb4n53
   complex(ki), public :: abb4n54
   complex(ki), public :: abb4n55
   complex(ki), public :: abb4n56
   complex(ki), public :: abb4n57
   complex(ki), public :: abb4n58
   complex(ki), public :: abb4n59
   complex(ki), public :: abb4n60
   complex(ki), public :: abb4n61
   complex(ki), public :: abb4n62
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   real(ki) :: t33
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p3_ud_emnebaruu_config, only: deltaOS
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_model
      use p3_ud_emnebaruu_color, only: TR
      use p3_ud_emnebaruu_globalsl1, only: epspow
      implicit none
      t1 = es12*c1*i_
      t33 = TR*TR
      t2 = (es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t3 = NC*NC*t2
      t4 = t1*spak1k6
      t5 = es345*c1*i_
      t6 = t5*spak1k6
      t7 = es61*c1*i_
      t8 = t7*spak1k6
      t9 = es12*c2*i_
      t2 = NC*t2
      t10 = t9*spak1k6
      t11 = es345*c2*i_
      t12 = t11*spak1k6
      t13 = es61*c2*i_
      t14 = t13*spak1k6
      abb4n1 = ((4.0_ki)*(t33*t10/t2*spak3k6*spbk4k2*spbk6k5+t33*t14/t2*spak3k6*&
      &spbk4k2*spbk6k5+t33/t3*t6*spak3k6*spbk4k2*spbk6k5+t33*t1/t3*spak1k3*spak1&
      &k6*spbk4k2*spbk5k1+t33*t11/t2*spak1k3*spak1k6*spbk4k2*spbk5k1+t33/t3*t7*s&
      &pak1k3*spak1k6*spbk4k2*spbk5k1-(t33/t3*t5*spak1k3*spak1k6*spbk4k2*spbk5k1&
      &+t33/t2*t9*spak1k3*spak1k6*spbk4k2*spbk5k1+t33*t13/t2*spak1k3*spak1k6*spb&
      &k4k2*spbk5k1+t33/t3*t8*spak3k6*spbk4k2*spbk6k5+t33/t3*t4*spak3k6*spbk4k2*&
      &spbk6k5+t33*t12/t2*spak3k6*spbk4k2*spbk6k5)))
      t15 = c1*i_
      t16 = t15*spak1k3
      t17 = t16*spak2k6
      t18 = t33*t17/t3*spbk4k2*spbk5k2
      t19 = c2*i_
      t20 = t19*spak1k3
      t21 = t20*spak2k6
      t22 = t33*t21/t2*spbk4k2*spbk5k2
      abb4n2 = ((8.0_ki)*(t18-t22))
      abb4n3 = ((8.0_ki)*(t22-t18))
      t23 = t33*t16/t3*spbk4k2
      t24 = t33*t20/t2*spbk4k2
      abb4n4 = ((8.0_ki)*(t23-t24))
      t23 = t24-t23
      abb4n5 = ((4.0_ki)*t23)
      abb4n6 = ((8.0_ki)*t23)
      t23 = t15*spak3k6
      t24 = t19*spak3k6
      abb4n7 = ((4.0_ki)*(t33*t24/t2*spbk4k1-t33*t23/t3*spbk4k1))
      t25 = t15*spak1k5
      t26 = t25*spak2k6
      t27 = TR*spbk5k2
      t27 = t27*t27
      t28 = t19*spak1k5
      t29 = t28*spak2k6
      abb4n8 = ((4.0_ki)*(t26*t27/t3-t27/t2*t29))
      t27 = t15*spak1k6
      t30 = t27*spak3k6
      t31 = t19*spak1k6
      t32 = t31*spak3k6
      abb4n9 = ((4.0_ki)*(t33*t32/t2*spbk5k1*spbk6k4-t33*t30/t3*spbk5k1*spbk6k4)&
      &)
      abb4n10 = ((8.0_ki)*(t22+t33*t32/t2*spbk4k2*spbk6k5+t33*t16/t3*spak1k6*spb&
      &k4k2*spbk5k1-(t33*t20/t2*spak1k6*spbk4k2*spbk5k1+t33*t30/t3*spbk4k2*spbk6&
      &k5+t18)))
      t16 = TR*spak1k6
      t16 = t16*t16
      abb4n11 = ((4.0_ki)*(t33*t12/t2*spbk5k4+t33/t3*t4*spbk5k4+t33/t3*t8*spbk5k&
      &4+t15*t16/t3*spbk5k1*spbk6k4+t33*t29/t2*spbk5k2*spbk5k4+t33*t31/t2*spak2k&
      &6*spbk5k2*spbk6k4-(t33*t27/t3*spak2k6*spbk5k2*spbk6k4+t33*t26/t3*spbk5k2*&
      &spbk5k4+t16*t19/t2*spbk5k1*spbk6k4+t33/t3*t6*spbk5k4+t33*t14/t2*spbk5k4+t&
      &33*t10/t2*spbk5k4)))
      abb4n12 = ((8.0_ki)*(t33*t31/t2*spbk5k2-t33*t27/t3*spbk5k2))
      abb4n13 = ((4.0_ki)*(t22+t33*t32/t2*spbk5k2*spbk6k4+t33*t30/t3*spbk5k4*spb&
      &k6k2+t33*t28/t2*spak3k6*spbk5k2*spbk5k4-(t33*t25/t3*spak3k6*spbk5k2*spbk5&
      &k4+t33*t30/t3*spbk5k2*spbk6k4+t33*t32/t2*spbk5k4*spbk6k2+t18)))
      abb4n14 = ((4.0_ki)*(t33*t25/t3*spbk5k2+t33*t27/t3*spbk6k2-(t33*t31/t2*spb&
      &k6k2+t33*t28/t2*spbk5k2)))
      abb4n15 = ((4.0_ki)*(t33*t32/t2*spbk6k4*spbk6k5-t33*t30/t3*spbk6k4*spbk6k5&
      &))
      t4 = t33*t27/t3*spbk5k4
      t6 = t33*t31/t2*spbk5k4
      abb4n16 = ((8.0_ki)*(t4-t6))
      t4 = t6-t4
      abb4n17 = ((4.0_ki)*t4)
      abb4n18 = ((8.0_ki)*t4)
      abb4n19 = ((8.0_ki)*(t33*t31/t2*spbk6k5-t33*t27/t3*spbk6k5))
      t4 = t15*spak2k6
      t6 = t19*spak2k6
      abb4n20 = ((4.0_ki)*(t33*t13/t2*spak3k6*spbk4k2+t33*t17/t3*spbk2k1*spbk4k2&
      &+t33/t2*t9*spak3k6*spbk4k2+t33/t3*t5*spak3k6*spbk4k2+t33/t2*t6*spak3k5*sp&
      &bk4k2*spbk5k2-(t33/t3*t4*spak3k5*spbk4k2*spbk5k2+t33/t3*t7*spak3k6*spbk4k&
      &2+t33*t21/t2*spbk2k1*spbk4k2+t33*t11/t2*spak3k6*spbk4k2+t33*t1/t3*spak3k6&
      &*spbk4k2)))
      abb4n21 = ((4.0_ki)*(t33*t19/t2*spak3k5*spbk4k2-t33*t15/t3*spak3k5*spbk4k2&
      &))
      t1 = t33*t24/t2*spbk4k2-t33*t23/t3*spbk4k2
      abb4n22 = ((4.0_ki)*t1)
      abb4n23 = ((8.0_ki)*t1)
      t1 = t33*t23/t3*spbk5k4
      t5 = t33*t24/t2*spbk5k4
      t7 = t1-t5
      abb4n24 = ((8.0_ki)*t7)
      abb4n25 = ((4.0_ki)*t7)
      t1 = t5-t1
      abb4n26 = ((4.0_ki)*t1)
      abb4n27 = ((8.0_ki)*t1)
      abb4n28 = ((4.0_ki)*(t33*t24/t2*spbk6k4-t33*t23/t3*spbk6k4))
      abb4n29 = ((4.0_ki)*(t33/t2*t6*spbk4k2+t33*t27/t3*spbk4k1+t33*t15/t3*spak5&
      &k6*spbk5k4-(t33*t19/t2*spak5k6*spbk5k4+t33/t3*t4*spbk4k2+t33*t31/t2*spbk4&
      &k1)))
      abb4n30 = ((4.0_ki)*(t33*t19/t2-t33*t15/t3))
      rat2d4 = 0
      rat2 = rat2 + rat2d4
      abb4n32 = abb4n1
      abb4n33 = abb4n29
      abb4n34 = abb4n28
      abb4n35 = abb4n27
      abb4n36 = abb4n26
      abb4n37 = abb4n24
      abb4n38 = abb4n23
      abb4n39 = abb4n21
      abb4n40 = abb4n19
      abb4n41 = abb4n18
      abb4n42 = abb4n16
      abb4n43 = abb4n14
      abb4n44 = abb4n13
      abb4n45 = abb4n12
      abb4n46 = abb4n7
      abb4n47 = abb4n6
      abb4n48 = abb4n5
      abb4n49 = abb4n4
      abb4n50 = -(abb4n2)
      abb4n51 = -(abb4n3)
      abb4n52 = -(abb4n5)
      abb4n53 = -(abb4n8)
      abb4n54 = -(abb4n9)
      abb4n55 = -(abb4n10)
      abb4n56 = -(abb4n11)
      abb4n57 = -(abb4n15)
      abb4n58 = -(abb4n17)
      abb4n59 = -(abb4n20)
      abb4n60 = -(abb4n22)
      abb4n61 = -(abb4n25)
      abb4n62 = -(abb4n30)
   end subroutine
end module p3_ud_emnebaruu_abbrevd4h1
