module     p7_dubar_emnebargg_abbrevd15h0
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_globalsh0
   implicit none
   private
   complex(ki), public :: abb15n1
   complex(ki), public :: abb15n2
   complex(ki), public :: abb15n3
   complex(ki), public :: abb15n4
   complex(ki), public :: abb15n5
   complex(ki), public :: abb15n6
   complex(ki), public :: abb15n7
   complex(ki), public :: rat2d15
   complex(ki), public :: abb15n9
   complex(ki), public :: abb15n10
   complex(ki), public :: abb15n11
   complex(ki), public :: abb15n12
   complex(ki), public :: abb15n13
   complex(ki), public :: abb15n14
   complex(ki), public :: abb15n15
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   complex(ki) :: t44
   complex(ki) :: t45
   complex(ki) :: t46
   complex(ki) :: t47
   complex(ki) :: t48
   complex(ki) :: t49
   complex(ki) :: t50
   complex(ki) :: t51
   complex(ki) :: t52
   complex(ki) :: t53
   real(ki) :: t54
   real(ki) :: t55
   real(ki) :: t56
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_dubar_emnebargg_config, only: deltaOS
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_model
      use p7_dubar_emnebargg_color, only: TR
      use p7_dubar_emnebargg_globalsl1, only: epspow
      implicit none
      t54 = es234-(es61+es56)
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c2
      t3 = es56*t2
      t4 = es61*t3*i_*spak2k3
      t5 = NC*t1
      t6 = es234*t5
      t7 = t54*spak5k6
      t7 = t7*t7
      t8 = t6*t7
      t9 = NC*TR*c2
      t10 = es56*t9
      t11 = es61*t10*i_*spak2k3
      t12 = es234*t1
      t13 = t12*t7
      t3 = t3*i_
      t14 = t3*spak2k3
      t15 = t14*spak2k5
      t16 = t15*spbk4k2
      t17 = t16*spbk5k1
      t5 = t5*t7
      t14 = t14*spak3k5*spbk4k3
      t18 = t14*spbk5k1
      t19 = es61*t2*i_
      t20 = t19*spak2k3
      t21 = t20*spak2k5
      t22 = t21*spbk4k2
      t23 = t22*spbk5k1
      t20 = t20*spak3k5*spbk4k3
      t24 = t20*spbk5k1
      t10 = t10*i_
      t25 = t10*spak2k3
      t26 = t25*spak2k5
      t27 = t26*spbk4k2
      t28 = t27*spbk5k1
      t29 = t1*t7
      t25 = t25*spak3k5*spbk4k3
      t30 = t25*spbk5k1
      t31 = es61*t9*i_
      t32 = t31*spak2k3
      t33 = t32*spak2k5
      t34 = t33*spbk4k2
      t35 = t34*spbk5k1
      t32 = t32*spak3k5*spbk4k3
      t36 = t32*spbk5k1
      t37 = t2*i_
      t38 = t37*spak2k3
      t39 = t38*spak2k5
      t40 = t39*spbk4k2
      t41 = t40*spbk5k1
      t55 = es56*es56
      t38 = t38*spak3k5*spbk4k3
      t42 = t38*spbk5k1
      t56 = es61*es61
      t43 = t9*i_
      t44 = t43*spak2k3
      t45 = t44*spak2k5
      t46 = t45*spbk4k2
      t47 = t46*spbk5k1
      t44 = t44*spak3k5*spbk4k3
      t48 = t44*spbk5k1
      t2 = es234*t2*i_
      t49 = t2*spak2k3*spak2k5
      t1 = (es345-(es61+es12))*t1
      t50 = NC*t1
      t54 = t54*t54
      t51 = t54*t50*spak5k6
      t9 = es234*t9*i_
      t52 = t9*spak2k3*spak2k5
      t53 = t54*t1*spak5k6
      t50 = t50*t7
      t1 = t1*t7
      abb15n1 = ((8.0_ki)*(t11/t13*spak2k5*spbk4k2*spbk5k1+t4/t8*spak3k5*spbk4k3&
      &*spbk5k1-(t4/t8*spak2k5*spbk4k2*spbk5k1+t11/t13*spak3k5*spbk4k3*spbk5k1))&
      &+(4.0_ki)*(t17/t5+t23/t5+t30/t29+t36/t29+t55*t47/t13+t56*t47/t13+t55*t42/&
      &t8+t56*t42/t8+t15/t51*spbk5k1*spbk5k4*spbk6k2+t21/t51*spbk5k1*spbk5k4*spb&
      &k6k2+t52/t53*spbk5k1*spbk5k4*spbk6k2+t9/t1*spak1k6*spak2k3*spak2k5*spbk4k&
      &1*spbk5k1*spbk6k2+t19/t50*spak1k6*spak2k3*spak2k5*spbk4k1*spbk5k1*spbk6k2&
      &+t3/t50*spak1k6*spak2k3*spak2k5*spbk4k1*spbk5k1*spbk6k2-(t2/t50*spak1k6*s&
      &pak2k3*spak2k5*spbk4k1*spbk5k1*spbk6k2+t31/t1*spak1k6*spak2k3*spak2k5*spb&
      &k4k1*spbk5k1*spbk6k2+t10/t1*spak1k6*spak2k3*spak2k5*spbk4k1*spbk5k1*spbk6&
      &k2+t49/t51*spbk5k1*spbk5k4*spbk6k2+t33/t53*spbk5k1*spbk5k4*spbk6k2+t26/t5&
      &3*spbk5k1*spbk5k4*spbk6k2+t56*t41/t8+t55*t41/t8+t56*t48/t13+t55*t48/t13+t&
      &35/t29+t28/t29+t24/t5+t18/t5)))
      t2 = t39/t51*spbk5k1*spbk5k4*spbk6k2
      t3 = t45/t53*spbk5k1*spbk5k4*spbk6k2
      t4 = t17/t8
      t7 = t18/t8
      t9 = t28/t13
      t10 = t30/t13
      t11 = t23/t8
      t17 = t24/t8
      t18 = t35/t13
      t19 = t36/t13
      t23 = t37*spak1k6*spak2k3
      t24 = t23*spak2k5
      t28 = t24/t50*spbk4k1*spbk5k1*spbk6k2
      t30 = t43*spak1k6*spak2k3
      t31 = t30*spak2k5
      t35 = t31/t1*spbk4k1*spbk5k1*spbk6k2
      abb15n2 = ((16.0_ki)*(t2+t7+t9-(t4+t3+t10))+(8.0_ki)*(t17+t18+t28-(t35+t19&
      &+t11)))
      abb15n3 = ((8.0_ki)*(t10+t3+t4-(t9+t7+t2))+(16.0_ki)*(t11+t19+t35-(t28+t18&
      &+t17)))
      abb15n4 = ((8.0_ki)*(t25/t13*spbk6k1+t32/t13*spbk6k1+t16/t8*spbk6k1+t22/t8&
      &*spbk6k1+t46/t29*spbk6k1+t38/t5*spbk6k1+t52/t1*spbk4k1*spbk6k2+t15/t50*sp&
      &bk4k1*spbk6k2+t21/t50*spbk4k1*spbk6k2-(t49/t50*spbk4k1*spbk6k2+t33/t1*spb&
      &k4k1*spbk6k2+t26/t1*spbk4k1*spbk6k2+t40/t5*spbk6k1+t44/t29*spbk6k1+t20/t8&
      &*spbk6k1+t14/t8*spbk6k1+t34/t13*spbk6k1+t27/t13*spbk6k1)))
      abb15n5 = ((8.0_ki)*(t27/t13*spbk6k5+t34/t13*spbk6k5+t14/t8*spbk6k5+t20/t8&
      &*spbk6k5+t44/t29*spbk6k5+t40/t5*spbk6k5+t52/t1*spbk5k4*spbk6k2+t15/t50*sp&
      &bk5k4*spbk6k2+t21/t50*spbk5k4*spbk6k2-(t49/t50*spbk5k4*spbk6k2+t33/t1*spb&
      &k5k4*spbk6k2+t26/t1*spbk5k4*spbk6k2+t38/t5*spbk6k5+t46/t29*spbk6k5+t22/t8&
      &*spbk6k5+t16/t8*spbk6k5+t32/t13*spbk6k5+t25/t13*spbk6k5)))
      abb15n6 = ((4.0_ki)*(t31/t1*spbk5k1*spbk5k4*spbk6k2+t24/t8*spbk4k2*spbk5k1&
      &*spbk6k5+t30/t13*spak3k5*spbk4k3*spbk5k1*spbk6k5-(t23/t8*spak3k5*spbk4k3*&
      &spbk5k1*spbk6k5+t24/t50*spbk5k1*spbk5k4*spbk6k2+t31/t13*spbk4k2*spbk5k1*s&
      &pbk6k5)))
      t1 = t54*t6*spak5k6
      t2 = t54*t12*spak5k6
      abb15n7 = ((4.0_ki)*(t41/t1*spbk6k1+t48/t2*spbk6k1+t39/t51*spbk4k1*spbk5k1&
      &*spbk6k2-(t45/t53*spbk4k1*spbk5k1*spbk6k2+t47/t2*spbk6k1+t42/t1*spbk6k1))&
      &)
      rat2d15 = 0
      rat2 = rat2 + rat2d15
      abb15n9 = abb15n1
      abb15n10 = -(abb15n2)
      abb15n11 = -(abb15n3)
      abb15n12 = -(abb15n4)
      abb15n13 = -(abb15n5)
      abb15n14 = -(abb15n6)
      abb15n15 = -(abb15n7)
   end subroutine
end module p7_dubar_emnebargg_abbrevd15h0
