module     p7_dubar_emnebargg_abbrevd14h1
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_globalsh1
   implicit none
   private
   complex(ki), public :: abb14n1
   complex(ki), public :: abb14n2
   complex(ki), public :: abb14n3
   complex(ki), public :: abb14n4
   complex(ki), public :: abb14n5
   complex(ki), public :: abb14n6
   complex(ki), public :: abb14n7
   complex(ki), public :: rat2d14
   complex(ki), public :: abb14n9
   complex(ki), public :: abb14n10
   complex(ki), public :: abb14n11
   complex(ki), public :: abb14n12
   complex(ki), public :: abb14n13
   complex(ki), public :: abb14n14
   complex(ki), public :: abb14n15
   complex(ki), public :: abb14n16
   complex(ki), public :: abb14n17
   complex(ki), public :: abb14n18
   complex(ki), public :: abb14n19
   complex(ki), public :: abb14n20
   complex(ki), public :: abb14n21
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   real(ki) :: t40
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_dubar_emnebargg_config, only: deltaOS
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_model
      use p7_dubar_emnebargg_color, only: TR
      use p7_dubar_emnebargg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c1
      t3 = t2*i_
      t4 = t3*spak1k5
      t5 = t4*spak2k5*spak3k5
      t6 = t5*spbk4k1*spbk6k1
      t7 = (es34+es61-(es345+es234))*t1
      t8 = NC*t7
      t9 = es61*t8
      t10 = t9*spak5k6
      t11 = t3*spak2k3
      t12 = t11*spak2k5
      t13 = t12*spbk6k1*spbk6k2*spbk6k4
      t14 = NC*TR*c1
      t15 = t14*i_
      t16 = t15*spak1k5
      t17 = t16*spak2k5*spak3k5
      t18 = t17*spbk4k1*spbk6k1
      t19 = es61*t7
      t20 = t19*spak5k6
      t21 = t15*spak2k3
      t22 = t21*spak2k5
      t23 = t22*spbk6k1*spbk6k2*spbk6k4
      t2 = es56*t2*i_*spak2k5*spak3k5
      t24 = t2*spbk6k1*spbk6k4
      t25 = t10*spbk6k5
      t14 = es56*t14*i_*spak2k5*spak3k5
      t26 = t14*spbk6k1*spbk6k4
      t27 = t20*spbk6k5
      t4 = t4*spak2k3
      t28 = t4*spak2k5
      t29 = spbk6k1*spbk6k1
      t30 = t28*t29*spbk4k2
      t31 = es234*NC*t1
      t32 = es61*t31*spak5k6*spbk6k5
      t4 = t29*t4*spak3k5*spbk4k3
      t16 = t16*spak2k3
      t33 = t16*spak2k5
      t34 = t29*t33*spbk4k2
      t1 = es234*t1
      t35 = es61*t1*spak5k6*spbk6k5
      t16 = t16*t29*spak3k5*spbk4k3
      t36 = t28*spbk4k1*spbk6k1*spbk6k2
      t37 = t33*spbk4k1*spbk6k1*spbk6k2
      abb14n1 = ((4.0_ki)*(t13/(t9*spbk6k5)+t18/t20+t24/t25+t37/t27+t4/t32+t34/t&
      &35-(t30/t32+t26/t27+t36/t25+t16/t35+t6/t10+t23/(t19*spbk6k5))))
      t3 = t3*spak2k5*spak3k5
      t9 = t15*spak2k5*spak3k5
      abb14n2 = ((8.0_ki)*(t9/t20*spbk6k4+t22/t27*spbk6k2*spbk6k4-(t12/t25*spbk6&
      &k2*spbk6k4+t3/t10*spbk6k4)))
      t15 = t8*spak5k6
      t40 = es61*es61
      t19 = t40*t15
      t38 = t7*spak5k6
      t39 = t40*t38
      t15 = t40*t15*spbk6k5
      t38 = t40*t38*spbk6k5
      abb14n3 = ((4.0_ki)*(t17/t39*spbk6k1*spbk6k4+t33/t38*spbk6k1*spbk6k2*spbk6&
      &k4-(t28/t15*spbk6k1*spbk6k2*spbk6k4+t5/t19*spbk6k1*spbk6k4)))
      t5 = t12*spbk4k1
      t17 = t22*spbk4k1
      t12 = t12*spbk4k2
      t11 = t11*spak3k5*spbk4k3
      t22 = t22*spbk4k2
      t21 = t21*spak3k5*spbk4k3
      abb14n4 = ((8.0_ki)*(t11/t32*spbk6k1+t17/t27*spbk6k2+t9/t20*spbk4k1+t22/t3&
      &5*spbk6k1-(t5/t25*spbk6k2+t21/t35*spbk6k1+t12/t32*spbk6k1+t3/t10*spbk4k1)&
      &))
      t3 = t6/t19
      t6 = t18/t39
      t9 = t40*t31*spak5k6*spbk6k5
      t10 = t30/t9
      t4 = t4/t9
      t9 = t40*t1*spak5k6*spbk6k5
      t18 = t34/t9
      t9 = t16/t9
      t16 = t36/t15
      t19 = t37/t38
      t8 = t40*t8*spbk6k5
      t13 = t13/t8
      t7 = t40*t7*spbk6k5
      t20 = t23/t7
      t23 = t24/t15
      t24 = t26/t38
      abb14n5 = ((8.0_ki)*(t13+t23-(t24+t20))+(16.0_ki)*(t18+t19+t4+t6-(t9+t3+t1&
      &6+t10)))
      abb14n6 = ((16.0_ki)*(t20+t24-(t23+t13))+(8.0_ki)*(t10+t16+t3+t9-(t6+t4+t1&
      &9+t18)))
      t3 = t40*t31*spbk6k5
      t1 = t40*t1*spbk6k5
      abb14n7 = ((4.0_ki)*(t22/t1*t29+t11*t29/t3+t14/t38*spbk4k1*spbk6k1+t17/t7*&
      &spbk6k1*spbk6k2-(t5/t8*spbk6k1*spbk6k2+t2/t15*spbk4k1*spbk6k1+t12*t29/t3+&
      &t21/t1*t29)))
      rat2d14 = 0
      rat2 = rat2 + rat2d14
      abb14n9 = abb14n1
      abb14n10 = abb14n7
      abb14n11 = abb14n6
      abb14n12 = abb14n5
      abb14n13 = abb14n4
      abb14n14 = abb14n3
      abb14n15 = abb14n2
      abb14n16 = -(abb14n2)
      abb14n17 = -(abb14n3)
      abb14n18 = -(abb14n4)
      abb14n19 = -(abb14n5)
      abb14n20 = -(abb14n6)
      abb14n21 = -(abb14n7)
   end subroutine
end module p7_dubar_emnebargg_abbrevd14h1
