module     p7_dubar_emnebargg_d84h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity1/d84h1l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d84
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd84h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      complex(ki) :: t105
      complex(ki) :: t106
      complex(ki) :: t107
      complex(ki) :: t108
      complex(ki) :: t109
      complex(ki) :: t110
      complex(ki) :: t111
      complex(ki) :: t112
      complex(ki) :: t113
      complex(ki) :: t114
      complex(ki) :: t115
      complex(ki) :: t116
      complex(ki) :: t117
      complex(ki) :: t118
      complex(ki) :: t119
      complex(ki) :: t120
      complex(ki) :: t121
      complex(ki) :: t122
      complex(ki) :: t123
      complex(ki) :: t124
      complex(ki) :: t125
      complex(ki) :: t126
      complex(ki) :: t127
      complex(ki) :: t128
      complex(ki) :: t129
      complex(ki) :: t130
      complex(ki) :: t131
      complex(ki) :: t132
      real(ki) :: t133
      real(ki) :: t134
      real(ki) :: t135
      real(ki) :: t136
      real(ki) :: t137
      real(ki) :: t138
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t133 = dotproduct(qshift, qshift)
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = t1*t1
      t3 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t134 = dotproduct(k6, qshift)
      t4 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t135 = dotproduct(k5, qshift)
      t136 = dotproduct(k1, qshift)
      t137 = dotproduct(k2, qshift)
      t5 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t6 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t7 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t8 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t9 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t10 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-s&
      &pvak3k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb84n68+t1*abb84n138+t133*abb84n121+t133*t133*abb84n104+t&
         &134*abb84n137+t135*abb84n140+t136*abb84n150+t137*abb84n161+t2*abb84n13&
         &2+t3*abb84n136+t4*abb84n139+t5*abb84n220+t1*t10*abb84n80+t1*t133*abb84&
         &n158+t1*t134*abb84n133+t1*t135*abb84n133+t1*t136*abb84n113+t1*t137*abb&
         &84n101+t1*t3*abb84n71+t1*t4*abb84n126+t1*t5*abb84n74+t1*t6*abb84n109+t&
         &1*t7*abb84n97+t1*t9*abb84n89+t10*t133*abb84n223+t10*t134*abb84n76+t10*&
         &t136*abb84n78+t10*t2*abb84n234+t133*t135*abb84n177+t133*t137*abb84n171&
         &+t133*t3*abb84n206+t133*t4*abb84n166+t133*t6*abb84n188+t134*t137*abb84&
         &n105+t134*t3*abb84n87+t134*t6*abb84n111+t135*t3*abb84n123+t135*t6*abb8&
         &4n98+t136*t137*abb84n102+t136*t2*abb84n148+t136*t3*abb84n85+t136*t4*ab&
         &b84n107+t136*t6*abb84n110+t137*t2*abb84n148+t137*t3*abb84n124+t137*t4*&
         &abb84n115+t137*t6*abb84n95+t2*t3*abb84n210+t2*t5*abb84n216+t2*t7*abb84&
         &n153+t2*t8*abb84n197+t2*t9*abb84n202+t3*t4*abb84n125+t4*t6*abb84n106+t&
         &1*t10*t133*abb84n72+t1*t10*t134*abb84n230+t1*t10*t135*abb84n228+t1*t10&
         &*t136*abb84n228+t1*t10*t137*abb84n230+t1*t133*t3*abb84n83+t1*t133*t4*a&
         &bb84n100+t1*t133*t6*abb84n117+t1*t133*t8*abb84n93+t1*t134*t3*abb84n213&
         &+t1*t134*t8*abb84n191+t1*t135*t3*abb84n218+t1*t135*t6*abb84n151+t1*t13&
         &6*t3*abb84n218+t1*t136*t4*abb84n184+t1*t136*t8*abb84n195+t1*t137*t3*ab&
         &b84n213+t1*t137*t4*abb84n184+t1*t137*t6*abb84n155+t1*t3*t4*abb84n145+t&
         &1*t4*t6*abb84n199+t1*t4*t9*abb84n226+t2*t4*t9*abb84n69)
         return
      end if
      t11 = k1(iv1)
      t12 = k2(iv1)
      t13 = k5(iv1)
      t14 = k6(iv1)
      t15 = qshift(iv1)
      t16 = spvak3k4(iv1)
      t17 = spvak5k1(iv1)
      t18 = spvak5k6(iv1)
      t19 = spvak6k1(iv1)
      t20 = spvak2k1(iv1)
      t21 = spvak2k4(iv1)
      t22 = spvak2k5(iv1)
      t23 = spvak2k6(iv1)
      t24 = spvak3k1(iv1)
      t25 = t18*abb84n134
      t26 = t24*abb84n72
      t27 = t24*abb84n73
      t28 = t16*abb84n99
      t29 = t17*abb84n81
      t30 = t17*abb84n83
      t31 = t18*abb84n147
      t32 = t18*abb84n72
      t33 = t18*abb84n73
      t34 = t18*abb84n81
      t35 = t18*abb84n83
      t36 = t18*abb84n99
      if(deg.eq.1) then
         numerator = (t11*abb84n119+t12*abb84n112+t13*abb84n127+t134*t25+t135*t2&
         &5+t14*abb84n130+t15*abb84n146+t16*abb84n128+t17*abb84n131+t18*abb84n12&
         &9+t19*abb84n79+t1*t11*abb84n160+t1*t12*abb84n180+t1*t13*abb84n134+t1*t&
         &134*t26+t1*t134*t30+t1*t135*t27+t1*t135*t29+t1*t136*t27+t1*t136*t28+t1&
         &*t136*t29+t1*t136*t31+t1*t137*t26+t1*t137*t28+t1*t137*t30+t1*t137*t31+&
         &t1*t14*abb84n134+t1*t15*abb84n157+t1*t16*abb84n141+t1*t17*abb84n232+t1&
         &*t18*abb84n135+t1*t19*abb84n227+t1*t20*abb84n200+t1*t22*abb84n186+t1*t&
         &23*abb84n164+t1*t24*abb84n219+t10*t11*abb84n221+t10*t134*t32+t10*t135*&
         &t33+t10*t136*t33+t10*t137*t32+t10*t14*abb84n225+t10*t15*abb84n222+t10*&
         &t18*abb84n219+t11*t137*abb84n179+t11*t2*abb84n120+t11*t3*abb84n208+t11&
         &*t4*abb84n168+t11*t6*abb84n163+t12*t133*abb84n105+t12*t134*abb84n171+t&
         &12*t136*abb84n179+t12*t2*abb84n120+t12*t3*abb84n143+t12*t4*abb84n156+t&
         &12*t6*abb84n190+t13*t133*abb84n103+t13*t3*abb84n144+t13*t6*abb84n185+t&
         &133*t15*abb84n175+t133*t16*abb84n108+t133*t17*abb84n86+t133*t18*abb84n&
         &114+t133*t23*abb84n96+t133*t24*abb84n77+t134*t17*abb84n204+t134*t23*ab&
         &b84n162+t134*t24*abb84n225+t134*t3*t35+t135*t15*abb84n176+t135*t17*abb&
         &84n144+t135*t23*abb84n185+t135*t3*t34+t136*t16*abb84n168+t136*t17*abb8&
         &4n208+t136*t18*abb84n160+t136*t23*abb84n163+t136*t24*abb84n221+t136*t3&
         &*t34+t136*t36*t4+t137*t14*abb84n171+t137*t15*abb84n170+t137*t16*abb84n&
         &156+t137*t17*abb84n143+t137*t18*abb84n180+t137*t23*abb84n190+t137*t3*t&
         &35+t137*t36*t4+t14*t3*abb84n204+t14*t6*abb84n162+t15*t3*abb84n205+t15*&
         &t4*abb84n165+t15*t6*abb84n187+t16*t3*abb84n142+t16*t6*abb84n169+t17*t2&
         &*abb84n84+t17*t4*abb84n142+t18*t3*abb84n232+t18*t4*abb84n141+t18*t5*ab&
         &b84n227+t18*t6*abb84n164+t18*t7*abb84n186+t18*t9*abb84n200+t19*t2*abb8&
         &4n82+t2*t20*abb84n88+t2*t21*abb84n91+t2*t22*abb84n117+t2*t24*abb84n70+&
         &t23*t4*abb84n169+t1*t10*t11*abb84n73+t1*t10*t12*abb84n72+t1*t10*t13*ab&
         &b84n73+t1*t10*t14*abb84n72+t1*t10*t15*abb84n231+t1*t10*t18*abb84n233+t&
         &1*t11*t3*abb84n81+t1*t11*t4*abb84n99+t1*t11*t8*abb84n92+t1*t12*t3*abb8&
         &4n83+t1*t12*t4*abb84n99+t1*t12*t6*abb84n116+t1*t13*t3*abb84n81+t1*t13*&
         &t6*abb84n118+t1*t133*t16*abb84n182+t1*t133*t17*abb84n213+t1*t133*t21*a&
         &bb84n193+t1*t133*t23*abb84n153+t1*t133*t24*abb84n230+t1*t134*t21*abb84&
         &n94+t1*t135*t23*abb84n118+t1*t136*t21*abb84n92+t1*t137*t23*abb84n116+t&
         &1*t14*t3*abb84n83+t1*t14*t8*abb84n94+t1*t15*t3*abb84n214+t1*t15*t4*abb&
         &84n183+t1*t15*t6*abb84n154+t1*t15*t8*abb84n194+t1*t16*t3*abb84n122+t1*&
         &t16*t6*abb84n90+t1*t16*t9*abb84n75+t1*t17*t4*abb84n122+t1*t18*t3*abb84&
         &n209+t1*t18*t5*abb84n215+t1*t18*t7*abb84n152+t1*t18*t8*abb84n196+t1*t1&
         &8*t9*abb84n201+t1*t20*t4*abb84n75+t1*t23*t4*abb84n90+t10*t133*t18*abb8&
         &4n230+t133*t18*t3*abb84n213+t133*t18*t4*abb84n182+t133*t18*t6*abb84n15&
         &3+t133*t18*t8*abb84n193+t134*t18*t8*abb84n94+t135*t18*t6*abb84n118+t13&
         &6*t18*t8*abb84n92+t137*t18*t6*abb84n116+t16*t2*t9*abb84n237+t18*t3*t4*&
         &abb84n122+t18*t4*t6*abb84n90+t18*t4*t9*abb84n75+t2*t20*t4*abb84n237+t1&
         &*t18*t4*t9*abb84n238)
         return
      end if
      t138 = d(iv1,iv2)
      t25 = qshift(iv2)
      t26 = spvak5k6(iv2)
      t27 = t18*t26
      t28 = t27*abb84n148
      t29 = k2(iv2)
      t30 = spvak2k6(iv2)
      t31 = spvak3k1(iv2)
      t32 = t11*t31
      t33 = spvak3k4(iv2)
      t34 = t11*t33
      t35 = spvak5k1(iv2)
      t36 = t11*t35
      t37 = t11*t26
      t38 = k1(iv2)
      t39 = t24*t38
      t40 = t16*t38
      t41 = t17*t38
      t42 = t18*t38
      t43 = k6(iv2)
      t44 = t12*t30
      t45 = t12*t33
      t46 = t12*t35
      t47 = t12*t26
      t48 = t23*t29
      t49 = t16*t29
      t50 = t17*t29
      t51 = t18*t29
      t52 = t13*t30
      t53 = t13*t35
      t54 = t13*t26
      t55 = k5(iv2)
      t56 = t23*t55
      t57 = t17*t55
      t58 = t18*t55
      t59 = t14*t31
      t60 = t14*t35
      t61 = t14*t26
      t62 = t24*t43
      t63 = t17*t43
      t64 = t18*t43
      t65 = t15*t30
      t66 = t15*t31
      t67 = t15*t33
      t68 = t15*t35
      t69 = t15*t26
      t70 = t23*t25
      t71 = t24*t25
      t72 = t16*t25
      t73 = t17*t25
      t74 = t18*t25
      t75 = t20*t26
      t76 = spvak2k1(iv2)
      t77 = t18*t76
      t22 = t22*t26
      t78 = spvak2k5(iv2)*t18
      t79 = t23*t33
      t80 = t23*t26
      t81 = t16*t30
      t82 = t18*t30
      t83 = t24*t26
      t84 = t18*t31
      t85 = t16*t35
      t86 = t16*t26
      t87 = t17*t33
      t88 = t18*t33
      t89 = t17*t26
      t90 = t18*t35
      t91 = spvak6k1(iv2)
      t92 = t18*t91
      t93 = t19*t26
      t94 = spvak2k4(iv2)
      t95 = t11*t94
      t96 = t21*t38
      t97 = t12*t31
      t98 = t24*t29
      t99 = t13*t31
      t100 = t24*t55
      t101 = t14*t94
      t102 = t21*t43
      t103 = t15*t94
      t104 = t21*t25
      t105 = t20*t33
      t106 = t16*t76
      t107 = t21*t26
      t108 = t18*t94
      t109 = t83*abb84n228
      t110 = t83*abb84n230
      t111 = t84*abb84n228
      t112 = t84*abb84n230
      t113 = t86*abb84n184
      t114 = t88*abb84n184
      t115 = t89*abb84n213
      t116 = t89*abb84n218
      t117 = t90*abb84n213
      t118 = t90*abb84n218
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t136*t28+t137*t28+t138*abb84n121+t27*abb84n132+t&
         &1*t138*abb84n158+t10*t138*abb84n223+t10*t27*abb84n234+t133*t138*abb84n&
         &174+t135*t138*abb84n177+t137*t138*abb84n171+t138*t3*abb84n206+t138*t4*&
         &abb84n166+t138*t6*abb84n188+t15*t25*abb84n173+t27*t3*abb84n210+t27*t5*&
         &abb84n216+t27*t7*abb84n153+t27*t8*abb84n197+t27*t9*abb84n202+t1*t10*t1&
         &38*abb84n72+t1*t138*t3*abb84n83+t1*t138*t4*abb84n100+t1*t138*t6*abb84n&
         &117+t1*t138*t8*abb84n93+t27*t4*t9*abb84n69)+t109*t135+t109*t136+t110*t&
         &134+t110*t137+t111*t135+t111*t136+t112*t134+t112*t137+t113*t136+t113*t&
         &137+t114*t136+t114*t137+t115*t134+t115*t137+t116*t135+t116*t136+t117*t&
         &134+t117*t137+t118*t135+t118*t136+t22*abb84n97+t32*abb84n78+t34*abb84n&
         &107+t36*abb84n85+t37*abb84n113+t39*abb84n78+t40*abb84n107+t41*abb84n85&
         &+t42*abb84n113+t44*abb84n95+t45*abb84n115+t46*abb84n124+t47*abb84n101+&
         &t48*abb84n95+t49*abb84n115+t50*abb84n124+t51*abb84n101+t52*abb84n98+t5&
         &3*abb84n123+t54*abb84n133+t56*abb84n98+t57*abb84n123+t58*abb84n133+t59&
         &*abb84n76+t60*abb84n87+t61*abb84n133+t62*abb84n76+t63*abb84n87+t64*abb&
         &84n133+t65*abb84n189+t66*abb84n224+t67*abb84n167+t68*abb84n207+t69*abb&
         &84n159+t70*abb84n189+t71*abb84n224+t72*abb84n167+t73*abb84n207+t74*abb&
         &84n159+t75*abb84n89+t77*abb84n89+t78*abb84n97+t79*abb84n106+t80*abb84n&
         &109+t81*abb84n106+t82*abb84n109+t83*abb84n80+t84*abb84n80+t85*abb84n12&
         &5+t86*abb84n126+t87*abb84n125+t88*abb84n126+t89*abb84n71+t90*abb84n71+&
         &t92*abb84n74+t93*abb84n74+t1*t100*abb84n228+t1*t101*abb84n191+t1*t102*&
         &abb84n191+t1*t103*abb84n192+t1*t104*abb84n192+t1*t105*abb84n226+t1*t10&
         &6*abb84n226+t1*t107*abb84n198+t1*t108*abb84n198+t1*t22*abb84n154+t1*t3&
         &2*abb84n228+t1*t34*abb84n184+t1*t36*abb84n218+t1*t37*abb84n149+t1*t39*&
         &abb84n228+t1*t40*abb84n184+t1*t41*abb84n218+t1*t42*abb84n149+t1*t44*ab&
         &b84n155+t1*t45*abb84n184+t1*t46*abb84n213+t1*t47*abb84n149+t1*t48*abb8&
         &4n155+t1*t49*abb84n184+t1*t50*abb84n213+t1*t51*abb84n149+t1*t52*abb84n&
         &151+t1*t53*abb84n218+t1*t56*abb84n151+t1*t57*abb84n218+t1*t59*abb84n23&
         &0+t1*t60*abb84n213+t1*t62*abb84n230+t1*t63*abb84n213+t1*t65*abb84n152+&
         &t1*t66*abb84n229+t1*t67*abb84n181+t1*t68*abb84n212+t1*t70*abb84n152+t1&
         &*t71*abb84n229+t1*t72*abb84n181+t1*t73*abb84n212+t1*t75*abb84n203+t1*t&
         &77*abb84n203+t1*t78*abb84n154+t1*t79*abb84n199+t1*t81*abb84n199+t1*t83&
         &*abb84n235+t1*t84*abb84n235+t1*t85*abb84n145+t1*t87*abb84n145+t1*t89*a&
         &bb84n211+t1*t90*abb84n211+t1*t92*abb84n217+t1*t93*abb84n217+t1*t95*abb&
         &84n195+t1*t96*abb84n195+t1*t97*abb84n230+t1*t98*abb84n230+t1*t99*abb84&
         &n228+t10*t37*abb84n228+t10*t42*abb84n228+t10*t47*abb84n230+t10*t51*abb&
         &84n230+t10*t54*abb84n228+t10*t58*abb84n228+t10*t61*abb84n230+t10*t64*a&
         &bb84n230+t10*t69*abb84n229+t10*t74*abb84n229+t105*t2*abb84n69+t106*t2*&
         &abb84n69+t107*t133*abb84n93+t107*t134*abb84n191+t107*t136*abb84n195+t1&
         &08*t133*abb84n93+t108*t134*abb84n191+t108*t136*abb84n195+t11*t29*abb84&
         &n102+t11*t30*abb84n110+t12*t25*abb84n172+t12*t38*abb84n102+t12*t43*abb&
         &84n105+t13*t25*abb84n178+t133*t80*abb84n117+t133*t82*abb84n117+t133*t8&
         &3*abb84n72+t133*t84*abb84n72+t133*t86*abb84n100+t133*t88*abb84n100+t13&
         &3*t89*abb84n83+t133*t90*abb84n83+t135*t80*abb84n151+t135*t82*abb84n151&
         &+t137*t80*abb84n155+t137*t82*abb84n155+t14*t29*abb84n105+t14*t30*abb84&
         &n111+t15*t29*abb84n172+t15*t55*abb84n178+t23*t38*abb84n110+t23*t43*abb&
         &84n111+t3*t37*abb84n218+t3*t42*abb84n218+t3*t47*abb84n213+t3*t51*abb84&
         &n213+t3*t54*abb84n218+t3*t58*abb84n218+t3*t61*abb84n213+t3*t64*abb84n2&
         &13+t3*t69*abb84n212+t3*t74*abb84n212+t3*t86*abb84n145+t3*t88*abb84n145&
         &+t37*t4*abb84n184+t37*t8*abb84n195+t4*t42*abb84n184+t4*t47*abb84n184+t&
         &4*t51*abb84n184+t4*t69*abb84n181+t4*t74*abb84n181+t4*t75*abb84n226+t4*&
         &t77*abb84n226+t4*t80*abb84n199+t4*t82*abb84n199+t4*t89*abb84n145+t4*t9&
         &0*abb84n145+t42*t8*abb84n195+t47*t6*abb84n155+t51*t6*abb84n155+t54*t6*&
         &abb84n151+t58*t6*abb84n151+t6*t69*abb84n152+t6*t74*abb84n152+t6*t86*ab&
         &b84n199+t6*t88*abb84n199+t61*t8*abb84n191+t64*t8*abb84n191+t69*t8*abb8&
         &4n192+t74*t8*abb84n192+t86*t9*abb84n226+t88*t9*abb84n226+t1*t4*t75*abb&
         &84n236+t1*t4*t77*abb84n236+t1*t86*t9*abb84n236+t1*t88*t9*abb84n236)
         return
      end if
      t133 = d(iv2,iv3)
      t134 = d(iv1,iv3)
      t2 = k2(iv3)
      t5 = k5(iv3)
      t7 = qshift(iv3)
      t28 = t133*t23
      t54 = t134*t30
      t58 = spvak2k6(iv3)
      t61 = t138*t58
      t64 = t133*t24
      t69 = t134*t31
      t74 = spvak3k1(iv3)
      t92 = t138*t74
      t93 = t133*t16
      t109 = t134*t33
      t110 = spvak3k4(iv3)
      t111 = t110*t138
      t112 = t133*t17
      t113 = t134*t35
      t114 = spvak5k1(iv3)
      t115 = t114*t138
      t116 = t133*t18
      t117 = t134*t26
      t118 = spvak5k6(iv3)
      t119 = t118*t138
      t120 = k1(iv3)
      t75 = t118*t75
      t77 = t118*t77
      t121 = spvak2k1(iv3)
      t122 = t121*t18*t26
      t123 = spvak2k4(iv3)
      t124 = t123*t18
      t125 = t18*t74
      t126 = t114*t18
      t127 = t110*t18
      t128 = k6(iv3)
      t105 = t105*t118
      t129 = t110*t20*t26
      t106 = t106*t118
      t130 = t110*t18*t76
      t131 = t121*t16*t26
      t132 = t121*t18*t33
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t109*abb84n108+t111*abb84n108+t112*abb84n86+t113&
         &*abb84n86+t115*abb84n86+t116*abb84n114+t117*abb84n114+t119*abb84n114+t&
         &122*abb84n88+t28*abb84n96+t54*abb84n96+t61*abb84n96+t64*abb84n77+t69*a&
         &bb84n77+t75*abb84n88+t77*abb84n88+t92*abb84n77+t93*abb84n108+spvak6k1(&
         &iv3)*t27*abb84n82+t1*t109*abb84n182+t1*t111*abb84n182+t1*t112*abb84n21&
         &3+t1*t113*abb84n213+t1*t115*abb84n213+t1*t28*abb84n153+t1*t54*abb84n15&
         &3+t1*t61*abb84n153+t1*t64*abb84n230+t1*t69*abb84n230+t1*t92*abb84n230+&
         &t1*t93*abb84n182+t10*t116*abb84n230+t10*t117*abb84n230+t10*t119*abb84n&
         &230+t107*t118*abb84n91+t108*t118*abb84n91+t116*t3*abb84n213+t116*t4*ab&
         &b84n182+t116*t6*abb84n153+t116*t8*abb84n193+t117*t3*abb84n213+t117*t4*&
         &abb84n182+t117*t6*abb84n153+t117*t8*abb84n193+t118*t22*abb84n117+t118*&
         &t37*abb84n120+t118*t42*abb84n120+t118*t47*abb84n120+t118*t51*abb84n120&
         &+t118*t78*abb84n117+t118*t83*abb84n70+t118*t84*abb84n70+t118*t89*abb84&
         &n84+t118*t90*abb84n84+t119*t3*abb84n213+t119*t4*abb84n182+t119*t6*abb8&
         &4n153+t119*t8*abb84n193+t12*t133*abb84n105+t122*t4*abb84n237+t124*t26*&
         &abb84n91+t125*t26*abb84n70+t126*t26*abb84n84+t13*t133*abb84n103+t133*t&
         &15*abb84n175+t134*t25*abb84n175+t134*t29*abb84n105+t134*t55*abb84n103+&
         &t138*t2*abb84n105+t138*t5*abb84n103+t138*t7*abb84n175+t4*t75*abb84n237&
         &+t4*t77*abb84n237+spvak2k5(iv3)*t18*t26*abb84n117+t1*t123*t138*abb84n1&
         &93+t1*t133*t21*abb84n193+t1*t134*t94*abb84n193+t118*t18*t91*abb84n82+t&
         &118*t19*t26*abb84n82+t118*t86*t9*abb84n237+t118*t88*t9*abb84n237+t120*&
         &t18*t26*abb84n120+t127*t26*t9*abb84n237+t18*t2*t26*abb84n120)+t105*abb&
         &84n75+t106*abb84n75+t129*abb84n75+t130*abb84n75+t131*abb84n75+t132*abb&
         &84n75+t1*t105*abb84n238+t1*t106*abb84n238+t1*t129*abb84n238+t1*t130*ab&
         &b84n238+t1*t131*abb84n238+t1*t132*abb84n238+t100*t118*abb84n73+t101*t1&
         &18*abb84n94+t102*t118*abb84n94+t103*t118*abb84n194+t104*t118*abb84n194&
         &+t118*t32*abb84n73+t118*t34*abb84n99+t118*t36*abb84n81+t118*t39*abb84n&
         &73+t118*t40*abb84n99+t118*t41*abb84n81+t118*t44*abb84n116+t118*t45*abb&
         &84n99+t118*t46*abb84n83+t118*t48*abb84n116+t118*t49*abb84n99+t118*t50*&
         &abb84n83+t118*t52*abb84n118+t118*t53*abb84n81+t118*t56*abb84n118+t118*&
         &t57*abb84n81+t118*t59*abb84n72+t118*t60*abb84n83+t118*t62*abb84n72+t11&
         &8*t63*abb84n83+t118*t65*abb84n154+t118*t66*abb84n231+t118*t67*abb84n18&
         &3+t118*t68*abb84n214+t118*t70*abb84n154+t118*t71*abb84n231+t118*t72*ab&
         &b84n183+t118*t73*abb84n214+t118*t79*abb84n90+t118*t81*abb84n90+t118*t8&
         &5*abb84n122+t118*t87*abb84n122+t118*t95*abb84n92+t118*t96*abb84n92+t11&
         &8*t97*abb84n72+t118*t98*abb84n72+t118*t99*abb84n73+t11*t110*t26*abb84n&
         &99+t11*t114*t26*abb84n81+t11*t123*t26*abb84n92+t11*t26*t74*abb84n73+t1&
         &10*t12*t26*abb84n99+t110*t15*t26*abb84n183+t110*t17*t26*abb84n122+t110&
         &*t18*t25*abb84n183+t110*t18*t29*abb84n99+t110*t18*t30*abb84n90+t110*t1&
         &8*t35*abb84n122+t110*t18*t38*abb84n99+t110*t23*t26*abb84n90+t114*t12*t&
         &26*abb84n83+t114*t13*t26*abb84n81+t114*t14*t26*abb84n83+t114*t15*t26*a&
         &bb84n214+t114*t16*t26*abb84n122+t114*t18*t25*abb84n214+t114*t18*t29*ab&
         &b84n83+t114*t18*t33*abb84n122+t114*t18*t38*abb84n81+t114*t18*t43*abb84&
         &n83+t114*t18*t55*abb84n81+t12*t26*t58*abb84n116+t12*t26*t74*abb84n72+t&
         &120*t16*t26*abb84n99+t120*t17*t26*abb84n81+t120*t18*t31*abb84n73+t120*&
         &t18*t33*abb84n99+t120*t18*t35*abb84n81+t120*t18*t94*abb84n92+t120*t21*&
         &t26*abb84n92+t120*t24*t26*abb84n73+t123*t14*t26*abb84n94+t123*t15*t26*&
         &abb84n194+t123*t18*t25*abb84n194+t123*t18*t38*abb84n92+t123*t18*t43*ab&
         &b84n94+t128*t17*t26*abb84n83+t128*t18*t31*abb84n72+t128*t18*t35*abb84n&
         &83+t128*t18*t94*abb84n94+t128*t21*t26*abb84n94+t128*t24*t26*abb84n72+t&
         &13*t26*t58*abb84n118+t13*t26*t74*abb84n73+t14*t26*t74*abb84n72+t15*t26&
         &*t58*abb84n154+t15*t26*t74*abb84n231+t16*t2*t26*abb84n99+t16*t26*t58*a&
         &bb84n90+t16*t26*t7*abb84n183+t17*t2*t26*abb84n83+t17*t26*t5*abb84n81+t&
         &17*t26*t7*abb84n214+t18*t2*t30*abb84n116+t18*t2*t31*abb84n72+t18*t2*t3&
         &3*abb84n99+t18*t2*t35*abb84n83+t18*t25*t58*abb84n154+t18*t25*t74*abb84&
         &n231+t18*t29*t58*abb84n116+t18*t29*t74*abb84n72+t18*t30*t5*abb84n118+t&
         &18*t30*t7*abb84n154+t18*t31*t5*abb84n73+t18*t31*t7*abb84n231+t18*t33*t&
         &58*abb84n90+t18*t33*t7*abb84n183+t18*t35*t5*abb84n81+t18*t35*t7*abb84n&
         &214+t18*t38*t74*abb84n73+t18*t43*t74*abb84n72+t18*t55*t58*abb84n118+t1&
         &8*t55*t74*abb84n73+t18*t7*t94*abb84n194+t2*t23*t26*abb84n116+t2*t24*t2&
         &6*abb84n72+t21*t26*t7*abb84n194+t23*t26*t5*abb84n118+t23*t26*t7*abb84n&
         &154+t24*t26*t5*abb84n73+t24*t26*t7*abb84n231)
         return
      end if
      t135 = d(iv3,iv4)
      t136 = d(iv2,iv4)
      t137 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t2 = spvak2k4(iv4)
      t3 = spvak2k6(iv4)
      t4 = spvak3k1(iv4)
      t5 = spvak3k4(iv4)
      t6 = spvak5k1(iv4)
      t7 = spvak2k1(iv4)
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t133*t137*abb84n104+t134*t136*abb84n104+t135*t13&
         &8*abb84n104)+(2.0_ki)*(t1*t105*abb84n69+t1*t106*abb84n69+t1*t129*abb84&
         &n69+t1*t130*abb84n69+t1*t131*abb84n69+t1*t132*abb84n69+t107*t135*abb84&
         &n93+t108*t135*abb84n93+t124*t136*abb84n93+t125*t136*abb84n72+t126*t136&
         &*abb84n83+t127*t136*abb84n100+t135*t80*abb84n117+t135*t82*abb84n117+t1&
         &35*t83*abb84n72+t135*t84*abb84n72+t135*t86*abb84n100+t135*t88*abb84n10&
         &0+t135*t89*abb84n83+t135*t90*abb84n83+t1*t110*t138*abb84n100+t1*t114*t&
         &138*abb84n83+t1*t123*t138*abb84n93+t1*t133*t16*abb84n100+t1*t133*t17*a&
         &bb84n83+t1*t133*t21*abb84n93+t1*t133*t23*abb84n117+t1*t133*t24*abb84n7&
         &2+t1*t134*t30*abb84n117+t1*t134*t31*abb84n72+t1*t134*t33*abb84n100+t1*&
         &t134*t35*abb84n83+t1*t134*t94*abb84n93+t1*t138*t58*abb84n117+t1*t138*t&
         &74*abb84n72+t110*t137*t26*abb84n100+t114*t137*t26*abb84n83+t118*t136*t&
         &16*abb84n100+t118*t136*t17*abb84n83+t118*t136*t21*abb84n93+t118*t136*t&
         &23*abb84n117+t118*t136*t24*abb84n72+t118*t137*t30*abb84n117+t118*t137*&
         &t31*abb84n72+t118*t137*t33*abb84n100+t118*t137*t35*abb84n83+t118*t137*&
         &t94*abb84n93+t118*t138*t2*abb84n93+t118*t138*t3*abb84n117+t118*t138*t4&
         &*abb84n72+t118*t138*t5*abb84n100+t118*t138*t6*abb84n83+t123*t137*t26*a&
         &bb84n93+t133*t18*t2*abb84n93+t133*t18*t3*abb84n117+t133*t18*t4*abb84n7&
         &2+t133*t18*t5*abb84n100+t133*t18*t6*abb84n83+t134*t2*t26*abb84n93+t134&
         &*t26*t3*abb84n117+t134*t26*t4*abb84n72+t134*t26*t5*abb84n100+t134*t26*&
         &t6*abb84n83+t136*t18*t58*abb84n117+t137*t26*t58*abb84n117+t137*t26*t74&
         &*abb84n72+t110*t18*t26*t7*abb84n69+t118*t16*t26*t7*abb84n69+t118*t18*t&
         &33*t7*abb84n69+t118*t18*t5*t76*abb84n69+t118*t20*t26*t5*abb84n69+t121*&
         &t18*t26*t5*abb84n69))
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d84:
   subroutine     reconstruct_d84(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group6
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group6), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_84:
      coeffs%coeffs_84%c0 = derivative(czip)
      coeffs%coeffs_84%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_84%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_84%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_84%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_84%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_84%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_84%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_84%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_84%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_84%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_84%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_84%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_84%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_84%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_84%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_84%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_84%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_84%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_84%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_84%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_84%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_84%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_84%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_84%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_84%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_84%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_84%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_84%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_84%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_84%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_84%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_84%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_84%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_84%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_84%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_84%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_84%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_84%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_84%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_84%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_84%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_84%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_84%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_84%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_84%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_84%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_84%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_84%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_84%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_84%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_84%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_84%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_84%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_84%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_84%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_84%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_84%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_84%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_84%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_84%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_84%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_84%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_84%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_84%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_84%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_84%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_84%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_84%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_84%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_84:
   end subroutine reconstruct_d84
!---#] subroutine reconstruct_d84:
end module p7_dubar_emnebargg_d84h1l1d
