module     p7_dubar_emnebargg_d93h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity1/d93h1l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d93
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd93h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      real(ki) :: t105
      real(ki) :: t106
      real(ki) :: t107
      real(ki) :: t108
      real(ki) :: t109
      real(ki) :: t110
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k6
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = t1*t1
      t105 = dotproduct(k5, qshift)
      t106 = dotproduct(qshift, qshift)
      t3 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t107 = dotproduct(k1, qshift)
      t4 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t108 = dotproduct(k6, qshift)
      t5 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t6 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t7 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t109 = dotproduct(k2, qshift)
      t8 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t9 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb93n50+t1*abb93n91+t105*abb93n76+t105*t105*abb93n61+t106&
         &*abb93n70+t106*t106*abb93n62+t107*abb93n72+t108*abb93n74+t2*abb93n60+t&
         &3*abb93n71+t4*abb93n73+t1*t105*abb93n58+t1*t106*abb93n103+t1*t107*abb9&
         &3n57+t1*t108*abb93n64+t1*t109*abb93n69+t1*t3*abb93n65+t1*t4*abb93n52+t&
         &1*t6*abb93n55+t105*t106*abb93n97+t105*t107*abb93n63+t105*t108*abb93n63&
         &+t105*t2*abb93n77+t105*t3*abb93n66+t105*t4*abb93n55+t106*t107*abb93n92&
         &+t106*t108*abb93n92+t106*t2*abb93n68+t106*t3*abb93n87+t106*t4*abb93n11&
         &6+t107*t108*abb93n61+t108*t2*abb93n79+t108*t3*abb93n67+t108*t4*abb93n5&
         &4+t109*t2*abb93n81+t2*t3*abb93n105+t2*t4*abb93n109+t2*t5*abb93n107+t2*&
         &t6*abb93n113+t2*t7*abb93n122+t2*t8*abb93n85+t2*t9*abb93n89+t1*t105*t3*&
         &abb93n100+t1*t105*t7*abb93n118+t1*t106*t3*abb93n59+t1*t106*t4*abb93n56&
         &+t1*t106*t7*abb93n53+t1*t107*t3*abb93n100+t1*t107*t7*abb93n120+t1*t108&
         &*t3*abb93n101+t1*t108*t4*abb93n111+t1*t109*t4*abb93n115+t1*t3*t4*abb93&
         &n121+t2*t3*t5*abb93n51)
         return
      end if
      t10 = k1(iv1)
      t11 = k5(iv1)
      t12 = k6(iv1)
      t13 = qshift(iv1)
      t14 = spvak3k4(iv1)
      t15 = spvak5k1(iv1)
      t16 = spvak5k6(iv1)
      t17 = k2(iv1)
      t18 = t11*abb93n63
      t19 = t13*abb93n93
      t20 = spvak2k1(iv1)
      t21 = spvak2k4(iv1)
      t22 = spvak2k6(iv1)
      t23 = spvak3k1(iv1)
      t24 = spvak6k1(iv1)
      t25 = t14*abb93n100
      t26 = t16*abb93n100
      if(deg.eq.1) then
         numerator = (t10*abb93n72+t107*t18+t107*t19+t108*t18+t108*t19+t11*abb93&
         &n76+t12*abb93n74+t13*abb93n75+t14*abb93n71+t15*abb93n73+t16*abb93n91+t&
         &1*t10*abb93n57+t1*t105*t25+t1*t107*t25+t1*t11*abb93n58+t1*t12*abb93n64&
         &+t1*t13*abb93n104+t1*t14*abb93n65+t1*t15*abb93n52+t1*t16*abb93n99+t1*t&
         &17*abb93n69+t1*t24*abb93n55+t10*t105*abb93n63+t10*t106*abb93n92+t10*t1&
         &08*abb93n61+t105*t11*abb93n96+t105*t12*abb93n63+t105*t13*abb93n98+t105&
         &*t14*abb93n66+t105*t15*abb93n55+t105*t16*abb93n58+t105*t26*t3+t106*t11&
         &*abb93n97+t106*t12*abb93n92+t106*t13*abb93n94+t106*t14*abb93n87+t106*t&
         &15*abb93n116+t106*t16*abb93n103+t107*t12*abb93n61+t107*t16*abb93n57+t1&
         &07*t26*t3+t108*t14*abb93n67+t108*t15*abb93n54+t108*t16*abb93n64+t109*t&
         &16*abb93n69+t11*t2*abb93n77+t11*t3*abb93n66+t11*t4*abb93n55+t12*t2*abb&
         &93n79+t12*t3*abb93n67+t12*t4*abb93n54+t13*t2*abb93n84+t13*t3*abb93n88+&
         &t13*t4*abb93n117+t14*t2*abb93n105+t15*t2*abb93n109+t16*t3*abb93n65+t16&
         &*t4*abb93n52+t16*t6*abb93n55+t17*t2*abb93n81+t2*t20*abb93n107+t2*t21*a&
         &bb93n89+t2*t22*abb93n85+t2*t23*abb93n122+t2*t24*abb93n113+t1*t10*t3*ab&
         &b93n100+t1*t10*t7*abb93n120+t1*t105*t16*abb93n78+t1*t105*t23*abb93n118&
         &+t1*t106*t14*abb93n59+t1*t106*t15*abb93n56+t1*t106*t16*abb93n84+t1*t10&
         &6*t23*abb93n53+t1*t107*t23*abb93n120+t1*t108*t14*abb93n101+t1*t108*t15&
         &*abb93n111+t1*t108*t16*abb93n80+t1*t109*t15*abb93n115+t1*t109*t16*abb9&
         &3n82+t1*t11*t3*abb93n100+t1*t11*t7*abb93n118+t1*t12*t3*abb93n101+t1*t1&
         &2*t4*abb93n111+t1*t13*t3*abb93n102+t1*t13*t4*abb93n112+t1*t13*t7*abb93&
         &n119+t1*t14*t4*abb93n121+t1*t15*t3*abb93n121+t1*t16*t3*abb93n106+t1*t1&
         &6*t4*abb93n110+t1*t16*t5*abb93n108+t1*t16*t6*abb93n114+t1*t16*t7*abb93&
         &n123+t1*t16*t8*abb93n86+t1*t16*t9*abb93n90+t1*t17*t4*abb93n115+t105*t1&
         &6*t7*abb93n118+t106*t16*t3*abb93n59+t106*t16*t4*abb93n56+t106*t16*t7*a&
         &bb93n53+t107*t16*t7*abb93n120+t108*t16*t3*abb93n101+t108*t16*t4*abb93n&
         &111+t109*t16*t4*abb93n115+t14*t2*t5*abb93n51+t16*t3*t4*abb93n121+t2*t2&
         &0*t3*abb93n51+t1*t16*t3*t5*abb93n124)
         return
      end if
      t110 = d(iv1,iv2)
      t18 = k5(iv2)
      t19 = qshift(iv2)
      t25 = spvak5k6(iv2)
      t26 = t16*t25
      t27 = t110*abb93n92
      t28 = k6(iv2)
      t29 = t10*t25
      t30 = k1(iv2)
      t31 = t16*t30
      t32 = t17*t25
      t33 = k2(iv2)
      t34 = t16*t33
      t35 = spvak3k4(iv2)
      t36 = t11*t35
      t37 = spvak5k1(iv2)
      t38 = t11*t25
      t39 = t14*t18
      t40 = t16*t18
      t41 = t12*t35
      t42 = t12*t37
      t43 = t12*t25
      t44 = t14*t28
      t45 = t15*t28
      t46 = t16*t28
      t47 = t13*t35
      t48 = t13*t37
      t49 = t13*t25
      t50 = t14*t19
      t51 = t15*t19
      t52 = t16*t19
      t53 = t14*t25
      t54 = t16*t35
      t55 = t15*t25
      t56 = t16*t37
      t57 = spvak6k1(iv2)
      t58 = t16*t57
      t59 = t24*t25
      t60 = spvak3k1(iv2)
      t61 = t10*t60
      t62 = t10*t35
      t63 = t23*t30
      t64 = t14*t30
      t65 = t17*t37
      t66 = t15*t33
      t67 = t11*t60
      t68 = t18*t23
      t69 = t13*t60
      t70 = t19*t23
      t71 = t20*t35
      t72 = t20*t25
      t73 = spvak2k1(iv2)
      t74 = t14*t73
      t75 = t16*t73
      t21 = t21*t25
      t76 = spvak2k4(iv2)*t16
      t22 = t22*t25
      t77 = spvak2k6(iv2)*t16
      t78 = t23*t25
      t79 = t16*t60
      t80 = t14*t37
      t81 = t53*abb93n100
      t82 = t15*t35
      t83 = t54*abb93n100
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t107*t27+t108*t27+t110*abb93n70+t26*abb93n60+t1*&
         &t110*abb93n103+t105*t110*abb93n97+t105*t26*abb93n77+t106*t110*abb93n95&
         &+t106*t26*abb93n68+t108*t26*abb93n79+t109*t26*abb93n81+t11*t18*abb93n6&
         &1+t110*t2*abb93n68+t110*t3*abb93n87+t110*t4*abb93n116+t13*t19*abb93n94&
         &+t26*t3*abb93n105+t26*t4*abb93n109+t26*t5*abb93n107+t26*t6*abb93n113+t&
         &26*t7*abb93n122+t26*t8*abb93n85+t26*t9*abb93n89+t1*t110*t3*abb93n59+t1&
         &*t110*t4*abb93n56+t1*t110*t7*abb93n53+t26*t3*t5*abb93n51)+t105*t81+t10&
         &5*t83+t107*t81+t107*t83+t29*abb93n57+t31*abb93n57+t32*abb93n69+t34*abb&
         &93n69+t36*abb93n66+t38*abb93n58+t39*abb93n66+t40*abb93n58+t41*abb93n67&
         &+t42*abb93n54+t43*abb93n64+t44*abb93n67+t45*abb93n54+t46*abb93n64+t47*&
         &abb93n88+t48*abb93n117+t49*abb93n104+t50*abb93n88+t51*abb93n117+t52*ab&
         &b93n104+t53*abb93n65+t54*abb93n65+t55*abb93n52+t56*abb93n52+t58*abb93n&
         &55+t59*abb93n55+t1*t21*abb93n90+t1*t22*abb93n86+t1*t32*abb93n82+t1*t34&
         &*abb93n82+t1*t36*abb93n100+t1*t38*abb93n78+t1*t39*abb93n100+t1*t40*abb&
         &93n78+t1*t41*abb93n101+t1*t42*abb93n111+t1*t43*abb93n80+t1*t44*abb93n1&
         &01+t1*t45*abb93n111+t1*t46*abb93n80+t1*t47*abb93n102+t1*t48*abb93n112+&
         &t1*t49*abb93n83+t1*t50*abb93n102+t1*t51*abb93n112+t1*t52*abb93n83+t1*t&
         &53*abb93n106+t1*t54*abb93n106+t1*t55*abb93n110+t1*t56*abb93n110+t1*t58&
         &*abb93n114+t1*t59*abb93n114+t1*t61*abb93n120+t1*t62*abb93n100+t1*t63*a&
         &bb93n120+t1*t64*abb93n100+t1*t65*abb93n115+t1*t66*abb93n115+t1*t67*abb&
         &93n118+t1*t68*abb93n118+t1*t69*abb93n119+t1*t70*abb93n119+t1*t72*abb93&
         &n108+t1*t75*abb93n108+t1*t76*abb93n90+t1*t77*abb93n86+t1*t78*abb93n123&
         &+t1*t79*abb93n123+t1*t80*abb93n121+t1*t82*abb93n121+t10*t18*abb93n63+t&
         &10*t19*abb93n93+t10*t28*abb93n61+t105*t78*abb93n118+t105*t79*abb93n118&
         &+t106*t53*abb93n59+t106*t54*abb93n59+t106*t55*abb93n56+t106*t56*abb93n&
         &56+t106*t78*abb93n53+t106*t79*abb93n53+t107*t78*abb93n120+t107*t79*abb&
         &93n120+t108*t53*abb93n101+t108*t54*abb93n101+t108*t55*abb93n111+t108*t&
         &56*abb93n111+t109*t55*abb93n115+t109*t56*abb93n115+t11*t19*abb93n98+t1&
         &1*t28*abb93n63+t11*t30*abb93n63+t11*t37*abb93n55+t12*t18*abb93n63+t12*&
         &t19*abb93n93+t12*t30*abb93n61+t13*t18*abb93n98+t13*t28*abb93n93+t13*t3&
         &0*abb93n93+t15*t18*abb93n55+t2*t71*abb93n51+t2*t74*abb93n51+t29*t3*abb&
         &93n100+t29*t7*abb93n120+t3*t31*abb93n100+t3*t38*abb93n100+t3*t40*abb93&
         &n100+t3*t43*abb93n101+t3*t46*abb93n101+t3*t49*abb93n102+t3*t52*abb93n1&
         &02+t3*t55*abb93n121+t3*t56*abb93n121+t31*t7*abb93n120+t32*t4*abb93n115&
         &+t34*t4*abb93n115+t38*t7*abb93n118+t4*t43*abb93n111+t4*t46*abb93n111+t&
         &4*t49*abb93n112+t4*t52*abb93n112+t4*t53*abb93n121+t4*t54*abb93n121+t40&
         &*t7*abb93n118+t49*t7*abb93n119+t52*t7*abb93n119+t1*t3*t72*abb93n124+t1&
         &*t3*t75*abb93n124+t1*t5*t53*abb93n124+t1*t5*t54*abb93n124)
         return
      end if
      t105 = d(iv2,iv3)
      t106 = d(iv1,iv3)
      t2 = k1(iv3)
      t6 = k5(iv3)
      t8 = k6(iv3)
      t9 = qshift(iv3)
      t27 = t105*t14
      t29 = t106*t35
      t31 = spvak3k4(iv3)
      t58 = t110*t31
      t59 = t105*t15
      t81 = t106*t37
      t83 = spvak5k1(iv3)
      t84 = t110*t83
      t85 = t105*t16
      t86 = t106*t25
      t87 = spvak5k6(iv3)
      t88 = t110*t87
      t89 = k2(iv3)
      t72 = t72*t87
      t75 = t75*t87
      t90 = spvak2k1(iv3)
      t91 = t16*t25*t90
      t92 = spvak3k1(iv3)
      t93 = t16*t92
      t94 = t53*t87
      t95 = t54*t87
      t96 = t16*t31
      t97 = t25*t96
      t98 = t16*t83
      t99 = t16*t87
      t100 = t25*t87
      t71 = t71*t87
      t101 = t20*t25*t31
      t74 = t74*t87
      t102 = t16*t31*t73
      t103 = t14*t25*t90
      t104 = t16*t35*t90
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t27*abb93n87+t29*abb93n87+t58*abb93n87+t59*abb93&
         &n116+t72*abb93n107+t75*abb93n107+t81*abb93n116+t84*abb93n116+t85*abb93&
         &n103+t86*abb93n103+t88*abb93n103+t91*abb93n107+t94*abb93n105+t95*abb93&
         &n105+t97*abb93n105+spvak6k1(iv3)*t26*abb93n113+t1*t27*abb93n59+t1*t29*&
         &abb93n59+t1*t58*abb93n59+t1*t59*abb93n56+t1*t81*abb93n56+t1*t84*abb93n&
         &56+t1*t85*abb93n84+t1*t86*abb93n84+t1*t88*abb93n84+t10*t105*abb93n92+t&
         &100*t24*abb93n113+t105*t11*abb93n97+t105*t12*abb93n92+t105*t13*abb93n9&
         &4+t106*t18*abb93n97+t106*t19*abb93n94+t106*t28*abb93n92+t106*t30*abb93&
         &n92+t110*t2*abb93n92+t110*t6*abb93n97+t110*t8*abb93n92+t110*t9*abb93n9&
         &4+t21*t87*abb93n89+t22*t87*abb93n85+t25*t93*abb93n122+t25*t98*abb93n10&
         &9+t3*t72*abb93n51+t3*t75*abb93n51+t3*t85*abb93n59+t3*t86*abb93n59+t3*t&
         &88*abb93n59+t3*t91*abb93n51+t32*t87*abb93n81+t34*t87*abb93n81+t38*t87*&
         &abb93n77+t4*t85*abb93n56+t4*t86*abb93n56+t4*t88*abb93n56+t40*t87*abb93&
         &n77+t43*t87*abb93n79+t46*t87*abb93n79+t49*t87*abb93n84+t5*t94*abb93n51&
         &+t5*t95*abb93n51+t5*t97*abb93n51+t52*t87*abb93n84+t55*t87*abb93n109+t5&
         &6*t87*abb93n109+t57*t99*abb93n113+t7*t85*abb93n53+t7*t86*abb93n53+t7*t&
         &88*abb93n53+t76*t87*abb93n89+t77*t87*abb93n85+t78*t87*abb93n122+t79*t8&
         &7*abb93n122+spvak2k4(iv3)*t16*t25*abb93n89+spvak2k6(iv3)*t16*t25*abb93&
         &n85+t1*t105*t23*abb93n53+t1*t106*t60*abb93n53+t1*t110*t92*abb93n53+t16&
         &*t25*t6*abb93n77+t16*t25*t8*abb93n79+t16*t25*t89*abb93n81+t16*t25*t9*a&
         &bb93n84)+t1*t101*abb93n124+t1*t102*abb93n124+t1*t103*abb93n124+t1*t104&
         &*abb93n124+t1*t71*abb93n124+t1*t74*abb93n124+t36*t87*abb93n100+t39*t87&
         &*abb93n100+t41*t87*abb93n101+t42*t87*abb93n111+t44*t87*abb93n101+t45*t&
         &87*abb93n111+t47*t87*abb93n102+t48*t87*abb93n112+t50*t87*abb93n102+t51&
         &*t87*abb93n112+t61*t87*abb93n120+t62*t87*abb93n100+t63*t87*abb93n120+t&
         &64*t87*abb93n100+t65*t87*abb93n115+t66*t87*abb93n115+t67*t87*abb93n118&
         &+t68*t87*abb93n118+t69*t87*abb93n119+t70*t87*abb93n119+t80*t87*abb93n1&
         &21+t82*t87*abb93n121+t10*t25*t31*abb93n100+t10*t25*t92*abb93n120+t11*t&
         &25*t31*abb93n100+t11*t25*t92*abb93n118+t12*t25*t31*abb93n101+t12*t25*t&
         &83*abb93n111+t13*t25*t31*abb93n102+t13*t25*t83*abb93n112+t13*t25*t92*a&
         &bb93n119+t14*t2*t25*abb93n100+t14*t25*t6*abb93n100+t14*t25*t8*abb93n10&
         &1+t14*t25*t83*abb93n121+t14*t25*t9*abb93n102+t15*t25*t31*abb93n121+t15&
         &*t25*t8*abb93n111+t15*t25*t89*abb93n115+t15*t25*t9*abb93n112+t16*t18*t&
         &31*abb93n100+t16*t18*t92*abb93n118+t16*t19*t31*abb93n102+t16*t19*t83*a&
         &bb93n112+t16*t19*t92*abb93n119+t16*t2*t35*abb93n100+t16*t2*t60*abb93n1&
         &20+t16*t28*t31*abb93n101+t16*t28*t83*abb93n111+t16*t30*t31*abb93n100+t&
         &16*t30*t92*abb93n120+t16*t31*t37*abb93n121+t16*t33*t83*abb93n115+t16*t&
         &35*t6*abb93n100+t16*t35*t8*abb93n101+t16*t35*t83*abb93n121+t16*t35*t9*&
         &abb93n102+t16*t37*t8*abb93n111+t16*t37*t89*abb93n115+t16*t37*t9*abb93n&
         &112+t16*t6*t60*abb93n118+t16*t60*t9*abb93n119+t17*t25*t83*abb93n115+t2&
         &*t23*t25*abb93n120+t23*t25*t6*abb93n118+t23*t25*t9*abb93n119)
         return
      end if
      t107 = d(iv3,iv4)
      t108 = d(iv2,iv4)
      t109 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t2 = spvak3k1(iv4)
      t3 = spvak3k4(iv4)
      t4 = spvak5k1(iv4)
      t5 = spvak2k1(iv4)
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t105*t109*abb93n62+t106*t108*abb93n62+t107*t110*&
         &abb93n62)+(4.0_ki)*(t100*t109*abb93n68+t107*t26*abb93n68+t108*t99*abb9&
         &3n68+t1*t105*t16*abb93n68+t1*t106*t25*abb93n68+t1*t110*t87*abb93n68)+(&
         &2.0_ki)*(t1*t101*abb93n51+t1*t102*abb93n51+t1*t103*abb93n51+t1*t104*ab&
         &b93n51+t1*t71*abb93n51+t1*t74*abb93n51+t107*t53*abb93n59+t107*t54*abb9&
         &3n59+t107*t55*abb93n56+t107*t56*abb93n56+t107*t78*abb93n53+t107*t79*ab&
         &b93n53+t108*t93*abb93n53+t108*t96*abb93n59+t108*t98*abb93n56+t1*t105*t&
         &14*abb93n59+t1*t105*t15*abb93n56+t1*t105*t23*abb93n53+t1*t106*t35*abb9&
         &3n59+t1*t106*t37*abb93n56+t1*t106*t60*abb93n53+t1*t110*t31*abb93n59+t1&
         &*t110*t83*abb93n56+t1*t110*t92*abb93n53+t105*t16*t2*abb93n53+t105*t16*&
         &t3*abb93n59+t105*t16*t4*abb93n56+t106*t2*t25*abb93n53+t106*t25*t3*abb9&
         &3n59+t106*t25*t4*abb93n56+t108*t14*t87*abb93n59+t108*t15*t87*abb93n56+&
         &t108*t23*t87*abb93n53+t109*t25*t31*abb93n59+t109*t25*t83*abb93n56+t109&
         &*t25*t92*abb93n53+t109*t35*t87*abb93n59+t109*t37*t87*abb93n56+t109*t60&
         &*t87*abb93n53+t110*t2*t87*abb93n53+t110*t3*t87*abb93n59+t110*t4*t87*ab&
         &b93n56+t14*t25*t5*t87*abb93n51+t16*t25*t3*t90*abb93n51+t16*t25*t31*t5*&
         &abb93n51+t16*t3*t73*t87*abb93n51+t16*t35*t5*t87*abb93n51+t20*t25*t3*t8&
         &7*abb93n51))
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d93:
   subroutine     reconstruct_d93(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_93:
      coeffs%coeffs_93%c0 = derivative(czip)
      coeffs%coeffs_93%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_93%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_93%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_93%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_93%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_93%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_93%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_93%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_93%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_93%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_93%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_93%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_93%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_93%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_93%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_93%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_93%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_93%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_93%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_93%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_93%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_93%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_93%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_93%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_93%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_93%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_93%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_93%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_93%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_93%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_93%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_93%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_93%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_93%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_93%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_93%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_93%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_93%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_93%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_93%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_93%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_93%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_93%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_93%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_93%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_93%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_93%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_93%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_93%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_93%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_93%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_93%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_93%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_93%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_93%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_93%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_93%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_93%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_93%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_93%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_93%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_93%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_93%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_93%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_93%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_93%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_93%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_93%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_93%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_93:
   end subroutine reconstruct_d93
!---#] subroutine reconstruct_d93:
end module p7_dubar_emnebargg_d93h1l1d
