module     p7_dubar_emnebargg_abbrevd21h3
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_globalsh3
   implicit none
   private
   complex(ki), public :: abb21n1
   complex(ki), public :: abb21n2
   complex(ki), public :: abb21n3
   complex(ki), public :: abb21n4
   complex(ki), public :: abb21n5
   complex(ki), public :: abb21n6
   complex(ki), public :: abb21n7
   complex(ki), public :: abb21n8
   complex(ki), public :: abb21n9
   complex(ki), public :: abb21n10
   complex(ki), public :: abb21n11
   complex(ki), public :: abb21n12
   complex(ki), public :: abb21n13
   complex(ki), public :: abb21n14
   complex(ki), public :: abb21n15
   complex(ki), public :: abb21n16
   complex(ki), public :: abb21n17
   complex(ki), public :: abb21n18
   complex(ki), public :: abb21n19
   complex(ki), public :: abb21n20
   complex(ki), public :: abb21n21
   complex(ki), public :: abb21n22
   complex(ki), public :: abb21n23
   complex(ki), public :: abb21n24
   complex(ki), public :: abb21n25
   complex(ki), public :: abb21n26
   complex(ki), public :: rat2d21
   complex(ki), public :: abb21n28
   complex(ki), public :: abb21n29
   complex(ki), public :: abb21n30
   complex(ki), public :: abb21n31
   complex(ki), public :: abb21n32
   complex(ki), public :: abb21n33
   complex(ki), public :: abb21n34
   complex(ki), public :: abb21n35
   complex(ki), public :: abb21n36
   complex(ki), public :: abb21n37
   complex(ki), public :: abb21n38
   complex(ki), public :: abb21n39
   complex(ki), public :: abb21n40
   complex(ki), public :: abb21n41
   complex(ki), public :: abb21n42
   complex(ki), public :: abb21n43
   complex(ki), public :: abb21n44
   complex(ki), public :: abb21n45
   complex(ki), public :: abb21n46
   complex(ki), public :: abb21n47
   complex(ki), public :: abb21n48
   complex(ki), public :: abb21n49
   complex(ki), public :: abb21n50
   complex(ki), public :: abb21n51
   complex(ki), public :: abb21n52
   complex(ki), public :: abb21n53
   complex(ki), public :: abb21n54
   complex(ki), public :: abb21n55
   complex(ki), public :: abb21n56
   complex(ki), public :: abb21n57
   complex(ki), public :: abb21n58
   complex(ki), public :: abb21n59
   complex(ki), public :: abb21n60
   complex(ki), public :: abb21n61
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_dubar_emnebargg_config, only: deltaOS
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_model
      use p7_dubar_emnebargg_color, only: TR
      use p7_dubar_emnebargg_globalsl1, only: epspow
      implicit none
      t1 = TR*c2
      t2 = t1*i_
      t3 = t2*spak1k2
      t4 = spbk6k1*spbk6k1
      t5 = NC*(es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t6 = t5*spbk6k5*spbk6k5
      t7 = t2*spak1k5
      abb21n1 = ((4.0_ki)*(t4/t6*t7*spak2k5*spak3k6*spbk5k4-t3*t4/t6*spak1k5*spa&
      &k3k6*spbk4k1))
      t4 = es234*t1*i_
      t8 = t4/t6*spak1k2*spak3k6*spbk4k1*spbk6k1
      t9 = t4*spak2k5
      t10 = t9/t6*spak3k6*spbk5k4*spbk6k1
      t11 = es56*t1*i_
      t12 = t11/t6*spak1k2*spak3k6*spbk4k1*spbk6k1
      t13 = t11*spak2k5
      t14 = t13/t6*spak3k6*spbk5k4*spbk6k1
      t1 = es61*t1*i_
      t15 = t1/t6*spak1k2*spak3k6*spbk4k1*spbk6k1
      t16 = t1*spak2k5
      t17 = t16/t6*spak3k6*spbk5k4*spbk6k1
      abb21n2 = ((4.0_ki)*(t14+t17+t8-(t15+t12+t10)))
      abb21n3 = ((8.0_ki)*(t10+t12+t15-(t8+t17+t14)))
      abb21n4 = ((4.0_ki)*(t9/t6*spbk6k1-(t16/t6*spbk6k1+t13/t6*spbk6k1)))
      t8 = t7*spak2k3
      abb21n5 = ((4.0_ki)*(t1/t6*spak3k5*spbk6k1+t11/t6*spak3k5*spbk6k1+t8/t6*sp&
      &bk2k1*spbk6k1-t4/t6*spak3k5*spbk6k1))
      t9 = t8*spbk4k1
      t10 = t9/t6*spbk6k1
      abb21n6 = ((4.0_ki)*t10)
      abb21n7 = (-8.0_ki)*t10
      t10 = t7/t6*spak3k6*spbk4k1*spbk6k1
      abb21n8 = ((4.0_ki)*t10)
      abb21n9 = (-8.0_ki)*t10
      abb21n10 = ((4.0_ki)/t6*t7*spbk6k1)
      t7 = t2*spak2k5
      abb21n11 = (-8.0_ki)/t6*t7*spbk5k1
      t10 = t2*spak2k3
      t12 = t10*spak5k6
      t13 = t12*spbk5k1
      t14 = t13/t6*spbk5k4
      t15 = t2*spak2k6*spak3k5
      t16 = t15*spbk5k1
      t17 = t16/t6*spbk5k4
      abb21n12 = ((4.0_ki)*(t14+t17))
      abb21n13 = ((8.0_ki)*(-(t17+t14)))
      t11 = t11*spak2k3
      t1 = t1*spak2k3
      t14 = t3*spak3k5*spbk4k1
      t10 = t10*spak2k5*spbk4k2
      t17 = t7*spak3k5
      abb21n14 = ((4.0_ki)*(t1/t6*spbk4k1+t10/t6*spbk5k1+t11/t6*spbk4k1+t13/t6*s&
      &pbk6k4+t14/t6*spbk5k1+t16/t6*spbk6k4-(t4/t6*spak2k3*spbk4k1+t17/t6*spbk5k&
      &1*spbk5k4)))
      t4 = (16.0_ki)/t6*t7*spbk6k1
      abb21n15 = t4
      abb21n16 = -(t4)
      t4 = t12/t6*spbk5k4*spbk6k1
      t13 = t15*spbk5k4
      t16 = t13/t6*spbk6k1
      t18 = t16+t4
      abb21n17 = ((16.0_ki)*t18)
      abb21n18 = ((8.0_ki)*t18)
      t4 = -(t4+t16)
      abb21n19 = ((8.0_ki)*t4)
      abb21n20 = ((16.0_ki)*t4)
      t4 = t14/t6*spbk6k1
      t16 = t10/t6*spbk6k1
      t12 = t12/t6*spbk6k1*spbk6k4
      t17 = t17*spbk5k4
      t18 = t17/t6*spbk6k1
      t19 = t15/t6*spbk6k1*spbk6k4
      abb21n21 = ((8.0_ki)*(t12+t16+t19+t4-t18))
      abb21n22 = ((8.0_ki)*(t18-(t4+t19+t16+t12)))
      t4 = t5*spbk6k5
      abb21n23 = ((8.0_ki)*(-(t3/t6*spbk6k1+t7/t4)))
      t5 = t11/t6*spbk5k4
      t7 = t1/t6*spbk5k4
      t12 = t13/t4
      t2 = t2*spak1k3
      t13 = t2*spak2k6
      t16 = t13/t6*spbk5k4*spbk6k1
      abb21n24 = ((4.0_ki)*(t12+t16+t5+t7))
      abb21n25 = ((8.0_ki)*(-(t7+t5+t16+t12)))
      abb21n26 = ((4.0_ki)*(t10/t4+t14/t4+t9/t4+t1/t6*spbk6k4+t11/t6*spbk6k4+t15&
      &/t4*spbk6k4+t13/t6*spbk6k1*spbk6k4+t8/t6*spbk5k4*spbk6k1+t3/t6*spak1k3*sp&
      &bk4k1*spbk6k1+t3/t6*spak2k3*spbk4k2*spbk6k1-(t2/t6*spak2k5*spbk5k4*spbk6k&
      &1+t17/t4)))
      rat2d21 = 0
      rat2 = rat2 + rat2d21
      abb21n28 = -(abb21n1)
      abb21n29 = abb21n26
      abb21n30 = abb21n25
      abb21n31 = abb21n22
      abb21n32 = abb21n21
      abb21n33 = abb21n20
      abb21n34 = abb21n17
      abb21n35 = abb21n14
      abb21n36 = abb21n13
      abb21n37 = abb21n9
      abb21n38 = abb21n8
      abb21n39 = abb21n7
      abb21n40 = abb21n5
      abb21n41 = abb21n4
      abb21n42 = abb21n2
      abb21n43 = ((2.0_ki)*abb21n2)
      abb21n44 = -(abb21n3)
      abb21n45 = -(abb21n6)
      abb21n46 = (-2.0_ki)*abb21n6
      abb21n47 = -(abb21n8)
      abb21n48 = (-2.0_ki)*abb21n8
      abb21n49 = -(abb21n10)
      abb21n50 = -(abb21n11)
      abb21n51 = -(abb21n12)
      abb21n52 = (-2.0_ki)*abb21n12
      abb21n53 = -(abb21n15)
      abb21n54 = -(abb21n16)
      abb21n55 = -(abb21n18)
      abb21n56 = (-2.0_ki)*abb21n18
      abb21n57 = -(abb21n19)
      abb21n58 = (-2.0_ki)*abb21n19
      abb21n59 = -(abb21n23)
      abb21n60 = -(abb21n24)
      abb21n61 = (-2.0_ki)*abb21n24
   end subroutine
end module p7_dubar_emnebargg_abbrevd21h3
