module     p7_dubar_emnebargg_d26h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity3/d26h3l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d26
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd26h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      real(ki) :: t43
      real(ki) :: t44
      real(ki) :: t45
      real(ki) :: t46
      real(ki) :: t47
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6+k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t43 = dotproduct(qshift, qshift)
      t1 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t2 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t44 = dotproduct(k2, qshift)
      t45 = dotproduct(k6, qshift)
      t46 = dotproduct(k5, qshift)
      t3 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t47 = dotproduct(k1, qshift)
      t4 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t7 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t8 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t9 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t10 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-s&
      &pvak5k2(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb26n33+t1*abb26n74+t2*abb26n75+t3*abb26n88+t43*abb26n44+&
         &t44*abb26n76+t45*abb26n77+t46*abb26n78+t47*abb26n90+t1*t2*abb26n35+t1*&
         &t3*abb26n58+t1*t43*abb26n97+t1*t44*abb26n38+t1*t45*abb26n36+t1*t46*abb&
         &26n36+t10*t2*abb26n52+t2*t3*abb26n42+t2*t4*abb26n38+t2*t43*abb26n84+t2&
         &*t44*abb26n49+t2*t45*abb26n47+t2*t46*abb26n49+t2*t5*abb26n40+t2*t6*abb&
         &26n41+t2*t7*abb26n46+t2*t8*abb26n50+t2*t9*abb26n51+t3*t43*abb26n65+t3*&
         &t45*abb26n61+t3*t47*abb26n62+t43*t5*abb26n71+t47*t5*abb26n60+t2*t3*t4*&
         &abb26n101+t2*t3*t6*abb26n94)
         return
      end if
      t11 = k1(iv1)
      t12 = k2(iv1)
      t13 = k5(iv1)
      t14 = k6(iv1)
      t15 = qshift(iv1)
      t16 = spvak3k4(iv1)
      t17 = spvak6k1(iv1)
      t18 = spvak6k5(iv1)
      t19 = spvak2k1(iv1)
      t20 = spvak2k5(iv1)
      t21 = spvak2k6(iv1)
      t22 = spvak3k1(iv1)
      t23 = spvak5k1(iv1)
      t24 = spvak5k2(iv1)
      t25 = spvak5k6(iv1)
      t26 = t17*abb26n99
      t27 = t18*abb26n82
      if(deg.eq.1) then
         numerator = (t11*abb26n43+t12*abb26n55+t13*abb26n53+t14*abb26n54+t15*ab&
         &b26n89+t16*abb26n45+t17*abb26n57+t18*abb26n56+t26*t45+t26*t46+t27*t44+&
         &t27*t46+t1*t12*abb26n95+t1*t13*abb26n99+t1*t14*abb26n99+t1*t15*abb26n9&
         &6+t1*t16*abb26n73+t1*t18*abb26n100+t10*t18*abb26n79+t11*t3*abb26n67+t1&
         &1*t5*abb26n69+t12*t2*abb26n82+t13*t2*abb26n82+t14*t2*abb26n86+t14*t3*a&
         &bb26n68+t15*t2*abb26n83+t15*t3*abb26n64+t15*t5*abb26n70+t16*t2*abb26n9&
         &1+t16*t43*abb26n63+t16*t45*abb26n68+t16*t47*abb26n67+t17*t2*abb26n100+&
         &t17*t3*abb26n73+t17*t43*abb26n37+t17*t44*abb26n95+t18*t3*abb26n91+t18*&
         &t4*abb26n95+t18*t43*abb26n48+t18*t45*abb26n86+t18*t5*abb26n93+t18*t6*a&
         &bb26n92+t18*t7*abb26n87+t18*t8*abb26n81+t18*t9*abb26n80+t19*t2*abb26n9&
         &2+t2*t20*abb26n80+t2*t21*abb26n81+t2*t22*abb26n93+t2*t23*abb26n95+t2*t&
         &24*abb26n79+t2*t25*abb26n87+t22*t43*abb26n59+t22*t47*abb26n69+t16*t2*t&
         &4*abb26n34+t16*t2*t6*abb26n39+t18*t3*t4*abb26n34+t18*t3*t6*abb26n39+t1&
         &9*t2*t3*abb26n39+t2*t23*t3*abb26n34)
         return
      end if
      t43 = d(iv1,iv2)
      t7 = spvak3k1(iv2)
      t8 = spvak3k4(iv2)
      t9 = k1(iv2)
      t10 = spvak6k1(iv2)
      t26 = spvak6k5(iv2)
      t27 = k2(iv2)
      t28 = k5(iv2)
      t29 = k6(iv2)
      t30 = qshift(iv2)
      t31 = t19*t26
      t32 = spvak2k1(iv2)
      t33 = t18*t32
      t34 = t16*t26
      t35 = t18*t8
      t36 = t23*t26
      t37 = spvak5k1(iv2)
      t38 = t18*t37
      t39 = t19*t8
      t40 = t16*t32
      t41 = t16*t37
      t42 = t23*t8
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t43*abb26n44+t1*t43*abb26n97+t2*t43*abb26n84+t3*&
         &t43*abb26n65+t43*t5*abb26n71)+t31*abb26n41+t33*abb26n41+t34*abb26n42+t&
         &35*abb26n42+t36*abb26n38+t38*abb26n38+spvak2k5(iv2)*t18*abb26n51+spvak&
         &2k6(iv2)*t18*abb26n50+spvak5k2(iv2)*t18*abb26n52+spvak5k6(iv2)*t18*abb&
         &26n46+t10*t12*abb26n38+t10*t13*abb26n36+t10*t14*abb26n36+t10*t15*abb26&
         &n98+t10*t16*abb26n58+t10*t18*abb26n35+t11*t7*abb26n60+t11*t8*abb26n62+&
         &t12*t26*abb26n49+t13*t26*abb26n49+t14*t26*abb26n47+t14*t8*abb26n61+t15&
         &*t26*abb26n85+t15*t7*abb26n72+t15*t8*abb26n66+t16*t29*abb26n61+t16*t30&
         &*abb26n66+t16*t9*abb26n62+t17*t26*abb26n35+t17*t27*abb26n38+t17*t28*ab&
         &b26n36+t17*t29*abb26n36+t17*t30*abb26n98+t17*t8*abb26n58+t18*t27*abb26&
         &n49+t18*t28*abb26n49+t18*t29*abb26n47+t18*t30*abb26n85+t18*t7*abb26n40&
         &+t2*t39*abb26n94+t2*t40*abb26n94+t2*t41*abb26n101+t2*t42*abb26n101+t20&
         &*t26*abb26n51+t21*t26*abb26n50+t22*t26*abb26n40+t22*t30*abb26n72+t22*t&
         &9*abb26n60+t24*t26*abb26n52+t25*t26*abb26n46+t3*t31*abb26n94+t3*t33*ab&
         &b26n94+t3*t36*abb26n101+t3*t38*abb26n101+t34*t4*abb26n101+t34*t6*abb26&
         &n94+t35*t4*abb26n101+t35*t6*abb26n94)
         return
      end if
      t44 = d(iv2,iv3)
      t45 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t2 = spvak6k5(iv3)
      t3 = spvak2k1(iv3)
      t4 = spvak5k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k1(iv3)*t43*abb26n59+spvak6k1(iv3)*t43*abb&
         &26n37+t1*t43*abb26n63+t10*t45*abb26n37+t16*t44*abb26n63+t17*t44*abb26n&
         &37+t18*t44*abb26n48+t2*t43*abb26n48+t22*t44*abb26n59+t26*t45*abb26n48+&
         &t45*t7*abb26n59+t45*t8*abb26n63)+t2*t39*abb26n39+t2*t40*abb26n39+t2*t4&
         &1*abb26n34+t2*t42*abb26n34+t1*t18*t32*abb26n39+t1*t18*t37*abb26n34+t1*&
         &t19*t26*abb26n39+t1*t23*t26*abb26n34+t16*t26*t3*abb26n39+t16*t26*t4*ab&
         &b26n34+t18*t3*t8*abb26n39+t18*t4*t8*abb26n34)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d26:
   subroutine     reconstruct_d26(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_26:
      coeffs%coeffs_26%c0 = derivative(czip)
      coeffs%coeffs_26%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_26%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_26%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_26%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_26%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_26%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_26%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_26%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_26%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_26%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_26%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_26%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_26%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_26%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_26%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_26%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_26%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_26%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_26%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_26%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_26%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_26%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_26%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_26%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_26%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_26%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_26%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_26%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_26%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_26%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_26%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_26%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_26%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_26%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_26:
   end subroutine reconstruct_d26
!---#] subroutine reconstruct_d26:
end module p7_dubar_emnebargg_d26h3l1d
