module     p7_dubar_emnebargg_d94h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity3/d94h3l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d94
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd94h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      complex(ki) :: t105
      complex(ki) :: t106
      complex(ki) :: t107
      complex(ki) :: t108
      complex(ki) :: t109
      complex(ki) :: t110
      complex(ki) :: t111
      complex(ki) :: t112
      complex(ki) :: t113
      complex(ki) :: t114
      complex(ki) :: t115
      complex(ki) :: t116
      complex(ki) :: t117
      complex(ki) :: t118
      complex(ki) :: t119
      complex(ki) :: t120
      complex(ki) :: t121
      complex(ki) :: t122
      complex(ki) :: t123
      complex(ki) :: t124
      complex(ki) :: t125
      complex(ki) :: t126
      complex(ki) :: t127
      complex(ki) :: t128
      complex(ki) :: t129
      complex(ki) :: t130
      complex(ki) :: t131
      complex(ki) :: t132
      complex(ki) :: t133
      complex(ki) :: t134
      complex(ki) :: t135
      complex(ki) :: t136
      complex(ki) :: t137
      complex(ki) :: t138
      complex(ki) :: t139
      complex(ki) :: t140
      complex(ki) :: t141
      complex(ki) :: t142
      complex(ki) :: t143
      complex(ki) :: t144
      complex(ki) :: t145
      complex(ki) :: t146
      complex(ki) :: t147
      complex(ki) :: t148
      complex(ki) :: t149
      complex(ki) :: t150
      complex(ki) :: t151
      complex(ki) :: t152
      complex(ki) :: t153
      complex(ki) :: t154
      complex(ki) :: t155
      complex(ki) :: t156
      complex(ki) :: t157
      complex(ki) :: t158
      complex(ki) :: t159
      complex(ki) :: t160
      complex(ki) :: t161
      complex(ki) :: t162
      complex(ki) :: t163
      complex(ki) :: t164
      complex(ki) :: t165
      complex(ki) :: t166
      complex(ki) :: t167
      complex(ki) :: t168
      complex(ki) :: t169
      complex(ki) :: t170
      complex(ki) :: t171
      complex(ki) :: t172
      complex(ki) :: t173
      complex(ki) :: t174
      complex(ki) :: t175
      complex(ki) :: t176
      complex(ki) :: t177
      complex(ki) :: t178
      complex(ki) :: t179
      complex(ki) :: t180
      complex(ki) :: t181
      complex(ki) :: t182
      complex(ki) :: t183
      complex(ki) :: t184
      complex(ki) :: t185
      complex(ki) :: t186
      complex(ki) :: t187
      complex(ki) :: t188
      complex(ki) :: t189
      complex(ki) :: t190
      complex(ki) :: t191
      complex(ki) :: t192
      real(ki) :: t193
      real(ki) :: t194
      real(ki) :: t195
      real(ki) :: t196
      real(ki) :: t197
      real(ki) :: t198
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t193 = dotproduct(k6, qshift)
      t194 = dotproduct(qshift, qshift)
      t195 = dotproduct(k2, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t196 = dotproduct(k1, qshift)
      t2 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t197 = dotproduct(k5, qshift)
      t3 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t4 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t7 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t8 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t9 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb94n82+t1*abb94n163+t193*abb94n188+t193*t193*abb94n126+t&
         &194*abb94n140+t194*t194*abb94n128+t195*abb94n162+t196*abb94n169+t197*a&
         &bb94n190+t2*abb94n171+t3*abb94n191+t4*abb94n199+t1*t193*abb94n149+t1*t&
         &194*abb94n180+t1*t196*abb94n157+t1*t197*abb94n147+t1*t2*abb94n150+t1*t&
         &3*abb94n146+t1*t4*abb94n145+t193*t194*abb94n202+t193*t195*abb94n159+t1&
         &93*t196*abb94n131+t193*t197*abb94n129+t193*t2*abb94n98+t193*t3*abb94n1&
         &24+t193*t4*abb94n119+t193*t5*abb94n153+t194*t195*abb94n166+t194*t196*a&
         &bb94n209+t194*t197*abb94n209+t194*t2*abb94n251+t194*t3*abb94n231+t194*&
         &t4*abb94n222+t194*t5*abb94n174+t195*t196*abb94n159+t195*t2*abb94n155+t&
         &195*t3*abb94n143+t195*t4*abb94n121+t196*t197*abb94n125+t196*t3*abb94n1&
         &12+t196*t4*abb94n117+t196*t5*abb94n151+t197*t2*abb94n100+t197*t3*abb94&
         &n142+t197*t4*abb94n120+t2*t3*abb94n89+t2*t4*abb94n144+t3*t4*abb94n111+&
         &t4*t6*abb94n97+t1*t193*t2*abb94n261+t1*t193*t3*abb94n217+t1*t193*t4*ab&
         &b94n228+t1*t194*t2*abb94n91+t1*t194*t3*abb94n123+t1*t194*t4*abb94n116+&
         &t1*t196*t3*abb94n217+t1*t196*t4*abb94n228+t1*t197*t2*abb94n265+t1*t197&
         &*t4*abb94n229+t1*t2*t3*abb94n273+t1*t3*t4*abb94n235+t1*t4*t6*abb94n260&
         &+t193*t3*t4*abb94n197+t193*t3*t5*abb94n271+t193*t4*t5*abb94n259+t194*t&
         &2*t3*abb94n105+t194*t3*t4*abb94n137+t194*t3*t5*abb94n87+t194*t4*t5*abb&
         &94n95+t194*t4*t6*abb94n102+t195*t2*t3*abb94n239+t195*t3*t4*abb94n195+t&
         &195*t4*t6*abb94n244+t196*t3*t5*abb94n267+t196*t4*t5*abb94n255+t197*t2*&
         &t3*abb94n243+t197*t3*t4*abb94n196+t197*t4*t6*abb94n248+t2*t3*t4*abb94n&
         &248+t3*t4*t5*abb94n272+t3*t4*t6*abb94n238+t3*t4*t7*abb94n198+t3*t4*t8*&
         &abb94n236+t3*t4*t9*abb94n237+t1*t3*t4*t9*abb94n83)
         return
      end if
      t10 = k1(iv1)
      t11 = k2(iv1)
      t12 = k5(iv1)
      t13 = k6(iv1)
      t14 = qshift(iv1)
      t15 = spvak3k4(iv1)
      t16 = spvak5k6(iv1)
      t17 = spvak6k1(iv1)
      t18 = spvak6k5(iv1)
      t19 = t11*abb94n164
      t20 = t14*abb94n208
      t21 = spvak3k1(iv1)
      t22 = spvak5k1(iv1)
      t23 = spvak2k1(iv1)
      t24 = spvak2k4(iv1)
      t25 = spvak2k5(iv1)
      t26 = t15*abb94n115
      t27 = t15*abb94n122
      t28 = t16*abb94n122
      t29 = t18*abb94n101
      t30 = t18*abb94n115
      if(deg.eq.1) then
         numerator = (t10*abb94n156+t11*abb94n161+t12*abb94n139+t13*abb94n141+t1&
         &4*abb94n189+t15*abb94n160+t16*abb94n138+t17*abb94n154+t18*abb94n132+t1&
         &9*t193+t19*t196+t196*t20+t197*t20+t1*t10*abb94n168+t1*t12*abb94n182+t1&
         &*t13*abb94n178+t1*t14*abb94n179+t1*t16*abb94n183+t1*t17*abb94n177+t1*t&
         &18*abb94n184+t1*t193*t28+t1*t193*t30+t1*t196*t28+t1*t196*t30+t10*t193*&
         &abb94n200+t10*t194*abb94n127+t10*t195*abb94n164+t10*t197*abb94n212+t10&
         &*t3*abb94n233+t10*t4*abb94n224+t10*t5*abb94n176+t11*t194*abb94n158+t11&
         &*t2*abb94n170+t11*t3*abb94n186+t11*t4*abb94n218+t12*t193*abb94n204+t12&
         &*t194*abb94n127+t12*t196*abb94n212+t12*t2*abb94n249+t12*t3*abb94n187+t&
         &12*t4*abb94n219+t13*t193*abb94n211+t13*t194*abb94n130+t13*t195*abb94n1&
         &64+t13*t196*abb94n200+t13*t197*abb94n204+t13*t2*abb94n253+t13*t3*abb94&
         &n213+t13*t4*abb94n220+t13*t5*abb94n172+t14*t193*abb94n201+t14*t194*abb&
         &94n207+t14*t195*abb94n165+t14*t2*abb94n250+t14*t3*abb94n230+t14*t4*abb&
         &94n221+t14*t5*abb94n173+t15*t193*abb94n178+t15*t194*abb94n148+t15*t196&
         &*abb94n168+t15*t197*abb94n182+t15*t2*abb94n177+t15*t3*abb94n183+t15*t4&
         &*abb94n184+t16*t193*abb94n213+t16*t194*abb94n113+t16*t195*abb94n186+t1&
         &6*t196*abb94n233+t16*t197*abb94n187+t16*t2*abb94n266+t16*t4*abb94n234+&
         &t17*t193*abb94n253+t17*t194*abb94n99+t17*t195*abb94n170+t17*t197*abb94&
         &n249+t17*t3*abb94n266+t17*t4*abb94n185+t18*t193*abb94n220+t18*t194*abb&
         &94n118+t18*t195*abb94n218+t18*t196*abb94n224+t18*t197*abb94n219+t18*t2&
         &*abb94n185+t18*t3*abb94n234+t18*t6*abb94n254+t193*t21*abb94n172+t193*t&
         &26*t4+t193*t27*t3+t194*t21*abb94n152+t196*t21*abb94n176+t196*t26*t4+t1&
         &96*t27*t3+t197*t29*t6+t2*t29*t3+t22*t4*abb94n254+t1*t10*t3*abb94n122+t&
         &1*t10*t4*abb94n115+t1*t12*t2*abb94n90+t1*t12*t4*abb94n114+t1*t13*t2*ab&
         &b94n92+t1*t13*t3*abb94n122+t1*t13*t4*abb94n115+t1*t14*t2*abb94n264+t1*&
         &t14*t3*abb94n216+t1*t14*t4*abb94n227+t1*t16*t194*abb94n215+t1*t16*t2*a&
         &bb94n84+t1*t16*t4*abb94n110+t1*t17*t193*abb94n92+t1*t17*t194*abb94n263&
         &+t1*t17*t197*abb94n90+t1*t17*t3*abb94n84+t1*t18*t194*abb94n226+t1*t18*&
         &t197*abb94n114+t1*t18*t3*abb94n110+t1*t18*t6*abb94n93+t1*t22*t4*abb94n&
         &93+t10*t3*t5*abb94n88+t10*t4*t5*abb94n96+t11*t2*t3*abb94n106+t11*t3*t4&
         &*abb94n136+t11*t4*t6*abb94n103+t12*t2*t3*abb94n104+t12*t3*t4*abb94n135&
         &+t12*t4*t6*abb94n101+t13*t3*t4*abb94n134+t13*t3*t5*abb94n86+t13*t4*t5*&
         &abb94n94+t14*t2*t3*abb94n242+t14*t3*t4*abb94n194+t14*t3*t5*abb94n270+t&
         &14*t4*t5*abb94n258+t14*t4*t6*abb94n247+t15*t193*t2*abb94n92+t15*t194*t&
         &2*abb94n263+t15*t194*t3*abb94n215+t15*t194*t4*abb94n226+t15*t197*t2*ab&
         &b94n90+t15*t197*t4*abb94n114+t15*t2*t3*abb94n84+t15*t3*t4*abb94n110+t1&
         &5*t4*t6*abb94n93+t16*t193*t4*abb94n134+t16*t193*t5*abb94n86+t16*t194*t&
         &2*abb94n241+t16*t194*t4*abb94n193+t16*t194*t5*abb94n269+t16*t195*t2*ab&
         &b94n106+t16*t195*t4*abb94n136+t16*t196*t5*abb94n88+t16*t197*t2*abb94n1&
         &04+t16*t197*t4*abb94n135+t16*t2*t4*abb94n101+t16*t4*t5*abb94n85+t16*t4&
         &*t6*abb94n107+t16*t4*t7*abb94n133+t16*t4*t8*abb94n109+t16*t4*t9*abb94n&
         &108+t17*t194*t3*abb94n241+t17*t195*t3*abb94n106+t17*t197*t3*abb94n104+&
         &t17*t3*t4*abb94n101+t18*t193*t3*abb94n134+t18*t193*t5*abb94n94+t18*t19&
         &4*t3*abb94n193+t18*t194*t5*abb94n257+t18*t194*t6*abb94n246+t18*t195*t3&
         &*abb94n136+t18*t195*t6*abb94n103+t18*t196*t5*abb94n96+t18*t197*t3*abb9&
         &4n135+t18*t3*t5*abb94n85+t18*t3*t6*abb94n107+t18*t3*t7*abb94n133+t18*t&
         &3*t8*abb94n109+t18*t3*t9*abb94n108+t193*t21*t3*abb94n86+t193*t21*t4*ab&
         &b94n94+t194*t21*t3*abb94n269+t194*t21*t4*abb94n257+t194*t22*t4*abb94n2&
         &46+t195*t22*t4*abb94n103+t196*t21*t3*abb94n88+t196*t21*t4*abb94n96+t19&
         &7*t22*t4*abb94n101+t21*t3*t4*abb94n85+t22*t3*t4*abb94n107+t23*t3*t4*ab&
         &b94n108+t24*t3*t4*abb94n109+t25*t3*t4*abb94n133+t1*t16*t4*t9*abb94n274&
         &+t1*t18*t3*t9*abb94n274+t1*t23*t3*t4*abb94n274+t15*t3*t4*t9*abb94n274)
         return
      end if
      t198 = d(iv1,iv2)
      t19 = k6(iv2)
      t20 = qshift(iv2)
      t26 = t198*abb94n209
      t27 = k2(iv2)
      t28 = k5(iv2)
      t29 = spvak3k1(iv2)
      t30 = t10*t29
      t31 = spvak3k4(iv2)
      t32 = t10*t31
      t33 = spvak5k6(iv2)
      t34 = t10*t33
      t35 = spvak6k5(iv2)
      t36 = t10*t35
      t37 = k1(iv2)
      t38 = t21*t37
      t39 = t15*t37
      t40 = t16*t37
      t41 = t18*t37
      t42 = t11*t33
      t43 = spvak6k1(iv2)
      t44 = t11*t43
      t45 = t11*t35
      t46 = t16*t27
      t47 = t17*t27
      t48 = t18*t27
      t49 = t12*t31
      t50 = t12*t33
      t51 = t12*t43
      t52 = t12*t35
      t53 = t15*t28
      t54 = t16*t28
      t55 = t17*t28
      t56 = t18*t28
      t57 = t13*t29
      t58 = t13*t31
      t59 = t13*t33
      t60 = t13*t43
      t61 = t13*t35
      t62 = t19*t21
      t63 = t15*t19
      t64 = t16*t19
      t65 = t17*t19
      t66 = t18*t19
      t67 = t14*t29
      t68 = t14*t31
      t69 = t14*t33
      t70 = t14*t43
      t71 = t14*t35
      t72 = t20*t21
      t73 = t15*t20
      t74 = t16*t20
      t75 = t17*t20
      t76 = t18*t20
      t77 = t15*t33
      t78 = t15*t43
      t79 = t15*t35
      t80 = t16*t31
      t81 = t17*t31
      t82 = t18*t31
      t83 = t22*t35
      t84 = spvak5k1(iv2)
      t85 = t18*t84
      t86 = t16*t43
      t87 = t16*t35
      t88 = t17*t33
      t89 = t18*t33
      t90 = t17*t35
      t91 = t18*t43
      t92 = t11*t84
      t93 = t22*t27
      t94 = t12*t84
      t95 = t22*t28
      t96 = t14*t84
      t97 = t20*t22
      t98 = t23*t33
      t99 = t23*t35
      t100 = spvak2k1(iv2)
      t101 = t100*t16
      t102 = t100*t18
      t103 = t24*t33
      t104 = spvak2k4(iv2)
      t105 = t104*t16
      t106 = t25*t33
      t107 = spvak2k5(iv2)
      t108 = t107*t16
      t109 = t21*t33
      t110 = t21*t35
      t111 = t16*t29
      t112 = t18*t29
      t113 = t15*t84
      t114 = t77*abb94n217
      t115 = t79*abb94n228
      t116 = t22*t31
      t117 = t80*abb94n217
      t118 = t82*abb94n228
      t119 = t22*t33
      t120 = t16*t84
      t121 = t23*t31
      t122 = t100*t15
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t196*t26+t197*t26+t198*abb94n140+t1*t198*abb94n1&
         &80+t13*t19*abb94n126+t14*t20*abb94n205+t193*t198*abb94n202+t194*t198*a&
         &bb94n206+t195*t198*abb94n166+t198*t2*abb94n251+t198*t3*abb94n231+t198*&
         &t4*abb94n222+t198*t5*abb94n174+t1*t198*t2*abb94n91+t1*t198*t3*abb94n12&
         &3+t1*t198*t4*abb94n116+t198*t2*t3*abb94n105+t198*t3*t4*abb94n137+t198*&
         &t3*t5*abb94n87+t198*t4*t5*abb94n95+t198*t4*t6*abb94n102)+t114*t193+t11&
         &4*t196+t115*t193+t115*t196+t117*t193+t117*t196+t118*t193+t118*t196+t30&
         &*abb94n151+t32*abb94n157+t34*abb94n112+t36*abb94n117+t38*abb94n151+t39&
         &*abb94n157+t40*abb94n112+t41*abb94n117+t42*abb94n143+t44*abb94n155+t45&
         &*abb94n121+t46*abb94n143+t47*abb94n155+t48*abb94n121+t49*abb94n147+t50&
         &*abb94n142+t51*abb94n100+t52*abb94n120+t53*abb94n147+t54*abb94n142+t55&
         &*abb94n100+t56*abb94n120+t57*abb94n153+t58*abb94n149+t59*abb94n124+t60&
         &*abb94n98+t61*abb94n119+t62*abb94n153+t63*abb94n149+t64*abb94n124+t65*&
         &abb94n98+t66*abb94n119+t67*abb94n175+t68*abb94n181+t69*abb94n232+t70*a&
         &bb94n252+t71*abb94n223+t72*abb94n175+t73*abb94n181+t74*abb94n232+t75*a&
         &bb94n252+t76*abb94n223+t77*abb94n146+t78*abb94n150+t79*abb94n145+t80*a&
         &bb94n146+t81*abb94n150+t82*abb94n145+t83*abb94n97+t85*abb94n97+t86*abb&
         &94n89+t87*abb94n111+t88*abb94n89+t89*abb94n111+t90*abb94n144+t91*abb94&
         &n144+t1*t34*abb94n217+t1*t36*abb94n228+t1*t40*abb94n217+t1*t41*abb94n2&
         &28+t1*t51*abb94n265+t1*t52*abb94n229+t1*t55*abb94n265+t1*t56*abb94n229&
         &+t1*t59*abb94n217+t1*t60*abb94n261+t1*t61*abb94n228+t1*t64*abb94n217+t&
         &1*t65*abb94n261+t1*t66*abb94n228+t1*t69*abb94n214+t1*t70*abb94n262+t1*&
         &t71*abb94n225+t1*t74*abb94n214+t1*t75*abb94n262+t1*t76*abb94n225+t1*t8&
         &3*abb94n260+t1*t85*abb94n260+t1*t86*abb94n273+t1*t87*abb94n235+t1*t88*&
         &abb94n273+t1*t89*abb94n235+t10*t19*abb94n131+t10*t20*abb94n210+t10*t27&
         &*abb94n159+t10*t28*abb94n125+t101*t4*abb94n237+t102*t3*abb94n237+t103*&
         &t4*abb94n236+t105*t4*abb94n236+t106*t4*abb94n198+t108*t4*abb94n198+t10&
         &9*t193*abb94n271+t109*t194*abb94n87+t109*t196*abb94n267+t109*t4*abb94n&
         &272+t11*t19*abb94n159+t11*t20*abb94n167+t11*t37*abb94n159+t110*t193*ab&
         &b94n259+t110*t194*abb94n95+t110*t196*abb94n255+t110*t3*abb94n272+t111*&
         &t193*abb94n271+t111*t194*abb94n87+t111*t196*abb94n267+t111*t4*abb94n27&
         &2+t112*t193*abb94n259+t112*t194*abb94n95+t112*t196*abb94n255+t112*t3*a&
         &bb94n272+t113*t4*abb94n260+t116*t4*abb94n260+t119*t4*abb94n238+t12*t19&
         &*abb94n129+t12*t20*abb94n210+t12*t37*abb94n125+t120*t4*abb94n238+t13*t&
         &20*abb94n203+t13*t27*abb94n159+t13*t28*abb94n129+t13*t37*abb94n131+t14&
         &*t19*abb94n203+t14*t27*abb94n167+t14*t28*abb94n210+t14*t37*abb94n210+t&
         &193*t78*abb94n261+t193*t81*abb94n261+t193*t87*abb94n197+t193*t89*abb94&
         &n197+t194*t77*abb94n123+t194*t78*abb94n91+t194*t79*abb94n116+t194*t80*&
         &abb94n123+t194*t81*abb94n91+t194*t82*abb94n116+t194*t83*abb94n102+t194&
         &*t85*abb94n102+t194*t86*abb94n105+t194*t87*abb94n137+t194*t88*abb94n10&
         &5+t194*t89*abb94n137+t195*t83*abb94n244+t195*t85*abb94n244+t195*t86*ab&
         &b94n239+t195*t87*abb94n195+t195*t88*abb94n239+t195*t89*abb94n195+t197*&
         &t78*abb94n265+t197*t79*abb94n229+t197*t81*abb94n265+t197*t82*abb94n229&
         &+t197*t83*abb94n248+t197*t85*abb94n248+t197*t86*abb94n243+t197*t87*abb&
         &94n196+t197*t88*abb94n243+t197*t89*abb94n196+t2*t42*abb94n239+t2*t46*a&
         &bb94n239+t2*t49*abb94n265+t2*t50*abb94n243+t2*t53*abb94n265+t2*t54*abb&
         &94n243+t2*t58*abb94n261+t2*t63*abb94n261+t2*t68*abb94n262+t2*t69*abb94&
         &n240+t2*t73*abb94n262+t2*t74*abb94n240+t2*t77*abb94n273+t2*t80*abb94n2&
         &73+t2*t87*abb94n248+t2*t89*abb94n248+t3*t30*abb94n267+t3*t32*abb94n217&
         &+t3*t38*abb94n267+t3*t39*abb94n217+t3*t44*abb94n239+t3*t45*abb94n195+t&
         &3*t47*abb94n239+t3*t48*abb94n195+t3*t51*abb94n243+t3*t52*abb94n196+t3*&
         &t55*abb94n243+t3*t56*abb94n196+t3*t57*abb94n271+t3*t58*abb94n217+t3*t6&
         &1*abb94n197+t3*t62*abb94n271+t3*t63*abb94n217+t3*t66*abb94n197+t3*t67*&
         &abb94n268+t3*t68*abb94n214+t3*t70*abb94n240+t3*t71*abb94n192+t3*t72*ab&
         &b94n268+t3*t73*abb94n214+t3*t75*abb94n240+t3*t76*abb94n192+t3*t78*abb9&
         &4n273+t3*t79*abb94n235+t3*t81*abb94n273+t3*t82*abb94n235+t3*t83*abb94n&
         &238+t3*t85*abb94n238+t3*t90*abb94n248+t3*t91*abb94n248+t3*t99*abb94n23&
         &7+t30*t4*abb94n255+t32*t4*abb94n228+t34*t5*abb94n267+t36*t5*abb94n255+&
         &t38*t4*abb94n255+t39*t4*abb94n228+t4*t42*abb94n195+t4*t46*abb94n195+t4&
         &*t49*abb94n229+t4*t50*abb94n196+t4*t53*abb94n229+t4*t54*abb94n196+t4*t&
         &57*abb94n259+t4*t58*abb94n228+t4*t59*abb94n197+t4*t62*abb94n259+t4*t63&
         &*abb94n228+t4*t64*abb94n197+t4*t67*abb94n256+t4*t68*abb94n225+t4*t69*a&
         &bb94n192+t4*t72*abb94n256+t4*t73*abb94n225+t4*t74*abb94n192+t4*t77*abb&
         &94n235+t4*t80*abb94n235+t4*t86*abb94n248+t4*t88*abb94n248+t4*t92*abb94&
         &n244+t4*t93*abb94n244+t4*t94*abb94n248+t4*t95*abb94n248+t4*t96*abb94n2&
         &45+t4*t97*abb94n245+t4*t98*abb94n237+t40*t5*abb94n267+t41*t5*abb94n255&
         &+t45*t6*abb94n244+t48*t6*abb94n244+t5*t59*abb94n271+t5*t61*abb94n259+t&
         &5*t64*abb94n271+t5*t66*abb94n259+t5*t69*abb94n268+t5*t71*abb94n256+t5*&
         &t74*abb94n268+t5*t76*abb94n256+t5*t87*abb94n272+t5*t89*abb94n272+t52*t&
         &6*abb94n248+t56*t6*abb94n248+t6*t71*abb94n245+t6*t76*abb94n245+t6*t79*&
         &abb94n260+t6*t82*abb94n260+t6*t87*abb94n238+t6*t89*abb94n238+t7*t87*ab&
         &b94n198+t7*t89*abb94n198+t8*t87*abb94n236+t8*t89*abb94n236+t87*t9*abb9&
         &4n237+t89*t9*abb94n237+t1*t101*t4*abb94n83+t1*t102*t3*abb94n83+t1*t3*t&
         &99*abb94n83+t1*t4*t98*abb94n83+t1*t87*t9*abb94n83+t1*t89*t9*abb94n83+t&
         &104*t18*t3*abb94n236+t107*t18*t3*abb94n198+t121*t3*t4*abb94n83+t122*t3&
         &*t4*abb94n83+t24*t3*t35*abb94n236+t25*t3*t35*abb94n198+t3*t79*t9*abb94&
         &n83+t3*t82*t9*abb94n83+t4*t77*t9*abb94n83+t4*t80*t9*abb94n83)
         return
      end if
      t193 = d(iv2,iv3)
      t194 = d(iv1,iv3)
      t7 = k1(iv3)
      t8 = k2(iv3)
      t26 = k5(iv3)
      t34 = k6(iv3)
      t36 = qshift(iv3)
      t40 = t193*t21
      t41 = t194*t29
      t44 = spvak3k1(iv3)
      t45 = t198*t44
      t47 = t15*t193
      t48 = t194*t31
      t51 = spvak3k4(iv3)
      t52 = t198*t51
      t55 = t16*t193
      t56 = t194*t33
      t60 = spvak5k6(iv3)
      t61 = t198*t60
      t65 = t17*t193
      t66 = t194*t43
      t70 = spvak6k1(iv3)
      t71 = t198*t70
      t75 = t18*t193
      t76 = t194*t35
      t90 = spvak6k5(iv3)
      t91 = t198*t90
      t99 = spvak5k1(iv3)
      t102 = t10*t44
      t114 = t10*t51
      t115 = t37*t44
      t117 = t37*t51
      t118 = t21*t7
      t123 = t29*t7
      t124 = t15*t7
      t125 = t31*t7
      t126 = t11*t60
      t127 = t27*t60
      t128 = t16*t8
      t129 = t33*t8
      t130 = t12*t51
      t131 = t12*t60
      t132 = t28*t51
      t133 = t28*t60
      t134 = t15*t26
      t135 = t26*t31
      t136 = t16*t26
      t137 = t26*t33
      t138 = t13*t44
      t139 = t13*t51
      t140 = t19*t44
      t141 = t19*t51
      t142 = t21*t34
      t143 = t29*t34
      t144 = t15*t34
      t145 = t31*t34
      t146 = t14*t44
      t147 = t14*t51
      t148 = t14*t60
      t149 = t20*t44
      t150 = t20*t51
      t151 = t20*t60
      t152 = t21*t36
      t153 = t29*t36
      t154 = t15*t36
      t155 = t31*t36
      t156 = t16*t36
      t157 = t33*t36
      t98 = t90*t98
      t158 = t23*t35*t60
      t101 = t101*t90
      t159 = t100*t18*t60
      t160 = spvak2k1(iv3)
      t161 = t16*t160*t35
      t162 = t160*t18*t33
      t163 = spvak2k4(iv3)
      t164 = spvak2k5(iv3)
      t165 = t21*t60
      t166 = t29*t60
      t167 = t16*t44
      t168 = t33*t44
      t169 = t77*t90
      t170 = t15*t60
      t171 = t170*t35
      t172 = t80*t90
      t173 = t31*t60
      t174 = t173*t18
      t175 = t16*t51
      t176 = t175*t35
      t177 = t33*t51
      t178 = t177*t18
      t179 = t16*t70
      t180 = t33*t70
      t181 = t17*t60
      t182 = t43*t60
      t183 = t121*t60
      t184 = t23*t51
      t185 = t184*t33
      t186 = t122*t60
      t187 = t100*t51
      t188 = t16*t187
      t189 = t15*t160
      t190 = t189*t33
      t191 = t160*t31
      t192 = t16*t191
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t40*abb94n152+t41*abb94n152+t45*abb94n152+t47*ab&
         &b94n148+t48*abb94n148+t52*abb94n148+t55*abb94n113+t56*abb94n113+t61*ab&
         &b94n113+t65*abb94n99+t66*abb94n99+t71*abb94n99+t75*abb94n118+t76*abb94&
         &n118+t91*abb94n118+t1*t55*abb94n215+t1*t56*abb94n215+t1*t61*abb94n215+&
         &t1*t65*abb94n263+t1*t66*abb94n263+t1*t71*abb94n263+t1*t75*abb94n226+t1&
         &*t76*abb94n226+t1*t91*abb94n226+t10*t193*abb94n127+t11*t193*abb94n158+&
         &t12*t193*abb94n127+t13*t193*abb94n130+t14*t193*abb94n207+t19*t194*abb9&
         &4n130+t194*t20*abb94n207+t194*t27*abb94n158+t194*t28*abb94n127+t194*t3&
         &7*abb94n127+t198*t26*abb94n127+t198*t34*abb94n130+t198*t36*abb94n207+t&
         &198*t7*abb94n127+t198*t8*abb94n158+t2*t47*abb94n263+t2*t48*abb94n263+t&
         &2*t52*abb94n263+t2*t55*abb94n241+t2*t56*abb94n241+t2*t61*abb94n241+t3*&
         &t40*abb94n269+t3*t41*abb94n269+t3*t45*abb94n269+t3*t47*abb94n215+t3*t4&
         &8*abb94n215+t3*t52*abb94n215+t3*t65*abb94n241+t3*t66*abb94n241+t3*t71*&
         &abb94n241+t3*t75*abb94n193+t3*t76*abb94n193+t3*t91*abb94n193+t4*t40*ab&
         &b94n257+t4*t41*abb94n257+t4*t45*abb94n257+t4*t47*abb94n226+t4*t48*abb9&
         &4n226+t4*t52*abb94n226+t4*t55*abb94n193+t4*t56*abb94n193+t4*t61*abb94n&
         &193+t5*t55*abb94n269+t5*t56*abb94n269+t5*t61*abb94n269+t5*t75*abb94n25&
         &7+t5*t76*abb94n257+t5*t91*abb94n257+t6*t75*abb94n246+t6*t76*abb94n246+&
         &t6*t91*abb94n246+t193*t22*t4*abb94n246+t194*t4*t84*abb94n246+t198*t4*t&
         &99*abb94n246)+t101*abb94n108+t158*abb94n108+t159*abb94n108+t161*abb94n&
         &108+t162*abb94n108+t169*abb94n110+t171*abb94n110+t172*abb94n110+t174*a&
         &bb94n110+t176*abb94n110+t178*abb94n110+t98*abb94n108+t1*t101*abb94n274&
         &+t1*t158*abb94n274+t1*t159*abb94n274+t1*t161*abb94n274+t1*t162*abb94n2&
         &74+t1*t98*abb94n274+t102*t33*abb94n88+t102*t35*abb94n96+t103*t90*abb94&
         &n109+t105*t90*abb94n109+t106*t90*abb94n133+t108*t90*abb94n133+t109*t90&
         &*abb94n85+t111*t90*abb94n85+t113*t90*abb94n93+t114*t33*abb94n122+t114*&
         &t35*abb94n115+t115*t16*abb94n88+t115*t18*abb94n96+t116*t90*abb94n93+t1&
         &17*t16*abb94n122+t117*t18*abb94n115+t118*t33*abb94n88+t118*t35*abb94n9&
         &6+t119*t90*abb94n107+t120*t90*abb94n107+t123*t16*abb94n88+t123*t18*abb&
         &94n96+t124*t33*abb94n122+t124*t35*abb94n115+t125*t16*abb94n122+t125*t1&
         &8*abb94n115+t126*t35*abb94n136+t126*t43*abb94n106+t127*t17*abb94n106+t&
         &127*t18*abb94n136+t128*t35*abb94n136+t128*t43*abb94n106+t129*t17*abb94&
         &n106+t129*t18*abb94n136+t130*t35*abb94n114+t130*t43*abb94n90+t131*t35*&
         &abb94n135+t131*t43*abb94n104+t132*t17*abb94n90+t132*t18*abb94n114+t133&
         &*t17*abb94n104+t133*t18*abb94n135+t134*t35*abb94n114+t134*t43*abb94n90&
         &+t135*t17*abb94n90+t135*t18*abb94n114+t136*t35*abb94n135+t136*t43*abb9&
         &4n104+t137*t17*abb94n104+t137*t18*abb94n135+t138*t33*abb94n86+t138*t35&
         &*abb94n94+t139*t33*abb94n122+t139*t35*abb94n115+t139*t43*abb94n92+t140&
         &*t16*abb94n86+t140*t18*abb94n94+t141*t16*abb94n122+t141*t17*abb94n92+t&
         &141*t18*abb94n115+t142*t33*abb94n86+t142*t35*abb94n94+t143*t16*abb94n8&
         &6+t143*t18*abb94n94+t144*t33*abb94n122+t144*t35*abb94n115+t144*t43*abb&
         &94n92+t145*t16*abb94n122+t145*t17*abb94n92+t145*t18*abb94n115+t146*t33&
         &*abb94n270+t146*t35*abb94n258+t147*t33*abb94n216+t147*t35*abb94n227+t1&
         &47*t43*abb94n264+t148*t35*abb94n194+t148*t43*abb94n242+t149*t16*abb94n&
         &270+t149*t18*abb94n258+t150*t16*abb94n216+t150*t17*abb94n264+t150*t18*&
         &abb94n227+t151*t17*abb94n242+t151*t18*abb94n194+t152*t33*abb94n270+t15&
         &2*t35*abb94n258+t153*t16*abb94n270+t153*t18*abb94n258+t154*t33*abb94n2&
         &16+t154*t35*abb94n227+t154*t43*abb94n264+t155*t16*abb94n216+t155*t17*a&
         &bb94n264+t155*t18*abb94n227+t156*t35*abb94n194+t156*t43*abb94n242+t157&
         &*t17*abb94n242+t157*t18*abb94n194+t165*t35*abb94n85+t166*t18*abb94n85+&
         &t167*t35*abb94n85+t168*t18*abb94n85+t169*t9*abb94n274+t17*t173*abb94n8&
         &4+t17*t177*abb94n84+t170*t43*abb94n84+t171*t9*abb94n274+t172*t9*abb94n&
         &274+t174*t9*abb94n274+t175*t43*abb94n84+t176*t9*abb94n274+t178*t9*abb9&
         &4n274+t179*t35*abb94n101+t18*t180*abb94n101+t18*t182*abb94n101+t181*t3&
         &5*abb94n101+t183*t4*abb94n274+t185*t4*abb94n274+t186*t4*abb94n274+t188&
         &*t4*abb94n274+t190*t4*abb94n274+t192*t4*abb94n274+t30*t60*abb94n88+t30&
         &*t90*abb94n96+t32*t60*abb94n122+t32*t90*abb94n115+t38*t60*abb94n88+t38&
         &*t90*abb94n96+t39*t60*abb94n122+t39*t90*abb94n115+t42*t70*abb94n106+t4&
         &2*t90*abb94n136+t46*t70*abb94n106+t46*t90*abb94n136+t49*t70*abb94n90+t&
         &49*t90*abb94n114+t50*t70*abb94n104+t50*t90*abb94n135+t53*t70*abb94n90+&
         &t53*t90*abb94n114+t54*t70*abb94n104+t54*t90*abb94n135+t57*t60*abb94n86&
         &+t57*t90*abb94n94+t58*t60*abb94n122+t58*t70*abb94n92+t58*t90*abb94n115&
         &+t59*t90*abb94n134+t60*t62*abb94n86+t60*t63*abb94n122+t60*t67*abb94n27&
         &0+t60*t68*abb94n216+t60*t72*abb94n270+t60*t73*abb94n216+t62*t90*abb94n&
         &94+t63*t70*abb94n92+t63*t90*abb94n115+t64*t90*abb94n134+t67*t90*abb94n&
         &258+t68*t70*abb94n264+t68*t90*abb94n227+t69*t70*abb94n242+t69*t90*abb9&
         &4n194+t70*t73*abb94n264+t70*t74*abb94n242+t70*t77*abb94n84+t70*t80*abb&
         &94n84+t72*t90*abb94n258+t73*t90*abb94n227+t74*t90*abb94n194+t86*t90*ab&
         &b94n101+t88*t90*abb94n101+t90*t92*abb94n103+t90*t93*abb94n103+t90*t94*&
         &abb94n101+t90*t95*abb94n101+t90*t96*abb94n247+t90*t97*abb94n247+t104*t&
         &18*t60*abb94n109+t107*t18*t60*abb94n133+t11*t35*t99*abb94n103+t12*t35*&
         &t99*abb94n101+t121*t3*t90*abb94n274+t122*t3*t90*abb94n274+t13*t35*t60*&
         &abb94n134+t14*t35*t99*abb94n247+t15*t35*t99*abb94n93+t16*t163*t35*abb9&
         &4n109+t16*t164*t35*abb94n133+t16*t34*t35*abb94n134+t16*t35*t99*abb94n1&
         &07+t163*t18*t33*abb94n109+t164*t18*t33*abb94n133+t18*t187*t3*abb94n274&
         &+t18*t19*t60*abb94n134+t18*t191*t3*abb94n274+t18*t20*t99*abb94n247+t18&
         &*t26*t84*abb94n101+t18*t27*t99*abb94n103+t18*t28*t99*abb94n101+t18*t31&
         &*t99*abb94n93+t18*t33*t34*abb94n134+t18*t33*t99*abb94n107+t18*t36*t84*&
         &abb94n247+t18*t51*t84*abb94n93+t18*t60*t84*abb94n107+t18*t8*t84*abb94n&
         &103+t184*t3*t35*abb94n274+t189*t3*t35*abb94n274+t22*t26*t35*abb94n101+&
         &t22*t35*t36*abb94n247+t22*t35*t51*abb94n93+t22*t35*t60*abb94n107+t22*t&
         &35*t8*abb94n103+t24*t35*t60*abb94n109+t25*t35*t60*abb94n133)
         return
      end if
      t195 = d(iv3,iv4)
      t196 = d(iv2,iv4)
      t197 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t2 = spvak6k5(iv4)
      t3 = spvak3k1(iv4)
      t4 = spvak6k1(iv4)
      t5 = spvak3k4(iv4)
      t6 = spvak5k1(iv4)
      t7 = t23*t5
      t8 = t100*t5
      t9 = t160*t5
      t10 = spvak2k1(iv4)
      t11 = t10*t15
      t12 = t10*t31
      t10 = t10*t51
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t193*t197*abb94n128+t194*t196*abb94n128+t195*t19&
         &8*abb94n128)+(2.0_ki)*(t109*t195*abb94n87+t110*t195*abb94n95+t111*t195&
         &*abb94n87+t112*t195*abb94n95+t165*t196*abb94n87+t166*t197*abb94n87+t16&
         &7*t196*abb94n87+t168*t197*abb94n87+t170*t196*abb94n123+t173*t197*abb94&
         &n123+t175*t196*abb94n123+t177*t197*abb94n123+t179*t196*abb94n105+t180*&
         &t197*abb94n105+t181*t196*abb94n105+t182*t197*abb94n105+t195*t77*abb94n&
         &123+t195*t78*abb94n91+t195*t79*abb94n116+t195*t80*abb94n123+t195*t81*a&
         &bb94n91+t195*t82*abb94n116+t195*t83*abb94n102+t195*t85*abb94n102+t195*&
         &t86*abb94n105+t195*t87*abb94n137+t195*t88*abb94n105+t195*t89*abb94n137&
         &+t1*t15*t193*abb94n123+t1*t17*t193*abb94n105+t1*t18*t193*abb94n137+t1*&
         &t193*t21*abb94n87+t1*t194*t29*abb94n87+t1*t194*t31*abb94n123+t1*t194*t&
         &35*abb94n137+t1*t194*t43*abb94n105+t1*t198*t44*abb94n87+t1*t198*t51*ab&
         &b94n123+t1*t198*t70*abb94n105+t1*t198*t90*abb94n137+t15*t193*t2*abb94n&
         &116+t15*t193*t4*abb94n91+t15*t196*t70*abb94n91+t15*t196*t90*abb94n116+&
         &t16*t193*t2*abb94n137+t16*t193*t3*abb94n87+t16*t193*t4*abb94n105+t16*t&
         &193*t5*abb94n123+t16*t196*t90*abb94n137+t17*t193*t5*abb94n91+t17*t196*&
         &t51*abb94n91+t18*t193*t3*abb94n95+t18*t193*t5*abb94n116+t18*t193*t6*ab&
         &b94n102+t18*t196*t44*abb94n95+t18*t196*t51*abb94n116+t18*t196*t60*abb9&
         &4n137+t18*t196*t99*abb94n102+t193*t2*t21*abb94n95+t193*t2*t22*abb94n10&
         &2+t194*t2*t29*abb94n95+t194*t2*t31*abb94n116+t194*t2*t33*abb94n137+t19&
         &4*t2*t84*abb94n102+t194*t3*t33*abb94n87+t194*t3*t35*abb94n95+t194*t31*&
         &t4*abb94n91+t194*t33*t4*abb94n105+t194*t33*t5*abb94n123+t194*t35*t5*ab&
         &b94n116+t194*t35*t6*abb94n102+t194*t43*t5*abb94n91+t196*t21*t90*abb94n&
         &95+t196*t22*t90*abb94n102+t197*t29*t90*abb94n95+t197*t31*t70*abb94n91+&
         &t197*t31*t90*abb94n116+t197*t33*t90*abb94n137+t197*t35*t44*abb94n95+t1&
         &97*t35*t51*abb94n116+t197*t35*t60*abb94n137+t197*t35*t99*abb94n102+t19&
         &7*t43*t51*abb94n91+t197*t84*t90*abb94n102+t198*t2*t44*abb94n95+t198*t2&
         &*t51*abb94n116+t198*t2*t60*abb94n137+t198*t2*t99*abb94n102+t198*t3*t60&
         &*abb94n87+t198*t3*t90*abb94n95+t198*t4*t51*abb94n91+t198*t4*t60*abb94n&
         &105+t198*t5*t60*abb94n123+t198*t5*t70*abb94n91+t198*t5*t90*abb94n116+t&
         &198*t6*t90*abb94n102)+t183*t2*abb94n83+t185*t2*abb94n83+t186*t2*abb94n&
         &83+t188*t2*abb94n83+t190*t2*abb94n83+t192*t2*abb94n83+t1*t121*t90*abb9&
         &4n83+t1*t122*t90*abb94n83+t1*t18*t187*abb94n83+t1*t18*t191*abb94n83+t1&
         &*t184*t35*abb94n83+t1*t189*t35*abb94n83+t10*t16*t35*abb94n83+t10*t18*t&
         &33*abb94n83+t11*t33*t90*abb94n83+t11*t35*t60*abb94n83+t12*t16*t90*abb9&
         &4n83+t12*t18*t60*abb94n83+t16*t35*t9*abb94n83+t16*t8*t90*abb94n83+t18*&
         &t33*t9*abb94n83+t18*t60*t8*abb94n83+t33*t7*t90*abb94n83+t35*t60*t7*abb&
         &94n83)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d94:
   subroutine     reconstruct_d94(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_94:
      coeffs%coeffs_94%c0 = derivative(czip)
      coeffs%coeffs_94%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_94%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_94%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_94%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_94%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_94%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_94%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_94%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_94%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_94%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_94%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_94%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_94%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_94%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_94%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_94%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_94%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_94%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_94%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_94%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_94%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_94%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_94%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_94%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_94%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_94%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_94%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_94%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_94%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_94%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_94%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_94%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_94%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_94%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_94%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_94%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_94%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_94%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_94%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_94%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_94%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_94%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_94%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_94%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_94%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_94%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_94%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_94%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_94%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_94%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_94%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_94%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_94%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_94%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_94%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_94%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_94%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_94%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_94%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_94%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_94%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_94%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_94%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_94%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_94%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_94%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_94%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_94%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_94%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_94:
   end subroutine reconstruct_d94
!---#] subroutine reconstruct_d94:
end module p7_dubar_emnebargg_d94h3l1d
